using System;
using System.Collections;
using BoardLib;
using System.Web;
using System.IO;
using System.Security;
using System.Security.Principal;

namespace BoardLib
{
	/// <summary>
	/// AdminQryLib   Դϴ.
	/// </summary>
	public class AdminQryLib
	{
		public AdminQryLib()
		{
		}

		#region ü Խ  Ȳ
		public static string MemberJoinState()
		{
			StringWriter Qry = new StringWriter();
			
			Qry.WriteLine("select count(guest_no) from NB_MemberData where datediff(d, join_time, getdate()) < 1 and guest_no != " + DBUtil.QryConvStr (NBLib.SuperAdmin, false));
			Qry.WriteLine("select count(guest_no) from NB_MemberData where guest_no != " + DBUtil.QryConvStr (NBLib.SuperAdmin, false));

			return Qry.ToString();
		}

		public static string GetBoardListAtBoardCfg()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("SELECT a.board_no, b.group_name, a.board_name");
			Qry.WriteLine("FROM NB_BoardSet a, NB_GroupInfo b");
			Qry.WriteLine("WHERE SUBSTRING(a.board_no, 1, 3) = b.group_code ");
			
			string AdminGroup = NBCmnUtil.GetCookieValue ("NEADMIN_ADMINGROUP");
			if (!NBAdminUtil.isSuperAdmin() && AdminGroup != null)
				Qry.WriteLine("AND b.group_code IN ('" + AdminGroup + "')");

			Qry.WriteLine("ORDER BY b.group_code ASC, a.board_no asc");

			return Qry.ToString();
		}

		public static string GetGroupBoardListAtBoardCfg(string sGroupNo)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select a.board_no, b.group_name, a.board_name");
			Qry.WriteLine("from NB_BoardSet a, NB_GroupInfo b");
			Qry.WriteLine("where substring(a.board_no, 1, 3) = b.group_code and b.group_code = '" + sGroupNo + "'");
			Qry.WriteLine("order by b.group_code asc, a.board_no asc");

			return Qry.ToString();
		}

		public static string BoardVisitState(string sBoardNo)
		{
			StringWriter Qry = new StringWriter();
			
			Qry.WriteLine("select count(idx_no)  from NB_BoardData_" + sBoardNo + " where datediff(d, write_date, getdate()) < 1");
			Qry.WriteLine("select count(idx_no)  from NB_BoardData_" + sBoardNo);			
			Qry.WriteLine("select count(visit_time)  from NB_VisitLogData_" + sBoardNo + " where datediff(d, visit_time, getdate()) < 1");
			Qry.WriteLine("select count(visit_time)  from NB_VisitLogData_" + sBoardNo);
			Qry.WriteLine("SELECT COUNT(*) FROM NB_BoardData_" + sBoardNo + " WHERE ISNULL(disp_end_date, getdate()) < getdate() AND RTRIM(disp_end_date) != ''");

			return Qry.ToString();
		}

		public static string AllBoardObject(string sBoardNo)
		{
			StringWriter Qry = new StringWriter();
			
			Qry.WriteLine("SELECT [name] FROM sysobjects WHERE type = 'P' AND [name] LIKE '%_" + sBoardNo + "' ORDER BY [name] ASC");
			Qry.WriteLine("SELECT [name] FROM sysobjects WHERE type = 'U' AND [name] LIKE '%_" + sBoardNo + "' ORDER BY [name] ASC");

			return Qry.ToString();
		}

		public static string PointCfg()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT write_point, cmmt_write_point, reply_write_point");
			Qry.WriteLine ("FROM NB_PointCfg");
			Qry.WriteLine ("WHERE idx_no = 1");

			return Qry.ToString();
		}
		#endregion

		#region ׷ 
		public static string NewGroupCode()
		{
			StringWriter Qry = new StringWriter();
			
			Qry.WriteLine("declare @group_code int, @code_cnt smallint");
			Qry.WriteLine("select @code_cnt = count(group_code) from NB_GroupInfo");
			Qry.WriteLine("if @code_cnt = 0");
			Qry.WriteLine("begin");
			Qry.WriteLine("set @group_code = 1");
			Qry.WriteLine("end");
			Qry.WriteLine("else");
			Qry.WriteLine("select @group_code = max(convert(int, group_code) + 1) from NB_GroupInfo");
			Qry.WriteLine("select @group_code");


			return Qry.ToString();
		}


		public static string GroupListMemDetail()
		{
			StringWriter Qry = new StringWriter();
               
			Qry.WriteLine("SELECT ");
			Qry.WriteLine("a.group_code, a.group_name, a.level_inherit, a.join_level, ");
			Qry.WriteLine("(SELECT COUNT(*) FROM NB_BoardSet WHERE a.group_code = SUBSTRING(board_no, 1, 3)) AS board_cnt ");
			Qry.WriteLine("FROM NB_GroupInfo a");
			Qry.WriteLine("WHERE ISNULL(a.level_inherit, '0') <> '1'");
			
			string AdminGroup = NBCmnUtil.GetCookieValue ("NEADMIN_ADMINGROUP");
			if (!NBAdminUtil.isSuperAdmin() && AdminGroup != null)
				Qry.WriteLine("AND a.group_code IN ('" + AdminGroup + "')");
            
			Qry.WriteLine("ORDER BY a.group_code ASC");

			return Qry.ToString();
		}

	
		public static string GroupList()
		{
			StringWriter Qry = new StringWriter();
               
			Qry.WriteLine("SELECT ");
			Qry.WriteLine("a.group_code, a.group_name, a.level_inherit, a.join_level, ");
			Qry.WriteLine("(SELECT COUNT(*) FROM NB_BoardSet WHERE a.group_code = SUBSTRING(board_no, 1, 3)) AS board_cnt ");
			Qry.WriteLine("FROM NB_GroupInfo a");
			
			string AdminGroup = NBCmnUtil.GetCookieValue ("NEADMIN_ADMINGROUP");
			if (!NBAdminUtil.isSuperAdmin() && AdminGroup != null)
				Qry.WriteLine("WHERE a.group_code IN ('" + AdminGroup + "')");
            
			Qry.WriteLine("ORDER BY a.group_code ASC");

			return Qry.ToString();
		}

		public static string GetGroupName(string sGroupCode)
		{
			StringWriter Qry = new StringWriter();
               
			Qry.WriteLine("select ");
			Qry.WriteLine("group_name ");
			Qry.WriteLine("from NB_GroupInfo");
			Qry.WriteLine("where group_code = '" + sGroupCode + "'");

			return Qry.ToString();
		}

		public static string GroupDelete(string sGroupCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("DELETE NB_GroupInfo WHERE group_code = '" + sGroupCode + "'");
			Qry.WriteLine("DELETE NB_GroupBoardCfg WHERE group_code = '" + sGroupCode + "'");
			Qry.WriteLine("DELETE NB_GroupDesignCfg WHERE group_code = '" + sGroupCode + "'");

			return Qry.ToString();
		}

		public static string GroupBoardRefTableName(string sGroupCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select [name] from sysobjects ");
			Qry.WriteLine("where type = 'U' and [name] != 'dtproperties' and ");
			Qry.WriteLine("[name] like 'NB_BoardData_" +sGroupCode + "%' or [name] like 'NB_CommentData_" + sGroupCode + "%'");

			return Qry.ToString();
		}

		public static string GroupPointCfg(string sGroupCode)
		{
            StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT a.write_point, a.cmmt_write_point, a.reply_write_point, b.point_inherit ");
			Qry.WriteLine ("FROM NB_GroupPointCfg a, NB_GroupInfo b ");
			Qry.WriteLine ("WHERE a.group_code = b.group_code AND a.group_code = '" + sGroupCode + "'");

			return Qry.ToString();
		}
		#endregion

		#region Խ 
		#endregion

		#region Խ 
		public static string GroupListSimple()
		{
			StringWriter Qry = new StringWriter();
			
			Qry.WriteLine("SELECT group_code, group_name");
			Qry.WriteLine("FROM NB_GroupInfo");
			Qry.WriteLine("ORDER BY group_code ASC");

			return Qry.ToString();
		}

		public static string BoardListSimple()
		{
			StringWriter Qry = new StringWriter();
			
			Qry.WriteLine("SELECT board_no, board_name");
			Qry.WriteLine("FROM NB_BoardSet");
			Qry.WriteLine("ORDER BY board_no ASC");

			return Qry.ToString();
		}

		public static string NewBoardNo(string sGroupNo)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("declare @board_no int, @code_cnt smallint");
			Qry.WriteLine("select @code_cnt = count(board_no) from NB_BoardSet");
			Qry.WriteLine("  where substring(board_no, 1, 3) = '" + sGroupNo.Trim().Replace("'", "''") + "'");
			Qry.WriteLine("if @code_cnt = 0");
			Qry.WriteLine("begin");
			Qry.WriteLine("set @board_no = convert(int, '" + sGroupNo.Trim().Replace("'", "''") + "' + '000') + 1");
			Qry.WriteLine("end");
			Qry.WriteLine("else");
			Qry.WriteLine("select @board_no = max(convert(int, board_no) + 1) from NB_BoardSet");
			Qry.WriteLine("where substring(board_no, 1, 3) = '" + sGroupNo.Trim().Replace("'", "''") + "'");
			Qry.WriteLine("select @board_no");

			return Qry.ToString();
		}
		#endregion

		#region Խ 
		public static string GetBoardCfgData(string sBoardNo)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select a.board_name, b.* from NB_BoardSet a, NB_BoardCfg b where a.board_no = b.board_no AND a.board_no = '" + sBoardNo + "'");

			return Qry.ToString();
		}

		public static string GetGroupBoardCfgData(string sGrpCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select * from NB_GroupBoardCfg b where group_code = '" + sGrpCode + "'");

			return Qry.ToString();
		}

		public static string GetBoardDesignCfgData(string sBoardNo)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select * from NB_DesignCfg where board_no = '" + sBoardNo + "'");

			return Qry.ToString();
		}

		public static string GetGroupDesignCfgData(string sGrpCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select * from NB_GroupDesignCfg where group_code = '" + sGrpCode + "'");

			return Qry.ToString();
		}

		public static string GetJoinDesignCfgData()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select * from NB_JoinDesignCfg where jd_idx = 1");

			return Qry.ToString();
		}

		public static string GetLoginDesignCfgData()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select * from NB_LoginDesignCfg where ld_idx = 1");

			return Qry.ToString();
		}
		#endregion

		#region īװ 
		public static string NewCatCode(string sBoardNo)
		{
			StringWriter Qry = new StringWriter();
			
			Qry.WriteLine("declare @cat_code int, @code_cnt smallint");
			Qry.WriteLine("select @code_cnt = count(cat_code) from NB_CategoryData where board_no = '" + sBoardNo + "'");
			Qry.WriteLine("if @code_cnt = 0");
			Qry.WriteLine("begin");
			Qry.WriteLine("set @cat_code = 1");
			Qry.WriteLine("end");
			Qry.WriteLine("else");
			Qry.WriteLine("select @cat_code = max(convert(int, cat_code) + 1) from NB_CategoryData where board_no = '" + sBoardNo + "'");
			Qry.WriteLine("select @cat_code");

			return Qry.ToString();
		}

		public static string CatList(string sBoardNo)
		{
			StringWriter Qry = new StringWriter();
			               
			Qry.WriteLine("select a.cat_code, a.cat_name, ");
			Qry.WriteLine("(select count(idx_no) from NB_BoardData_" + sBoardNo + " where cat_code = a.cat_code) content_cnt");
			Qry.WriteLine("from NB_CategoryData a ");
			Qry.WriteLine("where a.board_no = '" + sBoardNo + "'");
			Qry.WriteLine("order by a.cat_code asc");

			return Qry.ToString();
		}

		public static string CatListSimple(string sBoardNo)
		{
			StringWriter Qry = new StringWriter();
			               
			Qry.WriteLine("SELECT cat_code, cat_name ");
			Qry.WriteLine("FROM NB_CategoryData ");
			Qry.WriteLine("WHERE board_no = '" + sBoardNo + "'");
			Qry.WriteLine("ORDER BY cat_code ASC");

			return Qry.ToString();
		}

		public static string CatDelete(string sBoardNo, string sCatCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("DELETE NB_CategoryData WHERE board_no = '" + sBoardNo + "' AND cat_code = '" + sCatCode + "'");
            Qry.WriteLine("UPDATE NB_BoardData_" + sBoardNo + " SET cat_code = '' WHERE cat_code = '" + sCatCode + "'");


			return Qry.ToString();
		}

		public static string NoneCatCnt(string sBoardNo)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("SELECT COUNT(idx_no) FROM NB_BoardData_" + sBoardNo + " WHERE ISNULL(cat_code, '') = ''");

			return Qry.ToString();
		}
		#endregion

		#region ȸ 
		public static string MemSearch(string sWhere)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("SELECT ");
			Qry.WriteLine("	guest_no, mem_id, mem_email, mem_name, point_num, join_time, lastvisit_time, ");
			Qry.WriteLine("	(CASE user_enable WHEN '1' THEN '' ELSE '̽' END) AS user_enable ");
			Qry.WriteLine("FROM NB_MemberData ");
			Qry.WriteLine(sWhere);
			Qry.WriteLine("ORDER BY join_time DESC");

			return Qry.ToString();
		}

		public static string MemStateChg(string sState, string sGuestNos)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("update NB_MemberData set ");
			Qry.WriteLine("user_enable = '" + sState + "' ");
			Qry.WriteLine("where guest_no in (" + sGuestNos + ")");

			return Qry.ToString();
		}

		public static string MemDelete(string sGuestNos)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("DELETE NB_MemberData WHERE guest_no in (" + sGuestNos + ")");
			Qry.WriteLine("DELETE NB_AddMemberData WHERE guest_no in (" + sGuestNos + ")");
			Qry.WriteLine("DELETE NB_UserLevelInGroup WHERE guest_no in (" + sGuestNos + ")");
			Qry.WriteLine("DELETE NB_GroupAdminInfo WHERE guest_no in (" + sGuestNos + ")");

			return Qry.ToString();
		}

		public static string MaillingListSimple()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select mail_code, mail_name from NB_MaillingData order by mail_code asc");

			return Qry.ToString();
		}

		public static string GetJoinItemCfgData()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("SELECT nickname_use, citizennum_use, birthday_use, ");
			Qry.WriteLine("sex_use, messenger_use, homepage_use, homeaddr_use, homephone_use, workaddr_use, ");
			Qry.WriteLine("workphone_use, mobilephone_use, mailling_use, mempic_use, memdesc_use, passfind_use, ");
			Qry.WriteLine("openinfo_use, isnull(join_baseuse, '0') as join_baseuse, afterjoin_url, joinid_limit, ");
			Qry.WriteLine("homezip_use, workzip_use, sess_timeout, passfind_desc, join_point, login_point, cancel_script ");
			Qry.WriteLine("FROM NB_JoinItemCfg WHERE join_idx = 1");

			return Qry.ToString();
		}

		public static string MaillingListData()
		{
			StringWriter Qry = new StringWriter();
               
			Qry.WriteLine("select ");
			Qry.WriteLine("mail_code, mail_name, mail_subject, ");
			Qry.WriteLine("(case mail_body_type when '0' then 'TEXT' when '1' then 'HTML' end) as mail_body_type ");
			Qry.WriteLine("from NB_MaillingData ");
			Qry.WriteLine("order by mail_code desc ");

			return Qry.ToString();
		}

		public static string NewMailCode()
		{
			StringWriter Qry = new StringWriter();
			
			Qry.WriteLine("declare @mail_code int, @code_cnt smallint");
			Qry.WriteLine("select @code_cnt = count(mail_code) from NB_MaillingData");
			Qry.WriteLine("if @code_cnt = 0");
			Qry.WriteLine("begin");
			Qry.WriteLine("set @mail_code = 1");
			Qry.WriteLine("end");
			Qry.WriteLine("else");
			Qry.WriteLine("select @mail_code = max(convert(int, mail_code) + 1) from NB_MaillingData");
			Qry.WriteLine("select @mail_code");


			return Qry.ToString();
		}

		public static string MaillingDelete(string sMailCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("delete NB_MaillingData where mail_code = '" + sMailCode + "'");

			return Qry.ToString();
		}

		public static string MaillingData(string sMailCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select mail_code, mail_name, mail_subject, mail_sender, mail_bcc, mail_body, mail_body_type ");
			Qry.WriteLine("from NB_MaillingData where mail_code = '" + sMailCode + "'");

			return Qry.ToString();
		}

		public static string MemDataForMailling(string sGuestNos, bool bMaillingChk)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select guest_no, mem_id, mem_pwd, mem_name, mem_email, nick_name");
			Qry.WriteLine("from NB_MemberData");
			Qry.WriteLine("where 1=1 ");

			if (!bMaillingChk)
			{
				Qry.WriteLine("and mailling_chk = '1'");
			}

			if (!NBUtil.StrEmptyChk (sGuestNos))
			{
				Qry.WriteLine("and guest_no in (" + sGuestNos + ")");
			}

			Qry.WriteLine("Order By guest_no ASC");

			return Qry.ToString();
		}

		public static string MemDataFromGuestNo(string MemID)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("select * from NB_MemberData where mem_id = '" + MemID + "'");

			return Qry.ToString();
		}

		public static string MemDataForCsv(string sGuestNos)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("SELECT ");
			Qry.WriteLine("	* ");
			Qry.WriteLine(" FROM NB_MemberData ");

			Qry.WriteLine("where guest_no != '000000' ");

			if (!NBUtil.StrEmptyChk (sGuestNos))
			{
				Qry.WriteLine("and guest_no in (" + sGuestNos + ")");
			}

			Qry.WriteLine("ORDER BY guest_no ASC");

			return Qry.ToString();
		}

		#endregion

		#region DB 
		public static string DBBackupState()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("exec sp_spaceused");
			Qry.WriteLine("select count([name]) as tbl_cnt from sysobjects where type = 'U' and [name] != 'dtproperties'");

			return Qry.ToString();
		}

		public static string DBBackupList()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("exec sp_helpdevice");

			return Qry.ToString();
		}

		public static string DBBackupDelete(string sDeviceName)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("exec sp_dropdevice '" + sDeviceName + "', 'DELFILE'");

			return Qry.ToString();
		}

		public static string DBBackupMake(string sDBName, string sDeviceName, string sBackupPath)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("exec sp_addumpdevice 'disk', '" + sDeviceName + "', ");
			Qry.WriteLine("'" + sBackupPath + "'");
			Qry.WriteLine("BACKUP DATABASE " + sDBName + " TO " + sDeviceName);

			return Qry.ToString();
		}
		#endregion

		#region DB  
		public static string DBObjectList()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("SELECT [name], crdate FROM SYSOBJECTS WHERE TYPE = 'U' AND [NAME] LIKE 'NB_%' ORDER BY [NAME] ASC");

			return Qry.ToString();
		}

		public static string DBObjectSpaceUsed(string objName)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("exec sp_spaceused '" + objName + "'");

			return Qry.ToString();
		}
		#endregion

		#region ÷ 
		public static string GetBoardTableList()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select [name] from sysobjects where type = 'U' and [name] like 'NB_BoardData_%' order by [name] asc");

			return Qry.ToString();
		}

		public static string GetFileTableList()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select [name] from sysobjects where type = 'U' and [name] like 'NB_FileData_%' order by [name] asc");

			return Qry.ToString();
		}

		public static string GetBoardFiles(string sTblName)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("SELECT idx_no, fidx_no, (file_name + file_ext) AS fname FROM " + sTblName);
			Qry.WriteLine("WHERE LTRIM(RTRIM(ISNULL(file_name, ''))) != ''");
			Qry.WriteLine("ORDER BY idx_no");

			return Qry.ToString();
		}

		public static string DoBoardFileClear(string sBoardName, string sIdxNo, string sFIdxNo)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("UPDATE " + sBoardName + " SET file_name = '', file_ext = '', file_size = '', file_desc = '' WHERE idx_no = " + sIdxNo + " AND fidx_no = " + sFIdxNo);

			return Qry.ToString();
		}
		#endregion

		#region Խù 
		public static string GetBoardTableListWithName()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select a.[name], isnull(b.board_name, '') as board_name from sysobjects a, NB_BoardSet b ");
			Qry.WriteLine("where type = 'U' and [name] like 'NB_BoardData_%' and ");
			Qry.WriteLine("substring(a.[name], 14, 6) *= b.board_no ");
			Qry.WriteLine("order by [name] asc ");

			return Qry.ToString();
		}

		public static string GetFindAllQry(string sBoardName, string sTopNum, string sWhereStr)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select " + sTopNum + " a.idx_no, a.subject, a.write_date ");
			Qry.WriteLine("from " + sBoardName);
			Qry.WriteLine("where " + sWhereStr);
			Qry.WriteLine("order by a.write_date desc");

			return Qry.ToString();
		}
		#endregion

		#region ޸ Ȯ 
		public static string GetMemoData(string sGuestNo)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("select b.mem_name, a.send_guest_no, a.send_date, a.memo_subject, a.rcv_chk");
			Qry.WriteLine ("from NB_MemoData a, NB_MemberData b ");
			Qry.WriteLine ("where a.send_guest_no *= b.guest_no and a.rcv_guest_no = '" + sGuestNo + "' ");

			return Qry.ToString();
		}
		#endregion

		#region  
		public static string GetGroupAllowAuth(string sGroupCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT auth_code FROM NB_GroupAllowAuth WHERE group_code = '" + sGroupCode + "' ORDER BY auth_code ASC");

			return Qry.ToString();
		}

		public static string InOutAllowAuth(string sInOut, string sGroupCode, string sAuthCode)
		{
			StringWriter Qry = new StringWriter();

			if (sInOut.ToUpper().Equals("IN"))
			{
				Qry.WriteLine ("INSERT INTO NB_GroupAllowAuth (group_code, auth_code) VALUES ('" + sGroupCode + "', '" + sAuthCode + "')");
			}
			else if (sInOut.ToUpper().Equals("OUT"))
			{
				Qry.WriteLine ("DELETE NB_GroupAllowAuth WHERE group_code = '" + sGroupCode + "' AND auth_code = '" + sAuthCode + "'");
				Qry.WriteLine ("DELETE NB_AuthGroupInfo_Detail WHERE group_code = '" + sGroupCode + "' AND auth_code = '" + sAuthCode + "'");
			}
			else
			{
				Qry.WriteLine ("");
			}

			return Qry.ToString();
		}

		public static string GetAdminList(string sGroupCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT ");
			Qry.WriteLine ("	a.guest_no, a.group_admin, b.mem_name, b.mem_id");
			Qry.WriteLine ("FROM");
			Qry.WriteLine ("	NB_GroupAdminInfo a, NB_MemberData b");
			Qry.WriteLine ("WHERE");
			Qry.WriteLine ("	a.guest_no = b.guest_no AND");
			Qry.WriteLine ("	a.group_code = '" + sGroupCode + "'");

			return Qry.ToString();
		}

		public static string GetAdminDetail(string sGroupCode, string sGuestNo)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("DECLARE");
			Qry.WriteLine ("	@group_admin CHAR(1),");
			Qry.WriteLine ("	@allow_code INT,");
			Qry.WriteLine ("	@deny_code INT,");
			Qry.WriteLine ("	@allow_name VARCHAR(100),");
			Qry.WriteLine ("	@deny_name VARCHAR(100)");
			
			Qry.WriteLine ("SELECT");
			Qry.WriteLine ("	@group_admin = group_admin, @allow_code = allow_authgroup_code, @deny_code = deny_authgroup_code");
			Qry.WriteLine ("FROM");
			Qry.WriteLine ("	NB_GroupAdminInfo");
			Qry.WriteLine ("WHERE");
			Qry.WriteLine ("	group_code = '" + sGroupCode + "' AND");
			Qry.WriteLine ("	guest_no = '" + sGuestNo + "'");
			
			Qry.WriteLine ("SELECT");
			Qry.WriteLine ("	@allow_name = authgroup_name");
			Qry.WriteLine ("FROM");
			Qry.WriteLine ("	NB_AuthGroupInfo");
			Qry.WriteLine ("WHERE");
			Qry.WriteLine ("	group_code = '" + sGroupCode + "' AND");
			Qry.WriteLine ("	authgroup_code = @allow_code");

			Qry.WriteLine ("SELECT");
			Qry.WriteLine ("	@deny_name = authgroup_name");
			Qry.WriteLine ("FROM");
			Qry.WriteLine ("	NB_AuthGroupInfo");
			Qry.WriteLine ("WHERE");
			Qry.WriteLine ("	group_code = '" + sGroupCode + "' AND");
			Qry.WriteLine ("	authgroup_code = @deny_code");
			
			Qry.WriteLine ("SELECT @group_admin AS group_admin, @allow_code AS allow_code, ");
			Qry.WriteLine ("	@deny_code AS deny_code, @allow_name AS allow_name, @deny_name AS deny_name");

			return Qry.ToString();
		}

		public static string GetMemList_ForAdmin(string sSearchTxt)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT ");
			Qry.WriteLine ("	guest_no, mem_id, mem_name");
			Qry.WriteLine ("FROM");
			Qry.WriteLine ("	NB_MemberData");
			Qry.WriteLine ("WHERE");
			Qry.WriteLine ("	(mem_id LIKE '%" + sSearchTxt + "%' OR ");
			Qry.WriteLine ("	mem_name LIKE '%" + sSearchTxt + "%') AND");
			Qry.WriteLine ("	guest_no <> '000000'");
			Qry.WriteLine ("ORDER BY");
			Qry.WriteLine ("	mem_id ASC");

			return Qry.ToString();
		}

		public static string InOutGroupAdmin(string sInOut, string sGroupCode, string sGuestNo)
		{
			StringWriter Qry = new StringWriter();

			if (sInOut.ToUpper().Equals("IN"))
			{
				Qry.WriteLine ("INSERT INTO NB_GroupAdminInfo");
				Qry.WriteLine ("	(group_code, guest_no)");
				Qry.WriteLine ("VALUES");
				Qry.WriteLine ("	('" + sGroupCode + "', '" + sGuestNo + "')");
			}
			else if (sInOut.ToUpper().Equals("OUT"))
			{
				Qry.WriteLine ("DELETE NB_GroupAdminInfo");
				Qry.WriteLine ("WHERE");
				Qry.WriteLine ("	group_code = '" + sGroupCode + "' AND guest_no = '" + sGuestNo + "'");
			}
			else
			{
				Qry.WriteLine ("");
			}

			return Qry.ToString();
		}

		public static string UpdateAuthGroupInfo(string sGroupCode, string sGuestNo, string sGroupAdmin, string sAllowCode, string sDenyCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("UPDATE");
			Qry.WriteLine ("	NB_GroupAdminInfo");
			Qry.WriteLine ("SET");
            Qry.WriteLine ("	group_admin='" + sGroupAdmin + "', ");
			Qry.WriteLine ("	allow_authgroup_code='" + sAllowCode + "', ");
			Qry.WriteLine ("	deny_authgroup_code='" + sDenyCode + "' ");
			Qry.WriteLine ("WHERE");
			Qry.WriteLine ("	group_code = '" + sGroupCode + "' AND ");
			Qry.WriteLine ("	guest_no = '" + sGuestNo + "'");

			return Qry.ToString();
		}

		

		public static string UpdateAuthGroupCode(string sAllowDeny, string sAuthGroupCode, string sGroupCode, string sGuestNo)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("UPDATE");
			Qry.WriteLine ("	NB_GroupAdminInfo");
			Qry.WriteLine ("SET");
			if (sAllowDeny.ToUpper().Equals("ALLOW"))
                Qry.WriteLine ("	allow_authgroup_code = " + sAuthGroupCode);
			else if (sAllowDeny.ToUpper().Equals("DENY"))
				Qry.WriteLine ("	deny_authgroup_code = " + sAuthGroupCode);
			else
				Qry.WriteLine ("");
			Qry.WriteLine ("WHERE");
			Qry.WriteLine ("	group_code = '" + sGroupCode + "' AND ");
			Qry.WriteLine ("	guest_no = '" + sGuestNo + "'");

			return Qry.ToString();
		}

		public static string UpdateGroupAdminChk(string sGroupAdmin, string sGroupCode, string sGuestNo)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("UPDATE");
			Qry.WriteLine ("	NB_GroupAdminInfo");
			Qry.WriteLine ("SET");
			Qry.WriteLine ("	group_admin = '" + sGroupAdmin + "'");
			Qry.WriteLine ("WHERE");
			Qry.WriteLine ("	group_code = '" + sGroupCode + "' AND ");
			Qry.WriteLine ("	guest_no = '" + sGuestNo + "'");

			return Qry.ToString();
		}

		public static string GetAuthGroupList(string sGroupCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT");
			Qry.WriteLine ("	authgroup_code, authgroup_name ");
			Qry.WriteLine ("FROM");
			Qry.WriteLine ("	NB_AuthGroupInfo");
			Qry.WriteLine ("WHERE");
			Qry.WriteLine ("	group_code = '" + sGroupCode + "' ");
			Qry.WriteLine ("ORDER BY");
			Qry.WriteLine ("	authgroup_code ASC");

			return Qry.ToString();
		}

		public static string GetNewAuthGroupCode(string sGroupCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("DECLARE @authgroup_code INT, @code_cnt SMALLINT");
			Qry.WriteLine ("SELECT @code_cnt = COUNT(*) FROM NB_AuthGroupInfo WHERE group_code = " + DBUtil.QryConvStr (sGroupCode, false));
			Qry.WriteLine ("IF @code_cnt = 0");
			Qry.WriteLine ("	SET @authgroup_code = 1");
			Qry.WriteLine ("ELSE");
			Qry.WriteLine ("	SELECT @authgroup_code = (MAX(ISNULL(authgroup_code, 0)) + 1) FROM NB_AuthGroupInfo WHERE group_code = " + DBUtil.QryConvStr (sGroupCode, false));
			Qry.WriteLine ("SELECT @authgroup_code");

			return Qry.ToString();
		}

		public static string UpdateAuthGroup(string sMode, string sGroupCode, string sAuthGroupCode, string sAuthGroupName)
		{
            StringWriter Qry = new StringWriter();

			if (sMode.ToUpper().Equals("N"))
			{
				Qry.WriteLine ("INSERT INTO NB_AuthGroupInfo (group_code, authgroup_code, authgroup_name)");
				Qry.WriteLine ("VALUES (");
				Qry.WriteLine (DBUtil.QryConvStr (sGroupCode, true));
				Qry.WriteLine (DBUtil.QryConvInt (sAuthGroupCode, "", true));
				Qry.WriteLine (DBUtil.QryConvStr (sAuthGroupName, false));
				Qry.WriteLine (")");
			}
			else if (sMode.ToUpper().Equals("U"))
			{
				Qry.WriteLine ("UPDATE NB_AuthGroupInfo SET");
				Qry.WriteLine ("	authgroup_name = " + DBUtil.QryConvStr (sAuthGroupName, false));
                Qry.WriteLine ("WHERE");
				Qry.WriteLine ("	group_code = " + DBUtil.QryConvStr(sGroupCode, false) + " AND ");
				Qry.WriteLine ("	authgroup_code = " + DBUtil.QryConvInt(sAuthGroupCode, "", false));
			}
			else
			{
				Qry.WriteLine ("");
			}

			return Qry.ToString();
		}

		public static string GetAuthGroupItems(string sGroupCode, string sAuthGroupCode)
		{
			StringWriter Qry = new StringWriter();

            Qry.WriteLine ("SELECT auth_code FROM NB_AuthGroupInfo_Detail");
            Qry.WriteLine ("WHERE group_code = '" + sGroupCode + "' AND authgroup_code = " + sAuthGroupCode);
			Qry.WriteLine ("ORDER BY auth_code ASC");

            return Qry.ToString();
		}

		public static string InOutAuthGroupAuth(string sInOut, string sGroupCode, string sAuthGroupCode, string sAuthCode)
		{
			StringWriter Qry = new StringWriter();

			if (sInOut.ToUpper().Equals("IN"))
			{
				Qry.WriteLine ("INSERT INTO NB_AuthGroupInfo_Detail (group_code, authgroup_code, auth_code) VALUES ");
				Qry.WriteLine ("('" + sGroupCode + "', " + sAuthGroupCode + ", '" + sAuthCode + "')");
			}
			else if (sInOut.ToUpper().Equals("OUT"))
			{
				Qry.WriteLine ("DELETE NB_AuthGroupInfo_Detail ");
				Qry.WriteLine ("WHERE group_code = '" + sGroupCode + "' AND authgroup_code = " + sAuthGroupCode + " AND auth_code = '" + sAuthCode + "'");
			}
			else
			{
				Qry.WriteLine ("");
			}

			return Qry.ToString();
		}

		public static string DeleteAuthGroup(string sGroupCode, string sAuthGroupCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("DELETE NB_AuthGroupInfo ");
			Qry.WriteLine ("WHERE group_code = '" + sGroupCode + "' AND authgroup_code = " + sAuthGroupCode);
			Qry.WriteLine ("DELETE NB_AuthGroupInfo_Detail ");
			Qry.WriteLine ("WHERE group_code = '" + sGroupCode + "' AND authgroup_code = " + sAuthGroupCode);
			Qry.WriteLine ("UPDATE NB_GroupAdminInfo SET allow_authgroup_code = '' ");
			Qry.WriteLine ("WHERE group_code = '" + sGroupCode + "' AND allow_authgroup_code = " + sAuthGroupCode);
			Qry.WriteLine ("UPDATE NB_GroupAdminInfo SET deny_authgroup_code = '' ");
			Qry.WriteLine ("WHERE group_code = '" + sGroupCode + "' AND deny_authgroup_code = " + sAuthGroupCode);

			return Qry.ToString();
		}

		#endregion

		#region ȸ ߰ ׸ 
		public static string GetMemberDataCfg_List()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT add_item_code, add_item_name FROM NB_AddMemberDataCfg");
			Qry.WriteLine ("ORDER BY priority ASC");

			return Qry.ToString();
		}

		public static string GetMemberDataCfg_Detail(string sAddItemCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT add_item_code, add_item_name, add_item_use, add_item_type, add_item_len, add_item_list");
			Qry.WriteLine ("FROM NB_AddMemberDataCfg");
			Qry.WriteLine ("WHERE add_item_code = '" + sAddItemCode + "'");

			return Qry.ToString();
		}

		public static string GetNewMemberDataItemCode()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("DECLARE @item_code INT, @code_cnt SMALLINT");
			Qry.WriteLine ("SELECT @code_cnt = COUNT(*) FROM NB_AddMemberDataCfg");
			Qry.WriteLine ("IF @code_cnt = 0");
			Qry.WriteLine ("	SET @item_code = 1");
			Qry.WriteLine ("ELSE");
			Qry.WriteLine ("	SELECT @item_code = (MAX(ISNULL(CONVERT(INT, add_item_code), 0)) + 1) FROM NB_AddMemberDataCfg");
			Qry.WriteLine ("SELECT @item_code");

			return Qry.ToString();
		}

		public static string UpdateMemberDataCfg(string sMode, string sAddItemCode, string sAddItemName, 
			string sAddItemUse, string sAddItemType, string sAddItemLen, string sAddItemList)
		{
			StringWriter Qry = new StringWriter();

			if (sMode.ToUpper().Equals("N"))
			{
				Qry.WriteLine ("DECLARE @code_cnt SMALLINT, @next_prio INT");
				Qry.WriteLine ("SELECT @code_cnt = COUNT(*) FROM NB_AddMemberDataCfg");
				Qry.WriteLine ("IF @code_cnt = 0");
				Qry.WriteLine ("	SET @next_prio = 1");
				Qry.WriteLine ("ELSE");
				Qry.WriteLine ("	SELECT @next_prio = (MAX(ISNULL(priority, 0)) + 1) FROM NB_AddMemberDataCfg");
				Qry.WriteLine ("INSERT INTO NB_AddMemberDataCfg (add_item_code, add_item_name, add_item_use, add_item_type, ");
				Qry.WriteLine ("	add_item_len, add_item_list, priority)");
				Qry.WriteLine ("VALUES (");
				Qry.WriteLine (DBUtil.QryConvStr (sAddItemCode, true));
				Qry.WriteLine (DBUtil.QryConvStr (sAddItemName, true));
				Qry.WriteLine (DBUtil.QryConvStr (sAddItemUse, true));
				Qry.WriteLine (DBUtil.QryConvStr (sAddItemType, true));
				Qry.WriteLine (DBUtil.QryConvInt (sAddItemLen, "0", true));
				Qry.WriteLine (DBUtil.QryConvStr (sAddItemList, true));
				Qry.WriteLine ("@next_prio");
				Qry.WriteLine (")");
			}
			else if (sMode.ToUpper().Equals("U"))
			{
				Qry.WriteLine ("UPDATE NB_AddMemberDataCfg SET");
				Qry.WriteLine ("	add_item_name = " + DBUtil.QryConvStr (sAddItemName, true));
				Qry.WriteLine ("	add_item_use = " + DBUtil.QryConvStr (sAddItemUse, true));
				Qry.WriteLine ("	add_item_type = " + DBUtil.QryConvStr (sAddItemType, true));
				Qry.WriteLine ("	add_item_len = " + DBUtil.QryConvInt (sAddItemLen, "0", true));
				Qry.WriteLine ("	add_item_list = " + DBUtil.QryConvStr (sAddItemList, false));
				Qry.WriteLine ("WHERE");
				Qry.WriteLine ("	add_item_code = " + DBUtil.QryConvStr(sAddItemCode, false));
			}
			else
			{
				Qry.WriteLine ("");
			}

			return Qry.ToString();
		}

		public static string DoAddMemberDataDelete(string sAddItemCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("DELETE NB_AddMemberDataCfg WHERE add_item_code = '" + sAddItemCode + "'");
			Qry.WriteLine ("DELETE NB_AddMemberData WHERE add_item_code = '" + sAddItemCode + "'");

			return Qry.ToString();
		}

		public static string MoveMemberDataCfg(string sMode, string sAddItemCode)
		{
			StringWriter Qry = new StringWriter();


			Qry.WriteLine ("DECLARE @tar_item_code CHAR(3), @tar_priority INT, @src_priority INT");
			Qry.WriteLine ("SELECT @src_priority = priority FROM NB_AddMemberDataCfg WHERE add_item_code = '" + sAddItemCode + "'");

			if (sMode.ToUpper().Equals("UP"))
			{
				//  ̵
				Qry.WriteLine ("SELECT TOP 1 @tar_item_code = add_item_code, @tar_priority = priority FROM NB_AddMemberDataCfg WHERE priority < @src_priority ORDER BY priority DESC");
			}
			if (sMode.ToUpper().Equals("DOWN"))
			{
				// Ʒ ̵
				Qry.WriteLine ("SELECT TOP 1 @tar_item_code = add_item_code, @tar_priority = priority FROM NB_AddMemberDataCfg WHERE priority > @src_priority ORDER BY priority ASC");
			}

			Qry.WriteLine ("UPDATE NB_AddMemberDataCfg SET priority = @tar_priority WHERE add_item_code = '" + sAddItemCode + "'");
			Qry.WriteLine ("UPDATE NB_AddMemberDataCfg SET priority = @src_priority WHERE add_item_code = @tar_item_code");

			return Qry.ToString();
		}
		#endregion

		#region  
		public static string GetParentLevelList()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT");
			Qry.WriteLine ("	level_code, level_name ");
			Qry.WriteLine ("FROM");
			Qry.WriteLine ("	NB_UserAllowLevel");
			Qry.WriteLine ("ORDER BY");
			Qry.WriteLine ("	priority ASC");

			return Qry.ToString();
		}

		public static string GetNewParentLevelCode()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("DECLARE @level_code INT, @code_cnt SMALLINT");
			Qry.WriteLine ("SELECT @code_cnt = COUNT(*) FROM NB_UserAllowLevel");
			Qry.WriteLine ("IF @code_cnt = 0");
			Qry.WriteLine ("	SET @level_code = 1");
			Qry.WriteLine ("ELSE");
			Qry.WriteLine ("	SELECT @level_code = (MAX(ISNULL(CONVERT(INT, level_code), 0)) + 1) FROM NB_UserAllowLevel");
			Qry.WriteLine ("SELECT @level_code");

			return Qry.ToString();
		}

		public static string GetParentNotMemberChk(string sLevelCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT not_member FROM NB_UserAllowLevel WHERE level_code = '" + sLevelCode + "'");

			return Qry.ToString();
		}

		public static string DeleteParentLevelCode(string sLevelCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("DELETE NB_UserAllowLevel ");
			Qry.WriteLine ("WHERE level_code = '" + sLevelCode + "'");
			
			Qry.WriteLine ("DELETE NB_UserAllowLevel_Detail ");
			Qry.WriteLine ("WHERE level_code = '" + sLevelCode + "'");

			return Qry.ToString();
		}

		public static string ChkNotMember(string sLevelCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT COUNT(*)");
            Qry.WriteLine ("FROM NB_UserAllowLevel");
			Qry.WriteLine ("WHERE not_member = '1' AND level_code = '" + sLevelCode + "'");

			return Qry.ToString();
		}

		public static string UpdateParentLevel(string sMode, string sLevelCode, string sLevelName)
		{
			StringWriter Qry = new StringWriter();

			if (sMode.ToUpper().Equals("N"))
			{
				Qry.WriteLine ("DECLARE @code_cnt SMALLINT, @next_prio INT");
				Qry.WriteLine ("SELECT @code_cnt = COUNT(*) FROM NB_UserAllowLevel");
				Qry.WriteLine ("IF @code_cnt = 0");
				Qry.WriteLine ("	SET @next_prio = 1");
				Qry.WriteLine ("ELSE");
				Qry.WriteLine ("	SELECT @next_prio = (MAX(ISNULL(priority, 0)) + 1) FROM NB_UserAllowLevel");
				Qry.WriteLine ("INSERT INTO NB_UserAllowLevel (level_code, level_name, priority)");
				Qry.WriteLine ("VALUES (");
				Qry.WriteLine (DBUtil.QryConvStr (sLevelCode, true));
				Qry.WriteLine (DBUtil.QryConvStr (sLevelName, true));
				Qry.WriteLine ("@next_prio");
				Qry.WriteLine (")");
			}
			else if (sMode.ToUpper().Equals("U"))
			{
				Qry.WriteLine ("UPDATE NB_UserAllowLevel SET");
				Qry.WriteLine ("	level_name = " + DBUtil.QryConvStr (sLevelName, false));
				Qry.WriteLine ("WHERE");
				Qry.WriteLine ("	level_code = " + DBUtil.QryConvStr(sLevelCode, false));
			}
			else
			{
				Qry.WriteLine ("");
			}

			return Qry.ToString();
		}

		public static string MoveParentLevel(string sMode, string sLevelCode)
		{
			StringWriter Qry = new StringWriter();


			Qry.WriteLine ("DECLARE @tar_lvl_code CHAR(2), @tar_priority INT, @src_priority INT");
            Qry.WriteLine ("SELECT @src_priority = priority FROM NB_UserAllowLevel WHERE level_code = '" + sLevelCode + "'");

			if (sMode.ToUpper().Equals("UP"))
			{
                //  ̵
				Qry.WriteLine ("SELECT TOP 1 @tar_lvl_code = level_code, @tar_priority = priority FROM NB_UserAllowLevel WHERE priority < @src_priority ORDER BY priority DESC");
			}
			if (sMode.ToUpper().Equals("DOWN"))
			{
                // Ʒ ̵
				Qry.WriteLine ("SELECT TOP 1 @tar_lvl_code = level_code, @tar_priority = priority FROM NB_UserAllowLevel WHERE priority > @src_priority ORDER BY priority ASC");
			}

			Qry.WriteLine ("UPDATE NB_UserAllowLevel SET priority = @tar_priority WHERE level_code = '" + sLevelCode + "'");
			Qry.WriteLine ("UPDATE NB_UserAllowLevel SET priority = @src_priority WHERE level_code = @tar_lvl_code");

			return Qry.ToString();
		}

		public static string GetAllowLevelItems()
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT level_code, level_name, not_member FROM NB_UserAllowLevel ORDER BY priority ASC");
			Qry.WriteLine ("SELECT level_code, role_code FROM NB_UserAllowLevel_Detail ORDER BY role_code");

			return Qry.ToString();
		}

		public static string DoUseAllowLevelDetail(string sMode, string sLevelCode, string sRoleCode)
		{
			StringWriter Qry = new StringWriter();

			if (sMode.ToUpper().Equals("ADD"))
			{
				Qry.WriteLine ("DELETE NB_UserAllowLevel_Detail WHERE level_code = '" + sLevelCode + "' AND ");
				Qry.WriteLine ("role_code = '" + sRoleCode + "'");
				Qry.WriteLine ("INSERT INTO NB_UserAllowLevel_Detail (level_code, role_code) VALUES (");
				Qry.WriteLine ("'" + sLevelCode + "',");
				Qry.WriteLine ("'" + sRoleCode + "')");
			}
			if (sMode.ToUpper().Equals("REMOVE"))
			{
				Qry.WriteLine ("DELETE NB_UserAllowLevel_Detail WHERE level_code = '" + sLevelCode + "' AND ");
				Qry.WriteLine ("role_code = '" + sRoleCode + "'");
			}

			return Qry.ToString();
		}

		#endregion

		#region ׷캰  
		public static string GetBoardLevelList(string sBoardNo)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT");
			Qry.WriteLine ("	level_code, level_name ");
			Qry.WriteLine ("FROM");
			Qry.WriteLine ("	NB_BoardUserLevel");
			Qry.WriteLine ("WHERE");
			Qry.WriteLine ("	board_no = '" + sBoardNo + "'");
			Qry.WriteLine ("ORDER BY");
			Qry.WriteLine ("	priority ASC");

			return Qry.ToString();
		}

		public static string GetGroupLevelList(string sGroupCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT");
			Qry.WriteLine ("	level_code, level_name ");
			Qry.WriteLine ("FROM");
			Qry.WriteLine ("	NB_GroupUserLevel");
			Qry.WriteLine ("WHERE");
			Qry.WriteLine ("	group_code = '" + sGroupCode + "'");
			Qry.WriteLine ("ORDER BY");
			Qry.WriteLine ("	priority ASC");

			return Qry.ToString();
		}

		public static string GetNewBoardLevelCode(string sBoardNo)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("DECLARE @level_code INT, @code_cnt SMALLINT");
			Qry.WriteLine ("SELECT @code_cnt = COUNT(*) FROM NB_BoardUserLevel WHERE board_no = '" + sBoardNo + "'");
			Qry.WriteLine ("IF @code_cnt = 0");
			Qry.WriteLine ("	SET @level_code = 1");
			Qry.WriteLine ("ELSE");
			Qry.WriteLine ("	SELECT @level_code = (MAX(ISNULL(CONVERT(INT, level_code), 0)) + 1) FROM NB_BoardUserLevel WHERE board_no = '" + sBoardNo + "'");
			Qry.WriteLine ("SELECT @level_code");

			return Qry.ToString();
		}

		public static string GetNewGroupLevelCode(string sGroupCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("DECLARE @level_code INT, @code_cnt SMALLINT");
			Qry.WriteLine ("SELECT @code_cnt = COUNT(*) FROM NB_GroupUserLevel WHERE group_code = '" + sGroupCode + "'");
			Qry.WriteLine ("IF @code_cnt = 0");
			Qry.WriteLine ("	SET @level_code = 1");
			Qry.WriteLine ("ELSE");
			Qry.WriteLine ("	SELECT @level_code = (MAX(ISNULL(CONVERT(INT, level_code), 0)) + 1) FROM NB_GroupUserLevel WHERE group_code = '" + sGroupCode + "'");
			Qry.WriteLine ("SELECT @level_code");

			return Qry.ToString();
		}

		public static string GetBoardNotMemberChk(string sBoardNo, string sLevelCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT not_member FROM NB_BoardUserLevel WHERE board_no = '" + sBoardNo + "' AND level_code = '" + sLevelCode + "'");

			return Qry.ToString();
		}

		public static string GetGroupNotMemberChk(string sGroupCode, string sLevelCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT not_member FROM NB_GroupUserLevel WHERE group_code = '" + sGroupCode + "' AND level_code = '" + sLevelCode + "'");

			return Qry.ToString();
		}

		public static string DeleteBoardLevelCode(string sBoardNo, string sLevelCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("DELETE NB_BoardUserLevel ");
			Qry.WriteLine ("WHERE level_code = '" + sLevelCode + "' AND board_no = '" + sBoardNo + "'");
			
			Qry.WriteLine ("DELETE NB_BoardUserLevel_Detail ");
			Qry.WriteLine ("WHERE level_code = '" + sLevelCode + "' AND board_no = '" + sBoardNo + "'");

			return Qry.ToString();
		}

		public static string DeleteGroupLevelCode(string sGroupCode, string sLevelCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("DELETE NB_GroupUserLevel ");
			Qry.WriteLine ("WHERE level_code = '" + sLevelCode + "' AND group_code = '" + sGroupCode + "'");
			
			Qry.WriteLine ("DELETE NB_GroupUserLevel_Detail ");
			Qry.WriteLine ("WHERE level_code = '" + sLevelCode + "' AND group_code = '" + sGroupCode + "'");

			return Qry.ToString();
		}

		public static string UpdateBoardLevel(string sBoardNo, string sMode, string sLevelCode, string sLevelName)
		{
			StringWriter Qry = new StringWriter();

			if (sMode.ToUpper().Equals("N"))
			{
				Qry.WriteLine ("DECLARE @code_cnt SMALLINT, @next_prio INT");
				Qry.WriteLine ("SELECT @code_cnt = COUNT(*) FROM NB_BoardUserLevel WHERE board_no = '" + sBoardNo + "'");
				Qry.WriteLine ("IF @code_cnt = 0");
				Qry.WriteLine ("	SET @next_prio = 1");
				Qry.WriteLine ("ELSE");
				Qry.WriteLine ("	SELECT @next_prio = (MAX(ISNULL(priority, 0)) + 1) FROM NB_BoardUserLevel WHERE board_no = '" + sBoardNo + "'");
				Qry.WriteLine ("INSERT INTO NB_BoardUserLevel (board_no, level_code, level_name, priority)");
				Qry.WriteLine ("VALUES (");
				Qry.WriteLine (DBUtil.QryConvStr (sBoardNo, true));
				Qry.WriteLine (DBUtil.QryConvStr (sLevelCode, true));
				Qry.WriteLine (DBUtil.QryConvStr (sLevelName, true));
				Qry.WriteLine ("@next_prio");
				Qry.WriteLine (")");
			}
			else if (sMode.ToUpper().Equals("U"))
			{
				Qry.WriteLine ("UPDATE NB_BoardUserLevel SET");
				Qry.WriteLine ("	level_name = " + DBUtil.QryConvStr (sLevelName, false));
				Qry.WriteLine ("WHERE");
				Qry.WriteLine ("	level_code = " + DBUtil.QryConvStr(sLevelCode, false) + " AND ");
				Qry.WriteLine ("	board_no = " + DBUtil.QryConvStr(sBoardNo, false));
			}
			else
			{
				Qry.WriteLine ("");
			}

			return Qry.ToString();
		}

		public static string UpdateGroupLevel(string sGroupCode, string sMode, string sLevelCode, string sLevelName)
		{
			StringWriter Qry = new StringWriter();

			if (sMode.ToUpper().Equals("N"))
			{
				Qry.WriteLine ("DECLARE @code_cnt SMALLINT, @next_prio INT");
				Qry.WriteLine ("SELECT @code_cnt = COUNT(*) FROM NB_GroupUserLevel WHERE group_code = '" + sGroupCode + "'");
				Qry.WriteLine ("IF @code_cnt = 0");
				Qry.WriteLine ("	SET @next_prio = 1");
				Qry.WriteLine ("ELSE");
				Qry.WriteLine ("	SELECT @next_prio = (MAX(ISNULL(priority, 0)) + 1) FROM NB_GroupUserLevel WHERE group_code = '" + sGroupCode + "'");
				Qry.WriteLine ("INSERT INTO NB_GroupUserLevel (group_code, level_code, level_name, priority)");
				Qry.WriteLine ("VALUES (");
				Qry.WriteLine (DBUtil.QryConvStr (sGroupCode, true));
				Qry.WriteLine (DBUtil.QryConvStr (sLevelCode, true));
				Qry.WriteLine (DBUtil.QryConvStr (sLevelName, true));
				Qry.WriteLine ("@next_prio");
				Qry.WriteLine (")");
			}
			else if (sMode.ToUpper().Equals("U"))
			{
				Qry.WriteLine ("UPDATE NB_GroupUserLevel SET");
				Qry.WriteLine ("	level_name = " + DBUtil.QryConvStr (sLevelName, false));
				Qry.WriteLine ("WHERE");
				Qry.WriteLine ("	level_code = " + DBUtil.QryConvStr(sLevelCode, false) + " AND ");
				Qry.WriteLine ("	group_code = " + DBUtil.QryConvStr(sGroupCode, false));
			}
			else
			{
				Qry.WriteLine ("");
			}

			return Qry.ToString();
		}

		public static string MoveBoardLevel(string sBoardNo, string sMode, string sLevelCode)
		{
			StringWriter Qry = new StringWriter();


			Qry.WriteLine ("DECLARE @tar_lvl_code CHAR(2), @tar_priority INT, @src_priority INT");
			Qry.WriteLine ("SELECT @src_priority = priority FROM NB_BoardUserLevel WHERE level_code = '" + sLevelCode + "' AND board_no = '" + sBoardNo + "'");

			if (sMode.ToUpper().Equals("UP"))
			{
				//  ̵
				Qry.WriteLine ("SELECT TOP 1 @tar_lvl_code = level_code, @tar_priority = priority FROM NB_BoardUserLevel WHERE priority < @src_priority AND board_no = '" + sBoardNo + "' ORDER BY priority DESC");
			}
			if (sMode.ToUpper().Equals("DOWN"))
			{
				// Ʒ ̵
				Qry.WriteLine ("SELECT TOP 1 @tar_lvl_code = level_code, @tar_priority = priority FROM NB_BoardUserLevel WHERE priority > @src_priority AND board_no = '" + sBoardNo + "' ORDER BY priority ASC");
			}

			Qry.WriteLine ("UPDATE NB_BoardUserLevel SET priority = @tar_priority WHERE level_code = '" + sLevelCode + "' AND board_no = '" + sBoardNo + "'");
			Qry.WriteLine ("UPDATE NB_BoardUserLevel SET priority = @src_priority WHERE level_code = @tar_lvl_code AND board_no = '" + sBoardNo + "'");

			return Qry.ToString();
		}

		public static string MoveGroupLevel(string sGroupCode, string sMode, string sLevelCode)
		{
			StringWriter Qry = new StringWriter();


			Qry.WriteLine ("DECLARE @tar_lvl_code CHAR(2), @tar_priority INT, @src_priority INT");
			Qry.WriteLine ("SELECT @src_priority = priority FROM NB_GroupUserLevel WHERE level_code = '" + sLevelCode + "' AND group_code = '" + sGroupCode + "'");

			if (sMode.ToUpper().Equals("UP"))
			{
				//  ̵
				Qry.WriteLine ("SELECT TOP 1 @tar_lvl_code = level_code, @tar_priority = priority FROM NB_GroupUserLevel WHERE priority < @src_priority AND group_code = '" + sGroupCode + "' ORDER BY priority DESC");
			}
			if (sMode.ToUpper().Equals("DOWN"))
			{
				// Ʒ ̵
				Qry.WriteLine ("SELECT TOP 1 @tar_lvl_code = level_code, @tar_priority = priority FROM NB_GroupUserLevel WHERE priority > @src_priority AND group_code = '" + sGroupCode + "' ORDER BY priority ASC");
			}

			Qry.WriteLine ("UPDATE NB_GroupUserLevel SET priority = @tar_priority WHERE level_code = '" + sLevelCode + "' AND group_code = '" + sGroupCode + "'");
			Qry.WriteLine ("UPDATE NB_GroupUserLevel SET priority = @src_priority WHERE level_code = @tar_lvl_code AND group_code = '" + sGroupCode + "'");

			return Qry.ToString();
		}

		public static string GetBoardLevelItems(string sBoardNo)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT level_code, level_name, not_member FROM NB_BoardUserLevel WHERE board_no = '" + sBoardNo + "' ORDER BY priority ASC");
			Qry.WriteLine ("SELECT level_code, role_code FROM NB_BoardUserLevel_Detail WHERE board_no = '" + sBoardNo + "' ORDER BY role_code");

			return Qry.ToString();
		}

		public static string GetGroupLevelItems(string sGroupCode)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT level_code, level_name, not_member FROM NB_GroupUserLevel WHERE group_code = '" + sGroupCode + "' ORDER BY priority ASC");
			Qry.WriteLine ("SELECT level_code, role_code FROM NB_GroupUserLevel_Detail WHERE group_code = '" + sGroupCode + "' ORDER BY role_code");

			return Qry.ToString();
		}

		public static string DoUseBoardLevelDetail(string sBoardNo, string sMode, string sLevelCode, string sRoleCode)
		{
			StringWriter Qry = new StringWriter();

			if (sMode.ToUpper().Equals("ADD"))
			{
				Qry.WriteLine ("DELETE NB_BoardUserLevel_Detail WHERE level_code = '" + sLevelCode + "' AND ");
				Qry.WriteLine ("board_no = '" + sBoardNo + "' AND ");
				Qry.WriteLine ("role_code = '" + sRoleCode + "'");
				Qry.WriteLine ("INSERT INTO NB_BoardUserLevel_Detail (board_no, level_code, role_code) VALUES (");
				Qry.WriteLine ("'" + sBoardNo + "',");
				Qry.WriteLine ("'" + sLevelCode + "',");
				Qry.WriteLine ("'" + sRoleCode + "')");
			}
			if (sMode.ToUpper().Equals("REMOVE"))
			{
				Qry.WriteLine ("DELETE NB_BoardUserLevel_Detail WHERE level_code = '" + sLevelCode + "' AND ");
				Qry.WriteLine ("board_no = '" + sBoardNo + "' AND ");
				Qry.WriteLine ("role_code = '" + sRoleCode + "'");
			}

			return Qry.ToString();
		}

		public static string DoUseGroupLevelDetail(string sGroupCode, string sMode, string sLevelCode, string sRoleCode)
		{
			StringWriter Qry = new StringWriter();

			if (sMode.ToUpper().Equals("ADD"))
			{
				Qry.WriteLine ("DELETE NB_GroupUserLevel_Detail WHERE level_code = '" + sLevelCode + "' AND ");
				Qry.WriteLine ("group_code = '" + sGroupCode + "' AND ");
				Qry.WriteLine ("role_code = '" + sRoleCode + "'");
				Qry.WriteLine ("INSERT INTO NB_GroupUserLevel_Detail (group_code, level_code, role_code) VALUES (");
				Qry.WriteLine ("'" + sGroupCode + "',");
				Qry.WriteLine ("'" + sLevelCode + "',");
				Qry.WriteLine ("'" + sRoleCode + "')");
			}
			if (sMode.ToUpper().Equals("REMOVE"))
			{
				Qry.WriteLine ("DELETE NB_GroupUserLevel_Detail WHERE level_code = '" + sLevelCode + "' AND ");
				Qry.WriteLine ("group_code = '" + sGroupCode + "' AND ");
				Qry.WriteLine ("role_code = '" + sRoleCode + "'");
			}

			return Qry.ToString();
		}

		#endregion
	}
}
