using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Text;
using System.Web;
using System.IO;

namespace BoardLib
{
	public class DBUtil
	{
		public DBUtil()
		{
		}
		
		#region DataBase  
		/// <summary>
		///  DB 
		/// </summary>
		/// <param name="dbSqlConn"></param>
		public static void DBConnection(ref SqlConnection dbSqlConn)
		{
			string sConnStr = NBUtil.GetDBConnStr();

			try
			{
				dbSqlConn = null;

				dbSqlConn = new SqlConnection(sConnStr);
				dbSqlConn.Open();
			}
			catch (Exception E)
			{
				throw E;			
			}
		}

		/// <summary>
		///  DB  
		/// </summary>
		/// <param name="dbSqlConn"></param>
		public static void DBConnDispose(ref SqlConnection dbSqlConn)
		{
			try
			{
				if (dbSqlConn != null && dbSqlConn.State == ConnectionState.Open)
				{
					dbSqlConn.Close();
				
					dbSqlConn.Dispose();
				}
			}
			catch
			{
				throw new Exception("DBConnDispose : DB Dispose Error");
			}
		}

		/// <summary>
		/// DataBase  ׽Ʈ
		/// </summary>
		/// <returns></returns>
		public static bool bTestDbConnection()
		{
			bool bResult = true;

			try
			{
				SqlConnection dbSqlConn = null;

				try
				{
					DBUtil.DBConnection (ref dbSqlConn);
				}
				catch
				{
					bResult = false;
				}               
				finally
				{
					DBUtil.DBConnDispose (ref dbSqlConn);
				}
			}
			catch
			{
			}

			return bResult;
		}
		#endregion

		#region DB ԷµǴ ʵ 迭  
		public static object[] InsertParamItem(string sFieldName, NBLib.FieldQryType FieldType, string sFieldValue)
		{
			object[] ParamItem = new object[3];

			ParamItem[0] = sFieldName.Trim();
			ParamItem[1] = FieldType;
			ParamItem[2] = sFieldValue.Trim();
			
			return ParamItem;			
		}
		#endregion

		#region Insert  
		/// <summary>
		/// Insert Query ٽ 
		/// </summary>
		/// <param name="sTblName">Insert ̺ </param>
		/// <param name="QryParam">
		/// [0] : ʵ 
		/// [1] : ʵ (char, num, func)
		/// [2] : ʵ 
		/// </param>
		/// <returns></returns>
		public static string CreateInsertQry(string sTblName, ArrayList QryParam)
		{
            StringWriter ResultQry = new StringWriter();
			StringWriter FieldQry = new StringWriter();
			StringWriter ValueQry = new StringWriter();

			if (QryParam.Count > 0)
			{
				NBLib.FieldQryType FieldType;

				foreach (object[] sParamItem in QryParam)
				{	
					if (sParamItem.Length == 3)
					{
                        // Insert Field
						FieldQry.Write("[" + sParamItem[0].ToString() + "], ");
					
						FieldType = (NBLib.FieldQryType)sParamItem[1];
						
						// Insert Value
						if (FieldType.CompareTo(NBLib.FieldQryType.Char) == 0)
						{
                            ValueQry.Write("'" + sParamItem[2].ToString() + "', ");
						}
						else if (FieldType.CompareTo(NBLib.FieldQryType.Num) == 0)
						{
							ValueQry.Write(sParamItem[2].ToString() + ", ");
						}
						else if (FieldType.CompareTo(NBLib.FieldQryType.Func) == 0)
						{
							ValueQry.Write(sParamItem[2].ToString() + ", ");
						}
						else
						{
                            ValueQry.Write("'" + sParamItem[2].ToString() + "', ");
						}
					}
				}

				if (FieldQry.ToString().Length > 0 && ValueQry.ToString().Length > 0)
				{
                    ResultQry.WriteLine("insert " + sTblName);
					ResultQry.WriteLine("(" + FieldQry.ToString().Remove(FieldQry.ToString().Length - 2, 2) + ")");
                    ResultQry.WriteLine("values");
					ResultQry.WriteLine("(" + ValueQry.ToString().Remove(ValueQry.ToString().Length - 2, 2) + ")");
				}
			}

			return ResultQry.ToString();
		}
		#endregion

		#region Update  
		/// <summary>
		/// Update Query ٽ 
		/// </summary>
		/// <param name="sTblName">Update ̺ </param>
		/// <param name="QryParam">
		/// [0] : ʵ 
		/// [1] : ʵ (char, num, func)
		/// [2] : ʵ 
		/// </param>
		/// <returns></returns>
		public static string CreateUpdateQry(string sTblName, ArrayList QryParam, string sWhere)
		{
			StringWriter ResultQry = new StringWriter();
			StringWriter UpdateQry = new StringWriter();

			if (QryParam.Count > 0)
			{
				NBLib.FieldQryType FieldType;

				foreach (object[] sParamItem in QryParam)
				{	
					if (sParamItem.Length == 3)
					{
						// Insert Field
						UpdateQry.Write("[" + sParamItem[0].ToString() + "] = ");
					
						FieldType = (NBLib.FieldQryType)sParamItem[1];

						string sFieldValue = sParamItem[2].ToString().Replace("'", "''");
						
						// Update Value
						if (FieldType.Equals (NBLib.FieldQryType.Char))
						{
							UpdateQry.Write("'" + sFieldValue + "', ");
						}
						else if (FieldType.Equals (NBLib.FieldQryType.Num))
						{
							if (NBUtil.StrEmptyChk (sFieldValue))
                                UpdateQry.Write("0, ");
							else
								UpdateQry.Write(sFieldValue + ", ");
						}
						else if (FieldType.Equals (NBLib.FieldQryType.Func))
						{
							UpdateQry.Write(sFieldValue + ", ");
						}
						else
						{
							UpdateQry.Write("'" + sFieldValue + "', ");
						}
					}
				}

				if (UpdateQry.ToString().Length > 0)
				{
					ResultQry.WriteLine("update " + sTblName + " set ");
					ResultQry.WriteLine(UpdateQry.ToString().Remove(UpdateQry.ToString().Length - 2, 2));
					ResultQry.WriteLine(" where " + sWhere);
				}
			}

			return ResultQry.ToString();
		}
		#endregion

		#region ܸ ϰ   
		public static void NoThrowExceptionExcute(string sQry)
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, sQry);
			}
			catch 
			{}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}
		#endregion

		public static int GetCountData(SqlConnection dbSqlConn, string sTblName, string sWhere)
		{
			int nResult = 0;
			
			StringWriter Qry = new StringWriter();

			Qry.WriteLine("select count(*) from ");
			Qry.WriteLine(sTblName);
			Qry.WriteLine(" where ");
			Qry.WriteLine(sWhere);

			nResult = (int)SqlHelper.ExecuteScalar(dbSqlConn, CommandType.Text, Qry.ToString());

			return nResult;
		}


		#region  ڿ Ľ
		public static string ReplaceQuote(string sValue)
		{
			return sValue.Trim().Replace("'", "''");
		}

		/// <summary>
		/// ش簪()  ʵ    ڿ ȯѴ.
		/// </summary>
		/// <param name="sValue"></param>
		/// <param name="sFlag">ʵ  бȣ(,)  </param>
		/// <returns></returns>
		public static string QryConvStr(string sValue, bool sFlag)
		{
			string sResultQry = string.Empty;

			if ( !NBUtil.StrEmptyChk(sValue) )
                sResultQry = "'" + ReplaceQuote (sValue) + "'";
			else
                sResultQry = "''";

			if (sFlag)
				sResultQry += ", ";

			return sResultQry;

		}

		/// <summary>
		/// ش簪()  ʵ忡    ڿ ȯѴ.
		/// </summary>
		/// <param name="sValue"></param>
		/// <param name="sDefault">  ⺻</param>
		/// <param name="sFlag">ʵ  бȣ(,)  </param>
		/// <returns></returns>
		public static string QryConvInt(string sValue, string sDefault, bool sFlag)
		{
			string sResultQry = string.Empty;

			if ( !NBUtil.StrEmptyChk(sValue) )
				sResultQry = ReplaceQuote (sValue);
			else
			{
				if ( NBUtil.StrEmptyChk(sDefault) )
					sResultQry = "0";
				else
					sResultQry = ReplaceQuote(sDefault);
			}

			if (sFlag)
				sResultQry += ", ";

			return sResultQry;
		}
		#endregion

		#region DB Ÿ ؼ о 
		public static DataSet RunDBToDataSet (CommandType CmdType, string Qry)
		{
			SqlConnection dbSqlConn = null;
			DataSet dsData = null;
		
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);
				
				dsData = SqlHelper.ExecuteDataset(dbSqlConn, CmdType, Qry);
			}
			catch(Exception E)
			{
				throw E;	
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}

			return dsData;
		}

		public static DataTable RunDBToDataTable (CommandType CmdType, string Qry)
		{
			DataTable dt = null;

			DataSet ds = RunDBToDataSet (CmdType, Qry);

			if (ds != null)
			{
				dt = ds.Tables[0];
			}

			return dt;
		}

		public static int RunDBToNone (CommandType CmdType, string Qry)
		{
			SqlConnection dbSqlConn = null;
			int nRunQry = 0;
			
			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				nRunQry = SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, Qry.ToString());
			}
			catch (Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}

			return nRunQry;
		}

		public static string RunDBToScalar (CommandType CmdType, string Qry)
		{
			SqlConnection dbSqlConn = null;
			string sRunQry = string.Empty;
			
			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				object objVal = SqlHelper.ExecuteScalar(dbSqlConn, CmdType, Qry.ToString());

				if (objVal != null)
                    sRunQry = objVal.ToString();
			}
			catch (Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}

			return sRunQry;
		}

		public static string RunDBToScalar (CommandType CmdType, string Qry, SqlParameter SqlParm)
		{
			SqlConnection dbSqlConn = null;
			string sRunQry = string.Empty;
			
			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				object objVal = SqlHelper.ExecuteScalar(dbSqlConn, CmdType, Qry.ToString(), SqlParm);

				if (objVal != null)
					sRunQry = objVal.ToString();
			}
			catch (Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}

			return sRunQry;
		}

		public static ArrayList RunDBToArray (CommandType CmdType, string Qry)
		{
			SqlConnection dbSqlConn = null;
			ArrayList arrRun = new ArrayList();
		
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);
				
				SqlDataReader drData = SqlHelper.ExecuteReader(dbSqlConn, CmdType, Qry);
                
				if (drData.Read())
				{
					for (int i = 0; i < drData.FieldCount; i++)
					{
                        arrRun.Add (drData[i]);
					}
				}
			}
			catch(Exception E)
			{
				throw E;	
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}

			return arrRun;
		}
		#endregion
	}
}
