using System;
using System.Collections;
using System.Web;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using BoardLib;
using System.Text.RegularExpressions;
using System.Web.Security;
using System.IO;
using System.Security;
using System.Security.Principal;

namespace BoardLib
{
	public class NBAdminUtil
	{
		public NBAdminUtil()
		{
		}

		#region   Ʈ ؼ Խ ̸ Խ ȣ 
		public static void GetReqStr(ref string gBoardName, ref string gBoardNo)
		{
			if (!NBUtil.StrEmptyChk(HttpContext.Current.Request.QueryString["bnm"]))
			{
				gBoardName = HttpContext.Current.Server.UrlDecode(HttpContext.Current.Request.QueryString["bnm"]);
			}

			if (!NBUtil.StrEmptyChk(HttpContext.Current.Request.QueryString["bno"]))
			{
				gBoardNo = HttpContext.Current.Request.QueryString["bno"];
			}

			if (NBUtil.StrEmptyChk(gBoardName) || NBUtil.StrEmptyChk(gBoardNo))
			{
				throw new Exception("ùٸ Խ  ƴմϴ.");
			}

			
		}

		public static void GetReqStr(ref string gGroupNo)
		{
			if (!NBUtil.StrEmptyChk(HttpContext.Current.Request.QueryString["gno"]))
			{
				gGroupNo = HttpContext.Current.Request.QueryString["gno"];
			}

			if (NBUtil.StrEmptyChk(gGroupNo))
			{
				throw new Exception("ùٸ ׷  ƴմϴ.");
			}
		}
		#endregion

		#region   ޴  ǥ
		public static void view_pagetitle(Label lblPageName, string sPageName, bool bSub)
		{
			// Label lblPageName = (Label)objParentPage.FindControl("lbl_page_name");

			if (bSub)
			{
				lblPageName.Text += " : " + sPageName;
			}
			else
			{
				lblPageName.Text = sPageName;
			}
		}
		#endregion

		#region Խ ġ  ó
		public static bool InstallQryExec(string sExeQry)
		{
			bool bResult = false;

			try
			{
				if (!NBUtil.StrEmptyChk(sExeQry))
				{
					SqlConnection dbSqlConn = null;

					try
					{
						bool bExecResult = false;

						DBUtil.DBConnection (ref dbSqlConn);

						string[] aQryItems = Regex.Split(sExeQry, "-- end --");

						foreach (string sItem in aQryItems)
						{
							if (!NBUtil.StrEmptyChk (sItem))
							{
								if (RepeatQry (sItem))
									bExecResult = true;
								else
								{
									bExecResult = false;
									break;
								}
							}
						}

						if (bExecResult)
						{
							// ׷̵ 
							FormsAuthentication.SignOut();

							bResult = true;
						}
					}
					catch(Exception E)
					{
						throw E;
					}
					finally
					{
						DBUtil.DBConnDispose (ref dbSqlConn);
					}
				}
			}
			catch (Exception E)
			{
				throw E;
			}

			return bResult;
		}

		public static bool RepeatQry(string sQry)
		{
			const string sReplaceStr = "#RepeatTable#";

			bool bResult = false;

			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				if (sQry.IndexOf(sReplaceStr) > -1)
				{
					ArrayList arrObjName = GetObjectName();
					
					string sResultQry = string.Empty;
                    
					foreach (string sNameItem in arrObjName)
					{
						string[] sBoardNo = sNameItem.Split('_');

						sResultQry = sQry.Replace (sReplaceStr, sBoardNo[sBoardNo.Length - 1]);

						SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sResultQry);
					}
				}
				else
				{
					//   ̺ 
					SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sQry);
				}

				bResult = true;
			}
			catch (Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}

			return bResult;
		}



		public static ArrayList GetObjectName()
		{
			ArrayList arrHeaderNameList = new ArrayList();


			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				string sQry = "SELECT [name] FROM sysobjects WHERE xtype = 'U' AND [name] like 'NB_BoardData_%' ORDER BY [name] ASC";

				SqlDataReader drObjName = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, sQry);
                
				while (drObjName.Read())
				{
					arrHeaderNameList.Add (drObjName.GetString(0));
				}
			}
			catch
			{
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}


			return arrHeaderNameList;
		}
		#endregion

		public static bool isSuperAdmin()
		{
			if (NBCmnUtil.GetCookieValue ("NEADMIN_MBNO").Equals(NBLib.SuperAdmin))
				return true;
			else
				return false;
		}

		#region    Ȯ
		public static string[] GetAdminGroup(string sGuestNo)
		{
			string[] arrAdminGroup = null;

			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);
                
				StringWriter Qry = new StringWriter();

				Qry.WriteLine ("SELECT group_code FROM NB_GroupAdminInfo WHERE guest_no = " + DBUtil.QryConvStr (sGuestNo, false) + " ORDER BY group_code ASC");

				DataSet dsGroupList = SqlHelper.ExecuteDataset (dbSqlConn, CommandType.Text, Qry.ToString());

				if (dsGroupList != null)
				{
					DataTable dtGroupList = dsGroupList.Tables[0];

					if (dtGroupList.Rows.Count > 0)
					{
						arrAdminGroup = new string[dtGroupList.Rows.Count];
                                
						for (int i = 0; i < dtGroupList.Rows.Count; i++)
						{
							arrAdminGroup[i] = dtGroupList.Rows[i]["group_code"].ToString();
						}
					}
				}
			}
			catch(Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}

			return arrAdminGroup;
		}

		public static bool ChkGroupAdmin(string sGroupCode)
		{
			bool bResult = false;

			if (NBCmnUtil.GetCookieValue ("NEADMIN_MBNO").Equals (NBLib.SuperAdmin))
			{
				bResult = true;
			}
			else
			{
				SqlConnection dbSqlConn = null;

				try
				{
					DBUtil.DBConnection(ref dbSqlConn);
                
					StringWriter Qry = new StringWriter();

					Qry.WriteLine ("SELECT COUNT(*) FROM NB_GroupAdminInfo WHERE group_code = '" + sGroupCode + "' AND group_admin = '1'");

					int nUse = Convert.ToInt16 (SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, Qry.ToString()));

					if (nUse > 0)
					{
						bResult = true;
					}
				}
				catch(Exception E)
				{
					throw E;
				}
				finally
				{
					DBUtil.DBConnDispose(ref dbSqlConn);
				}                
			}

			return bResult;
		}

		public static bool ChkAdminAuth(string sGroupCode, string sAuthCode)
		{
			bool bResult = false;

			if (NBCmnUtil.GetCookieValue ("NEADMIN_MBNO").Equals (NBLib.SuperAdmin))
			{
				bResult = true;
			}
			else
			{
				SqlConnection dbSqlConn = null;

				try
				{
					DBUtil.DBConnection(ref dbSqlConn);
                
					StringWriter Qry = new StringWriter();

					Qry.WriteLine ("SELECT ");
					Qry.WriteLine ("	COUNT(*)");
					Qry.WriteLine ("FROM NB_GroupAdminInfo a, NB_AuthGroupInfo_Detail b");
					Qry.WriteLine ("WHERE");
					Qry.WriteLine ("	a.allow_authgroup_code = b.authgroup_code AND a.group_code = b.group_code AND ");
					Qry.WriteLine ("	a.group_code LIKE '" + sGroupCode + "%' AND");
					Qry.WriteLine ("	a.guest_no = " + DBUtil.QryConvStr (NBCmnUtil.GetCookieValue ("NEADMIN_MBNO"), false) + " AND");
					Qry.WriteLine ("	b.auth_code = '" + sAuthCode + "' AND");
					Qry.WriteLine ("	b.auth_code NOT IN ");
					Qry.WriteLine ("	(");
					Qry.WriteLine ("		SELECT ");
					Qry.WriteLine ("			d.auth_code ");
					Qry.WriteLine ("		FROM");
					Qry.WriteLine ("			NB_GroupAdminInfo c, NB_AuthGroupInfo_Detail d");
					Qry.WriteLine ("		WHERE");
					Qry.WriteLine ("			c.deny_authgroup_code = d.authgroup_code AND c.group_code = d.group_code AND ");
					Qry.WriteLine ("			c.group_code = a.group_code AND a.guest_no = a.guest_no");
					Qry.WriteLine ("	)");

					int nUse = Convert.ToInt16 (SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, Qry.ToString()));

					if (nUse > 0)
					{
						bResult = true;
					}
				}
				catch(Exception E)
				{
					throw E;
				}
				finally
				{
					DBUtil.DBConnDispose(ref dbSqlConn);
				}
			}

			return bResult;
		}
		#endregion

		public static void DoLoadGroupList(DropDownList ddlGroupCode)
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				//  Խ 
				DataSet dsGroupList = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.GroupList());

				if (dsGroupList != null)
				{
					ddlGroupCode.DataSource = dsGroupList;
					ddlGroupCode.DataTextField = "group_name";
					ddlGroupCode.DataValueField = "group_code";
					ddlGroupCode.DataBind();

					if (ddlGroupCode.Items.Count > 0 && ddlGroupCode.SelectedIndex < 0)
					{
						ddlGroupCode.SelectedIndex = 0;
					}

					if (HttpContext.Current.Request.Cookies["curr_group_code"] != null && !NBUtil.StrEmptyChk (HttpContext.Current.Request.Cookies["curr_group_code"].Value))
						NBCmnUtil.DdlLst_Chk (ddlGroupCode, HttpContext.Current.Request.Cookies["curr_group_code"].Value);
				}
			}
			catch(Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		public static void DoLoadGroupList(ListBox ddlGroupCode)
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				//  Խ 
				DataSet dsGroupList = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.GroupList());

				if (dsGroupList != null)
				{
					ddlGroupCode.DataSource = dsGroupList;
					ddlGroupCode.DataTextField = "group_name";
					ddlGroupCode.DataValueField = "group_code";
					ddlGroupCode.DataBind();

					if (ddlGroupCode.Items.Count > 0 && ddlGroupCode.SelectedIndex < 0)
					{
						ddlGroupCode.SelectedIndex = 0;
					}

					if (HttpContext.Current.Request.Cookies["curr_group_code"] != null && !NBUtil.StrEmptyChk (HttpContext.Current.Request.Cookies["curr_group_code"].Value))
						NBCmnUtil.DdlLst_Chk (ddlGroupCode, HttpContext.Current.Request.Cookies["curr_group_code"].Value);
				}
			}
			catch(Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		public static void DisplayAdminAuth(string sGroupCode, string sGroupRole, ImageButton btnSaveBtn, Panel pnlError)
		{
			//   ˻
			bool bChkAdmin = NBAdminUtil.ChkAdminAuth (sGroupCode, sGroupRole);

			if (btnSaveBtn != null)
                btnSaveBtn.Visible = bChkAdmin;

			if (pnlError != null)
				pnlError.Visible = !bChkAdmin;
		}

		public static bool isAdminLogin()
		{
			bool bResult = false;

			if (!NBUtil.StrEmptyChk(NBCmnUtil.GetCookieValue("NEADMIN_MBNO")) && !NBUtil.StrEmptyChk(NBCmnUtil.GetCookieValue("NEADMIN_ADMINGROUP")))
			{
                return true;
			}

			return bResult;
		}

		public static string GetGroupName(string sGroupCode)
		{
			string sGroupName = string.Empty;

			sGroupName = DBUtil.RunDBToScalar (CommandType.Text, AdminQryLib.GetGroupName(sGroupCode));

			return sGroupName;
		}
	}
}
