using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;

namespace BoardLib
{
	/// <summary>
	/// ü Ʈ  
	/// </summary>
	public class NBCmnUtil
	{
		public NBCmnUtil()
		{
		}

		#region Request.QueryString Ÿ ó
		/// <summary>
		/// Request.QueryString  б
		/// </summary>
		public static string QStrLoad (string s_name)
		{
			string sResult = string.Empty;

			if (!NBUtil.StrEmptyChk (HttpContext.Current.Request.QueryString[s_name]))
				sResult = HttpContext.Current.Request.QueryString[s_name].Trim();

			return sResult;
		}
		#endregion

		#region Request.Form Ÿ ó
		/// <summary>
		/// Request.Form  б
		/// </summary>
		public static string FStrLoad (string s_name)
		{
			string sResult = string.Empty;

			if (!NBUtil.StrEmptyChk (HttpContext.Current.Request.Form[s_name]))
				sResult = HttpContext.Current.Request.Form[s_name].Trim();

			return sResult;
		}
		#endregion


		public static bool ValidChk_Email(string str_email)
		{
			bool bResult = false;

			Regex rexEmail = new Regex(@"^([a-zA-Z0-9_\-\.]+)@([a-zA-Z0-9_\-\.]+)\.([a-zA-Z]{2,5})$");

			if (!rexEmail.IsMatch (str_email))
			{
				bResult = true;
			}

			return bResult;
		}
		
		public static bool ChkBitFlag(string sSrcText, int nFlag)
		{
			bool bResult = false;

			if (!NBUtil.StrEmptyChk (sSrcText))
			{
				if ((int.Parse(sSrcText) & nFlag) == nFlag)
					bResult = true;
			}

			return bResult;
		}

		public static string TextFileRead(string sPath)
		{
			string sFileText = string.Empty;

			if (File.Exists(sPath))
			{
				StreamReader sr = new StreamReader(sPath, Encoding.Default);

				sFileText = sr.ReadToEnd();

				sr.Close();
			}

			return sFileText;
		}

		// ////////////////////////////////////////////////////////////
		// Hashtable ش Ű ԵǾ ִ ˻
		public static bool HsTblKeyExist(Hashtable hsTbl, string sKey)
		{
			bool bResult = false;

			if (hsTbl != null && sKey != null && sKey.Trim().Length != 0)
			{
				if (hsTbl.ContainsKey(sKey))
				{
					if (hsTbl[sKey] != null)
					{
						bResult = true;
					}
				}
			}

			return bResult;
		}

		/// <summary>
		/// DB Table Ͽ TextBox MaxLength  Ѵ.
		/// </summary>
		/// <param name="sTableName"></param>
		/// <param name="objContCols"></param>
		public static void FieldInputValidSetting(string sTableName, ArrayList objContCols)
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				SqlParameter[] dbSqlParm = new SqlParameter[1];

				dbSqlParm[0] = new SqlParameter();
				dbSqlParm[0].ParameterName = "@objname";
				dbSqlParm[0].SqlDbType = SqlDbType.NVarChar;
				dbSqlParm[0].Value = sTableName;				
                				
				DataSet dbDS = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.StoredProcedure, "sp_help", dbSqlParm);

				DataTable dbDT = dbDS.Tables[1];

				if (dbDT.Rows.Count > 0)
				{
					TextBox ctrlTextField;
				
					foreach (DataRow dbDR in dbDT.Rows)
					{
						switch (dbDR["Type"].ToString().ToUpper())
						{
							case "VARCHAR":
								ctrlTextField = (TextBox)FindContolAtID("txt_" + dbDR["Column_name"], objContCols);

								if (ctrlTextField != null)
								{
									ctrlTextField.MaxLength = (int)dbDR["Length"];
								}
								break;
							case "NVARCHAR":
								ctrlTextField = (TextBox)FindContolAtID("txt_" + dbDR["Column_name"], objContCols);

								if (ctrlTextField != null)
								{
									ctrlTextField.MaxLength = (int)dbDR["Length"] / 2;
								}
								break;
						}
					}
				}
			}
			catch(Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		/// <summary>
		/// Ʈ Ե ArrayList ش ID Ʈ ã´.
		/// </summary>
		/// <param name="sID"></param>
		/// <param name="objConts"></param>
		/// <returns></returns>
		public static Control FindContolAtID(string sID, ArrayList objConts)
		{
			Control objResult = null;

			foreach (Control objCont in objConts)
			{
				if ( objCont.ID.Equals(sID) )
				{
					objResult = objCont;
					break;
				}
			}

			return objResult;
		}

		/// <summary>
		///   TextBox Ʈ ȯѴ.
		/// </summary>
		/// <param name="objValidChkCont"></param>
		/// <param name="objConts"></param>
		public static void PageTextBoxControls(ArrayList objValidChkCont, ControlCollection objConts)
		{
			TextBox txtTemp = new TextBox();

			foreach(Control objCont in objConts)
			{
				if (objCont.GetType() == txtTemp.GetType())
				{
					objValidChkCont.Add(objCont);
				}

				if (objCont.Controls != null)
				{
					PageTextBoxControls(objValidChkCont, objCont.Controls);
				}
			}
		}

		public static void DDListDataBind(ref DropDownList objDDList, DataSet ds, string sTblName, string sTextField, string sValueField)
		{
			objDDList.DataSource = ds;
			objDDList.DataTextField = sTextField;
			objDDList.DataValueField = sValueField;
			objDDList.DataBind();
		}

		public static void ChkBox_Chk(CheckBox objCtrl, string chkValue)
		{
			if (chkValue.Length == 0)
			{
				objCtrl.Checked = false;
				return;
			}

			if (chkValue.CompareTo("1") == 0)
			{
				objCtrl.Checked = true;
			}
			else if (chkValue.CompareTo("0") == 0)
			{
				objCtrl.Checked = false;
			}
			else
			{
				objCtrl.Checked = false;
			}				
		}

		public static void ChkBoxList_Chk(CheckBoxList objCtrl, string chkValue)
		{
			if (!NBUtil.StrEmptyChk (chkValue))
			{
				ListItem lstItem = objCtrl.Items.FindByText (chkValue);

				if (lstItem != null)
					lstItem.Selected = true;
			}
		}

		public static void ChkBox_BitChk(CheckBox objCtrl, string chkValue)
		{
			if (chkValue.Length == 0)
			{
				return;
			}

			string[] aObjID = objCtrl.ID.Split('_');

			if (aObjID.Length > 1)
			{
				if (NBUtil.ChkNumType(aObjID[aObjID.Length - 1], 0) && NBUtil.ChkNumType(chkValue, 0))
				{
					int nObjVal = int.Parse (aObjID[aObjID.Length - 1]);
					int nChkVal = int.Parse (chkValue);

					if ((nChkVal & nObjVal) == nObjVal)
					{
						objCtrl.Checked = true;
					}
					else
					{
						objCtrl.Checked = false;
					}
				}
			}
		}

		public static void RdoBtn_Chk(RadioButtonList objCtrl, int chkIdx)
		{
			objCtrl.SelectedIndex = chkIdx;
		}

		public static void RdoBtn_Chk(RadioButtonList objCtrl, string chkValue)
		{
			objCtrl.SelectedIndex = -1;

			if (!NBUtil.StrEmptyChk (chkValue))
			{
				ListItem lstItem = objCtrl.Items.FindByText (chkValue);

				if (lstItem != null)
					lstItem.Selected = true;
			}

			if (objCtrl.SelectedIndex == -1)
				objCtrl.SelectedIndex = 0;
		}

		public static void DdlLst_Chk(DropDownList objCtrl, string chkValue)
		{
			objCtrl.SelectedIndex = -1;

			if (!NBUtil.StrEmptyChk (chkValue))
			{
				ListItem lstItem = objCtrl.Items.FindByValue (chkValue);

				if (lstItem != null)
                    lstItem.Selected = true;
			}

			if (objCtrl.SelectedIndex == -1)
				objCtrl.SelectedIndex = 0;
		}

		public static void DdlLst_Chk(ListBox objCtrl, string chkValue)
		{
			objCtrl.SelectedIndex = -1;

			if (!NBUtil.StrEmptyChk (chkValue))
			{
				ListItem lstItem = objCtrl.Items.FindByValue (chkValue);

				if (lstItem != null)
					lstItem.Selected = true;
			}

			if (objCtrl.SelectedIndex == -1)
				objCtrl.SelectedIndex = 0;
		}

		public static void LstBox_Bind(ListBox objLst, string lstValue)
		{
			if (lstValue.Trim().Length > 0)
			{
				objLst.Items.Clear();

				string[] arrValue = lstValue.Split(';');

				foreach (string sVal in arrValue)
				{
					if (sVal.Trim().Length > 0)
					{
						objLst.Items.Add (new ListItem (sVal, sVal));
					}
				}
			}
		}

		public static void DataTbl_to_Control(DataRow dtBoardCfg, ControlCollection objContCol)
		{
			// TXT, LTR, RDOLST, CHK, DDL

			string sCtrlID;
			string sCtrlPreFix;
			string sFieldName;
			TextBox objTextBox;
			TextBox objNTextBox;
			CheckBox objCheckBox;
			DropDownList objDropDownList;
			RadioButtonList objRdoBtnList;
			ListBox objListBox;
			Literal objLiteral;

			foreach (Control CtrlItem in objContCol)
			{
				if (CtrlItem.ID != null)
				{
					sCtrlID = CtrlItem.ID;

					if (sCtrlID.IndexOf('_') > 0)
					{
						sCtrlPreFix = sCtrlID.Substring(0, sCtrlID.IndexOf('_'));
						sFieldName = sCtrlID.Substring(sCtrlID.IndexOf('_') + 1, sCtrlID.Length - (sCtrlID.IndexOf('_') + 1));


						switch (sCtrlPreFix.ToUpper())
						{
							case "TXT":
							case "OTXT":
								objTextBox = (TextBox)CtrlItem;
								objTextBox.Text = dtBoardCfg[sFieldName].ToString();
								break;
							case "NTXT":
								objNTextBox = (TextBox)CtrlItem;
								objNTextBox.Text = NBUtil.ConvStrToInt(dtBoardCfg[sFieldName].ToString()).ToString();
								break;
							case "LTR":
								objLiteral = (Literal)CtrlItem;
								objLiteral.Text = dtBoardCfg[sFieldName].ToString();
								break;
							case "RDOLST":
								objRdoBtnList = (RadioButtonList)CtrlItem;
								RdoBtn_Chk(objRdoBtnList, NBUtil.ConvStrToInt(dtBoardCfg[sFieldName].ToString()));
								break;
							case "CHK":
								objCheckBox = (CheckBox)CtrlItem;
								ChkBox_Chk(objCheckBox, dtBoardCfg[sFieldName].ToString());
								break;
							case "BITCHK":
								objCheckBox = (CheckBox)CtrlItem;
								sFieldName = sCtrlID.Substring(sCtrlID.IndexOf('_') + 1, (sCtrlID.LastIndexOf('_') - 1) - sCtrlID.IndexOf('_'));
								ChkBox_BitChk(objCheckBox, dtBoardCfg[sFieldName].ToString());
								break;
							case "DDL":
								objDropDownList = (DropDownList)CtrlItem;
								DdlLst_Chk(objDropDownList, dtBoardCfg[sFieldName].ToString());
								break;
							case "LST":
								objListBox = (ListBox)CtrlItem;
								LstBox_Bind(objListBox, dtBoardCfg[sFieldName].ToString());
								break;
						}
					}
				}
			}
		}

		public static void DoControlsEnableChange(ControlCollection objCtrlCol, bool bEnable)
		{
			// TXT, LTR, RDOLST, CHK, DDL, UDDL

			string sCtrlID;
			string sCtrlPreFix;
			string sFieldName;

			TextBox objTextBox;
			CheckBox objCheckBox;
			RadioButtonList objRdoBtnList;
			DropDownList objDropDownList;
			ListBox objListBox;

			foreach (Control CtrlItem in objCtrlCol)
			{
				if (CtrlItem.ID != null)
				{
					sCtrlID = CtrlItem.ID;
					sCtrlPreFix = sCtrlID.Substring(0, sCtrlID.IndexOf('_'));
					sFieldName = sCtrlID.Substring(sCtrlID.IndexOf('_') + 1, sCtrlID.Length - sCtrlID.IndexOf('_') - 1);

					switch (sCtrlPreFix.ToUpper())
					{
						case "TXT":
							objTextBox = (TextBox)CtrlItem;
							objTextBox.Enabled = bEnable;
							break;
						case "NTXT":
							objTextBox = (TextBox)CtrlItem;
                            objTextBox.Enabled = bEnable;
							break;
						case "RDOLST":
							objRdoBtnList = (RadioButtonList)CtrlItem;
							objRdoBtnList.Enabled = bEnable;
							break;
						case "CHK":
							objCheckBox = (CheckBox)CtrlItem;
							objCheckBox.Enabled = bEnable;
							break;
						case "DDL":
						case "UDDL":
							objDropDownList = (DropDownList)CtrlItem;
							objDropDownList.Enabled = bEnable;
							break;
						case "LST":
							objListBox = (ListBox)CtrlItem;
							objListBox.Enabled = bEnable;
							break;
					}
				}
			}
		}

		public static ArrayList GetUpdateFields(ControlCollection objCtrlCol)
		{
			// TXT, LTR, RDOLST, CHK, DDL, UDDL

			ArrayList UpdateLists = new ArrayList();

			string sCtrlID;
			string sCtrlPreFix;
			string sFieldName;

			TextBox objTextBox;
			CheckBox objCheckBox;
			RadioButtonList objRdoBtnList;
			DropDownList objDropDownList;
			ListBox objListBox;

			foreach (Control CtrlItem in objCtrlCol)
			{
				if (CtrlItem.ID != null)
				{
					sCtrlID = CtrlItem.ID;
					sCtrlPreFix = sCtrlID.Substring(0, sCtrlID.IndexOf('_'));
					sFieldName = sCtrlID.Substring(sCtrlID.IndexOf('_') + 1, sCtrlID.Length - sCtrlID.IndexOf('_') - 1);

					switch (sCtrlPreFix.ToUpper())
					{
						case "TXT":
							objTextBox = (TextBox)CtrlItem;
							UpdateLists.Add(DBUtil.InsertParamItem(sFieldName, NBLib.FieldQryType.Char, objTextBox.Text));
							break;
						case "NTXT":
							objTextBox = (TextBox)CtrlItem;

							if (objTextBox.Text.Trim().Length > 0)
							{
								if (NBUtil.ChkNumType (objTextBox.Text, 0))
								{
									UpdateLists.Add(DBUtil.InsertParamItem(sFieldName, NBLib.FieldQryType.Num, objTextBox.Text));
								}
								else
								{
									throw new Exception(@"ڷ Էؾ ʵ忡 ڰ ԷµǾ ֽϴ.\n\nٽѹ Ȯ ּ.");
									// UpdateLists.Add(DBUtil.InsertParamItem(sFieldName, NBLib.FieldQryType.Num, "0"));
								}
							}
							else
							{
								UpdateLists.Add(DBUtil.InsertParamItem(sFieldName, NBLib.FieldQryType.Num, "0"));
							}
							
							break;
						case "RDOLST":
							objRdoBtnList = (RadioButtonList)CtrlItem;
							UpdateLists.Add(DBUtil.InsertParamItem(sFieldName, NBLib.FieldQryType.Char, objRdoBtnList.SelectedValue));
							break;
						case "CHK":
							objCheckBox = (CheckBox)CtrlItem;
							if (objCheckBox.Checked)
								UpdateLists.Add(DBUtil.InsertParamItem(sFieldName, NBLib.FieldQryType.Char, "1"));
							else
								UpdateLists.Add(DBUtil.InsertParamItem(sFieldName, NBLib.FieldQryType.Char, "0"));
							break;
						case "DDL":
						case "UDDL":
							objDropDownList = (DropDownList)CtrlItem;
							UpdateLists.Add(DBUtil.InsertParamItem(sFieldName, NBLib.FieldQryType.Char, objDropDownList.SelectedValue));
							break;
						case "LST":
							objListBox = (ListBox)CtrlItem;
							UpdateLists.Add(DBUtil.InsertParamItem(sFieldName, NBLib.FieldQryType.Char, GetListItemToStr(objListBox)));
							break;
					}
				}
			}

			return UpdateLists;
		}

		public static string GetListItemToStr(ListBox objLstBox)
		{
			string sResult = string.Empty;

			if (objLstBox.Items.Count > 0)
			{
				foreach (ListItem lstItem in objLstBox.Items)
				{
					sResult += lstItem.Value + ";";
				}
			}

			return sResult;
		}

		public static void GetDesignTagReplace (ref StringBuilder sbSrcTxt, string sStartStr, string sEndStr, string sReplace)
		{
			if ( !NBUtil.StrEmptyChk(sbSrcTxt.ToString()) && !NBUtil.StrEmptyChk(sStartStr) && !NBUtil.StrEmptyChk(sEndStr) )
			{
				Regex rEx = new Regex(sStartStr + @"[\s\S]*?" + sEndStr);

				Match rMc = rEx.Match(sbSrcTxt.ToString().Replace("\\", "\\\\"));

                if ( rMc.Success )
                {
					sbSrcTxt = sbSrcTxt.Replace(rMc.Value, sReplace);
                }

				
			}
		}

		public static void GetDesignTagReplace (ref string sSrcTxt, string sStartStr, string sEndStr, string sReplace)
		{
			if ( !NBUtil.StrEmptyChk(sSrcTxt) && !NBUtil.StrEmptyChk(sStartStr) && !NBUtil.StrEmptyChk(sEndStr) )
			{
				Regex rEx = new Regex(sStartStr + @"[\s\S]*?" + sEndStr);

				Match rMc = rEx.Match(sSrcTxt.Replace("\\", "\\\\"));

				if ( rMc.Success )
				{
					sSrcTxt = sSrcTxt.Replace(rMc.Value, sReplace);
				}

				
			}
		}

		public static string GetDesignTag_Str (string sSrcTxt, string sStartStr, string sEndStr)
		{
			string sResult = string.Empty;

			if ( !NBUtil.StrEmptyChk(sSrcTxt) && !NBUtil.StrEmptyChk(sStartStr) && !NBUtil.StrEmptyChk(sEndStr) )
			{
				Regex rEx = new Regex(sStartStr + @"[\s\S]*?" + sEndStr);

				Match rMc = rEx.Match(sSrcTxt.Replace("\\", "\\\\"));

				if ( rMc.Success )
				{
					sResult = rMc.Value;
				}
			}

			return sResult;
		}

		public static MatchCollection GetDesignTag_McColl (string sSrcTxt, string sStartStr, string sEndStr)
		{
			MatchCollection mcResult = null;

			if ( !NBUtil.StrEmptyChk(sSrcTxt) && !NBUtil.StrEmptyChk(sStartStr) && !NBUtil.StrEmptyChk(sEndStr) )
			{
				Regex rEx = new Regex(sStartStr + @"[\s\S]*?" + sEndStr);

				MatchCollection rMcColl = rEx.Matches(sSrcTxt.Replace("\\", "\\\\"));

				if ( rMcColl.Count > 0 )
				{
					mcResult = rMcColl;
				}
			}

			return mcResult;
		}

		public static string ByteToKB_Format(int nFileSize)
		{
            string sResult = string.Empty;

			double nConvSize = Math.Round((Convert.ToDouble(nFileSize) / 1024.0), 1);

			sResult = nConvSize.ToString("#,##0.0#");
			
			return sResult;
		}

		



		#region Ű ó
		/// <summary>
		/// Ű  о 
		/// </summary>
		/// <param name="sCookieName"></param>
		/// <returns></returns>
		public static string GetCookieValue(string sCookieName)
		{
			string sResult = string.Empty;

			if (HttpContext.Current.Request.Cookies[sCookieName] != null)
			{
				sResult = HttpContext.Current.Request.Cookies[sCookieName].Value;
			}

			//Ű ڵ
			sResult = HttpContext.Current.Server.UrlDecode(sResult);

			return sResult;
		}

		/// <summary>
		/// Ű 
		/// </summary>
		/// <param name="cooki_id"></param>
		/// <param name="cooki_value"></param>
		/// <param name="cooki_expires"></param>
		public static void SaveCookiValue(string cooki_id, string cooki_value, double exp_min)
		{
			//Ű ڵ
			cooki_value = HttpContext.Current.Server.UrlEncode(cooki_value);
			
			HttpCookie objCooki = new HttpCookie(cooki_id, cooki_value);

			if (exp_min > 0.0)
                objCooki.Expires = DateTime.Now.AddMinutes (exp_min);
			HttpContext.Current.Response.Cookies.Add (objCooki);
		}

		/// <summary>
		/// Ű 
		/// </summary>
		/// <param name="cooki_id"></param>
		public static void RemoveCookiValue(string cooki_id)
		{
            HttpContext.Current.Response.Cookies[cooki_id].Expires = DateTime.Now.AddDays(-1);			
		}

		/// <summary>
		/// Ű  ִ üũ
		/// </summary>
		/// <param name="objCooki"></param>
		/// <returns></returns>
		public static bool CookiNullChk(HttpCookie objCooki)
		{
			bool bResult = false;

			if (objCooki == null)
				bResult = true;				
			else
			{
				if (objCooki.Value.Trim().Length == 0)
					bResult = true;
			}

			return bResult;
		}
		#endregion

		#region ũƮ ˸ ޽  Լ
		// ////////////////////////////////////////////////
		// ڹٽũƮ  ޽   Ŀ µ 
		public static string sClientScriptMsgReplace(string sMsg)
		{
			string sResult = sMsg.Replace("'", "\'").Replace("\"", "\\\"").Replace("\r\n", "\\n");

			return sResult;
		}

		// ////////////////////////////////////////////////
		// ˸ ޽ 
		public static void ViewAlertMsg(Page oPage, string sMsg)
		{
            StringWriter swScript = new StringWriter();

			swScript.WriteLine ("<script language=\"javascript\">");
			swScript.WriteLine ("<!--");
			swScript.WriteLine ("	alert (\"" + sClientScriptMsgReplace(sMsg) + "\");");
			swScript.WriteLine ("//-->");
			swScript.WriteLine ("</script>");

			// oPage.Response.Write (swScript.ToString());

			oPage.RegisterStartupScript ("errAlert", swScript.ToString());
		}

		// ////////////////////////////////////////////////
		// ۼ  Ŭ忡 ϰ ޽ 
		public static void ViewMsgAndCopy(Page oPage, string sMsg, string sTarID)
		{
			StringWriter swScript = new StringWriter();

			swScript.WriteLine ("<script language=\"javascript\">");
			swScript.WriteLine ("<!--");
			swScript.WriteLine ("	ClipBoardCopy ('" + sTarID + "'); ");
			swScript.WriteLine ("	alert (\"" + sClientScriptMsgReplace(sMsg) + "\"); ");
			swScript.WriteLine ("//-->");
			swScript.WriteLine ("</script>");

			oPage.RegisterStartupScript ("errAlert", swScript.ToString());
		}

		// ////////////////////////////////////////////////
		// ˸ ޽ ϰ   ̵
		public static void ViewMsgGoBack(Page oPage, string sMsg)
		{
			StringWriter swScript = new StringWriter();

			swScript.WriteLine ("<script language=\"javascript\">");
			swScript.WriteLine ("<!--");
			if ( !NBUtil.StrEmptyChk(sMsg) )
				swScript.WriteLine ("	alert (\"" + sClientScriptMsgReplace(sMsg) + "\");");
			swScript.WriteLine ("	history.back();");
			swScript.WriteLine ("//-->");
			swScript.WriteLine ("</script>");

			oPage.RegisterStartupScript ("errAlert", swScript.ToString());
		}

		// ////////////////////////////////////////////////
		// ˸ ޽ ϰ   ̵
		public static void ViewMsgAndClose(Page oPage, string sMsg)
		{
			StringWriter swScript = new StringWriter();

			swScript.WriteLine ("<script language=\"javascript\">");
			swScript.WriteLine ("<!--");
			if ( !NBUtil.StrEmptyChk(sMsg) )
				swScript.WriteLine ("	alert (\"" + sClientScriptMsgReplace(sMsg) + "\");");
			swScript.WriteLine ("	self.close();");
			swScript.WriteLine ("//-->");
			swScript.WriteLine ("</script>");

			oPage.RegisterStartupScript ("errAlert", swScript.ToString());
		}

		// ////////////////////////////////////////////////
		// ˸ ޽ ϰ θ  ε  ڽ  ݱ(ɼ)
		public static void ViewMsgOpenerReLoad(Page oPage, string sMsg, bool bClose)
		{
			StringWriter swScript = new StringWriter();

			swScript.WriteLine ("<script language=\"javascript\">");
			swScript.WriteLine ("<!--");
			if ( !NBUtil.StrEmptyChk(sMsg) )
				swScript.WriteLine ("	alert (\"" + sClientScriptMsgReplace(sMsg) + "\");");
			swScript.WriteLine ("");
			swScript.WriteLine ("	if (self.opener) ");
			swScript.WriteLine ("	{ ");
			swScript.WriteLine ("		self.opener.top.location.reload(); ");
			swScript.WriteLine ("	} ");
			swScript.WriteLine ("");
			if (bClose)
                swScript.WriteLine ("	self.close(); ");
			swScript.WriteLine ("//-->");
			swScript.WriteLine ("</script>");

			oPage.RegisterStartupScript ("errAlert", swScript.ToString());
		}

		// ////////////////////////////////////////////////
		// ˸ ޽ ϰ θ  ε  ڽ  ݱ(ɼ)
		public static void ViewMsgOpenerReLoadUrl(Page oPage, string sMsg, bool bClose, string sUrl)
		{
			StringWriter swScript = new StringWriter();

			swScript.WriteLine ("<script language=\"javascript\">");
			swScript.WriteLine ("<!--");
			if ( !NBUtil.StrEmptyChk(sMsg) )
				swScript.WriteLine ("	alert (\"" + sClientScriptMsgReplace(sMsg) + "\");");
			swScript.WriteLine ("");
			swScript.WriteLine ("	if (self.opener) ");
			swScript.WriteLine ("	{ ");
			swScript.WriteLine ("		self.opener.top.location.replace('" + sUrl + "');");
			swScript.WriteLine ("	} ");
			swScript.WriteLine ("");
			if (bClose)
				swScript.WriteLine ("	self.close(); ");
			swScript.WriteLine ("//-->");
			swScript.WriteLine ("</script>");

			oPage.RegisterStartupScript ("errAlert", swScript.ToString());
		}

		public static void ViewMsgGoUrl(Page oPage, string sUrl, string sMsg)
		{
			StringWriter swScript = new StringWriter();

			swScript.WriteLine ("<script language=\"javascript\">");
			swScript.WriteLine ("<!--");
			
			if ( !NBUtil.StrEmptyChk(sMsg) )
				swScript.WriteLine ("	alert (\"" + sClientScriptMsgReplace(sMsg) + "\"); ");

			if ( !NBUtil.StrEmptyChk(sUrl) )
				swScript.WriteLine ("	location.href=\"" + sUrl + "\"; ");

			swScript.WriteLine ("//-->");
			swScript.WriteLine ("</script>");

			oPage.RegisterStartupScript ("errAlert", swScript.ToString());		
		}
		#endregion

	}
}
