----------------------------------------------------
-- ü ̸	: nbsp_get_boardlist
-- Ķ		: 
-- 		:
-- 		:
----------------------------------------------------
CREATE PROCEDURE nbsp_get_boardlist ( @group_code VARCHAR(3) )
AS
	SET NOCOUNT ON

	SELECT
		board_no, board_name 
	FROM
		NB_BoardSet 
	WHERE
		board_no LIKE @group_code + '%'
	ORDER BY
		board_no ASC
	
	
	
----------------------------------------------------
-- ü ̸	: nbsp_get_catname_list
-- Ķ		: 
-- 		:
-- 		:
----------------------------------------------------
CREATE PROCEDURE nbsp_get_catname_list ( @board_no VARCHAR(6) )
AS
	SET NOCOUNT ON

	SELECT
		cat_code, cat_name
	FROM
		NB_CategoryData
	WHERE
		board_no = @board_no
	ORDER BY
		cat_code ASC



----------------------------------------------------
-- ü ̸	: nbsp_sel_boardlist_001001
-- Ķ		: @idxno (Խù ε)
-- 		: 2004.11.13
-- 		: 2005.04.27
----------------------------------------------------
CREATE PROCEDURE nbsp_sel_boardlist_001001 
					(					
						@row_cnt INT, 
						@page_num INT,
						@agree_yn VARCHAR(1),
						@cat_code VARCHAR(2),
						@notice_yn VARCHAR(1),
						@private_yn VARCHAR(1),
						@level_no2 VARCHAR(3),
						@writer VARCHAR(20),
						@subject VARCHAR(200),
						@content VARCHAR(200)
					)
AS
	SET NOCOUNT ON

	DECLARE @tmp_cnt INT
	DECLARE @tbl_not_in_idx TABLE(idx_no INT)

	--------------------------------------------
	-- NOT IN idx_no READ
	SET @tmp_cnt = (@page_num - 1) * @row_cnt

	IF @tmp_cnt > 0
	BEGIN
		SET ROWCOUNT @tmp_cnt
		
		INSERT INTO @tbl_not_in_idx 
			SELECT
				idx_no
			FROM
				NB_BoardData_001001
			WHERE 
				ISNULL(agree_yn, '0') LIKE @agree_yn + '%' AND
				ISNULL(cat_code, '0') LIKE @cat_code + '%' AND
				ISNULL(notice_yn, '0') LIKE @notice_yn + '%' AND
				ISNULL(private_yn, '0') LIKE @private_yn + '%' AND
				CONVERT(VARCHAR(3), level_no2) LIKE @level_no2 + '%' AND
				(
					(writer LIKE @writer AND LEN(@writer) > 0) OR 
					(subject LIKE @subject AND LEN(@subject) > 0) OR 
					(content LIKE @content AND LEN(@content) > 0)
				)
			ORDER BY
				notice_yn DESC, ref_no DESC, level_no2 ASC, level_no1 ASC
	END

	--------------------------------------------
	-- BOARD LIST READ
	SET ROWCOUNT @row_cnt
	
	SELECT
		a.idx_no, a.guest_no, a.writer, a.email, a.homepage, a.writer_ip, a.write_date,
		a.cat_code, a.subject, a.content, a.html_use, a.pwd, a.vote_yn, a.vote_start,
		a.vote_end, a.hit_cnt, a.good_cnt, a.ref_no, a.level_no1, a.level_no2, a.replymail_yn, 
		a.private_yn, a.notice_yn, a.agree_yn, a.link1, a.link2, isnull(b.cmmt_cnt,0) as cmmt_cnt, 
		ISNULL(c.nick_name, '') as nick_name, ISNULL(c.mem_name, '') as mem_name,
		ISNULL(c.mempic_name, '') as mempic_name, d.cat_name 
	FROM
		NB_BoardData_001001 a,
		(SELECT idx_no, count(cmmt_idx) AS cmmt_cnt FROM NB_CommentData_001001 GROUP BY idx_no) b,
		NB_MemberData c,
		NB_CategoryData d
	WHERE
		a.idx_no *= b.idx_no AND
		a.guest_no *= c.guest_no AND 
		a.cat_code *= d.cat_code AND
		d.board_no = '001001' AND
		ISNULL(a.agree_yn, '0') LIKE @agree_yn + '%' AND
		ISNULL(a.cat_code, '0') LIKE @cat_code + '%' AND
		ISNULL(a.notice_yn, '0') LIKE @notice_yn + '%' AND
		ISNULL(a.private_yn, '0') LIKE @private_yn + '%' AND
		CONVERT(VARCHAR(3), a.level_no2) LIKE @level_no2 + '%' AND
		(		
			(a.writer LIKE @writer AND LEN(@writer) > 0) OR 
			(a.subject LIKE @subject AND LEN(@subject) > 0) OR 
			(a.content LIKE @content AND LEN(@content) > 0)
		) AND
		a.idx_no NOT IN (SELECT idx_no FROM @tbl_not_in_idx) 
	ORDER BY
		a.notice_yn DESC, a.ref_no DESC, a.level_no2 ASC, a.level_no1 ASC 




----------------------------------------------------
-- ü ̸	: nbsp_get_listcnt_001001
-- Ķ		: @idxno (Խù ε)
-- 		: 2004.11.13
-- 		: 2005.04.27
----------------------------------------------------
CREATE PROCEDURE nbsp_get_listcnt_001001
					(					
						@agree_yn VARCHAR(1),
						@cat_code VARCHAR(2),
						@notice_yn VARCHAR(1),
						@private_yn VARCHAR(1),
						@level_no2 VARCHAR(3),
						@writer VARCHAR(20),
						@subject VARCHAR(200),
						@content VARCHAR(200)
					)
AS
	SET NOCOUNT ON

	SELECT
		COUNT(*)
	FROM
		NB_BoardData_001001
	WHERE 
		ISNULL(agree_yn, '0') LIKE @agree_yn + '%' AND
		ISNULL(cat_code, '0') LIKE @cat_code + '%' AND
		ISNULL(notice_yn, '0') LIKE @notice_yn + '%' AND
		ISNULL(private_yn, '0') LIKE @private_yn + '%' AND
		CONVERT(VARCHAR(3), level_no2) LIKE @level_no2 + '%' AND
		(
			(writer LIKE @writer AND LEN(@writer) > 0) OR 
			(subject LIKE @subject AND LEN(@subject) > 0) OR
			(content LIKE @content AND LEN(@content) > 0)
		)
		


----------------------------------------------------
-- ü ̸	: nbsp_get_cmmtdata_001001
-- Ķ		: @idxno (Խù ε)
-- 		: 2004.11.13
-- 		: 2004.11.13
----------------------------------------------------
CREATE PROCEDURE nbsp_get_cmmtdata_001001
					(					
						@idx_no INT
					)
AS
	SET NOCOUNT ON
	
	SELECT
		a.idx_no, a.cmmt_idx, a.guest_no, a.writer_name, a.writer_ip, a.pwd,
		a.write_date, a.cmmt_cont, b.mempic_name
	FROM
		NB_CommentData_001001 a, NB_MemberData b
	WHERE
		a.idx_no = @idx_no AND a.guest_no *= b.guest_no
		
		
		
----------------------------------------------------
-- ü ̸		: nbsp_sel_filedata_001001
-- Ķ		: @idxno (Խù ε)
-- 		: ȣ
-- ̸		: potato@dotnetpia.co.kr
-- 		: 2004.11.13
-- 		: 2004.11.13
-- 			: NB_FileData_001001 ̺ Selete
----------------------------------------------------

CREATE PROCEDURE nbsp_sel_filedata_001001
					(
						@idx_no INT
					)
AS
	SET NOCOUNT ON

	SELECT
		idx_no, fidx_no, file_name, file_ext, file_down, file_size, file_desc
	FROM
		NB_FileData_001001
	WHERE
		idx_no = @idx_no
	ORDER BY fidx_no ASC





----------------------------------------------------
-- ü ̸	: nbsp_pre_next_cont_001001
-- Ķ		: @idxno (Խù ε)
-- 		: ȣ
-- ̸		: potato@dotnetpia.co.kr
-- 		: 2004.11.13
-- 		: 2004.11.13
-- 			: NB_FileData_001001 ̺ Selete
----------------------------------------------------

CREATE PROCEDURE nbsp_pre_next_cont_001001
					(
						@curr_num INT
					)
AS
	SET NOCOUNT ON

	DECLARE
		@pre_idx INT,
		@pre_subject VARCHAR(200),
		@next_idx INT,
		@next_subject VARCHAR(200)

	SELECT TOP 1
		@pre_idx = idx_no, 
		@pre_subject = subject 
	FROM
		NB_BoardData_001001
	WHERE
		notice_yn = '0' AND
		ref_no < @curr_num
	ORDER BY
		ref_no DESC, level_no2 ASC

	SELECT TOP 1
		@next_idx = idx_no,
		@next_subject = subject
	FROM
		NB_BoardData_001001
	WHERE
		notice_yn = '0' AND
		ref_no > @curr_num
	ORDER BY
		ref_no ASC, level_no2 ASC

	SELECT
		@pre_idx AS pre_idx, @pre_subject AS pre_subject,
		@next_idx AS next_idx, @next_subject AS next_subject





----------------------------------------------------
-- ü ̸	: nbsp_cmmt_insert_001001
-- Ķ		: @idxno (Խù ε)
-- 		: 2004.11.13
-- 		: 2004.11.13
----------------------------------------------------
CREATE PROCEDURE nbsp_cmmt_insert_001001
					(
						@idx_no INT,
						@guest_no CHAR(6),
						@writer_name VARCHAR(20),
						@writer_ip VARCHAR(20),
						@pwd VARCHAR(20),
						@cmmt_cont NTEXT
					)
AS
	DECLARE @new_cmmt_idx INT

	SELECT 
		@new_cmmt_idx = isNull(max(cmmt_idx), 0) + 1 
	FROM NB_CommentData_001001

	INSERT INTO NB_CommentData_001001
		(idx_no, cmmt_idx, guest_no, writer_name, pwd, writer_ip, write_date, cmmt_cont)
	VALUES
	(
		@idx_no,
		@new_cmmt_idx,
		@guest_no,
		@writer_name,
		@pwd,
		@writer_ip,
		GETDATE(),
		@cmmt_cont
	)
		
		
		
----------------------------------------------------
-- ü ̸	: nbsp_get_board_mail_data_001001
-- Ķ		: @idxno (Խù ε)
-- 		: 2004.11.13
-- 		: 2004.11.13
----------------------------------------------------
CREATE PROCEDURE nbsp_get_board_mail_data_001001
					(
						@idx_no INT
					)
AS
	SET NOCOUNT ON

	SELECT
		email, subject, write_date, cmmtmail_yn 
	FROM
		NB_BoardData_001001
	WHERE
		idx_no = @idx_no
		
		
		
----------------------------------------------------
-- ü ̸	: nbsp_do_board_recommend_001001
-- Ķ		: @idxno (Խù ε)
-- 		: 2004.11.13
-- 		: 2004.11.13
----------------------------------------------------
CREATE PROCEDURE nbsp_do_board_recommend_001001
					(
						@idx_no INT
					)
AS
	UPDATE NB_BoardData_001001 SET
		good_cnt = isnull(good_cnt,0) + 1
	WHERE idx_no = @idx_no
	
	
	

----------------------------------------------------
-- ü ̸	: nbsp_write_boarddata_001001
-- Ķ		: @idxno (Խù ε)
-- 		: ȣ
-- ̸		: potato@dotnetpia.co.kr
-- 		: 2004.11.13
-- 		: 2004.11.13
-- 			: Խ Ÿ   Ѵ.
----------------------------------------------------
CREATE PROCEDURE nbsp_write_boarddata_001001
					(
						@new_idx_no INT,					
						@reply_yn CHAR(1),
						@curr_ref_no INT,
						@curr_level_no2 INT,

						@guest_no CHAR(6),
						@writer VARCHAR(20),
						@email varchar(100),
						@homepage VARCHAR(150),
						@writer_ip VARCHAR(20),
						@cat_code CHAR(2),
						@subject VARCHAR(200),
						@content NTEXT,
						@html_use CHAR(1),
						@pwd VARCHAR(20),
						@level_no1 INT,
						@level_no2 INT,
						@replymail_yn CHAR(1),
						@private_yn CHAR(1),
						@notice_yn CHAR(1),
						@agree_yn CHAR(1),
						@link1 VARCHAR(150),
						@link2 VARCHAR(150),
						@cmmtmail_yn CHAR(1),
						@vote_yn CHAR(1),
						@vote_start VARCHAR(20),
						@vote_end VARCHAR(20),
						@vote_disp_type CHAR(1),
						@sum_yn CHAR(1),
						@sum_content CHAR(1),
						@sum_html_use char(1)
					)

AS
	DECLARE
		@ref_no INT

	BEGIN TRAN

	-- level_no2 UPDATE, ref_no LOAD
	IF @reply_yn = '1'
		BEGIN
			UPDATE NB_BoardData_001001 SET
				level_no2 = level_no2 + 1
			WHERE
				ref_no = @curr_ref_no AND
				level_no2 > @curr_level_no2
			
			SET @ref_no = @curr_ref_no
		END
	ELSE
		BEGIN
			SELECT @ref_no = ISNULL(MAX(ref_no), 0) + 1 FROM NB_BoardData_001001
		END
	
	-- INPUT DATA INSERT
	INSERT INTO NB_BoardData_001001
	(
		idx_no,	guest_no, writer, email, homepage, writer_ip, write_date, cat_code, 
		subject, content, html_use, pwd, hit_cnt, good_cnt, ref_no, level_no1, level_no2, 
		replymail_yn, cmmtmail_yn, agree_yn, private_yn, notice_yn, link1, link2, vote_yn,
		vote_start, vote_end, vote_disp_type, sum_yn, sum_content, sum_html_use 
	)
	VALUES
	(
		@new_idx_no,
		@guest_no,
		@writer,
		@email,
		@homepage,
		@writer_ip,
		GETDATE(),
		@cat_code,
		@subject,
		@content,
		@html_use,
		@pwd,
		0,
		0,
		@ref_no,
		@level_no1,
		@level_no2,
		@replymail_yn,
		@cmmtmail_yn,
		@agree_yn,
		@private_yn,
		@notice_yn,
		@link1,
		@link2,
		@vote_yn,
		@vote_start,
		@vote_end,
		@vote_disp_type,
		@sum_yn,
		@sum_content,
		@sum_html_use
	)
	
	IF @@ERROR <> 0
		BEGIN
			ROLLBACK TRAN
		END
	ELSE
		BEGIN
			COMMIT TRAN
		END


		
----------------------------------------------------
-- ü ̸	: nbsp_get_new_idx_001001
-- Ķ		: @idxno (Խù ε)
-- 		: 2004.11.13
-- 		: 2004.11.13
----------------------------------------------------
CREATE PROCEDURE nbsp_get_new_idx_001001
AS
	SET NOCOUNT ON

	-- NEW idx_no LOAD
	SELECT ISNULL(MAX(idx_no), 0) + 1 FROM NB_BoardData_001001
	
	


----------------------------------------------------
-- ü ̸	: nbsp_update_filedata_001001
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------

CREATE PROCEDURE nbsp_update_filedata_001001
(
@idx_no INT,
@fidx_no INT,
@file_name VARCHAR(30),
@file_ext VARCHAR(30),
@file_size INT,
@file_desc VARCHAR(150),
@file_chg CHAR(1)
)
AS
	IF EXISTS (SELECT * FROM NB_FileData_001001 WHERE idx_no = @idx_no AND fidx_no = @fidx_no)
		BEGIN
			UPDATE NB_FileData_001001 SET 
				file_name = @file_name,
				file_ext = @file_ext,
				file_size = @file_size,
				file_down = (CASE @file_chg WHEN '1' THEN 0 WHEN '0' THEN file_down END),
				file_desc = @file_desc
			WHERE idx_no = @idx_no AND fidx_no = @fidx_no
		END
	ELSE
		BEGIN
			INSERT NB_FileData_001001
				(idx_no, fidx_no, file_name, file_ext, file_size, file_down, file_desc)
			VALUES 
			(
				@idx_no,
				@fidx_no,
				@file_name,
				@file_ext,
				@file_size,
				0,
				@file_desc
			)
		END
		
		
		
		
		
----------------------------------------------------
-- ü ̸	: nbsp_alert_mail_data_001001
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------

CREATE PROCEDURE nbsp_alert_mail_data_001001
					(
						@idx_no INT
					)
AS
	SET NOCOUNT ON

	SELECT
		email, subject, write_date, replymail_yn
	FROM
		NB_BoardData_001001
	WHERE
		idx_no = @idx_no
		
		
		
		
		
----------------------------------------------------
-- ü ̸	: nbsp_ref_content_001001
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------

CREATE PROCEDURE nbsp_ref_content_001001
					(
						@idx_no INT
					)
AS
	SET NOCOUNT ON

	SELECT
		pwd, cat_code, private_yn, notice_yn, vote_yn, content, subject, ref_no, level_no1, level_no2
	FROM
		NB_BoardData_001001
	WHERE idx_no = @idx_no
	
	
	
	
	
----------------------------------------------------
-- ü ̸	: nbsp_board_data_all_001001
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------

CREATE PROCEDURE nbsp_board_data_all_001001
					(
						@idx_no INT
					)
AS
	SET NOCOUNT ON

	SELECT
		idx_no, guest_no, writer, email, homepage, writer_ip, write_date,
		cat_code, subject, content, html_use, pwd, hit_cnt, good_cnt, ref_no,
		level_no1, level_no2, replymail_yn, private_yn, notice_yn, agree_yn,
		link1, link2, cmmtmail_yn, vote_yn, vote_start, vote_end, vote_disp_type,
		sum_yn, sum_content, sum_html_use
	FROM
		NB_BoardData_001001
	WHERE
		idx_no = @idx_no
		
		
		
		
		
----------------------------------------------------
-- ü ̸	: nbsp_get_vote_content_001001
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------

CREATE PROCEDURE nbsp_get_vote_content_001001
					(
						@idx_no INT
					)
AS
	SET NOCOUNT ON

	SELECT 
		vote_yn, content 
	FROM 
		NB_BoardData_001001
	WHERE
		idx_no = @idx_no
		
		
		
		
----------------------------------------------------
-- ü ̸	: nbsp_get_board_pwd_001001
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------

CREATE PROCEDURE nbsp_get_board_pwd_001001
					(
						@idx_no INT
					)
AS
	SET NOCOUNT ON

	SELECT
		pwd
	FROM
		NB_BoardData_001001
	WHERE
		idx_no = @idx_no
		
		
		
		
----------------------------------------------------
-- ü ̸		: nbsp_update_boarddata_001001
-- Ķ		: @idxno (Խù ε)
-- 		: ȣ
-- ̸		: potato@dotnetpia.co.kr
-- 		: 2004.11.13
-- 		: 2004.11.13
-- 			: Խ Ÿ   Ѵ.
----------------------------------------------------

CREATE PROCEDURE nbsp_update_boarddata_001001
(					
@idx_no CHAR(6),
@writer VARCHAR(20),
@email varchar(100),
@homepage VARCHAR(150),
@writer_ip VARCHAR(20),
@cat_code CHAR(2),
@subject VARCHAR(200),
@content NTEXT,
@html_use CHAR(1),
@replymail_yn CHAR(1),
@private_yn CHAR(1),
@notice_yn CHAR(1),
@link1 VARCHAR(150),
@link2 VARCHAR(150),
@cmmtmail_yn CHAR(1),
@vote_yn CHAR(1),
@vote_start VARCHAR(20),
@vote_end VARCHAR(20),
@vote_disp_type CHAR(1),
@sum_yn CHAR(1),
@sum_content NTEXT,
@sum_html_use CHAR(1)
)

AS
	DECLARE
		@ref_no INT,
		@new_idx_no INT

	BEGIN TRAN

	UPDATE NB_BoardData_001001 SET
		writer = @writer,
		homepage = @homepage,
		writer_ip = @writer_ip,
		subject = @subject,
		content = @content,
		html_use = @html_use,
		replymail_yn = @replymail_yn,
		cmmtmail_yn = @cmmtmail_yn,
		private_yn = @private_yn,
		notice_yn = @notice_yn,
		vote_yn = @vote_yn,
		vote_start = @vote_start,
		vote_end = @vote_end,
		vote_disp_type = @vote_disp_type,
		cat_code = @cat_code,
		link1 = @link1,
		link2 = @link2,
		sum_yn = @sum_yn,
		sum_content = @sum_content,
		sum_html_use = @sum_html_use
	WHERE idx_no = @idx_no
	
	IF @@ERROR <> 0
		BEGIN
			ROLLBACK TRAN
		END
	ELSE
		BEGIN
			COMMIT TRAN
		END
		
		
		
		
		
----------------------------------------------------
-- ü ̸	: nbsp_writer_guest_no_001001
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------

CREATE PROCEDURE nbsp_writer_guest_no_001001
					(
						@idx_no INT
					)
AS
	SET NOCOUNT ON

	SELECT
		ISNULL(guest_no, '') AS guest_no
	FROM
		NB_BoardData_001001
	WHERE
		idx_no = @idx_no

		


----------------------------------------------------
-- ü ̸	: nbsp_do_login_data
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------

CREATE PROCEDURE nbsp_do_login_data
					(
						@mem_id VARCHAR(15),
						@mem_pwd VARCHAR(20)						
					)
AS
	SET NOCOUNT ON

	SELECT
		guest_no, mem_id, mem_email, homepage, mem_name, user_enable 
	FROM
		NB_MemberData 
	WHERE
		mem_id = @mem_id AND
		mem_pwd = @mem_pwd
		
		
		
		
----------------------------------------------------
-- ü ̸	: nbsp_get_joinitem_cfg
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		: 2005.04.27
----------------------------------------------------

CREATE PROCEDURE nbsp_get_joinitem_cfg
AS
	SET NOCOUNT ON

	SELECT
		join_baseuse, nickname_use, citizennum_use, birthday_use,
		sex_use, messenger_use, homepage_use, homezip_use, homeaddr_use, homephone_use, 
		workzip_use, workaddr_use, workphone_use, mobilephone_use, mailling_use, mempic_use, 
		passfind_use, openinfo_use, afterjoin_url, joinid_limit, sess_timeout, passfind_desc, cancel_script
	FROM
		NB_JoinItemCfg
	where join_idx = 1

	
	
	
	
----------------------------------------------------
-- ü ̸	: nbsp_get_sel_memberdata
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------
CREATE PROCEDURE nbsp_get_sel_memberdata
(
	@guest_no CHAR(6)
)
AS
	SET NOCOUNT ON

	SELECT
		*
	FROM
		NB_MemberData
	WHERE
		guest_no = @guest_no
		
		
		
		
		
----------------------------------------------------
-- ü ̸		: nbsp_join_member
-- Ķ		: @idxno (Խù ε)
-- 		: ȣ
-- ̸		: potato@dotnetpia.co.kr
-- 		: 2004.11.13
-- 		: 2004.11.13
-- 			: Խ Ÿ   Ѵ.
----------------------------------------------------

CREATE PROCEDURE nbsp_join_member
(					
	@edit_mode CHAR(1),			-- 1:JOIN, 2:MODIFY
	@guest_no CHAR(6),
	@mem_id VARCHAR(15),
	@mem_pwd VARCHAR(20),
	@mem_name VARCHAR(20),
	@mem_email VARCHAR(100),
	@nick_name VARCHAR(20),
	@messenger_type CHAR(1),
	@messenger_id VARCHAR(30),
	@homepage VARCHAR(150),
	@citizennum VARCHAR(25),
	@birthday CHAR(10),
	@lunar_use CHAR(1),
	@sex CHAR(1),
	@mobilephone VARCHAR(20),
	@homephone VARCHAR(20),
	@workphone VARCHAR(20),
	@homezip VARCHAR(7),
	@homeaddr VARCHAR(100),
	@workzip VARCHAR(7),
	@workaddr VARCHAR(100),
	@passfind_q VARCHAR(100),
	@passfind_a VARCHAR(100),
	@point_num INT,
	@mailling_chk CHAR(1),
	@mempic_name VARCHAR(100),
	@memsign_name VARCHAR(100),	
	@mem_name_open CHAR(1),
	@mem_email_open CHAR(1),
	@nick_name_open CHAR(1),
	@messenger_id_open CHAR(1),
	@homepage_open CHAR(1),
	@birthday_open CHAR(1),
	@sex_open CHAR(1),
	@mobilephone_open CHAR(1),
	@homephone_open CHAR(1),
	@workphone_open CHAR(1),
	@homeaddr_open CHAR(1),
	@workaddr_open CHAR(1)
)


AS
	BEGIN TRAN

	IF @edit_mode = '1'
		BEGIN
			DECLARE	
				@join_baseuse CHAR(1)
		
			SELECT @join_baseuse = ISNULL(join_baseuse, '1')
			FROM NB_JoinItemCfg WHERE join_idx = 1
		
			INSERT NB_MemberData
			(
				guest_no, mem_id, mem_pwd, mem_name, mem_email, nick_name, homepage, citizennum, birthday,
				lunar_use, sex, join_time, mobilephone, homephone, workphone, homezip, homeaddr, workzip,
				workaddr, user_enable, mailling_chk, mempic_name, memsign_name, passfind_q, passfind_a,
				messenger_id, messenger_type,
				mem_name_open, mem_email_open, nick_name_open, messenger_id_open, homepage_open, birthday_open, 
				sex_open, mobilephone_open, homephone_open, workphone_open, homeaddr_open, workaddr_open
			)
			VALUES
			(
				@guest_no,
				@mem_id,
				@mem_pwd,
				@mem_name,
				@mem_email,
				@nick_name,
				@homepage,
				@citizennum,
				@birthday,
				@lunar_use,
				@sex,
				GETDATE(),
				@mobilephone,
				@homephone,
				@workphone,
				@homezip,
				@homeaddr,
				@workzip,
				@workaddr,
				@join_baseuse,
				@mailling_chk,
				@mempic_name,
				@memsign_name,
				@passfind_q,
				@passfind_a,
				@messenger_id,
				@messenger_type,
				@mem_name_open,
				@mem_email_open,
				@nick_name_open,
				@messenger_id_open,
				@homepage_open,
				@birthday_open,
				@sex_open,
				@mobilephone_open,
				@homephone_open,
				@workphone_open,
				@homeaddr_open,
				@workaddr_open
			)
		END
	ELSE IF @edit_mode = '2'
		BEGIN
			UPDATE NB_MemberData SET 
				mem_name = @mem_name,
				mem_pwd = (CASE LEN(LTRIM(@mem_pwd)) WHEN 0 THEN mem_pwd ELSE @mem_pwd END),
				nick_name = @nick_name,
				messenger_id = @messenger_id,
				messenger_type = @messenger_type,
				homepage = @homepage,
				citizennum = @citizennum,
				sex = @sex,
				birthday = @birthday,
				lunar_use = @lunar_use,
				homephone = @homephone,
				workphone = @workphone,
				mobilephone = @mobilephone,
				mempic_name = (CASE @mempic_name WHEN 'NONE' THEN mempic_name ELSE @mempic_name END),
				memsign_name = (CASE @memsign_name WHEN 'NONE' THEN memsign_name ELSE @memsign_name END),
				homezip = @homezip,
				homeaddr = @homeaddr,
				workzip = @workzip,
				workaddr = @workaddr,
				passfind_q = @passfind_q,
				passfind_a = @passfind_a,
				mem_email = @mem_email,
				mem_name_open = @mem_name_open,
				mem_email_open = @mem_email_open,
				nick_name_open = @nick_name_open,
				messenger_id_open = @messenger_id_open,
				homepage_open = @homepage_open,
				birthday_open = @birthday_open,
				sex_open = @sex_open,
				mobilephone_open = @mobilephone_open,
				homephone_open = @homephone_open,
				workphone_open = @workphone_open,
				homeaddr_open = @homeaddr_open,
				@workaddr_open = @workaddr_open
			WHERE guest_no = @guest_no
		END	
	
	IF @@ERROR <> 0
		BEGIN
			ROLLBACK TRAN
		END
	ELSE
		BEGIN
			COMMIT TRAN
		END
		
		
		
		
		
----------------------------------------------------
-- ü ̸	: nbsp_dup_chk_mem_id
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------
CREATE PROCEDURE nbsp_dup_chk_mem_id
(
	@mem_id VARCHAR(15)
)
AS
	SET NOCOUNT ON

	SELECT 
		COUNT(*)
	FROM
		NB_MemberData
	WHERE
		mem_id = @mem_id
		
		
		
		
		
----------------------------------------------------
-- ü ̸	: nbsp_get_boardset_data
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------
CREATE PROCEDURE nbsp_get_boardset_data
(
	@board_no CHAR(6)
)
AS
	SET NOCOUNT ON

	SELECT
		board_name, groupboardcfg_use, groupdesigncfg_use, grouplevelcfg_use
	FROM
		NB_BoardSet
	WHERE
		board_no = @board_no
		
		


----------------------------------------------------
-- ü ̸	: nbsp_get_global_cfg
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------
CREATE PROCEDURE nbsp_get_global_cfg
AS
	SET NOCOUNT ON

	SELECT
		sess_timeout, mempic_use, passfind_use, join_point, login_point
	FROM
		NB_JoinItemCfg
	WHERE
		join_idx = 1
		
		


----------------------------------------------------
-- ü ̸	: nbsp_get_board_cfg
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------
CREATE PROCEDURE nbsp_get_board_cfg
(
	@group_use CHAR(1),
	@board_no VARCHAR(6)
)
AS
	SET NOCOUNT ON

	IF @group_use = '1'
		SELECT *
		FROM NB_GroupBoardCfg
		WHERE group_code = SUBSTRING(@board_no, 1, 3)
	else
		SELECT *
		FROM NB_BoardCfg
		WHERE board_no = @board_no
		
		
		
		
----------------------------------------------------
-- ü ̸	: nbsp_get_design_cfg
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------
CREATE PROCEDURE nbsp_get_design_cfg
(
	@group_use CHAR(1),
	@board_no VARCHAR(6)
)
AS
	SET NOCOUNT ON
	
	IF @group_use = '1'
		SELECT
			skin_path, boardtitle_view, boardtitle_cont,
			pagebg_color, pagebg_img, boardbg_color,boardbg_img, board_width, board_align, noticebg_color,
			noticefont_color, noticeover_color, evenbg_color, evenfont_color, evenover_color, oddbg_color,
			oddfont_color, oddover_color, hitfire_color, goodfire_color,
			header_type, header_cont, copyright_type, copyright_cont, tail_type, tail_cont, sbar_style, browser_title
		FROM NB_GroupDesignCfg
		WHERE group_code = SUBSTRING(@board_no, 1, 3)
	ELSE
		SELECT
			skin_path, boardtitle_view, boardtitle_cont,
			pagebg_color, pagebg_img, boardbg_color,boardbg_img, board_width, board_align, noticebg_color,
			noticefont_color, noticeover_color, evenbg_color, evenfont_color, evenover_color, oddbg_color,
			oddfont_color, oddover_color, hitfire_color, goodfire_color,
			header_type, header_cont, copyright_type, copyright_cont, tail_type, tail_cont, sbar_style, browser_title
		FROM NB_DesignCfg
		WHERE board_no = @board_no
		
		
		
		
----------------------------------------------------
-- ü ̸	: nbsp_chk_private_001001
-- Ķ		: 
-- 		:
-- ̸		:
-- 		:
-- 		:
----------------------------------------------------
CREATE PROCEDURE nbsp_chk_private_001001
(
	@idx_no INT
)
AS
	SET NOCOUNT ON

	SELECT private_yn FROM NB_BoardData_001001 WHERE idx_no = @idx_no
	
	
	
	
	
----------------------------------------------------
-- ü ̸		: nbsp_view_boarddata_001001
-- Ķ		: @idxno (Խù ε)
-- 		: ȣ
-- ̸		: potato@dotnetpia.co.kr
-- 		: 2004.11.13
-- 		: 2004.11.13
-- 			: Խ Ÿ   Ѵ.
----------------------------------------------------

CREATE  PROCEDURE nbsp_view_boarddata_001001
(					
	@idx_no INT,
	@hit_update CHAR(1)
)

AS
	SET NOCOUNT ON

	BEGIN TRAN
	
	-- hit_cnt UPDATE
	IF @hit_update = '1'
		BEGIN
			UPDATE NB_BoardData_001001 SET hit_cnt = hit_cnt + 1 WHERE idx_no = @idx_no
		END	

	-- READ BOARD DATA	
	SELECT
		a.idx_no, a.guest_no, a.writer, a.email, a.homepage, a.writer_ip, 
		a.subject, a.content, a.html_use, ISNULL(a.hit_cnt,0) as hit_cnt, 
		isnull(a.good_cnt,0) as good_cnt, a.ref_no, a.level_no1, a.level_no2,
		a.agree_yn, vote_yn, a.private_yn, a.notice_yn, a.link1, a.link2, 
		a.write_date, vote_start, vote_end, b.nick_name, 
		b.mem_name, b.mempic_name, b.memsign_name, c.cat_name
	FROM
		NB_BoardData_001001 a, NB_MemberData b, NB_CategoryData c
	WHERE
		a.idx_no = @idx_no AND
		a.guest_no *= b.guest_no AND 
		c.board_no = '001001' AND 
		a.cat_code *= c.cat_code


	IF @@ERROR <> 0
		BEGIN
			ROLLBACK TRAN
		END
	ELSE
		BEGIN
			COMMIT TRAN
		END
		
		

----------------------------------------------------
-- ü ̸		: nbsp_get_point_data
-- Ķ		: @idxno (Խù ε)
-- 		: ȣ
-- ̸		: potato@dotnetpia.co.kr
-- 		: 2004.11.13
-- 		: 2004.11.13
-- 			: Խ Ÿ   Ѵ.
----------------------------------------------------
CREATE PROCEDURE nbsp_get_point_data
(
	@board_no CHAR(6)
)
AS
	SET NOCOUNT ON

	DECLARE @inherit_point CHAR(1)
	
	SELECT @inherit_point = ISNULL(point_inherit, '0') FROM NB_GroupInfo WHERE group_code = SUBSTRING(@board_no, 1, 3)
	
	IF @inherit_point = '0'
		SELECT * FROM NB_GroupPointCfg WHERE group_code = SUBSTRING(@board_no, 1, 3)
	ELSE
		SELECT * FROM NB_PointCfg