﻿using System;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Web.Security;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;
using System.Xml;
using System.IO;

namespace NeAdmin.Body.BoardMng
{
	public class BoardMng : Page
	{
		#region Controls
		protected Label lbl_admin_id;
		protected Label lbl_admin_level;
		protected Label lbl_page_name;
		protected PlaceHolder plc_page_cont;
		protected LinkButton btnSignOut;
		protected Literal ltr_now_date;
		protected Table tbl_board_list;
		protected Literal ltr_appversion_info;
		protected Literal ltr_dbversion_info;
		protected System.Web.UI.WebControls.HyperLink hyp_db_backup;
		protected System.Web.UI.WebControls.HyperLink hyp_db_state;
		protected System.Web.UI.WebControls.HyperLink hyp_file_arrange;
		protected System.Web.UI.WebControls.HyperLink hyp_find_all;
		protected System.Web.UI.WebControls.HyperLink hyp_board_manual;
		protected System.Web.UI.WebControls.HyperLink hyp_mem_mng;
		protected System.Web.UI.WebControls.HyperLink hyp_board_create;
		protected System.Web.UI.WebControls.Panel pnl_auth_deny;
		protected System.Web.UI.WebControls.HyperLink hyp_level_mng;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hid_mem_url;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hid_group_url;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hid_board_url;
		protected System.Web.UI.WebControls.HyperLink hyp_group_add;
		#endregion
		protected System.Web.UI.WebControls.HyperLink hyp_neboard_cfg;
		protected System.Web.UI.WebControls.HyperLink hyp_report;

		public string pbVisibleStyle;

		public string ManualPageUrl = string.Empty;

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				if (NBAdminUtil.isAdminLogin())
				{
					if(!IsPostBack)
					{
						// 현재 날짜 표시
						ltr_now_date.Text = DateTime.Now.ToString("yyyy.MM.dd ddd'요일'");

						// 버전 체크
						DoVersionCheck();

						// 관리자 정보 표시
						DisplayAdminInfo();
					}

					MenuPosSave();

					DisplayBoardMenu();

					UserControlLoad();

					SetManualPageUrl();

					SetBoardDisp();
				}
				else
				{
					Response.Redirect("../../Default.aspx", false);
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void SetBoardDisp()
		{
			string sViewMode = NBCmnUtil.QStrLoad ("vm");

			if (!NBUtil.StrEmptyChk (sViewMode))
			{
				if (sViewMode.ToUpper().Trim().Equals ("S"))
				{
					pbVisibleStyle = "style=\"display : none;\"";
				}
			}
		}		
		

		private void SetManualPageUrl()
		{
			string sPGC = NBCmnUtil.QStrLoad ("pgc");

			if (!NBUtil.StrEmptyChk (sPGC))
			{
				string[] arrPGC = sPGC.Split('/');

				switch (arrPGC[0].ToUpper())
				{
					case "MEMBERPAGE":
						ManualPageUrl = "Manual/NeAdminManual_Mem.html#" + sPGC;
						break;
					case "GROUPPAGE":
					case "BOARDPAGE":
						ManualPageUrl = "Manual/NeAdminManual_Group.html#" + sPGC;
						break;
					case "BOARDUTIL":
						ManualPageUrl = "Manual/NeAdminManual_Etc.html#" + sPGC;
						break;
					default:
						ManualPageUrl = "Manual/NeAdminManual_Group.html#" + sPGC;
						break;
				}
			}
			else
			{
				ManualPageUrl = "Manual/NeAdminManual_Group.html";
			}
		}		

		private void MenuPosSave()
		{
			//double nExpMin = 60 * 24 * 30;

			string sPgc = NBCmnUtil.QStrLoad("pgc");


			// 회원 관리 메뉴 위치 기억
			if (!NBUtil.StrEmptyChk (sPgc) && sPgc.ToUpper().StartsWith("MEMBERPAGE"))
			{
				hid_mem_url.Value = sPgc;
				// NBCmnUtil.SaveCookiValue ("CURR_MEM_MENU", sPgc, nExpMin);
			}

			// 그룹 관리 메뉴 위치 기억
			if (!NBUtil.StrEmptyChk (sPgc) && sPgc.ToUpper().StartsWith("GROUPPAGE") && !sPgc.ToUpper().StartsWith("GROUPPAGE/GROUPMNG.ASCX"))
			{
				hid_group_url.Value = sPgc;
				//NBCmnUtil.SaveCookiValue ("CURR_GROUP_MENU", sPgc, nExpMin);
			}
					
			// 게시판 메뉴 메뉴 위치 기억
			if (!NBUtil.StrEmptyChk (sPgc) && sPgc.ToUpper().StartsWith("BOARDPAGE"))
			{
				hid_board_url.Value = sPgc;
                //NBCmnUtil.SaveCookiValue ("CURR_BOARD_MENU", sPgc, nExpMin);
			}
		}

		private string GetCurrNav_MEM()
		{
			string sCurrUrl = string.Empty;

			// string sCookieUrl = NBCmnUtil.GetCookieValue ("CURR_MEM_MENU");
			string sCookieUrl = hid_mem_url.Value;

			if (NBUtil.StrEmptyChk (sCookieUrl))
				sCurrUrl = "MemberPage/MemMng.ascx";
			else
				sCurrUrl = sCookieUrl;
			
			return sCurrUrl;
		}

		private string GetCurrNav_GROUP()
		{
			string sCurrUrl = string.Empty;

			// string sCookieUrl = NBCmnUtil.GetCookieValue ("CURR_GROUP_MENU");
			string sCookieUrl = hid_group_url.Value;

			if (NBUtil.StrEmptyChk (sCookieUrl))
				sCurrUrl = "GroupPage/GroupBoardState.ascx";
			else
				sCurrUrl = sCookieUrl;
			
			return sCurrUrl;
		}

		private string GetCurrNav_BOARD()
		{
            string sCurrUrl = string.Empty;

			// string sCookieUrl = NBCmnUtil.GetCookieValue ("CURR_BOARD_MENU");
			string sCookieUrl = hid_board_url.Value;

			if (NBUtil.StrEmptyChk (sCookieUrl))
				sCurrUrl = "BoardPage/BoardSet.ascx";
			else
				sCurrUrl = sCookieUrl;
			
			return sCurrUrl;
		}

		#region 버전 체크
		private void DoVersionCheck()
		{
			if (!NBUtil.StrEmptyChk(ConfigurationSettings.AppSettings["DB_Ver_Check"]) && 
				!ConfigurationSettings.AppSettings["DB_Ver_Check"].Equals("1"))
			{
			}
			else
			{
				string sAppVersion = VersionInfo.GetAppVersion();
				string sDbVersion = VersionInfo.GetDbVersion();

				if (NBUtil.StrEmptyChk (sDbVersion))
				{
					NBCmnUtil.ViewMsgGoUrl (Page, "Default.aspx", @"DB 버전 정보를 읽어 올 수 없습니다.");
				}
				else
				{
					// 버전을 체크 한다.
					VerCheck.VerCheck svcVersionCheck = null;

					try
					{
						svcVersionCheck = new VerCheck.VerCheck();
					}
					catch
					{
					}

					if (svcVersionCheck != null)
					{
						string sChkStr = svcVersionCheck.VersionCheck(sAppVersion, sDbVersion);

						string[] aChkStr = sChkStr.Split(':');
			
						if (aChkStr[0].Trim().ToUpper().Equals("OK"))
						{
							switch (aChkStr[1].Trim().ToUpper())
							{
								case "DBUPGRADE":
									NBCmnUtil.ViewMsgGoUrl(Page, "../../NeBoardUpgrade/SysUpgrade.aspx", @"NeBoard의 DB가 업그레이드 되었습니다.\n\nDB 업그레이드 작업을 진행 합니다.");
									break;
								default:
									break;
							}
						}
						else
						{
							throw new Exception("버전 체크 도중 오류가 발생하였습니다.");					
						}
					}

					ltr_appversion_info.Text = sAppVersion;
					ltr_dbversion_info.Text = sDbVersion;					
				}
			}
		}

		
		#endregion

		#region 그룹/게시판 리스트 표시
		/// <summary>
		/// 좌측 게시판 메뉴 구성
		/// </summary>
		public void DisplayBoardMenu()
		{
			hyp_mem_mng.NavigateUrl = "BoardMng.aspx?pgc=" + GetCurrNav_MEM();

			hyp_report.NavigateUrl = "BoardMng.aspx?pgc=Report/MemberReport.ascx";
			hyp_neboard_cfg.NavigateUrl = "BoardMng.aspx?pgc=AppCfg/BoardSetEdit.ascx";

			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				DataTable dtGroupList = GetGroupList(dbSqlConn);
				DataTable dtBoardList = GetBoardList(dbSqlConn);

                dbSqlConn.Close();

				if (dtGroupList.Rows.Count > 0)
				{
					// 이전 데이타 모두 제거
					tbl_board_list.Rows.Clear();

					TableRow trBoardList = null;
					TableCell tdBoardList = null;

					foreach (DataRow gRow in dtGroupList.Rows)
					{
						// 그룹 메뉴 추가
						trBoardList = new TableRow();

						tdBoardList = new TableCell();
						tdBoardList.Controls.Add (new LiteralControl ("<img src='img/folder_open.gif' align='absmiddle'> "));

						string sGrpStyle = string.Empty;

						if (gRow["group_code"].ToString().Equals(GetSelGroupCode()))
						{
                            sGrpStyle = "left_me1_S";
						}
						else
						{
							sGrpStyle = "left_me1";
						}
						
						tdBoardList.Controls.Add (new LiteralControl ("<a class=\"" + sGrpStyle + "\" href=\"BoardMng.aspx?pgc=" + GetCurrNav_GROUP() + "&gno=" + gRow["group_code"].ToString() + "\">" + gRow["group_name"].ToString() + "</a>"));

						trBoardList.Cells.Add (tdBoardList);

						tbl_board_list.Rows.Add (trBoardList);
			
                    
						DataRow[] bRows = dtBoardList.Select("board_no LIKE '" + gRow["group_code"].ToString() + "%'", "board_no asc");

						if (bRows.Length > 0)
						{
							foreach (DataRow bRow in bRows)
							{
								trBoardList = new TableRow();

								tdBoardList = new TableCell();
								tdBoardList.Controls.Add (new LiteralControl ("&nbsp;&nbsp;<img src='img/folder_close.gif' align='absmiddle'> "));

								string sBoardStyle = string.Empty;

								if (bRow["board_no"].ToString().Equals(GetSelBoardNo()))
								{
									sBoardStyle = "left_me2_S";
								}
								else
								{
									if (gRow["group_code"].ToString().Equals(GetSelGroupCode()))
									{
										sBoardStyle = "left_me2_GS";
									}
									else
									{
										sBoardStyle = "left_me2";
									}
								}

								tdBoardList.Controls.Add (new LiteralControl ("<a class=\"" + sBoardStyle + "\" href=\"BoardMng.aspx?pgc=" + GetCurrNav_BOARD() + "&bno=" + bRow["board_no"].ToString() + "&bnm=" + Server.UrlEncode(bRow["board_name"].ToString()) + "\">" + bRow["board_name"].ToString() + "</a>"));
								tdBoardList.Controls.Add (new LiteralControl (" <a href='" + NBUtil.GetBoardTransLink(bRow["board_no"].ToString(), "LIST") + "' target='_blank'><img src='Images/icon_view_01.gif' align='absmiddle' border='0'></a>"));

								trBoardList.Cells.Add (tdBoardList);

								tbl_board_list.Rows.Add (trBoardList);
							}
						}

						trBoardList = new TableRow();

						tdBoardList = new TableCell();
						tdBoardList.Height = 2;
						trBoardList.Cells.Add (tdBoardList);

						tbl_board_list.Rows.Add (trBoardList);

						trBoardList = new TableRow();

						tdBoardList = new TableCell();
						tdBoardList.Height = 1;
						tdBoardList.BackColor = System.Drawing.Color.FromName ("#f3f3f3");
						trBoardList.Cells.Add (tdBoardList);

                        tbl_board_list.Rows.Add (trBoardList);

						trBoardList = new TableRow();

						tdBoardList = new TableCell();
						tdBoardList.Height = 5;
						trBoardList.Cells.Add (tdBoardList);

						tbl_board_list.Rows.Add (trBoardList);
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private string GetSelGroupCode()
		{
			string sSelCode = string.Empty;

			string sGrpCode = NBCmnUtil.QStrLoad("gno");

			if (!NBUtil.StrEmptyChk (sGrpCode))
			{
				sSelCode = sGrpCode;
			}
			else
			{
				string sBnoCode = NBCmnUtil.QStrLoad ("bno");

				if (!NBUtil.StrEmptyChk (sBnoCode))
				{
					sSelCode = sBnoCode.Substring(0, 3);
				}
			}

			return sSelCode;
		}

		private string GetSelBoardNo()
		{
			string sSelCode = string.Empty;

			string sBnoCode = NBCmnUtil.QStrLoad ("bno");

			if (!NBUtil.StrEmptyChk (sBnoCode))
			{
				sSelCode = sBnoCode;
			}

			return sSelCode;
		}

		public DataTable GetGroupList(SqlConnection dbSqlConn)
		{
			DataSet ds = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.GroupList());

			return ds.Tables[0];
		}

		public DataTable GetBoardList(SqlConnection dbSqlConn)
		{
			DataSet ds = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.BoardListSimple());

			return ds.Tables[0];
		}
		#endregion

		#region 사용자 정의 컨트롤 로드 (URL의 pgc 값에 따라)
		/// <summary>
		/// UserControl Load
		/// </summary>
		public void UserControlLoad()
		{
			try
			{
				string sControlName = string.Empty;

				if (NBUtil.StrEmptyChk (Request.QueryString["pgc"]))
					sControlName = ConfigurationSettings.AppSettings["NeAdminPath"] + "/Body/MngPages/CommonPage/TotalState.ascx";
				else
					sControlName = ConfigurationSettings.AppSettings["NeAdminPath"] + "/Body/MngPages/" + Request.QueryString["pgc"];

				if (sControlName.Length > 0)
				{
					Control uContLoaded = LoadControl(sControlName);
					uContLoaded.ID = "UserPageControl";
					
					if (uContLoaded != null && !plc_page_cont.Controls.Contains(uContLoaded))
					{
						if (plc_page_cont.Controls.IndexOf(uContLoaded) > -1)
                            plc_page_cont.Controls.RemoveAt (plc_page_cont.Controls.IndexOf(uContLoaded));

						plc_page_cont.Controls.Add(uContLoaded);
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}
		#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// 디자이너 지원에 필요한 메서드입니다.
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnSignOut.Click += new System.EventHandler(this.btnSignOut_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		#region 관리자 종류에 따른 설정
		/// <summary>
		/// 관리자 정보 표시
		/// </summary>
		private void DisplayAdminInfo()
		{
			if ( NBCmnUtil.GetCookieValue ("NEADMIN_MBNO").Equals(NBLib.SuperAdmin) )
			{
				lbl_admin_id.Text = "<a href='javascript:AdminInfoWinOpen();'>" + GetAdminMemInfo() + "</a>";

				lbl_admin_level.Text = "최고 관리자";
			}
			else
			{
				lbl_admin_id.Text = GetAdminMemInfo();

				lbl_admin_level.Text = "일반 관리자";
			}
		}

		private string GetAdminMemInfo()
		{
			string sAdminName = string.Empty;

            SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				StringWriter Qry = new StringWriter();

				Qry.WriteLine ("SELECT mem_id + '(' + mem_name + ')' FROM NB_MemberData WHERE guest_no = " + DBUtil.QryConvStr(NBCmnUtil.GetCookieValue ("NEADMIN_MBNO"), false));

                string sVal = SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, Qry.ToString()).ToString();

				if (!NBUtil.StrEmptyChk (sVal))
				{
                    sAdminName = sVal;
				}
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}

			return sAdminName;
		}

		/// <summary>
		/// 관리자 로그 아웃
		/// </summary>
		private void btnSignOut_Click(object sender, EventArgs e)
		{
			NBCmnUtil.SaveCookiValue ("NEADMIN_MBNO", string.Empty, 10);
			NBCmnUtil.SaveCookiValue ("NEADMIN_ADMINGROUP", string.Empty, 10);

			NBCmnUtil.ViewMsgGoUrl (Page, "../../default.aspx", "");
		}
		#endregion

		

	}
}

