﻿using System;
using System.Configuration;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;
using System.IO;
using BoardLib;


namespace NeAdmin.Body.MngPages.BoardPage
{
	public class BoardBasicSet : UserControl
	{
		#region Controls
		protected CheckBox chk_fileupdown_use;
		protected CheckBox chk_homebtn_use;
		protected CheckBox chk_replyview_use;
		protected CheckBox chk_badword_use;
		protected TextBox txt_badword_word;
		protected TextBox txt_use_htmltag;
		protected TextBox txt_cut_ip;
		protected TextBox txt_homebtn_url;
		protected TextBox ntxt_fileup_size;
		protected TextBox ntxt_listrow_cnt;
		protected TextBox ntxt_pagingnum_cnt;
		protected TextBox ntxt_newicon_term;
		protected TextBox ntxt_subjectlen_cnt;
		protected TextBox ntxt_errlog_limitcnt;
		protected TextBox ntxt_goodfire_cnt;
		protected TextBox txt_fileup_ext;
		protected Literal xltr_max_request_length;
		protected CheckBox chk_fileup_ext_use;
		protected CheckBox chk_cut_ip_use;
		protected RadioButtonList rdolst_html_use;
		protected ImageButton imgbtn_basicset_save;
		protected TextBox txt_writer_limit;
		protected CheckBox chk_cmmt_sort;
		protected TextBox txt_rss_encoding;
		protected CheckBox chk_list_imgview;
		protected TextBox ntxt_list_imgview_width;
		protected TextBox ntxt_list_imgview_height;
		protected TextBox ntxt_img_thumb_width;
		protected TextBox ntxt_img_thumb_height;
		protected TextBox ntxt_file_up_cnt;
		protected TextBox txt_default_cont;
		protected TextBox txt_afterlogin_url;
		protected RadioButtonList rdolst_memboard_use;
		protected System.Web.UI.WebControls.CheckBox chk_musicboard_use;
		protected System.Web.UI.WebControls.DropDownList ddl_musicplayer_skin;
		protected System.Web.UI.WebControls.CheckBox chk_voteboard_use;
		protected System.Web.UI.WebControls.TextBox ntxt_revote_limit;
		#endregion

		protected string gBoardName = string.Empty;
		protected System.Web.UI.WebControls.RadioButtonList rdolst_vote_disp_type;
		protected System.Web.UI.WebControls.TextBox txt_vote_start;
		protected System.Web.UI.WebControls.TextBox txt_vote_end;
		protected System.Web.UI.WebControls.TextBox txt_afterwrite_url;
		protected System.Web.UI.WebControls.TextBox txt_afteredit_url;
		protected System.Web.UI.WebControls.TextBox ntxt_updateicon_term;
		protected string gBoardNo = string.Empty;

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				NBAdminUtil.GetReqStr(ref gBoardName, ref gBoardNo);

				BoardMng.BoardMng objParentPage = (BoardMng.BoardMng)this.Parent.Page;

				NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "[<font color='#FFC0C0'>" + gBoardName + "</font>] : 기본설정 변경", false);

				CfgOldDataLoad();

				set_button_script();

				Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
				NBAdminUtil.DisplayAdminAuth (gBoardNo.Substring(0, 3), NBLib.MngAuthRole.BoardBasicCfgMod, imgbtn_basicset_save, pnlError);
			}
			catch(Exception E)
			{
				Response.Clear();
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void set_button_script()
		{
			chk_fileupdown_use.Attributes["onclick"] = "Do_FileUp_Default(this, '" + ntxt_file_up_cnt.ClientID + "', '" + ntxt_fileup_size.ClientID + "');";
			chk_list_imgview.Attributes["onclick"] = "Do_ListImg_Default(this, '" + ntxt_list_imgview_width.ClientID + "', '" + ntxt_list_imgview_height.ClientID + "');";
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		디자이너 지원에 필요한 메서드입니다. 이 메서드의 내용을
		///		코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtn_basicset_save.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_basicset_save_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void CfgOldDataLoad()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				ddl_musicplayer_skin.Items.Clear();

				// 스킨 폴더에서 스킨 리스트 검색
				ddl_musicplayer_skin.Items.Add(new ListItem("선택 안됨", ""));

				DirectoryInfo fsSkinDir = new DirectoryInfo(Server.MapPath(ConfigurationSettings.AppSettings["NeBoardPath"] + "/SkinTemplates/MPlayerSkin/"));

				if (fsSkinDir.GetDirectories().Length > 0)
				{
					foreach (DirectoryInfo dirInfo in fsSkinDir.GetDirectories())
					{
						ddl_musicplayer_skin.Items.Add(new ListItem(dirInfo.Name, dirInfo.Name));
					}
				}

				// 선택 게시판 내용
				DataSet dsBoardCfg = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.GetBoardCfgData(gBoardNo));

				if (dsBoardCfg != null)
				{
					DataTable dtBoardCfg = dsBoardCfg.Tables[0];

					if (dtBoardCfg.Rows.Count > 0)
					{
                        NBCmnUtil.DataTbl_to_Control(dtBoardCfg.Rows[0], this.Controls);
					}
				}

				
				// 설정 내용
				XmlDocument xmlDoc = new XmlDocument();
				xmlDoc.Load(Server.MapPath ("../../web.config"));
				XmlNode xNode = xmlDoc.SelectSingleNode ("/configuration/system.web/httpRuntime");

				if (!BoardLib.NBUtil.StrEmptyChk (xNode.Attributes["maxRequestLength"].Value) && int.Parse (xNode.Attributes["maxRequestLength"].Value) > 0)
					xltr_max_request_length.Text = int.Parse (xNode.Attributes["maxRequestLength"].Value).ToString("#,##0") + "KB 까지 업로드 가능";
				else
                    xltr_max_request_length.Text = "무제한";

			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}		

		private void imgbtn_basicset_save_Click(object sender, ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;
		
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				ArrayList UpdateFields = NBCmnUtil.GetUpdateFields(this.Controls);

				if (UpdateFields.Count > 0)
				{
					string Qry = string.Empty;

					Qry = DBUtil.CreateUpdateQry("NB_BoardCfg", UpdateFields, "board_no = '" + gBoardNo + "'");

					if (Qry.Trim().Length > 0)
					{
						int nUpdate = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, Qry);

						if (nUpdate > 0)
						{
							if (chk_musicboard_use.Checked)
							{
								string sMsg = @"수정 완료\n\n";
								sMsg += @"음악게시판을 사용하실 경우 디자인 설정에서 음악 게시판용 스킨을 선택해 주셔야 합니다.\n";
								sMsg += @"현재 스킨이 MusicCenter_e 또는 MusicCenter_k 인지 확인해주시기 바랍니다.";
								NBCmnUtil.ViewAlertMsg(Page, sMsg);
							}
							else
							{
								NBCmnUtil.ViewAlertMsg(Page, "수정 완료");
							}
						}
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}
	}
}
