﻿using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;


namespace NeAdmin.Body.MngPages.BoardPage
{
	public class BoardCategorySet : UserControl
	{
		#region Controls
		protected LinkButton lnk_board_info;
		protected LinkButton lnk_basic_set;
		protected LinkButton lnk_design_set;
		protected LinkButton lnk_level_set;
		protected LinkButton lnk_category_mng;
		protected DataGrid dGroupList;
		protected TextBox txt_cat_code;
		protected TextBox txt_cat_name;
		protected LinkButton lnk_display_set;
		protected ImageButton imgbtn_cat_add;
		#endregion
		protected System.Web.UI.WebControls.DropDownList ddl_src_cat;
		protected System.Web.UI.WebControls.DropDownList ddl_tar_cat;
		protected System.Web.UI.WebControls.ImageButton imgbtn_cat_move;
		protected System.Web.UI.WebControls.Literal ltr_none_cat;

		protected string gBoardName = string.Empty;
		protected string gBoardNo = string.Empty;

		BoardMng.BoardMng objParentPage;

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		디자이너 지원에 필요한 메서드입니다. 이 메서드의 내용을
		///		코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtn_cat_add.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_cat_add_Click);
			this.imgbtn_cat_move.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_cat_move_Click);
			this.Load += new System.EventHandler(this.Page_Load);
			this.PreRender += new System.EventHandler(this.Page_PreRender);

		}

		private void Page_PreRender(object sender, EventArgs e)
		{
			DoCatMoveBind();
		}

		#endregion

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				NBAdminUtil.GetReqStr(ref gBoardName, ref gBoardNo);

				objParentPage = (BoardMng.BoardMng)this.Parent.Page;

				DoCatDataBind();

				NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "[<font color='#FFC0C0'>" + gBoardName + "</font>] : 카테고리 관리", false);

				DoPageEventSet();

				Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
				NBAdminUtil.DisplayAdminAuth (gBoardNo.Substring(0, 3), NBLib.MngAuthRole.CategoryMod, imgbtn_cat_add, pnlError);
				NBAdminUtil.DisplayAdminAuth (gBoardNo.Substring(0, 3), NBLib.MngAuthRole.CategoryMod, imgbtn_cat_move, pnlError);
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		/// <summary>
		/// 새로운 카테고리 입력해 사용할 카테고리 코드를 생성 한다.
		/// </summary>
		private void GetNewCatCode()
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				string sNewCatCode = SqlHelper.ExecuteScalar(dbSqlConn, CommandType.Text, AdminQryLib.NewCatCode(gBoardNo)).ToString();

				if (sNewCatCode.Length > 0 && int.Parse(sNewCatCode) < 100)
				{
					txt_cat_code.Text = sNewCatCode.PadLeft(2, '0');
					imgbtn_cat_add.Enabled = true;
				}
				else
				{
					imgbtn_cat_add.Enabled = false;
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		#region 메뉴 이벤트 정의
		/// <summary>
		/// 페이지의 이벤트를 정의 한다.
		/// </summary>
		private void DoPageEventSet()
		{
			this.dGroupList.CancelCommand += new DataGridCommandEventHandler(this.dGroupList_CancelCommand);
			this.dGroupList.EditCommand += new DataGridCommandEventHandler(this.dGroupList_EditCommand);
			this.dGroupList.UpdateCommand += new DataGridCommandEventHandler(this.dGroupList_UpdateCommand);
			this.dGroupList.DeleteCommand += new DataGridCommandEventHandler(this.dGroupList_DeleteCommand);
		}
		#endregion

		#region 카테고리 GridList 관련
		/// <summary>
		/// 카테고리를 리스트에 바인딩
		/// </summary>
		private void DoCatDataBind()
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				DataSet ds = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.CatList(gBoardNo));

				dGroupList.DataSource = ds;
				dGroupList.DataKeyField = "cat_code";
				dGroupList.DataBind();

				GetNewCatCode();

				GetNoneCateCnt();
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}		
		}

		private void GetNoneCateCnt()
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				int nCnt = int.Parse(SqlHelper.ExecuteScalar(dbSqlConn, CommandType.Text, AdminQryLib.NoneCatCnt(gBoardNo)).ToString()) ;

				ltr_none_cat.Text = nCnt.ToString("#,##0");
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		/// <summary>
		/// 데이타그리드 DELETE 이벤트
		/// </summary>
		/// <param name="source"></param>
		/// <param name="e"></param>
		private void dGroupList_DeleteCommand(object source, DataGridCommandEventArgs e)
		{
			if (NBAdminUtil.ChkAdminAuth (gBoardNo.Substring(0, 3), NBLib.MngAuthRole.CategoryMod))
			{
				SqlConnection dbSqlConn = null;

				try
				{
					DBUtil.DBConnection(ref dbSqlConn);

					string sSelCatCode = e.Item.Cells[0].Text.Trim();

					if (sSelCatCode.Trim().Length > 0)
					{
						SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, AdminQryLib.CatDelete(gBoardNo, sSelCatCode));

						DoCatDataBind();
					}
				}
				catch(Exception E)
				{
					NBCmnUtil.ViewAlertMsg (Page, E.Message);
				}
				finally
				{
					DBUtil.DBConnDispose(ref dbSqlConn);
				}
			}
			else
			{
				NBCmnUtil.ViewAlertMsg (Page, "권한이 없습니다.");
			}
		}

        /// <summary>
        /// 카테고리 리스트 수정 이벤트
        /// </summary>
        /// <param name="source"></param>
        /// <param name="e"></param>
		private void dGroupList_EditCommand(object source, DataGridCommandEventArgs e)
		{
			if (NBAdminUtil.ChkAdminAuth (gBoardNo.Substring(0, 3), NBLib.MngAuthRole.CategoryMod))
			{
				dGroupList.EditItemIndex = e.Item.ItemIndex;
				dGroupList.DataBind();
			}
			else
			{
				NBCmnUtil.ViewAlertMsg (Page, "권한이 없습니다.");
			}
		}

		/// <summary>
		/// 카테고리 리스트 취소 이벤트
		/// </summary>
		/// <param name="source"></param>
		/// <param name="e"></param>
		private void dGroupList_CancelCommand(object source, DataGridCommandEventArgs e)
		{
			dGroupList.EditItemIndex = -1;
			dGroupList.DataBind();
		}

		/// <summary>
		/// 카테고리 수정 입력 값 유효성 체크
		/// </summary>
		/// <param name="GridItem"></param>
		/// <returns></returns>
		private bool CatModifyValidChk(DataGridItem GridItem)
		{
			TextBox objText = (TextBox)GridItem.FindControl("txt_cat_name_edit");

			if (objText.Text.Trim().Length == 0)
			{
				NBCmnUtil.ViewAlertMsg(Page, "카테고리 이름이 없습니다.");
				return false;
			}

			return true;
		}

		/// <summary>
		/// 카테고리 리스트 수정 이벤트
		/// </summary>
		/// <param name="source"></param>
		/// <param name="e"></param>
		private void dGroupList_UpdateCommand(object source, DataGridCommandEventArgs e)
		{
			if (CatModifyValidChk(e.Item))
			{
				SqlConnection dbSqlConn = null;

				try
				{
					DBUtil.DBConnection(ref dbSqlConn);

					ArrayList UpdateParam = new ArrayList();

					TextBox txtCatName = (TextBox)e.Item.FindControl("txt_cat_name_edit");
					UpdateParam.Add(DBUtil.InsertParamItem("cat_name", NBLib.FieldQryType.Char, txtCatName.Text));

					string sUpdateQry = DBUtil.CreateUpdateQry("NB_CategoryData", UpdateParam, "board_no = '" + gBoardNo + "' and cat_code='" + dGroupList.DataKeys[e.Item.ItemIndex].ToString() + "'");

					if (sUpdateQry.Trim().Length > 0)
					{
						SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, sUpdateQry);

						dGroupList.EditItemIndex = -1;
						DoCatDataBind();
					}
				}
				catch(Exception E)
				{
					NBCmnUtil.ViewAlertMsg (Page, E.Message);
				}
				finally
				{
					DBUtil.DBConnDispose(ref dbSqlConn);
				}
			}		
		}
		#endregion

		#region 카테고리 추가
		/// <summary>
		/// 카테고리 추가 입력 값 유효성 검사
		/// </summary>
		/// <returns></returns>
		private bool CatAddValidChk()
		{
			if ( txt_cat_code.Text.Trim().Length == 0)
			{
				NBCmnUtil.ViewAlertMsg(Page, "카테고리 코드가 없습니다.");
				return false;
			}

			if (txt_cat_name.Text.Trim().Length == 0)
			{
				NBCmnUtil.ViewAlertMsg(Page, "카테고리 이름이 없습니다.");
				return false;
			}

			return true;
		}

		/// <summary>
		/// 신규 카테고리 추가
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void imgbtn_cat_add_Click(object sender, ImageClickEventArgs e)
		{
			if (CatAddValidChk())
			{
				SqlConnection dbSqlConn = null;

				try
				{
					DBUtil.DBConnection(ref dbSqlConn);

					ArrayList InsertParam = new ArrayList();

					InsertParam.Add(DBUtil.InsertParamItem("board_no", NBLib.FieldQryType.Char, gBoardNo));
					InsertParam.Add(DBUtil.InsertParamItem("cat_code", NBLib.FieldQryType.Char, txt_cat_code.Text));
					InsertParam.Add(DBUtil.InsertParamItem("cat_name", NBLib.FieldQryType.Char, txt_cat_name.Text));

					string sInsertQry = DBUtil.CreateInsertQry("NB_CategoryData", InsertParam);

					if (sInsertQry.Trim().Length > 0)
					{
						SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, sInsertQry);

						txt_cat_name.Text = string.Empty;

						DoCatDataBind();
					}
				}
				catch(Exception E)
				{
					NBCmnUtil.ViewAlertMsg (Page, E.Message);
				}
				finally
				{
					DBUtil.DBConnDispose(ref dbSqlConn);
				}
			}
		}
		#endregion

		#region 카테고리 이동
		/// <summary>
		/// 카테고리 이동을 위하여 원본 카테고리와 대상 카테고리를 선택 가능하도록
		/// DropDown리스트에 카테고리 리스트를 바인딩 한다.
		/// </summary>
		private void DoCatMoveBind()
		{
			SqlConnection dbSqlConn = null;
			DataSet ds = null;
			DataTable dtCatList = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				ds = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.CatListSimple(gBoardNo));

				dtCatList = ds.Tables[0];
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}

			ddl_src_cat.Items.Clear();
			ddl_tar_cat.Items.Clear();

			if (dtCatList.Rows.Count > 0)
			{
				ddl_src_cat.Items.Add(new ListItem("설정 안됨", "")) ;

				foreach (DataRow drCatItem in dtCatList.Rows)
				{
					ddl_src_cat.Items.Add(new ListItem(drCatItem["cat_name"].ToString(), drCatItem["cat_code"].ToString())) ;
					ddl_tar_cat.Items.Add(new ListItem(drCatItem["cat_name"].ToString(), drCatItem["cat_code"].ToString())) ;
				}

				imgbtn_cat_move.Enabled = true;
			}
			else
			{
				imgbtn_cat_move.Enabled = false;
			}
		}

		private bool CatMoveValidChk()
		{
            if (ddl_src_cat.SelectedIndex < 0 || ddl_tar_cat.SelectedIndex < 0)
            {
				NBCmnUtil.ViewAlertMsg(Page, "이동할 원본 카테고리와 대상 카테고리를 선택해 주세요.");
				return false;
            }

			if ( ddl_src_cat.SelectedValue.Equals(ddl_tar_cat.SelectedValue) )
			{
				NBCmnUtil.ViewAlertMsg(Page, "원본 카테고리와 대상 카테고리가 같은 카테고리 입니다.");
				return false;
			}

			return true;
		}

		/// <summary>
		/// 카테고리 이동 버튼 이벤트
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void imgbtn_cat_move_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if (CatMoveValidChk())
			{
				SqlConnection dbSqlConn = null;

				string sSrcCatCode = ddl_src_cat.SelectedValue;
				string sTarCatCode = ddl_tar_cat.SelectedValue;

				try
				{
					DBUtil.DBConnection(ref dbSqlConn);

					string sQry = "UPDATE NB_BoardData_" + gBoardNo + " SET ";
					sQry += "cat_code = " + DBUtil.QryConvStr(sTarCatCode, false);
					sQry += "WHERE ISNULL(cat_code, '') = " + DBUtil.QryConvStr(sSrcCatCode, false);

					int nMoveResult = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, sQry);

                    DoCatDataBind();

					NBCmnUtil.ViewAlertMsg(Page, nMoveResult.ToString("#,##0") + "개의 게시물이 이동 했습니다.");
				}
				catch(Exception E)
				{
					NBCmnUtil.ViewAlertMsg (Page, E.Message);
				}
				finally
				{
					DBUtil.DBConnDispose(ref dbSqlConn);
				}

			}
		}
		#endregion
	}
}
