﻿using System;
using System.Configuration;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;


namespace NeAdmin.Body.MngPages.BoardPage
{
	/// <summary>
	///		BoardDesignSet에 대한 요약 설명입니다.
	/// </summary>
	public class BoardDesignSet : UserControl
	{
		#region Page Controls
		protected LinkButton lnk_board_info;
		protected LinkButton lnk_basic_set;
		protected LinkButton lnk_design_set;
		protected LinkButton lnk_level_set;
		protected LinkButton lnk_category_mng;
		protected Literal ltr_board_name;
		protected DropDownList ddl_boardtitle_view;
		protected TextBox txt_boardtitle_cont;
		protected TextBox txt_pagebg_color;
		protected TextBox txt_pagebg_img;
		protected TextBox txt_boardbg_color;
		protected TextBox txt_boardbg_img;
		protected TextBox ntxt_board_width;
		protected DropDownList ddl_board_align;
		protected TextBox txt_noticebg_color;
		protected TextBox txt_noticefont_color;
		protected TextBox txt_noticeover_color;
		protected TextBox txt_evenbg_color;
		protected TextBox txt_evenfont_color;
		protected TextBox txt_evenover_color;
		protected TextBox txt_oddbg_color;
		protected TextBox txt_oddfont_color;
		protected TextBox txt_oddover_color;
		protected TextBox txt_hitfire_color;
		protected TextBox txt_goodfire_color;
		protected DropDownList ddl_header_type;
		protected TextBox txt_header_cont;
		protected DropDownList ddl_copyright_type;
		protected TextBox ddl_copyright_cont;
		protected DropDownList ddl_tail_type;
		protected TextBox txt_tail_cont;
		protected TextBox txt_sbar_style;
		#endregion

		protected TextBox txt_copyright_cont;
		protected LinkButton lnk_display_set;
		protected Literal xltr_header_type;
		protected Literal xltr_copyright_type;
		protected Literal xltr_tail_type;
		protected ImageButton imgbtn_design_save;
		protected Literal xltr_title_view;

		BoardMng.BoardMng objParentPage;

		protected string gBoardName = string.Empty;
		protected System.Web.UI.WebControls.CheckBox xchk_grouplevel_use;
		protected System.Web.UI.WebControls.TextBox txt_browser_title;
		protected System.Web.UI.WebControls.DropDownList ddl_skin_path;
		protected System.Web.UI.WebControls.ImageButton imbbtn_design_preview;
		protected string gBoardNo = string.Empty;

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				NBAdminUtil.GetReqStr(ref gBoardName, ref gBoardNo);				

				objParentPage = (BoardMng.BoardMng)this.Parent.Page;

				NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "[<font color='#FFC0C0'>" + gBoardName + "</font>] : 게시판 디자인 변경", false);

				CfgOldDataLoad();

				NBCmnUtil.DoControlsEnableChange(this.Controls, !xchk_grouplevel_use.Checked);

				Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
				NBAdminUtil.DisplayAdminAuth (gBoardNo.Substring(0, 3), NBLib.MngAuthRole.BoardDesignMod, imgbtn_design_save, pnlError);
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void CfgOldDataLoad()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				ddl_skin_path.Items.Clear();

				// 스킨 폴더에서 스킨 리스트 검색
				ddl_skin_path.Items.Add(new ListItem("선택 안됨", ""));

				DirectoryInfo fsSkinDir = new DirectoryInfo(Server.MapPath(ConfigurationSettings.AppSettings["NeBoardPath"] + "/SkinTemplates/BoardSkin/"));

				if (fsSkinDir.GetDirectories().Length > 0)
				{
					foreach (DirectoryInfo dirInfo in fsSkinDir.GetDirectories())
					{
						ddl_skin_path.Items.Add(new ListItem(dirInfo.Name, dirInfo.Name));
					}
				}


                DBUtil.DBConnection(ref dbSqlConn);

				// 선택 게시판의 디자인 설정
				DataSet dsBoardCfg = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.GetBoardDesignCfgData(gBoardNo));

				if (dsBoardCfg != null)
				{
					DataTable dtBoardCfg = dsBoardCfg.Tables[0];

					if (dtBoardCfg.Rows.Count > 0)
					{
						NBCmnUtil.DataTbl_to_Control(dtBoardCfg.Rows[0], this.Controls);
					}
				}

                dbSqlConn.Close();



				// 그룹 체크 게시판 설정 읽어 오기
				string sGroupLevelUse = SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, "SELECT ISNULL(groupdesigncfg_use, '0') FROM NB_BoardSet WHERE board_no = '" + gBoardNo + "'").ToString();

				dbSqlConn.Close();

				xchk_grouplevel_use.Checked = BoardLib.NBUtil.ConvStrToBool(sGroupLevelUse);


				// 머리말 / 카피라이트 / 꼬리말 형태에 따라서 TextBox의 TextMode 변경
				SetTextModeChg (ddl_header_type, xltr_header_type, txt_header_cont, "표시할 파일의 절대 경로를 입력해 주세요. (예: c:\\Inetpub\\wwwroot\\neboard\\header.htm)");
				SetTextModeChg (ddl_copyright_type, xltr_copyright_type, txt_copyright_cont, "표시할 파일의 절대 경로를 입력해 주세요. (예: c:\\Inetpub\\wwwroot\\neboard\\copyright.htm)");
				SetTextModeChg (ddl_tail_type, xltr_tail_type, txt_tail_cont, "표시할 파일의 절대 경로를 입력해 주세요. (예: c:\\Inetpub\\wwwroot\\neboard\\tail.htm)");
				SetTextModeChg (ddl_boardtitle_view, xltr_title_view, txt_boardtitle_cont, "표시할 파일의 절대 경로를 입력해 주세요. (예: c:\\Inetpub\\wwwroot\\neboard\\tail.htm)");
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}		

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		디자이너 지원에 필요한 메서드입니다. 이 메서드의 내용을
		///		코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{
			this.ddl_boardtitle_view.SelectedIndexChanged += new System.EventHandler(this.ddl_boardtitle_view_SelectedIndexChanged);
			this.ddl_header_type.SelectedIndexChanged += new System.EventHandler(this.ddl_header_type_SelectedIndexChanged);
			this.ddl_copyright_type.SelectedIndexChanged += new System.EventHandler(this.ddl_copyright_type_SelectedIndexChanged);
			this.ddl_tail_type.SelectedIndexChanged += new System.EventHandler(this.ddl_tail_type_SelectedIndexChanged);
			this.imgbtn_design_save.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_design_save_Click);
			this.imbbtn_design_preview.Click += new System.Web.UI.ImageClickEventHandler(this.imbbtn_design_preview_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ddl_header_type_SelectedIndexChanged(object sender, EventArgs e)
		{
			SetTextModeChg (ddl_header_type, xltr_header_type, txt_header_cont, "표시할 파일의 절대 경로를 입력해 주세요. (예: c:\\Inetpub\\wwwroot\\neboard\\header.htm)");
		}

		private void ddl_copyright_type_SelectedIndexChanged(object sender, EventArgs e)
		{
			SetTextModeChg (ddl_copyright_type, xltr_copyright_type, txt_copyright_cont, "표시할 파일의 절대 경로를 입력해 주세요. (예: c:\\Inetpub\\wwwroot\\neboard\\copyright.htm)");
		}

		private void ddl_tail_type_SelectedIndexChanged(object sender, EventArgs e)
		{
			SetTextModeChg (ddl_tail_type, xltr_tail_type, txt_tail_cont, "표시할 파일의 절대 경로를 입력해 주세요. (예: c:\\Inetpub\\wwwroot\\neboard\\tail.htm)");
		}

		private void SetTextModeChg(DropDownList objDdl, Literal ltrHelp, TextBox txtInputBox, string sHelpTxt)
		{
			if (objDdl.SelectedIndex > -1)
			{
				if (objDdl.SelectedValue.Equals("3"))
				{
					ltrHelp.Text = sHelpTxt;
					txtInputBox.TextMode = TextBoxMode.SingleLine;
				}
				else
				{
					ltrHelp.Text = string.Empty;
					txtInputBox.TextMode = TextBoxMode.MultiLine;;
				}
			}
		}

		private void imgbtn_design_save_Click(object sender, ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;
		
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				ArrayList UpdateFields = NBCmnUtil.GetUpdateFields(this.Controls);

				if (UpdateFields.Count > 0)
				{
					string Qry = DBUtil.CreateUpdateQry("NB_DesignCfg", UpdateFields, "board_no = '" + gBoardNo + "'");

					if (Qry.Trim().Length > 0)
					{
						int nUpdate = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, Qry);

						if (nUpdate > 0)
						{
							// 게시판 환경 설정에 그룹 회원 권한설정 업데이트
							nUpdate = SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text,  "UPDATE NB_BoardSet SET groupdesigncfg_use = '" + BoardLib.NBUtil.ConvBoolToStr (xchk_grouplevel_use.Checked) + "' WHERE board_no = '" + gBoardNo + "'");

							NBCmnUtil.DoControlsEnableChange(this.Controls, !xchk_grouplevel_use.Checked);

							if (nUpdate > 0)
								NBCmnUtil.ViewAlertMsg(Page, "수정 완료");
						}
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void ddl_boardtitle_view_SelectedIndexChanged(object sender, EventArgs e)
		{
			SetTextModeChg (ddl_boardtitle_view, xltr_title_view, txt_boardtitle_cont, "표시할 파일의 절대 경로를 입력해 주세요. (예: c:\\Inetpub\\wwwroot\\neboard\\tail.htm)");		
		}

		private void imbbtn_design_preview_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;
		
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				ArrayList UpdateFields = NBCmnUtil.GetUpdateFields(this.Controls);

				if (UpdateFields.Count > 0)
				{
					string Qry = "IF EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'NB_DesignCfg_PV') AND OBJECTPROPERTY(id, N'IsUserTable') = 1) \r\n";
					Qry += "DROP TABLE NB_DesignCfg_PV \r\n";
					Qry += "SELECT * INTO NB_DesignCfg_PV FROM NB_DesignCfg \r\n";
					Qry += DBUtil.CreateUpdateQry("NB_DesignCfg_PV", UpdateFields, "board_no = '" + gBoardNo + "'");

					if (Qry.Trim().Length > 0)
					{
						int nUpdate = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, Qry);

						if (nUpdate > 0)
						{
							if (xchk_grouplevel_use.Checked)
							{
								NBCmnUtil.ViewAlertMsg (Page, "그룹 설정 적용이 체크되어 있으면 게시판별 미리보기를 할 수 없습니다.");
							}
							else
							{
								StringWriter swScript = new StringWriter();

								swScript.WriteLine ("<script language=\"javascript\">");
								swScript.WriteLine ("<!--");
								swScript.WriteLine ("	var objPrevWin = window.open ('/NeBoard/BoardPreview.aspx?bno=" + gBoardNo + "&mode=LIST', 'NBPrevWin', 'width=800,height=600,scrollbars=yes');");
								swScript.WriteLine ("	if (objPrevWin == null)");
								swScript.WriteLine ("		alert ('새창 띄우기가 차단되어 있습니다.');");
								swScript.WriteLine ("	else");
								swScript.WriteLine ("		objPrevWin.window.focus();");
								swScript.WriteLine ("//-->");
								swScript.WriteLine ("</script>");

								Page.RegisterStartupScript ("NBPrevWin", swScript.ToString());
							}
						}							
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}
	}
}
