﻿using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;


namespace NeAdmin.Body.MngPages.BoardPage
{
	/// <summary>
	///		BoardDisplaySet에 대한 요약 설명입니다.
	/// </summary>
	public class BoardDisplaySet : UserControl
	{
		protected LinkButton lnk_basic_set;
		protected LinkButton lnk_display_set;
		protected LinkButton lnk_design_set;
		protected LinkButton lnk_level_set;
		protected LinkButton lnk_category_mng;
		protected CheckBox bitchk_good_use_1;
		protected CheckBox bitchk_good_use_16;
		protected CheckBox bitchk_good_use_32;
		protected CheckBox bitchk_listrownum_use_1;
		protected CheckBox bitchk_write_viewtype_1;
		protected CheckBox bitchk_write_viewtype_16;
		protected CheckBox bitchk_write_viewtype_32;
		protected CheckBox bitchk_homepage_use_2;
		protected CheckBox bitchk_homepage_use_16;
		protected CheckBox bitchk_homepage_use_32;
		protected CheckBox bitchk_wdate_use_1;
		protected CheckBox bitchk_wdate_use_16;
		protected CheckBox bitchk_wdate_use_32;
		protected CheckBox bitchk_email_use_2;
		protected CheckBox bitchk_email_use_16;
		protected CheckBox bitchk_email_use_32;
		protected CheckBox bitchk_hit_use_1;
		protected CheckBox bitchk_hit_use_16;
		protected CheckBox bitchk_hit_use_32;
		protected CheckBox bitchk_ip_use_16;
		protected CheckBox bitchk_ip_use_32;
		protected ImageButton imgbtn_displayset_save;
		protected CheckBox bitchk_write_viewtype_2;

		BoardMng.BoardMng objParentPage;

		protected string gBoardName = string.Empty;
		protected System.Web.UI.WebControls.CheckBox bitchk_writer_with_id_1;
		protected System.Web.UI.WebControls.CheckBox bitchk_writer_with_id_16;
		protected System.Web.UI.WebControls.CheckBox bitchk_writer_with_id_32;
		protected string gBoardNo = string.Empty;

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				NBAdminUtil.GetReqStr(ref gBoardName, ref gBoardNo);

				objParentPage = (BoardMng.BoardMng)this.Parent.Page;

				NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "[<font color='#FFC0C0'>" + gBoardName + "</font>] : 표시 여부 설정", false);

				CfgOldDataLoad();

				SetEnableChk();

				Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
				NBAdminUtil.DisplayAdminAuth (gBoardNo.Substring(0, 3), NBLib.MngAuthRole.BoardItemViewMod, imgbtn_displayset_save, pnlError);
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void SetEnableChk()
		{
			// 글쓰기 항목
			bitchk_write_viewtype_2.Enabled = false;
			bitchk_write_viewtype_2.Checked = true;

			// 일반 사용자 글읽기
			bitchk_write_viewtype_16.Enabled = false;
			bitchk_write_viewtype_16.Checked = true;

			// 관리자 글읽기
			bitchk_write_viewtype_32.Enabled = false;
			bitchk_write_viewtype_32.Checked = true;			
		}

		private void CfgOldDataLoad()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				// 선택 게시판 내용
				DataSet dsBoardCfg = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.GetBoardCfgData(gBoardNo));

				if (dsBoardCfg != null)
				{
					DataTable dtBoardCfg = dsBoardCfg.Tables[0];

					if (dtBoardCfg.Rows.Count > 0)
					{
						NBCmnUtil.DataTbl_to_Control(dtBoardCfg.Rows[0], this.Controls);
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		디자이너 지원에 필요한 메서드입니다. 이 메서드의 내용을
		///		코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtn_displayset_save.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_displayset_save_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private ArrayList GetUploadList()
		{

			int nGoodUseValue = 0;
			int nListRowNumValue = 0;
			int nWriteViewTypeValue = 0;
			int nWriterWithIDValue = 0;
			int nHomePageUseValue = 0;
			int nWDateUseValue = 0;
			int nEmailUseValue = 0;
			int nHitUseValue = 0;
			int nIPUseValue = 0;

			// 체크된 컨트롤로 입력값을 계산 한다.
			foreach (Control CtrlItem in this.Controls)
			{
				if (CtrlItem.ID != null)
				{
					string sCtrlPreFix = CtrlItem.ID.Substring(0, CtrlItem.ID.IndexOf('_'));

					if (sCtrlPreFix.ToUpper().Equals("BITCHK"))
					{
						CheckBox objChkBox = (CheckBox)CtrlItem;

						if (objChkBox.Checked)
						{
							string[] aObjID = objChkBox.ID.Split('_');

							if (aObjID.Length > 1 && BoardLib.NBUtil.ChkNumType(aObjID[aObjID.Length - 1], 0))
							{
								int nSelValue = int.Parse (aObjID[aObjID.Length - 1]);

								string sFieldName = objChkBox.ID.Substring(objChkBox.ID.IndexOf('_') + 1, (objChkBox.ID.LastIndexOf('_') - 1) - objChkBox.ID.IndexOf('_'));

								switch(sFieldName.Trim().ToUpper())
								{
									case "GOOD_USE":
										nGoodUseValue += nSelValue;
										break;
									case "LISTROWNUM_USE":
										nListRowNumValue += nSelValue;
										break;
									case "WRITE_VIEWTYPE":
										nWriteViewTypeValue += nSelValue;
										break;
									case "WRITER_WITH_ID":
										nWriterWithIDValue += nSelValue;
										break;
									case "HOMEPAGE_USE":
										nHomePageUseValue += nSelValue;
										break;
									case "WDATE_USE":
										nWDateUseValue += nSelValue;
										break;
									case "EMAIL_USE":
										nEmailUseValue += nSelValue;
										break;
									case "HIT_USE":
										nHitUseValue += nSelValue;
										break;
									case "IP_USE":
										nIPUseValue += nSelValue;
										break;
								}
							}
						}
					}
				}
			}

            
			// 계산된 값으로 Upload List를 생성 한다.

			ArrayList oUploadArray = new ArrayList();

            oUploadArray.Add(DBUtil.InsertParamItem("good_use", NBLib.FieldQryType.Num, nGoodUseValue.ToString()));
			oUploadArray.Add(DBUtil.InsertParamItem("listrownum_use", NBLib.FieldQryType.Num, nListRowNumValue.ToString()));
			oUploadArray.Add(DBUtil.InsertParamItem("write_viewtype", NBLib.FieldQryType.Num, nWriteViewTypeValue.ToString()));
			oUploadArray.Add(DBUtil.InsertParamItem("writer_with_id", NBLib.FieldQryType.Num, nWriterWithIDValue.ToString()));
			oUploadArray.Add(DBUtil.InsertParamItem("homepage_use", NBLib.FieldQryType.Num, nHomePageUseValue.ToString()));
			oUploadArray.Add(DBUtil.InsertParamItem("wdate_use", NBLib.FieldQryType.Num, nWDateUseValue.ToString()));
			oUploadArray.Add(DBUtil.InsertParamItem("email_use", NBLib.FieldQryType.Num, nEmailUseValue.ToString()));
			oUploadArray.Add(DBUtil.InsertParamItem("hit_use", NBLib.FieldQryType.Num, nHitUseValue.ToString()));
			oUploadArray.Add(DBUtil.InsertParamItem("ip_use", NBLib.FieldQryType.Num, nIPUseValue.ToString()));

            return oUploadArray;
		}

		private void imgbtn_displayset_save_Click(object sender, ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;
		
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				ArrayList UpdateFields = GetUploadList();

				if (UpdateFields.Count > 0)
				{
					string Qry = DBUtil.CreateUpdateQry("NB_BoardCfg", UpdateFields, "board_no = '" + gBoardNo + "'");

					if (Qry.Trim().Length > 0)
					{
						int nUpdate = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, Qry);

						if (nUpdate > 0)
						{
							NBCmnUtil.ViewAlertMsg(Page, "수정 완료");
						}
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}
	}
}

