using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using BoardLib;


namespace NeAdmin.Body.MngPages.BoardPage
{
	

	/// <summary>
	///		BoardEnableSet   Դϴ.
	/// </summary>
	public class BoardEnableSet : UserControl
	{
		protected System.Web.UI.WebControls.CheckBox chk_reply_use;
		protected System.Web.UI.WebControls.CheckBox chk_cmmt_use;
		protected System.Web.UI.WebControls.CheckBox chk_replymail_use;
		protected System.Web.UI.WebControls.CheckBox chk_cmmtmail_use;
		protected System.Web.UI.WebControls.CheckBox chk_listview_use;
		protected System.Web.UI.WebControls.CheckBox chk_agree_use;
		protected System.Web.UI.WebControls.CheckBox chk_hitfire_use;
		protected System.Web.UI.WebControls.TextBox ntxt_hitfire_cnt;
		protected System.Web.UI.WebControls.CheckBox chk_goodfire_use;
		protected System.Web.UI.WebControls.TextBox ntxt_goodfire_cnt;
		protected System.Web.UI.WebControls.CheckBox chk_notice_use;
		protected System.Web.UI.WebControls.CheckBox chk_private_use;
		protected System.Web.UI.WebControls.CheckBox chk_previewcont_use;
		protected System.Web.UI.WebControls.CheckBox chk_category_use;
		protected System.Web.UI.WebControls.CheckBox chk_memo_use;
		protected System.Web.UI.WebControls.CheckBox chk_sitelink_use;
		protected System.Web.UI.WebControls.CheckBox chk_write_alert;
		protected System.Web.UI.WebControls.CheckBox chk_cmmt_alert;
		protected System.Web.UI.WebControls.CheckBox chk_autolink_use;
		protected System.Web.UI.WebControls.ImageButton imgbtn_basicset_save;

		protected string gBoardName = string.Empty;
		protected System.Web.UI.WebControls.CheckBox chk_homebtn_use;
		protected System.Web.UI.WebControls.TextBox txt_homebtn_url;
		protected System.Web.UI.WebControls.CheckBox chk_voteboard_use;
		protected System.Web.UI.WebControls.TextBox ntxt_revote_limit;
		protected System.Web.UI.WebControls.CheckBox chk_adminbtn_use;
		protected System.Web.UI.WebControls.CheckBox chk_rssbtn_use;
		protected System.Web.UI.WebControls.CheckBox chk_memboard_use;
		protected System.Web.UI.WebControls.CheckBox chk_view_userlevel;
		protected System.Web.UI.WebControls.CheckBox chk_async_update_use;
		protected string gBoardNo = string.Empty;

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				NBAdminUtil.GetReqStr(ref gBoardName, ref gBoardNo);

				BoardMng.BoardMng objParentPage = (BoardMng.BoardMng)this.Parent.Page;

				NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "[<font color='#FFC0C0'>" + gBoardName + "</font>] : ׸ 뿩 ", false);

				CfgOldDataLoad();

				set_button_script();

				Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
				NBAdminUtil.DisplayAdminAuth (gBoardNo.Substring(0, 3), NBLib.MngAuthRole.BoardItemUseMod, imgbtn_basicset_save, pnlError);
			}
			catch(Exception E)
			{
				Response.Clear();
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void set_button_script()
		{
			chk_hitfire_use.Attributes["onclick"] = "Do_FireCnt_Default(this, '" + ntxt_hitfire_cnt.ClientID + "');";
			chk_goodfire_use.Attributes["onclick"] = "Do_FireCnt_Default(this, '" + ntxt_goodfire_cnt.ClientID + "');";
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.  ޼ 
		///		ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtn_basicset_save.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_basicset_save_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void CfgOldDataLoad()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				//  Խ 
				DataSet dsBoardCfg = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.GetBoardCfgData(gBoardNo));

				if (dsBoardCfg != null)
				{
					DataTable dtBoardCfg = dsBoardCfg.Tables[0];

					if (dtBoardCfg.Rows.Count > 0)
					{
						NBCmnUtil.DataTbl_to_Control(dtBoardCfg.Rows[0], this.Controls);
					}
				}

			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}		

		private void imgbtn_basicset_save_Click(object sender, ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;
		
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				ArrayList UpdateFields = NBCmnUtil.GetUpdateFields(this.Controls);

				if (UpdateFields.Count > 0)
				{
					string Qry = string.Empty;

					Qry = DBUtil.CreateUpdateQry("NB_BoardCfg", UpdateFields, "board_no = '" + gBoardNo + "'");

					if (Qry.Trim().Length > 0)
					{
						int nUpdate = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, Qry);

						if (nUpdate > 0)
						{
							if (chk_replymail_use.Checked || chk_cmmtmail_use.Checked)
							{
								string sQry = "select count(*) from nb_boardcfg where (email_use & 2) = 2";

								string nEmailUse = SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, sQry).ToString();

								if (nEmailUse.Equals ("0"))
								{
									NBCmnUtil.ViewAlertMsg (Page, @" Ϸ\n\n\n Ͻ ˸ ڸƮ Ͻ ˸ \n\nǥ   ۾⿡ ̸  üũǾ ־ մϴ.");
								}
							}

							NBCmnUtil.ViewAlertMsg(Page, " Ϸ");
						}
						else
						{
							NBCmnUtil.ViewAlertMsg (Page, " ");
						}
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}
	}
}
