using System;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using BoardLib;

namespace NeAdmin.Body.MngPages.BoardPage
{
	/// <summary>
	///		BoardPage_MC   Դϴ.
	/// </summary>
	public class BoardPage_MC : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.HyperLink hyp_basic_set;
		protected System.Web.UI.WebControls.HyperLink hyp_enable_set;
		protected System.Web.UI.WebControls.HyperLink hyp_display_set;
		protected System.Web.UI.WebControls.HyperLink hyp_design_set;
		protected System.Web.UI.WebControls.HyperLink hyp_board_set;
		protected System.Web.UI.WebControls.HyperLink hyp_category_mng;
		protected System.Web.UI.WebControls.HyperLink hyp_boardlevel_mng;

		string gBoardName = string.Empty;
		
		string gBoardNo = string.Empty;

		private void Page_Load(object sender, System.EventArgs e)
		{
			SetHypLink();
		}

		private void SetHypLink()
		{
			NBAdminUtil.GetReqStr (ref gBoardName, ref gBoardNo);

			string sAddQryStr = "&bno=" + gBoardNo + "&bnm=" + Server.UrlEncode(gBoardName);

			string sViewMode = NBCmnUtil.QStrLoad ("vm");

			if (!NBUtil.StrEmptyChk (sViewMode))
			{
				sAddQryStr += "&vm=" + sViewMode;
			}

            hyp_board_set.NavigateUrl = "../../BoardMng/BoardMng.aspx?pgc=BoardPage/BoardSet.ascx" + sAddQryStr;

			if (GetGroupSetUse())
			{
				hyp_basic_set.Enabled = false;
				hyp_basic_set.ToolTip = "׷     ˴ϴ.";
				hyp_enable_set.Enabled = false;
				hyp_enable_set.ToolTip = "׷     ˴ϴ.";
				hyp_display_set.Enabled = false;
				hyp_display_set.ToolTip = "׷     ˴ϴ.";

				string sPgc = NBCmnUtil.QStrLoad("pgc");

				if (
					sPgc.ToUpper().Equals("BOARDPAGE/BOARDBASICSET.ASCX") || 
					sPgc.ToUpper().Equals ("BOARDPAGE/BOARDENABLESET.ASCX") || 
					sPgc.ToUpper().Equals ("BOARDPAGE/BOARDDISPLAYSET.ASCX")
					)
				{
					Response.Redirect ("../BoardMng/BoardMng.aspx?pgc=BoardPage/BoardSet.ascx" + sAddQryStr, false);
				}
			}
			else
			{
				hyp_basic_set.NavigateUrl = "../../BoardMng/BoardMng.aspx?pgc=BoardPage/BoardBasicSet.ascx" + sAddQryStr;
				hyp_enable_set.NavigateUrl = "../../BoardMng/BoardMng.aspx?pgc=BoardPage/BoardEnableSet.ascx" + sAddQryStr;
				hyp_display_set.NavigateUrl = "../../BoardMng/BoardMng.aspx?pgc=BoardPage/BoardDisplaySet.ascx" + sAddQryStr;
			}
			
			hyp_design_set.NavigateUrl = "../../BoardMng/BoardMng.aspx?pgc=BoardPage/BoardDesignSet.ascx" + sAddQryStr;
			hyp_category_mng.NavigateUrl = "../../BoardMng/BoardMng.aspx?pgc=BoardPage/BoardCategorySet.ascx" + sAddQryStr;
			hyp_boardlevel_mng.NavigateUrl = "../../BoardMng/BoardMng.aspx?pgc=BoardPage/BoardLevelMng.ascx" + sAddQryStr;

			if (!NBUtil.StrEmptyChk (Request.QueryString["pgc"]))
			{
				foreach (Control objCtrl in this.Controls)
				{
					if (objCtrl.ID != null && objCtrl.ID.StartsWith("hyp_"))
					{
                        HyperLink objHyp = (HyperLink)objCtrl;

						if (objHyp.NavigateUrl.IndexOf(Request.QueryString["pgc"]) > 0)
						{
                            objHyp.Style["font-weight"] = "bold";
						}
					}
				}
			}

		}

		private bool GetGroupSetUse()
		{
			bool bResult = false;

			try
			{
				string sQry = "SELECT ISNULL(groupboardcfg_use, '0') FROM nb_boardset WHERE board_no = " + DBUtil.QryConvStr(gBoardNo, false);

				string sGrpSet = DBUtil.RunDBToScalar (CommandType.Text, sQry);

				if (NBUtil.ConvStrToBool (sGrpSet))
				{
                    bResult = true;
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}

			return bResult;
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.  ޼ 
		///		ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
