using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;
using BoardLib;
using System.IO;


namespace NeAdmin.Body.MngPages.BoardPage
{
	/// <summary>
	///		BoardSet   Դϴ.
	/// </summary>
	public class BoardSet : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.CheckBox xchk_grouplevel_use;
		protected System.Web.UI.WebControls.TextBox otxt_board_name;
		protected System.Web.UI.WebControls.ImageButton imgbtn_basicset_save;

		protected string gBoardName = string.Empty;
		protected System.Web.UI.WebControls.DropDownList ddlGroupList;
		protected System.Web.UI.WebControls.ImageButton imgBtnBoardTrans;
		protected string gBoardNo = string.Empty;
		
		BoardMng.BoardMng objParentPage;

		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				objParentPage = (BoardMng.BoardMng)this.Parent.Page;

				NBAdminUtil.GetReqStr(ref gBoardName, ref gBoardNo);

				NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "[<font color='#FFC0C0'>" + gBoardName + "</font>] : ⺻ ", false);

				CfgOldDataLoad();

				Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
				NBAdminUtil.DisplayAdminAuth (gBoardNo.Substring(0, 3), NBLib.MngAuthRole.BoardMainCfgMod, imgbtn_basicset_save, pnlError);

				imgBtnBoardTrans.Attributes["onclick"] = "return OkMove();";
			}
			catch(Exception E)
			{
				Response.Clear();
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.  ޼ 
		///		ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtn_basicset_save.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_basicset_save_Click);
			this.imgBtnBoardTrans.Click += new System.Web.UI.ImageClickEventHandler(this.imgBtnBoardTrans_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void CfgOldDataLoad()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				//  Խ 
				DataSet dsBoardCfg = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.GetBoardCfgData(gBoardNo));

				if (dsBoardCfg != null)
				{
					DataTable dtBoardCfg = dsBoardCfg.Tables[0];

					if (dtBoardCfg.Rows.Count > 0)
					{
						NBCmnUtil.DataTbl_to_Control(dtBoardCfg.Rows[0], this.Controls);
					}
				}

				
				// ׷ üũ Խ  о 
				string sGroupLevelUse = SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, "SELECT ISNULL(groupboardcfg_use, '0') FROM NB_BoardSet WHERE board_no = '" + gBoardNo + "'").ToString();

				dbSqlConn.Close();

				xchk_grouplevel_use.Checked = BoardLib.NBUtil.ConvStrToBool(sGroupLevelUse);

				GetGroupList();
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}		

		private void GetGroupList()
		{
			string Qry = "select group_code, group_name from nb_groupinfo where group_code != '" + gBoardNo.Substring(0, 3) + "' order by group_code asc";

			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				DataSet dsData = SqlHelper.ExecuteDataset (dbSqlConn, CommandType.Text, Qry);

				if (dsData != null)
				{
					ddlGroupList.DataSource = dsData;
					ddlGroupList.DataTextField = "group_name";
					ddlGroupList.DataValueField = "group_code";
					ddlGroupList.DataBind();
				}
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}

		private void imgbtn_basicset_save_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if (NBAdminUtil.ChkAdminAuth (gBoardNo.Substring(0, 3), NBLib.MngAuthRole.BoardMainCfgMod))
			{
				SqlConnection dbSqlConn = null;
		
				try
				{
					DBUtil.DBConnection(ref dbSqlConn);

					string Qry = string.Empty;

					Qry = "UPDATE NB_BoardSet SET board_name = " + DBUtil.QryConvStr(otxt_board_name.Text, false) + " WHERE board_no = '" + gBoardNo + "' \r\n";

					if (Qry.Trim().Length > 0)
					{
						int nUpdate = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, Qry);

						if (nUpdate > 0)
						{
							// Խ ȯ  ׷ ȸ Ѽ Ʈ
							nUpdate = SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text,  "UPDATE NB_BoardSet SET groupboardcfg_use = '" + BoardLib.NBUtil.ConvBoolToStr (xchk_grouplevel_use.Checked) + "' WHERE board_no = '" + gBoardNo + "'");

							if (nUpdate > 0)
								NBCmnUtil.ViewMsgGoUrl (Page, Request.Url.ToString(), " Ϸ");
						}
					}
				}
				catch(Exception E)
				{
					NBCmnUtil.ViewAlertMsg (Page, E.Message);
				}
				finally
				{
					DBUtil.DBConnDispose(ref dbSqlConn);
				}	
			}
			else
			{
				NBCmnUtil.ViewAlertMsg(Page, " ϴ.");
			}
		}

		private void imgBtnBoardTrans_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if (ddlGroupList.SelectedIndex > -1)
			{
				string sNewBoardNo = string.Empty;
				string sTarGroupCode = ddlGroupList.SelectedValue;
				string sCurrBoardNo = gBoardNo;

				SqlConnection dbSqlConn = null;

				try
				{
					DBUtil.DBConnection(ref dbSqlConn);

					sNewBoardNo = SqlHelper.ExecuteScalar(dbSqlConn, CommandType.Text, AdminQryLib.NewBoardNo(sTarGroupCode)).ToString();

					dbSqlConn.Close();

					if (sNewBoardNo.Trim().Length > 0)
					{
						sNewBoardNo = sNewBoardNo.PadLeft(6, '0');
                        
						BoardDbReName(dbSqlConn, sCurrBoardNo, sNewBoardNo);

						ReNameBoardDataFolder (sCurrBoardNo, sNewBoardNo);

						objParentPage.DisplayBoardMenu();

						NBCmnUtil.ViewMsgGoUrl (Page, "BoardMng.aspx", "̵ Ϸ");
					}
				}
				catch(Exception E)
				{
					NBCmnUtil.ViewAlertMsg (Page, E.Message);
				}
				finally
				{
					DBUtil.DBConnDispose(ref dbSqlConn);
				}
			}
			else
			{
				NBCmnUtil.ViewAlertMsg (Page, "̵ ׷  ּ.");
			}
		}

		private void ReNameBoardDataFolder(string sBoardNo, string sNewBoardNo)
		{
			string sPath = BoardLib.NBUtil.GetUploadRootPath() + "\\NB_BoardData_" + sBoardNo;
			string sNewPath = BoardLib.NBUtil.GetUploadRootPath() + "\\NB_BoardData_" + sNewBoardNo;

			if (Directory.Exists (sNewPath))
				Directory.Delete (sNewPath, true);

			if (Directory.Exists (sPath))
			{
				Directory.Move (sPath, sNewPath);
			}
		}

		private bool BoardDbReName(SqlConnection dbSqlConn, string sOldBoardNo, string sNewBoardNo)
		{
			bool bResult = false;

			if (sOldBoardNo.Trim().Length > 0 && sNewBoardNo.Trim().Length > 0)
			{
				XmlDocument xmlDoc = new XmlDocument();
				XmlNodeList xmlNodeList;


				// /////////////////////////////////////
				// Խ  ̺  κ
				xmlDoc.Load(Server.MapPath("../../CfgXml/BoardTrans.xml"));

				xmlNodeList = xmlDoc.GetElementsByTagName("Script");

				if (xmlNodeList.Count > 0)
				{
					foreach (XmlNode xNode in  xmlNodeList)
					{
						string sTblCreateQry = xNode.InnerText;

						if (sTblCreateQry.Length > 0)
						{
							sTblCreateQry = Server.HtmlDecode(ReplaceString(sTblCreateQry, sOldBoardNo, sNewBoardNo));

							SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, sTblCreateQry);                            
						}
					}
				}
				
				bResult = true;
			}

			return bResult;
		}

		private string ReplaceString(string sOriginStr, string sBoardNo, string sNewBoardNo)
		{
			// #BoardNo#, #NewBoardNo#
			
			string sResult = sOriginStr.Replace("#BoardNo#", sBoardNo);
			sResult = sResult.Replace("#NewBoardNo#", sNewBoardNo);

			return sResult;

		}
	}
}
