﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;


namespace NeAdmin.Body.MngPages.NBUtilAdmin
{
	/// <summary>
	///		DBState에 대한 요약 설명입니다.
	/// </summary>
	public class DBState : UserControl
	{
		protected DataGrid dObjList;
		BoardMng.BoardMng objParentPage;

		private void Page_Load(object sender, EventArgs e)
		{
			objParentPage = (BoardMng.BoardMng)this.Parent.Page;

			NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "DB 상태보기", false);

			DBStateLoad();
		}

		private void DBStateLoad()
		{
			SqlConnection dbSqlConn = null;
		
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				DataSet dsDBObjList = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.DBObjectList());

				if (dsDBObjList != null)
				{
					DataSet dsDBObjDetail;

					DataRowCollection DBObjListRow = dsDBObjList.Tables[0].Rows;

					DataTable dtObjList = new DataTable("DBObjList");

					dtObjList.Columns.Add("name", typeof(string));
					dtObjList.Columns.Add("rows", typeof(string));
					dtObjList.Columns.Add("data", typeof(string));
					dtObjList.Columns.Add("index_size", typeof(string));
					dtObjList.Columns.Add("crdate", typeof(string));

					DataRow drRows;
					
					foreach (DataRow drItem in DBObjListRow)
					{
						drRows = dtObjList.NewRow();
                        
						drRows["name"] = drItem["name"].ToString();
						drRows["crdate"] = drItem["crdate"].ToString();

                        dsDBObjDetail = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.DBObjectSpaceUsed(drItem["name"].ToString()));

						if (dsDBObjDetail != null)
						{
							drRows["rows"] = dsDBObjDetail.Tables[0].Rows[0]["rows"].ToString();
							drRows["data"] = dsDBObjDetail.Tables[0].Rows[0]["data"].ToString();
							drRows["index_size"] = dsDBObjDetail.Tables[0].Rows[0]["index_size"].ToString();
						}

						dtObjList.Rows.Add(drRows);
					}

					dObjList.DataSource = dtObjList;
					dObjList.DataBind();
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		디자이너 지원에 필요한 메서드입니다. 이 메서드의 내용을
		///		코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
