﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;


namespace NeAdmin.Body.MngPages.NBUtilAdmin
{
	/// <summary>
	///		FindAll에 대한 요약 설명입니다.
	/// </summary>
	public class FindAll : UserControl
	{
		protected TextBox txt_writer;
		protected TextBox txt_mem_id;
		protected TextBox txt_email;
		protected TextBox txt_writer_ip;
		protected TextBox txt_subject;
		protected TextBox txt_content;
		protected DataGrid dFindAll;
		protected DropDownList ddl_top_limit;
		protected ImageButton imgbtn_start_find;
		BoardMng.BoardMng objParentPage;

		private void Page_Load(object sender, EventArgs e)
		{
			objParentPage = (BoardMng.BoardMng)this.Parent.Page;

			NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "게시물 추적", false);

			Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
			NBAdminUtil.DisplayAdminAuth ("", NBLib.MngAuthRole.AllBoardSearch, imgbtn_start_find, pnlError);
		}
		
		// 페이지의 버튼 이벤트를 정의 한다.
		private void DoPageEventSet()
		{
			this.imgbtn_start_find.Click += new ImageClickEventHandler(this.imgbtn_start_find_Click);
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		디자이너 지원에 필요한 메서드입니다. 이 메서드의 내용을
		///		코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtn_start_find.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_start_find_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private string sGetWhereStr()
		{
			string sInputWriter = txt_writer.Text.Trim();
			string sInputMemID = txt_mem_id.Text.Trim();
			string sInputEmail = txt_email.Text.Trim();
			string sInputWriterIP = txt_writer_ip.Text.Trim();
			string sInputSubject = txt_subject.Text.Trim();
			string sInputContent = txt_content.Text.Trim();

			StringWriter QryWhere = new StringWriter();

			QryWhere.WriteLine ("a.guest_no *= b.guest_no");

			// 일반 검색
			if ( !BoardLib.NBUtil.StrEmptyChk(sInputWriter) )
				QryWhere.WriteLine("and a.writer like '%" + sInputWriter + "%'");
			if ( !BoardLib.NBUtil.StrEmptyChk(sInputEmail) )
				QryWhere.WriteLine("and a.email like '%" + sInputEmail + "%'");
			if ( !BoardLib.NBUtil.StrEmptyChk(sInputWriterIP) )
				QryWhere.WriteLine("and a.writer_ip like '%" + sInputWriterIP + "%'");
			if ( !BoardLib.NBUtil.StrEmptyChk(sInputSubject) )
				QryWhere.WriteLine("and a.subject like '%" + sInputSubject + "%'");
			if ( !BoardLib.NBUtil.StrEmptyChk(sInputContent) )
				QryWhere.WriteLine("and a.content like '%" + sInputContent + "%'");
			if ( !BoardLib.NBUtil.StrEmptyChk(sInputMemID) )
				QryWhere.WriteLine("and b.guest_no like '%" + sInputMemID + "%'");

			return QryWhere.ToString();
		}

		private string sGetFromStr()
		{
			string sInputMemID = txt_mem_id.Text.Trim();

			StringWriter QryFrom = new StringWriter();

			// 일반 검색
			QryFrom.WriteLine("(select guest_no from NB_MemberData where mem_id like '%" + sInputMemID + "%')");

			return QryFrom.ToString();
		}

		private string sGetAdvanceQry(string sFieldName, string sInputValue)
		{
			string sResultQry = "";

			if (sInputValue.Trim().Length > 0)
			{
				// char[] charOR = "[OR]".ToCharArray();
				// char[] charAND = "[AND]".ToCharArray();

				// OR 검색
				string[] arrOrSplit = sInputValue.ToUpper().Split('|');

				if (arrOrSplit.Length > 1)
				{
					foreach (string OrSplitItem in arrOrSplit)
					{
						sResultQry += " or " + sFieldName + " like '%" + OrSplitItem + "%' ";
					}
				}

				if (sResultQry.EndsWith("or "))
				{
					sResultQry = sResultQry.Remove(sResultQry.Length - 3, 3);
				}

				// AND 검색
				string[] arrAndSplit = sInputValue.ToUpper().Split('&');

				if (arrAndSplit.Length > 1)
				{
					foreach (string AndSplitItem in arrAndSplit)
					{
						sResultQry += " and " + sFieldName + " like '%" + AndSplitItem + "%' ";
					}
				}

				if (sResultQry.Trim().Length == 0)
				{
					sResultQry = sFieldName + " like '%" + arrOrSplit[0] + "%'";
				}
				else
				{
					if (sResultQry.StartsWith(" or "))
					{
						sResultQry = sResultQry.Remove(0, 4);
					}
					else if (sResultQry.StartsWith(" and "))
					{
						sResultQry = sResultQry.Remove(0, 5);
					}

                    sResultQry = "(" + sResultQry + ")";
				}

				sResultQry = "and " + sResultQry;
			}

			return sResultQry;            
		}

		private void imgbtn_start_find_Click(object sender, ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;
		
			try
			{
				DataTable dtResultTbl = new DataTable("TblFindAll");

				DataRow drResultRow;

				dtResultTbl.Columns.Add("board_name", typeof(string));
				dtResultTbl.Columns.Add("subject", typeof(string));
				dtResultTbl.Columns.Add("write_date", typeof(string));

				DBUtil.DBConnection(ref dbSqlConn);

				DataSet dsBoardTblList = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.GetBoardTableListWithName());

				DataTable dtBoardTblList = dsBoardTblList.Tables[0];

				
				string sTopLimit = string.Empty;

				if (ddl_top_limit.SelectedIndex > -1 && ddl_top_limit.SelectedValue.Trim() != "0")
				{
					sTopLimit = "top " + ddl_top_limit.SelectedValue;
				}

				foreach(DataRow drBoardTblItem in  dtBoardTblList.Rows)
				{
					SqlDataReader drQryRow = SqlHelper.ExecuteReader(dbSqlConn, CommandType.Text, AdminQryLib.GetFindAllQry(drBoardTblItem[0].ToString() + " a, " + sGetFromStr() + " b", sTopLimit, sGetWhereStr()));

					string sBoardNo = drBoardTblItem[0].ToString().Split('_')[2];

					while (drQryRow.Read())
					{
						drResultRow = dtResultTbl.NewRow();
                        
						drResultRow["board_name"] = drBoardTblItem[1].ToString();
						drResultRow["subject"] = "<a href='" + NBUtil.GetBoardTransLink (sBoardNo, "VIEW", "", "", "", "", drQryRow["idx_no"].ToString(), "", "") + "' target='_blank'>" + drQryRow["subject"].ToString() + "</a>";
						drResultRow["write_date"] = drQryRow["write_date"];

						dtResultTbl.Rows.Add(drResultRow);
					}

					dbSqlConn.Close();
				}

				dFindAll.DataSource = dtResultTbl;
				dFindAll.DataBind();
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}
	}
}
