﻿using System;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;

namespace NeAdmin.Body.MngPages.CommonPage
{
	public class BoardRemove : Page
	{
		protected ImageButton imgbtn_remove_start;
		string mBoardNo = string.Empty;

		private void Page_Load(object sender, EventArgs e)
		{
			mBoardNo = NBCmnUtil.QStrLoad ("bno");

			if (NBUtil.StrEmptyChk (mBoardNo))
			{
				NBCmnUtil.ViewMsgAndClose (Page, "선택된 게시판이 없습니다.");
			}
			else
			{
				if ( !NBAdminUtil.ChkAdminAuth (mBoardNo.Substring(0, 3), NBLib.MngAuthRole.BoardDel))
				{
					NBCmnUtil.ViewMsgAndClose (Page, "해당 게시판의 삭제 권한이 없습니다.");
				}
			}
		}			

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// 디자이너 지원에 필요한 메서드입니다.
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{    
			this.imgbtn_remove_start.Click += new ImageClickEventHandler(this.imgbtn_remove_start_Click);
			this.Load += new EventHandler(this.Page_Load);

		}
		#endregion


		private void imgbtn_remove_start_Click(object sender, ImageClickEventArgs e)
		{
			if (NBAdminUtil.ChkAdminAuth (mBoardNo.Substring(0, 3), NBLib.MngAuthRole.BoardDel))
			{
				try
				{
					StringWriter Qry = new StringWriter();

					DataSet dsBoardObjects = DBUtil.RunDBToDataSet (CommandType.Text, AdminQryLib.AllBoardObject(mBoardNo));

				
					// Store Procedure 삭제
					DataTable dtSP = dsBoardObjects.Tables[0];

					if (dtSP != null)
					{
						foreach (DataRow drSP in dtSP.Rows)
						{
							Qry.WriteLine ("DROP PROC " + drSP[0].ToString());
						}
					}
				

					// Table 삭제
					DataTable dtTABLE = dsBoardObjects.Tables[1];

					if (dtTABLE != null)
					{
						foreach (DataRow drTBL in dtTABLE.Rows)
						{
							Qry.WriteLine ("DROP TABLE " + drTBL[0].ToString());
						}
					}


					// Data 삭제
            
					Qry.WriteLine ("BEGIN TRAN");

					Qry.WriteLine ("DELETE NB_BoardSet WHERE board_no = '" + mBoardNo + "'");
					Qry.WriteLine ("DELETE NB_BoardCfg WHERE board_no = '" + mBoardNo + "'");
					Qry.WriteLine ("DELETE NB_CategoryData WHERE board_no = '" + mBoardNo + "'");
					Qry.WriteLine ("DELETE NB_DesignCfg WHERE board_no = '" + mBoardNo + "'");

					Qry.WriteLine ("COMMIT TRAN");

				

					int nRunQry = DBUtil.RunDBToNone (CommandType.Text, Qry.ToString());

					if (nRunQry > 0)
					{
						// 첨부 파일 삭제
						string sUpLoadPath = NBUtil.GetUploadRootPath() + "\\" + "NB_BoardData_" + mBoardNo;

						if (Directory.Exists(sUpLoadPath))
							Directory.Delete (sUpLoadPath, true);

						NBCmnUtil.ViewMsgOpenerReLoad (Page, "게시판 삭제가 성공적으로 이루어 졌습니다.", true);
					}
					else
					{
						throw new Exception ("DB 삭제가 정상적으로 이루어 지지 않았습니다.");
					}
				}
				catch (Exception E)
				{
					NBCmnUtil.ViewAlertMsg (Page, E.Message);
				}
			}
			else
			{
				NBCmnUtil.ViewAlertMsg (Page, "권한이 없습니다.");
			}
		}
	}
}
