using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using BoardLib;

namespace NeAdmin.Body.MngPages.GroupPage
{
	/// <summary>
	/// AuthGroupInfo1   Դϴ.
	/// </summary>
	public class AuthGroupInfo1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.ListBox lst_auth_group;
		protected System.Web.UI.WebControls.Button btn_auth_group_del;
		protected System.Web.UI.WebControls.TextBox txt_auth_group_code;
		protected System.Web.UI.WebControls.TextBox txt_auth_group_name;
		protected System.Web.UI.WebControls.Button btn_auth_group_save;
		protected System.Web.UI.WebControls.Button btn_new_authgroup;
		protected System.Web.UI.WebControls.ListBox lst_sel_auth_code;
		protected System.Web.UI.WebControls.Button btn_auth_code_del;
		protected System.Web.UI.WebControls.ListBox lst_enable_auth_code;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hid_edit_mode;
		protected System.Web.UI.WebControls.Button btn_group_auth_set;
		protected System.Web.UI.WebControls.Button btn_auth_code_add;

		string sGroupCode = string.Empty;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			sGroupCode = NBCmnUtil.QStrLoad ("gc");

			if (!NBAdminUtil.ChkGroupAdmin (sGroupCode))
			{
				lst_auth_group.Enabled = false;
				btn_auth_group_del.Enabled = false;
				btn_auth_group_save.Enabled = false;

				NBCmnUtil.ViewAlertMsg (Page, " ϴ.");
			}
			else
			{
				lst_auth_group.Enabled = true;
				btn_auth_group_del.Enabled = true;
				btn_auth_group_save.Enabled = true;
			}

			if (!IsPostBack)
			{
				DoLoadAuthGroupList();

				if (lst_auth_group.SelectedIndex > -1)
				{
					btn_new_authgroup.Visible = true;
				}
				else
				{
					DoLoadNewAuthGroupCode();
				}

				if (lst_auth_group.Items.Count > 0 && lst_auth_group.SelectedIndex == -1)
				{
                    lst_auth_group.SelectedIndex = 0;
					lst_auth_group_SelectedIndexChanged (null, null);    
				}
			}

			SetButtonScript();

			
		}

		private void SetButtonScript()
		{
			btn_group_auth_set.Attributes["onclick"] = "return WinOpenSimple('GroupAuthSet.aspx?gc=" + sGroupCode + "', 'GroupAdminAdd', 'width=550, height=370')";
		}

		private void DoLoadAuthGroupList()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				DBUtil.DBConnection(ref dbSqlConn);

				SqlDataReader drAuthGroupList = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, AdminQryLib.GetAuthGroupList(sGroupCode));

				lst_auth_group.Items.Clear();

				while (drAuthGroupList.Read())
				{
					lst_auth_group.Items.Add (new ListItem(drAuthGroupList["authgroup_name"].ToString(), drAuthGroupList["authgroup_code"].ToString()));
				}

			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void DoLoadNewAuthGroupCode()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				//  Խ 
				string sNewAuthGroupCode = SqlHelper.ExecuteScalar(dbSqlConn, CommandType.Text, AdminQryLib.GetNewAuthGroupCode(sGroupCode)).ToString();

				if (!NBUtil.StrEmptyChk(sNewAuthGroupCode))
				{
					txt_auth_group_code.Text = sNewAuthGroupCode;
					txt_auth_group_name.Text = string.Empty;
					
					lst_auth_group.SelectedIndex = -1;

					hid_edit_mode.Value = "";
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void lst_auth_group_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (lst_auth_group.SelectedIndex > -1 && !lst_auth_group.SelectedIndex.ToString().Equals(hid_edit_mode.Value))
			{
				txt_auth_group_code.Text = lst_auth_group.SelectedValue;
				txt_auth_group_name.Text = lst_auth_group.SelectedItem.Text;

				LoadCurrAuthCode();
				LoadEnableAuthCode();				
	
				hid_edit_mode.Value = lst_auth_group.SelectedIndex.ToString();

				btn_auth_group_save.Text = " ׷ ";

				btn_new_authgroup.Visible = true;
				btn_auth_group_del.Visible = true;
			}
		}

		private void LoadCurrAuthCode()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				SqlDataReader drAuthList = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, AdminQryLib.GetAuthGroupItems(sGroupCode, lst_auth_group.SelectedValue));

				lst_sel_auth_code.Items.Clear();

				while (drAuthList.Read())
				{
					foreach (string[] AuthItem in NBLib.GetMngAuthRole())
					{
						if (AuthItem[0].Equals(drAuthList["auth_code"].ToString()))
						{
							lst_sel_auth_code.Items.Add (new ListItem(AuthItem[1], AuthItem[0]));
							break;
						}
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void LoadEnableAuthCode()
		{
			lst_enable_auth_code.Items.Clear();

			DataRowCollection drAllowAuth = null;

			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				DataSet dsAllowAuth = SqlHelper.ExecuteDataset (dbSqlConn, CommandType.Text, AdminQryLib.GetGroupAllowAuth(sGroupCode));
                
				if (dsAllowAuth != null)
				{
					drAllowAuth = dsAllowAuth.Tables[0].Rows;
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}

			foreach (string[] AuthItem in NBLib.GetMngAuthRole())
			{
				bool bAllowCode = false;

				if (drAllowAuth != null)
				{
					foreach (DataRow drItem in drAllowAuth)
					{
						if (drItem["auth_code"].Equals (AuthItem[0]))
						{
							bAllowCode = true;
							break;
						}
					}
				}

				if (bAllowCode)
				{
					bool bFindCode = true;

					foreach (ListItem selItem in lst_sel_auth_code.Items)
					{
						if (selItem.Value.Equals(AuthItem[0]))
						{
							bFindCode = false;
							break;
						}
					}

					if (bFindCode)
					{
						lst_enable_auth_code.Items.Add (new ListItem(AuthItem[1], AuthItem[0]));
					}
				}
			}
		}



		private void btn_auth_group_save_Click(object sender, System.EventArgs e)
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				if (!NBUtil.StrEmptyChk(txt_auth_group_code.Text) && !NBUtil.StrEmptyChk(txt_auth_group_name.Text))
				{
					DBUtil.DBConnection(ref dbSqlConn);

					int nRunQry = 0;
					string sMode = string.Empty;
                
					if (lst_auth_group.SelectedIndex > -1)
					{
						// 
						sMode = "U";				
					}
					else
					{
						// ű
						sMode = "N";
					}

					nRunQry = SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, AdminQryLib.UpdateAuthGroup (sMode, sGroupCode, txt_auth_group_code.Text, txt_auth_group_name.Text));

					if (nRunQry > 0)
					{
						DoLoadAuthGroupList();

						DoLoadNewAuthGroupCode();                    

						btn_auth_group_save.Text = " ׷ ߰";

						btn_new_authgroup.Visible = false;
						btn_auth_group_del.Visible = false;

						lst_sel_auth_code.Items.Clear();
						lst_enable_auth_code.Items.Clear();
					}
				}
				else
				{
					throw new Exception(" ׷ ڵ ̸ Է ּ.");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void btn_auth_code_add_Click(object sender, System.EventArgs e)
		{
			try
			{
				// õ  
				if (lst_enable_auth_code.SelectedIndex > -1)
				{
					ArrayList arrItem = new ArrayList();
				    
					foreach (ListItem objItem in lst_enable_auth_code.Items)
					{
						if (objItem.Selected)
						{
							arrItem.Add (objItem.Value);
						}
					}

					if (arrItem.Count > 0)
					{
						for (int i=0; i < arrItem.Count; i++)
						{
							DBUtil.RunDBToNone (CommandType.Text, AdminQryLib.InOutAuthGroupAuth ("IN", sGroupCode, lst_auth_group.SelectedValue, arrItem[i].ToString()));
						}

						LoadCurrAuthCode();
						LoadEnableAuthCode();
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void btn_auth_code_del_Click(object sender, System.EventArgs e)
		{
			try
			{
				// õ  
				if (lst_sel_auth_code.SelectedIndex > -1)
				{
					ArrayList arrItem = new ArrayList();
				    
					foreach (ListItem objItem in lst_sel_auth_code.Items)
					{
						if (objItem.Selected)
						{
							arrItem.Add (objItem.Value);
						}
					}

					if (arrItem.Count > 0)
					{
						for (int i=0; i < arrItem.Count; i++)
						{
							DBUtil.RunDBToNone (CommandType.Text, AdminQryLib.InOutAuthGroupAuth ("OUT", sGroupCode, lst_auth_group.SelectedValue, arrItem[i].ToString()));
						}

						LoadCurrAuthCode();
						LoadEnableAuthCode();
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}



		private void btn_new_authgroup_Click(object sender, System.EventArgs e)
		{
			DoLoadNewAuthGroupCode();

			lst_sel_auth_code.Items.Clear();
			lst_enable_auth_code.Items.Clear();

			btn_auth_group_save.Text = " ׷ ߰";

			btn_new_authgroup.Visible = false;
			btn_auth_group_del.Visible = false;
		}

		private void btn_auth_group_del_Click(object sender, System.EventArgs e)
		{
			if (lst_auth_group.SelectedIndex > -1)
			{
				SqlConnection dbSqlConn = null;
			
				try
				{
					DBUtil.DBConnection(ref dbSqlConn);
						
					int nRunQry = SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, AdminQryLib.DeleteAuthGroup(sGroupCode, lst_auth_group.SelectedValue));

					if (nRunQry > 0)
					{
						DoLoadAuthGroupList();
						DoLoadNewAuthGroupCode();

						lst_sel_auth_code.Items.Clear();
						lst_enable_auth_code.Items.Clear();
					}
				}
				catch(Exception E)
				{
					NBCmnUtil.ViewAlertMsg (Page, E.Message);
				}
				finally
				{
					DBUtil.DBConnDispose(ref dbSqlConn);
				}
			}
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.lst_auth_group.SelectedIndexChanged += new System.EventHandler(this.lst_auth_group_SelectedIndexChanged);
			this.btn_auth_group_del.Click += new System.EventHandler(this.btn_auth_group_del_Click);
			this.btn_auth_group_save.Click += new System.EventHandler(this.btn_auth_group_save_Click);
			this.btn_new_authgroup.Click += new System.EventHandler(this.btn_new_authgroup_Click);
			this.btn_auth_code_del.Click += new System.EventHandler(this.btn_auth_code_del_Click);
			this.btn_auth_code_add.Click += new System.EventHandler(this.btn_auth_code_add_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
