using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using BoardLib;

namespace NeAdmin.Body.MngPages.GroupPage
{
	public class GroupAdminInfo : System.Web.UI.UserControl
	{
		protected System.Web.UI.HtmlControls.HtmlTable tbl_admin_list;
		protected System.Web.UI.WebControls.Button btn_mng_auth_group;
		protected System.Web.UI.WebControls.Button btn_add_admin;
		protected System.Web.UI.WebControls.Button btn_del_admin;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hid_sel_rdo;
		protected System.Web.UI.WebControls.Button btn_mod_admin;

		string sGroupCode = string.Empty;

		private void Page_Load(object sender, System.EventArgs e)
		{
			sGroupCode = NBCmnUtil.QStrLoad("gno");

			BoardMng.BoardMng objParentPage = (BoardMng.BoardMng)this.Parent.Page;

			NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "׷  : <font color='#FFC0C0'>" + NBAdminUtil.GetGroupName(sGroupCode) + "</font> ׷  ", false);

			CfgOldDataLoad();

			SetButtonScript();

			ChkPermission();
		}

		private void ChkPermission()
		{
			if (!NBAdminUtil.ChkGroupAdmin (sGroupCode))
			{
				btn_mng_auth_group.Enabled = false;
				btn_add_admin.Enabled = false;
				btn_del_admin.Enabled = false;
				btn_mod_admin.Enabled = false;
			}
			else
			{
				btn_mng_auth_group.Enabled = true;
				btn_add_admin.Enabled = true;
				btn_del_admin.Enabled = true;
				btn_mod_admin.Enabled = true;
			}
		}

		private void SetButtonScript()
		{
			btn_add_admin.Attributes["onclick"] = "return WinOpenSimple('../MngPages/GroupPage/GroupAdmin_ADD.aspx?gc=" + sGroupCode + "', 'GroupAdminAdd', 'width=280, height=280')";
            btn_mng_auth_group.Attributes["onclick"] = "return WinOpenSimple('../MngPages/GroupPage/AuthGroupInfo.aspx?gc=" + sGroupCode + "', 'AuthGroupInfo', 'width=600, height=610')";
		}

		private void CfgOldDataLoad()
		{
			DataTable dt = DBUtil.RunDBToDataTable (CommandType.Text, AdminQryLib.GetAdminList(sGroupCode));

			HtmlTableRow tblRow = null;
			HtmlTableCell tblCell = null;
			RadioButton rdoBtn = null;

			tbl_admin_list.Rows.Clear();

            tblRow = new HtmlTableRow();

			tblCell = new HtmlTableCell();
			tblCell.Attributes["class"] = "tb_title1";
			tblCell.Width = "30";
			tblCell.Height = "25";
			tblCell.InnerText = "";
			tblRow.Cells.Add (tblCell);

			tblCell = new HtmlTableCell();
			tblCell.Attributes["class"] = "tb_title1";
			tblCell.InnerText = " ̵(̸)";
			tblRow.Cells.Add (tblCell);

			tblCell = new HtmlTableCell();
			tblCell.Attributes["class"] = "tb_title1";
			tblCell.Width = "100";
			tblCell.InnerText = "  ׷";
			tblRow.Cells.Add (tblCell);

			tblCell = new HtmlTableCell();
			tblCell.Attributes["class"] = "tb_title1";
			tblCell.Width = "100";
			tblCell.InnerText = "ź  ׷";
			tblRow.Cells.Add (tblCell);

			tbl_admin_list.Rows.Add (tblRow);

			foreach (DataRow dr in dt.Rows)
			{
                tblRow = new HtmlTableRow();
                
                rdoBtn = new RadioButton();
                rdoBtn.ID = "ga_" + sGroupCode + "_" + dr["guest_no"].ToString();
				rdoBtn.AutoPostBack = true;
				rdoBtn.CheckedChanged += new EventHandler(rdoBtn_CheckedChanged);
				rdoBtn.GroupName = "ga_" + sGroupCode;

				string sAdminName = string.Empty;
				sAdminName = dr["mem_id"].ToString() + "(" + dr["mem_name"].ToString() + ")";
				if (dr["group_admin"].ToString().Equals("1"))
				{
                    sAdminName += "&nbsp;&nbsp;<font class='font_small'><b>+ ׷ </b></font>";
				}

				tblCell = new HtmlTableCell();
				tblCell.Attributes["class"] = "tb_data2";
				tblCell.Align = "center";
				tblCell.Controls.Add (rdoBtn);
				tblRow.Cells.Add (tblCell);

				tblCell = new HtmlTableCell();
				tblCell.Attributes["class"] = "tb_data2";
				tblCell.InnerHtml = sAdminName;
				tblRow.Cells.Add (tblCell);

                ArrayList arrDetail = DBUtil.RunDBToArray (CommandType.Text, AdminQryLib.GetAdminDetail(sGroupCode, dr["guest_no"].ToString()));

                tblCell = new HtmlTableCell();
				tblCell.Attributes["class"] = "tb_data2";
                tblCell.InnerText = arrDetail[3].ToString();
				tblRow.Cells.Add (tblCell);

				tblCell = new HtmlTableCell();
				tblCell.Attributes["class"] = "tb_data2";
				tblCell.InnerText = arrDetail[4].ToString();
				tblRow.Cells.Add (tblCell);

				tbl_admin_list.Rows.Add (tblRow);
			}
		}		

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.  ޼ 
		///		ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btn_del_admin.Click += new System.EventHandler(this.btn_del_admin_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private string[] GetSelID()
		{
			string[] arrSelID = new string[2];

			string sSelID = string.Empty;

			if (tbl_admin_list.Rows.Count > 1)
			{
				foreach (HtmlTableRow tblRow in tbl_admin_list.Rows)
				{
					System.Web.UI.Control webCont = tblRow.Cells[0].Controls[0];

					if (webCont.GetType().ToString().Equals("System.Web.UI.WebControls.RadioButton"))
					{
						RadioButton rdoBtn = (RadioButton)webCont;

						if (rdoBtn.Checked)
						{
							sSelID = rdoBtn.ID;
							break;
						}
					}
				}
			}

			if (!NBUtil.StrEmptyChk (sSelID))
			{
                string[] arrIDSplit = sSelID.Split('_');

				arrSelID[0] = arrIDSplit[1];
                arrSelID[1] = arrIDSplit[2];
			}

            return arrSelID;
		}

		private void btn_del_admin_Click(object sender, System.EventArgs e)
		{
			string[] arrSelID = GetSelID();

			if (NBUtil.StrEmptyChk(arrSelID[0]) || NBUtil.StrEmptyChk(arrSelID[1]))
			{
				NBCmnUtil.ViewAlertMsg (Page, " ڸ  ּ.");
				return;
			}

			if (DBUtil.RunDBToNone (CommandType.Text, AdminQryLib.InOutGroupAdmin ("OUT", arrSelID[0], arrSelID[1])) > 0)
			{
				CfgOldDataLoad();
			}
		}

		private void rdoBtn_CheckedChanged(object sender, EventArgs e)
		{
			RadioButton rdoBtn = (RadioButton)sender;

			string[] arrID = rdoBtn.ID.Split('_');

            btn_mod_admin.Attributes["onclick"] = "return WinOpenSimple('../MngPages/GroupPage/GroupAdmin_MOD.aspx?gc=" + arrID[1] + "&gno=" + arrID[2] + "', 'GroupAdminMod', 'width=210, height=200')";
		}
	}
}
