using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using BoardLib;

namespace NeAdmin.Body.MngPages.GroupPage
{

	public class GroupAdmin_MOD : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.CheckBox chk_group_admin;
	
		string sGroupCode = string.Empty;
		protected System.Web.UI.WebControls.Button btn_save;
		protected System.Web.UI.WebControls.DropDownList ddl_allow_authgroup;
		protected System.Web.UI.WebControls.DropDownList ddl_deny_authgroup;
		string sGuestNo = string.Empty;

		private void Page_Load(object sender, System.EventArgs e)
		{
            sGroupCode = NBCmnUtil.QStrLoad ("gc");
            sGuestNo = NBCmnUtil.QStrLoad ("gno");


			if (NBCmnUtil.GetCookieValue ("NEADMIN_MBNO").Equals (NBLib.SuperAdmin))
			{
				chk_group_admin.Enabled = true;
			}
			else
			{
				chk_group_admin.Enabled = false;
			}

			if (!IsPostBack)
			{
				GetOldDataLoad();
			}
		}

		private void GetOldDataLoad()
		{
			DoAuthGroupListLoad();
			DoDetailDataLoad();			
		}

		private void DoDetailDataLoad()
		{
			ArrayList arrData = DBUtil.RunDBToArray (CommandType.Text, AdminQryLib.GetAdminDetail (sGroupCode, sGuestNo));

			DoDetailDataBind(arrData[0].ToString(), arrData[1].ToString(), arrData[2].ToString(), arrData[3].ToString(), arrData[4].ToString());
		}

		private void DoDetailDataBind(string sGroupAdmin, string sAllowCode, string sDdenyCode, string sAllowName, string sDenyName)
		{
			chk_group_admin.Checked = NBUtil.isUseChk(sGroupAdmin);

			NBUtil.lstctrl_chk (ddl_allow_authgroup, sAllowCode);
			NBUtil.lstctrl_chk (ddl_deny_authgroup, sDdenyCode);
		}

		
		private void DoAuthGroupListLoad()
		{
			ddl_allow_authgroup.Items.Clear();
			ddl_deny_authgroup.Items.Clear();

			ddl_allow_authgroup.Items.Add (new ListItem (" ּ", ""));
			ddl_deny_authgroup.Items.Add (new ListItem (" ּ", ""));

			DataTable dt = DBUtil.RunDBToDataTable (CommandType.Text, AdminQryLib.GetAuthGroupList(sGroupCode));

			if (dt != null)
			{
				foreach (DataRow dr in dt.Rows)
				{
					ddl_allow_authgroup.Items.Add (new ListItem(dr["authgroup_name"].ToString(), dr["authgroup_code"].ToString()));
					ddl_deny_authgroup.Items.Add (new ListItem(dr["authgroup_name"].ToString(), dr["authgroup_code"].ToString()));
				}
			}
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btn_save.Click += new System.EventHandler(this.btn_save_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btn_save_Click(object sender, System.EventArgs e)
		{
			if (DBUtil.RunDBToNone (CommandType.Text, AdminQryLib.UpdateAuthGroupInfo (sGroupCode, sGuestNo, NBUtil.ConvBoolToStr (chk_group_admin.Checked), ddl_allow_authgroup.SelectedValue, ddl_deny_authgroup.SelectedValue)) > 0)
			{
				NBCmnUtil.ViewMsgOpenerReLoadUrl (Page, " Ͽϴ.", true, "/neadmin/Body/BoardMng/BoardMng.aspx?pgc=GroupPage/GroupAdminInfo.ascx&gno=" + sGroupCode);
			}
			else
			{
				NBCmnUtil.ViewAlertMsg (Page, " ");
			}
		}
	}
}
