using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using BoardLib;

namespace NeAdmin.Body.MngPages.GroupPage
{
	/// <summary>
	/// GroupAuthSet1   Դϴ.
	/// </summary>
	public class GroupAuthSet1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.ListBox lst_sel_auth_code;
		protected System.Web.UI.WebControls.Button btn_out_aith;
		protected System.Web.UI.WebControls.Button btn_in_auth;
		protected System.Web.UI.WebControls.ListBox lst_enable_auth_code;

		string sGroupCode = string.Empty;

		private void Page_Load(object sender, System.EventArgs e)
		{
			sGroupCode = NBCmnUtil.QStrLoad ("gc");

			if (!NBCmnUtil.GetCookieValue ("NEADMIN_MBNO").Equals (NBLib.SuperAdmin))
			{
				btn_in_auth.Enabled = false;
				btn_out_aith.Enabled = false;

				NBCmnUtil.ViewAlertMsg (Page, " ϴ.");
			}

			if (!IsPostBack)
			{
				CfgOldDataLoad();
				LoadEnableAuthCode();
			}
		}

		private void CfgOldDataLoad()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				SqlDataReader drGroupAllowAuth = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, AdminQryLib.GetGroupAllowAuth(sGroupCode));

				lst_sel_auth_code.Items.Clear();

				while (drGroupAllowAuth.Read())
				{
					foreach (string[] AuthItem in NBLib.GetMngAuthRole())
					{
						if (AuthItem[0].Equals(drGroupAllowAuth["auth_code"].ToString()))
						{
							lst_sel_auth_code.Items.Add (new ListItem(AuthItem[1], AuthItem[0]));
							break;
						}
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}
	
		private void LoadEnableAuthCode()
		{
			lst_enable_auth_code.Items.Clear();

			foreach (string[] AuthItem in NBLib.GetMngAuthRole())
			{
				bool bFindCode = true;

				foreach (ListItem selItem in lst_sel_auth_code.Items)
				{
					if (selItem.Value.Equals(AuthItem[0]))
					{
						bFindCode = false;
						break;
					}
				}

				if (bFindCode)
				{
					lst_enable_auth_code.Items.Add (new ListItem(AuthItem[1], AuthItem[0]));
				}
			}
		}

		private void btn_in_auth_Click(object sender, System.EventArgs e)
		{
			try
			{
				// õ  
				if (lst_enable_auth_code.SelectedIndex > -1)
				{
					ArrayList arrItem = new ArrayList();
				    
					foreach (ListItem objItem in lst_enable_auth_code.Items)
					{
						if (objItem.Selected)
						{
							bool bDupChk = false;

							foreach (ListItem selItem in lst_sel_auth_code.Items)
							{
								if (selItem.Value.Equals(objItem.Value))
								{
                                    bDupChk = true;
									break;
								}
							}

							if (!bDupChk)
							{
								arrItem.Add (objItem.Value);
							}
						}
					}

					if (arrItem.Count > 0)
					{
						for (int i=0; i < arrItem.Count; i++)
						{
                            DBUtil.RunDBToNone (CommandType.Text, AdminQryLib.InOutAllowAuth ("IN", sGroupCode, arrItem[i].ToString()));
						}

						CfgOldDataLoad();
						LoadEnableAuthCode();
					}
				}
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void btn_out_aith_Click(object sender, System.EventArgs e)
		{
			// õ  
			try
			{
				// õ  
				if (lst_sel_auth_code.SelectedIndex > -1)
				{
					ArrayList arrItem = new ArrayList();
				    
					foreach (ListItem objItem in lst_sel_auth_code.Items)
					{
						if (objItem.Selected)
						{
							arrItem.Add (objItem.Value);
						}
					}

					if (arrItem.Count > 0)
					{
						for (int i=0; i < arrItem.Count; i++)
						{
							DBUtil.RunDBToNone (CommandType.Text, AdminQryLib.InOutAllowAuth ("OUT", sGroupCode, arrItem[i].ToString()));
						}

						CfgOldDataLoad();
						LoadEnableAuthCode();
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btn_out_aith.Click += new System.EventHandler(this.btn_out_aith_Click);
			this.btn_in_auth.Click += new System.EventHandler(this.btn_in_auth_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
