using System;
using System.Configuration;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;
using System.IO;
using BoardLib;


namespace NeAdmin.Body.MngPages.GroupPage
{
	public class GroupBoardCfg : System.Web.UI.UserControl
	{
		#region Controls
		protected CheckBox chk_fileupdown_use;
		protected CheckBox chk_homebtn_use;
		protected CheckBox chk_replyview_use;
		protected CheckBox chk_badword_use;
		protected TextBox txt_badword_word;
		protected TextBox txt_use_htmltag;
		protected TextBox txt_cut_ip;
		protected TextBox txt_homebtn_url;
		protected TextBox ntxt_fileup_size;
		protected TextBox ntxt_listrow_cnt;
		protected TextBox ntxt_pagingnum_cnt;
		protected TextBox ntxt_newicon_term;
		protected TextBox ntxt_subjectlen_cnt;
		protected TextBox ntxt_errlog_limitcnt;
		protected TextBox ntxt_goodfire_cnt;
		protected TextBox txt_fileup_ext;
		protected Literal xltr_max_request_length;
		protected CheckBox chk_fileup_ext_use;
		protected CheckBox chk_cut_ip_use;
		protected RadioButtonList rdolst_html_use;
		protected ImageButton imgbtn_basicset_save;
		protected TextBox txt_writer_limit;
		protected CheckBox chk_cmmt_sort;
		protected TextBox txt_rss_encoding;
		protected CheckBox chk_list_imgview;
		protected TextBox ntxt_list_imgview_width;
		protected TextBox ntxt_list_imgview_height;
		protected TextBox ntxt_img_thumb_width;
		protected TextBox ntxt_img_thumb_height;
		protected TextBox ntxt_file_up_cnt;
		protected TextBox txt_default_cont;
		protected TextBox txt_afterlogin_url;
		protected RadioButtonList rdolst_memboard_use;
		protected System.Web.UI.WebControls.CheckBox chk_musicboard_use;
		protected System.Web.UI.WebControls.DropDownList ddl_musicplayer_skin;
		protected System.Web.UI.WebControls.CheckBox chk_voteboard_use;
		protected System.Web.UI.WebControls.TextBox ntxt_revote_limit;
		protected System.Web.UI.WebControls.RadioButtonList rdolst_vote_disp_type;
		protected System.Web.UI.WebControls.TextBox txt_vote_start;
		protected System.Web.UI.WebControls.TextBox txt_vote_end;

		BoardMng.BoardMng objParentPage;
		protected System.Web.UI.WebControls.TextBox txt_afterwrite_url;
		protected System.Web.UI.WebControls.TextBox txt_afteredit_url;
		protected System.Web.UI.WebControls.TextBox ntxt_updateicon_term;

		string sGroupCode = string.Empty;

		#endregion

		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				sGroupCode = NBCmnUtil.QStrLoad("gno");

				objParentPage = (BoardMng.BoardMng)this.Parent.Page;

				NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "׷  : <font color='#FFC0C0'>" + NBAdminUtil.GetGroupName(sGroupCode) + "</font> Խ ⺻ ", false);

				DoGroupInitInsert();

				CfgOldDataLoad();

				set_button_script();
			}
			catch(Exception E)
			{
				Response.Clear();
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void set_button_script()
		{
			chk_fileupdown_use.Attributes["onclick"] = "Do_FileUp_Default(this, '" + ntxt_file_up_cnt.ClientID + "', '" + ntxt_fileup_size.ClientID + "');";
			chk_list_imgview.Attributes["onclick"] = "Do_ListImg_Default(this, '" + ntxt_list_imgview_width.ClientID + "', '" + ntxt_list_imgview_height.ClientID + "');";
		}

		private void DoGroupInitInsert()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				string sQry = string.Empty;

				sQry = "SELECT COUNT(group_code) FROM NB_GroupBoardCfg WHERE group_code = " + DBUtil.QryConvStr (sGroupCode, false);

				if (int.Parse(SqlHelper.ExecuteScalar(dbSqlConn, CommandType.Text, sQry).ToString()) == 0)
				{
					sQry = "INSERT INTO NB_GroupBoardCfg (group_code) VALUES (" + DBUtil.QryConvStr (sGroupCode, false) + ")";

					SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sQry);
				}                			
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void CfgOldDataLoad()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				ddl_musicplayer_skin.Items.Clear();

				// Ų  Ų Ʈ ˻
				ddl_musicplayer_skin.Items.Add(new ListItem(" ȵ", ""));

				DirectoryInfo fsSkinDir = new DirectoryInfo(Server.MapPath(ConfigurationSettings.AppSettings["NeBoardPath"] + "/SkinTemplates/MPlayerSkin/"));

				if (fsSkinDir.GetDirectories().Length > 0)
				{
					foreach (DirectoryInfo dirInfo in fsSkinDir.GetDirectories())
					{
						ddl_musicplayer_skin.Items.Add(new ListItem(dirInfo.Name, dirInfo.Name));
					}
				}

				//  Խ 
				DataSet dsBoardCfg = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.GetGroupBoardCfgData(sGroupCode));

				if (dsBoardCfg != null)
				{
					DataTable dtBoardCfg = dsBoardCfg.Tables[0];

					if (dtBoardCfg.Rows.Count > 0)
					{
						NBCmnUtil.DataTbl_to_Control(dtBoardCfg.Rows[0], this.Controls);
					}
				}

				//  

				XmlDocument xmlDoc = new XmlDocument();
				xmlDoc.Load(Server.MapPath ("../../web.config"));
				XmlNode xNode = xmlDoc.SelectSingleNode ("/configuration/system.web/httpRuntime");

				if (!BoardLib.NBUtil.StrEmptyChk (xNode.Attributes["maxRequestLength"].Value) &&
					int.Parse (xNode.Attributes["maxRequestLength"].Value) > 0)
				{
					xltr_max_request_length.Text = int.Parse (xNode.Attributes["maxRequestLength"].Value).ToString("#,##0") + "KB  ε ";
				}
				else
				{
					xltr_max_request_length.Text = "";
				}

				Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
                NBAdminUtil.DisplayAdminAuth (sGroupCode, NBLib.MngAuthRole.GrpInfoMod, imgbtn_basicset_save, pnlError);

			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}		

		private void imgbtn_basicset_save_Click(object sender, ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;
		
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				ArrayList UpdateFields = NBCmnUtil.GetUpdateFields(this.Controls);

				if (UpdateFields.Count > 0)
				{
					string Qry = string.Empty;

					Qry = DBUtil.CreateUpdateQry("NB_GroupBoardCfg", UpdateFields, "group_code = '" + sGroupCode + "'");

					if (Qry.Trim().Length > 0)
					{
						int nUpdate = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, Qry);

						if (nUpdate > 0)
						{
							if (chk_musicboard_use.Checked)
							{
								string sMsg = @" Ϸ\n\n";
								sMsg += @"ǰԽ Ͻ     Խǿ Ų  ּž մϴ.\n";
								sMsg += @" Ų MusicCenter_e Ǵ MusicCenter_k  Ȯֽñ ٶϴ.";
								NBCmnUtil.ViewAlertMsg(Page, sMsg);
							}
							else
							{
								NBCmnUtil.ViewAlertMsg(Page, " Ϸ");
							}
						}

					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.  ޼ 
		///		ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtn_basicset_save.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_basicset_save_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
