using System;
using System.Configuration;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;


namespace NeAdmin.Body.MngPages.GroupPage
{
	/// <summary>
	///		GroupDesignCfg   Դϴ.
	/// </summary>
	public class GroupDesignCfg : System.Web.UI.UserControl
	{
		#region Controls
		protected System.Web.UI.WebControls.DropDownList ddl_skin_path;
		protected System.Web.UI.WebControls.DropDownList ddl_boardtitle_view;
		protected System.Web.UI.WebControls.Literal xltr_title_view;
		protected System.Web.UI.WebControls.TextBox txt_boardtitle_cont;
		protected System.Web.UI.WebControls.TextBox txt_pagebg_color;
		protected System.Web.UI.WebControls.TextBox txt_pagebg_img;
		protected System.Web.UI.WebControls.TextBox txt_boardbg_color;
		protected System.Web.UI.WebControls.TextBox txt_boardbg_img;
		protected System.Web.UI.WebControls.TextBox ntxt_board_width;
		protected System.Web.UI.WebControls.DropDownList ddl_board_align;
		protected System.Web.UI.WebControls.TextBox txt_noticebg_color;
		protected System.Web.UI.WebControls.TextBox txt_noticefont_color;
		protected System.Web.UI.WebControls.TextBox txt_noticeover_color;
		protected System.Web.UI.WebControls.TextBox txt_evenbg_color;
		protected System.Web.UI.WebControls.TextBox txt_evenfont_color;
		protected System.Web.UI.WebControls.TextBox txt_evenover_color;
		protected System.Web.UI.WebControls.TextBox txt_oddbg_color;
		protected System.Web.UI.WebControls.TextBox txt_oddfont_color;
		protected System.Web.UI.WebControls.TextBox txt_oddover_color;
		protected System.Web.UI.WebControls.TextBox txt_hitfire_color;
		protected System.Web.UI.WebControls.TextBox txt_goodfire_color;
		protected System.Web.UI.WebControls.DropDownList ddl_header_type;
		protected System.Web.UI.WebControls.Literal xltr_header_type;
		protected System.Web.UI.WebControls.TextBox txt_header_cont;
		protected System.Web.UI.WebControls.DropDownList ddl_copyright_type;
		protected System.Web.UI.WebControls.Literal xltr_copyright_type;
		protected System.Web.UI.WebControls.TextBox txt_copyright_cont;
		protected System.Web.UI.WebControls.DropDownList ddl_tail_type;
		protected System.Web.UI.WebControls.Literal xltr_tail_type;
		protected System.Web.UI.WebControls.TextBox txt_tail_cont;
		protected System.Web.UI.WebControls.TextBox txt_sbar_style;
		protected System.Web.UI.WebControls.ImageButton imgbtn_design_save;
		protected System.Web.UI.WebControls.TextBox txt_browser_title;

		string sGroupCode = string.Empty;
		string sFirstBoard = string.Empty;
		protected System.Web.UI.WebControls.ImageButton imgbtn_design_preview;

		BoardMng.BoardMng objParentPage;
		#endregion

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				sGroupCode = NBCmnUtil.QStrLoad("gno");

				objParentPage = (BoardMng.BoardMng)this.Parent.Page;

				NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "׷  : <font color='#FFC0C0'>" + NBAdminUtil.GetGroupName(sGroupCode) + "</font> Խ  ", false);

				DoGroupInitInsert();

				CfgOldDataLoad();

				GetLoadFirstBoard();
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void GetLoadFirstBoard()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				string sQry = "select top 1 board_no from nb_boardset where board_no like '" + sGroupCode + "___' and groupdesigncfg_use = '1' order by board_no asc";

                object sBoardNo = SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, sQry);

				if (sBoardNo != null)
				{
					if (!NBUtil.StrEmptyChk(sBoardNo.ToString()))
					{
						sFirstBoard = sBoardNo.ToString();
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}


		private void DoGroupInitInsert()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				string sQry = string.Empty;

				sQry = "SELECT COUNT(group_code) FROM NB_GroupDesignCfg WHERE group_code = " + DBUtil.QryConvStr (sGroupCode, false);

				if (int.Parse(SqlHelper.ExecuteScalar(dbSqlConn, CommandType.Text, sQry).ToString()) == 0)
				{
                    sQry = "INSERT INTO NB_GroupDesignCfg (group_code) VALUES (" + DBUtil.QryConvStr (sGroupCode, false) + ")";

					SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sQry);
				}                			
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void CfgOldDataLoad()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				ddl_skin_path.Items.Clear();

				// Ų  Ų Ʈ ˻
				ddl_skin_path.Items.Add(new ListItem(" ȵ", ""));

				DirectoryInfo fsSkinDir = new DirectoryInfo(Server.MapPath(ConfigurationSettings.AppSettings["NeBoardPath"] + "/SkinTemplates/BoardSkin/"));

				if (fsSkinDir.GetDirectories().Length > 0)
				{
					foreach (DirectoryInfo dirInfo in fsSkinDir.GetDirectories())
					{
						ddl_skin_path.Items.Add(new ListItem(dirInfo.Name, dirInfo.Name));
					}
				}


				DBUtil.DBConnection(ref dbSqlConn);

				//  Խ  
				DataSet dsBoardCfg = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.GetGroupDesignCfgData(sGroupCode));

				if (dsBoardCfg != null)
				{
					DataTable dtBoardCfg = dsBoardCfg.Tables[0];

					if (dtBoardCfg.Rows.Count > 0)
					{
						NBCmnUtil.DataTbl_to_Control(dtBoardCfg.Rows[0], this.Controls);
					}
				}


				// Ӹ / īǶƮ /  ¿  TextBox TextMode 
				SetTextModeChg (ddl_header_type, xltr_header_type, txt_header_cont, "ǥ   θ Է ּ. (: c:\\Inetpub\\wwwroot\\neboard\\header.htm)");
				SetTextModeChg (ddl_copyright_type, xltr_copyright_type, txt_copyright_cont, "ǥ   θ Է ּ. (: c:\\Inetpub\\wwwroot\\neboard\\copyright.htm)");
				SetTextModeChg (ddl_tail_type, xltr_tail_type, txt_tail_cont, "ǥ   θ Է ּ. (: c:\\Inetpub\\wwwroot\\neboard\\tail.htm)");
				SetTextModeChg (ddl_boardtitle_view, xltr_title_view, txt_boardtitle_cont, "ǥ   θ Է ּ. (: c:\\Inetpub\\wwwroot\\neboard\\tail.htm)");		

				
				Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
				NBAdminUtil.DisplayAdminAuth (sGroupCode, NBLib.MngAuthRole.GrpInfoMod, imgbtn_design_save, pnlError);
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}		

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.  ޼ 
		///		ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.ddl_boardtitle_view.SelectedIndexChanged += new System.EventHandler(this.ddl_boardtitle_view_SelectedIndexChanged);
			this.ddl_header_type.SelectedIndexChanged += new System.EventHandler(this.ddl_header_type_SelectedIndexChanged);
			this.ddl_copyright_type.SelectedIndexChanged += new System.EventHandler(this.ddl_copyright_type_SelectedIndexChanged);
			this.ddl_tail_type.SelectedIndexChanged += new System.EventHandler(this.ddl_tail_type_SelectedIndexChanged);
			this.imgbtn_design_save.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_design_save_Click);
			this.imgbtn_design_preview.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_design_preview_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void ddl_header_type_SelectedIndexChanged(object sender, EventArgs e)
		{
			SetTextModeChg (ddl_header_type, xltr_header_type, txt_header_cont, "ǥ   θ Է ּ. (: c:\\Inetpub\\wwwroot\\neboard\\header.htm)");
		}

		private void ddl_copyright_type_SelectedIndexChanged(object sender, EventArgs e)
		{
			SetTextModeChg (ddl_copyright_type, xltr_copyright_type, txt_copyright_cont, "ǥ   θ Է ּ. (: c:\\Inetpub\\wwwroot\\neboard\\copyright.htm)");
		}

		private void ddl_tail_type_SelectedIndexChanged(object sender, EventArgs e)
		{
			SetTextModeChg (ddl_tail_type, xltr_tail_type, txt_tail_cont, "ǥ   θ Է ּ. (: c:\\Inetpub\\wwwroot\\neboard\\tail.htm)");
		}

		private void SetTextModeChg(DropDownList objDdl, Literal ltrHelp, TextBox txtInputBox, string sHelpTxt)
		{
			if (objDdl.SelectedIndex > -1)
			{
				if (objDdl.SelectedValue.Equals("3"))
				{
					ltrHelp.Text = sHelpTxt;
					txtInputBox.TextMode = TextBoxMode.SingleLine;
				}
				else
				{
					ltrHelp.Text = string.Empty;
					txtInputBox.TextMode = TextBoxMode.MultiLine;;
				}
			}
		}

		private void imgbtn_design_save_Click(object sender, ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;
		
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				ArrayList UpdateFields = NBCmnUtil.GetUpdateFields(this.Controls);

				if (UpdateFields.Count > 0)
				{
					string Qry = DBUtil.CreateUpdateQry("NB_GroupDesignCfg", UpdateFields, "group_code = '" + sGroupCode + "'");

					if (Qry.Trim().Length > 0)
					{
						int nUpdate = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, Qry);

						if (nUpdate > 0)
							NBCmnUtil.ViewAlertMsg (Page, " Ϸ");
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void ddl_boardtitle_view_SelectedIndexChanged(object sender, EventArgs e)
		{
			SetTextModeChg (ddl_boardtitle_view, xltr_title_view, txt_boardtitle_cont, "ǥ   θ Է ּ. (: c:\\Inetpub\\wwwroot\\neboard\\tail.htm)");		
		}

		private void imgbtn_design_preview_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;
		
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				ArrayList UpdateFields = NBCmnUtil.GetUpdateFields(this.Controls);

				if (UpdateFields.Count > 0)
				{
					string Qry = "IF EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'NB_GroupDesignCfg_PV') AND OBJECTPROPERTY(id, N'IsUserTable') = 1) \r\n";
					Qry += "DROP TABLE NB_GroupDesignCfg_PV \r\n";
					Qry += "SELECT * INTO NB_GroupDesignCfg_PV FROM NB_GroupDesignCfg \r\n";
					Qry += DBUtil.CreateUpdateQry("NB_GroupDesignCfg_PV", UpdateFields, "group_code = '" + sGroupCode + "'");

					if (Qry.Trim().Length > 0)
					{
						int nUpdate = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, Qry);

						if (nUpdate > 0)
						{
							if (NBUtil.StrEmptyChk(sFirstBoard))
							{
                                NBCmnUtil.ViewAlertMsg (Page, @"׷  ӹ޴ Խ ϴ.\n\n׷  ӹ޴ Խ ־ ̸Ⱑ  մϴ.");
							}
							else
							{
								StringWriter swScript = new StringWriter();

								swScript.WriteLine ("<script language=\"javascript\">");
								swScript.WriteLine ("<!--");
								swScript.WriteLine ("	var objPrevWin = window.open ('/NeBoard/BoardPreview.aspx?bno=" + sFirstBoard + "&mode=LIST', 'NBPrevWin', 'width=800,height=600,scrollbars=yes');");
								swScript.WriteLine ("	if (objPrevWin == null)");
								swScript.WriteLine ("		alert ('â Ⱑ ܵǾ ֽϴ.');");
								swScript.WriteLine ("	else");
								swScript.WriteLine ("		objPrevWin.window.focus();");
								swScript.WriteLine ("//-->");
								swScript.WriteLine ("</script>");

								Page.RegisterStartupScript ("NBPrevWin", swScript.ToString());
							}
						}							
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}		
		}
	}
}
