﻿using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;

using System.IO;


namespace NeAdmin.Body.MngPages.GroupPage
{
	/// <summary>
	///		GroupLevelMng에 대한 요약 설명입니다.
	/// </summary>
	public class GroupLevelMng : UserControl
	{
		protected System.Web.UI.WebControls.Table tbl_level_item_set;
		protected System.Web.UI.WebControls.CheckBox chk_inherit_level;
		protected System.Web.UI.WebControls.DropDownList ddl_join_base_level;
		protected System.Web.UI.WebControls.ImageButton imgbtn_save;
		protected System.Web.UI.WebControls.Button btn_load_lvl;
		protected System.Web.UI.WebControls.Button btn_lvl_mod;

		string sGroupCode = string.Empty;
	
		private void Page_Load(object sender, EventArgs e)
		{
			sGroupCode = NBCmnUtil.QStrLoad("gno");

			BoardMng.BoardMng objParentPage = (BoardMng.BoardMng)this.Parent.Page;

			NBAdminUtil.view_pagetitle ((Label)objParentPage.FindControl("lbl_page_name"), "그룹 관리 : <font color='#FFC0C0'>" + NBAdminUtil.GetGroupName(sGroupCode) + "</font> 그룹 회원 등급 설정", false);

			DoLoadOldData();

			BindLevelItem();

			SetDisable();

			ButtonScriptSet();

			if (!NBAdminUtil.ChkAdminAuth(sGroupCode, NBLib.MngAuthRole.GrpInfoMod))
				NBCmnUtil.ViewMsgGoBack (Page, "권한이 없습니다.");
		}


		private void ButtonScriptSet()
		{
			btn_lvl_mod.Attributes["onclick"] = "return WinOpenSimple('../MngPages/GroupPage/GroupLevelMng_Detail.aspx?gc=" + sGroupCode + "', 'GroupLevelMng_Detail', 'width=560, height=280')";
		}


		private void DoLoadOldData()
		{
            DataTable dt = DBUtil.RunDBToDataTable (CommandType.Text, AdminQryLib.GetGroupLevelList(sGroupCode));

			ddl_join_base_level.DataSource = dt;
			ddl_join_base_level.DataTextField = "level_name";
			ddl_join_base_level.DataValueField = "level_code";
            ddl_join_base_level.DataBind();

			ArrayList arrOldData = DBUtil.RunDBToArray (CommandType.Text, "SELECT level_inherit, join_level FROM NB_GroupInfo WHERE group_code = '" + sGroupCode + "'");
			chk_inherit_level.Checked = NBUtil.ConvStrToBool (arrOldData[0].ToString());
			NBUtil.lstctrl_chk (ddl_join_base_level, arrOldData[1].ToString());
		}

		private void SetDisable()
		{
			if (chk_inherit_level.Checked)
			{
				ddl_join_base_level.Enabled = false;
				btn_load_lvl.Enabled = false;
				btn_lvl_mod.Enabled = false;
			}
			else
			{
				ddl_join_base_level.Enabled = true;
				btn_load_lvl.Enabled = true;
				btn_lvl_mod.Enabled = true;
			}
		}

		private void imgbtn_save_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			try
			{
				if (NBAdminUtil.ChkAdminAuth(sGroupCode, NBLib.MngAuthRole.GrpInfoMod))
				{
					StringWriter QryUp = new StringWriter();

					QryUp.WriteLine ("UPDATE NB_GroupInfo SET");
					QryUp.WriteLine ("	level_inherit = '" + NBUtil.ConvBoolToStr (chk_inherit_level.Checked) + "', ");
					QryUp.WriteLine ("	join_level = '" + ddl_join_base_level.SelectedValue + "' ");
					QryUp.WriteLine ("WHERE");
					QryUp.WriteLine ("	group_code = '" + sGroupCode + "'");

					int nCnt = DBUtil.RunDBToNone (CommandType.Text, QryUp.ToString());

					
					
					StringWriter Qry = new StringWriter();

					foreach (TableRow tr in tbl_level_item_set.Rows)
					{
						foreach (TableCell td in tr.Cells)
						{
							if (td.Controls.Count > 0)
							{
								if (td.Controls[0] != null && td.Controls[0].GetType().ToString().Equals("System.Web.UI.WebControls.CheckBox"))
								{
									string
										sMode = string.Empty,
										sLevelCode = string.Empty,
										sRoleCode = string.Empty;

									CheckBox chkBox = (CheckBox)td.Controls[0];

									if (chkBox.Enabled)
									{
										string[] arrSelValue = chkBox.Attributes["value"].Split('|');

										sLevelCode = arrSelValue[0];
										sRoleCode = arrSelValue[1];

										if (chkBox.Checked)
											sMode = "ADD";
										else
											sMode = "REMOVE";

										Qry.WriteLine (AdminQryLib.DoUseGroupLevelDetail(sGroupCode, sMode, sLevelCode, sRoleCode));
									}
								}
							}
						}
					}


					if (!NBUtil.StrEmptyChk (Qry.ToString()))
					{
						int nItemCnt = DBUtil.RunDBToNone (CommandType.Text, Qry.ToString());
					}

					
					SetDisable();

					BindLevelItem();

					NBCmnUtil.ViewMsgGoUrl (Page, Request.Url.ToString(),  "저장 하였습니다.");
				}
				else
				{
					NBCmnUtil.ViewAlertMsg (Page, "권한이 없습니다.");
				}
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}			
		}

		private void BindLevelItem()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				int nLevelCnt = 0;

				DataTable dtAllowLevel = new DataTable();
				DataTable dtAllowLevelItems = new DataTable();
				
				ArrayList arrRoleItems = NBLib.GetUseLvlRole();

				DataSet dsLevelData = SqlHelper.ExecuteDataset (dbSqlConn, CommandType.Text, AdminQryLib.GetGroupLevelItems(sGroupCode));
                
				if (dsLevelData.Tables[0] != null)
					dtAllowLevel = dsLevelData.Tables[0];

				if (dsLevelData.Tables[1] != null)
					dtAllowLevelItems = dsLevelData.Tables[1];

				nLevelCnt = dtAllowLevel.Rows.Count;


				tbl_level_item_set.Rows.Clear();

				
				TableRow trItem = null;
				TableCell tdItem = null;

			
				// 첫줄의 경우 회원 등급 제목을 표시 한다.
				trItem = new TableRow();

				tdItem = new TableCell();
				tdItem.Text = "&nbsp;";
				tdItem.Width = 130;
				trItem.Cells.Add (tdItem);

				for (int nCntItem = 0; nCntItem < nLevelCnt; nCntItem++)
				{
					tdItem = new TableCell();
					tdItem.Text = dtAllowLevel.Rows[nCntItem][1].ToString();
					if (dtAllowLevel.Rows[nCntItem][2].ToString().Equals("1"))
						tdItem.Text += " (비회원)";
					tdItem.CssClass = "td_ud_title1";
					trItem.Cells.Add (tdItem);
				}

				tbl_level_item_set.Rows.Add (trItem);


				for (int nCnt = 0; nCnt < arrRoleItems.Count; nCnt++)
				{
					string[] arrAllLevelItem = (string[])arrRoleItems[nCnt];

					trItem = new TableRow();

					tdItem = new TableCell();
					tdItem.Text = arrAllLevelItem[1];
					
					tdItem.CssClass = "td_ud_title2";
					trItem.Cells.Add (tdItem);

					for (int nCntCell = 0; nCntCell < nLevelCnt; nCntCell++)
					{
						DataRow[] arrSelRole = dtAllowLevelItems.Select ("level_code = '" + dtAllowLevel.Rows[nCntCell][0].ToString() + "' AND role_code = '" + arrAllLevelItem[0] + "'");

						CheckBox chkIsUse = new CheckBox();
						chkIsUse.Enabled = !chk_inherit_level.Checked;
						// chkIsUse.CheckedChanged += new EventHandler(chkIsUse_CheckedChanged);
						chkIsUse.Attributes["value"] = dtAllowLevel.Rows[nCntCell][0].ToString() + "|" + arrAllLevelItem[0];
						// chkIsUse.AutoPostBack = true;

						if (dtAllowLevel.Rows[nCntCell][2].ToString().Equals("1") && arrAllLevelItem[0].Equals(NBLib.UserLvlRole.BoardAdmin))
						{
							// 관리자 권한은 비회원에게는 부여할 수 없다.
							// 허용 이면
							tdItem = new TableCell();
							chkIsUse.Enabled = false;
							chkIsUse.Checked = false;
							tdItem.Controls.Add (chkIsUse);
							tdItem.CssClass = "td_ud_content1";
							trItem.Cells.Add (tdItem);
						}
						else
						{
							if (arrSelRole.Length > 0)
							{
								// 허용 이면
								tdItem = new TableCell();
								chkIsUse.Checked = true;
								tdItem.Controls.Add (chkIsUse);
								tdItem.CssClass = "td_ud_content1";
								trItem.Cells.Add (tdItem);
							}
							else
							{
								// 미 허용 이면 
								tdItem = new TableCell();
								chkIsUse.Checked = false;
								tdItem.Controls.Add (chkIsUse);
								tdItem.CssClass = "td_ud_content1";
								trItem.Cells.Add (tdItem);
							}
						}
					}

					tbl_level_item_set.Rows.Add (trItem);
				}				
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}
  
		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		디자이너 지원에 필요한 메서드입니다. 이 메서드의 내용을
		///		코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtn_save.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_save_Click);
			this.btn_load_lvl.Click += new System.EventHandler(this.btn_load_lvl_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btn_load_lvl_Click(object sender, System.EventArgs e)
		{
			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("DELETE NB_GroupUserLevel WHERE group_code = '" + sGroupCode + "'");
			Qry.WriteLine ("DELETE NB_GroupUserLevel_Detail WHERE group_code = '" + sGroupCode + "'");
			Qry.WriteLine ("INSERT INTO NB_GroupUserLevel (group_code, level_code, level_name, priority, not_member ) SELECT '" + sGroupCode + "', level_code, level_name, priority, not_member FROM NB_UserAllowLevel");
			Qry.WriteLine ("INSERT INTO NB_GroupUserLevel_Detail (group_code, level_code, role_code) SELECT '" + sGroupCode + "', level_code, role_code FROM NB_UserAllowLevel_Detail");

			if (DBUtil.RunDBToNone (CommandType.Text, Qry.ToString()) > 0)
			{
				BindLevelItem();
			}
		}

	}
}
