using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;
using System.IO;

namespace NeAdmin.Body.MngPages.GroupPage
{
	public class GroupPointCfg : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.TextBox ntxt_write_point;
		protected System.Web.UI.WebControls.TextBox ntxt_cmmt_write_point;
		protected System.Web.UI.WebControls.TextBox ntxt_reply_write_point;
		protected System.Web.UI.WebControls.ImageButton imgbtn_save;
		protected System.Web.UI.WebControls.CheckBox chk_inherit_point;
		protected System.Web.UI.WebControls.CheckBox xchk_inherit_point;
		
		string sGroupCode = string.Empty;

		private void Page_Load(object sender, System.EventArgs e)
		{
			sGroupCode = NBCmnUtil.QStrLoad("gno");

			BoardMng.BoardMng objParentPage = (BoardMng.BoardMng)this.Parent.Page;

			NBAdminUtil.view_pagetitle ((Label)objParentPage.FindControl("lbl_page_name"), "׷  : <font color='#FFC0C0'>" + NBAdminUtil.GetGroupName(sGroupCode) + "</font> ׷ Ʈ ", false);

			CfgOldDataLoad();

			SetEnableField (!xchk_inherit_point.Checked);

			if (!NBAdminUtil.ChkAdminAuth(sGroupCode, NBLib.MngAuthRole.PointCfgMod))
				NBCmnUtil.ViewMsgGoBack (Page, " ϴ.");
		}
        
		private void CfgOldDataLoad()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				int nDataCnt = DBUtil.GetCountData(dbSqlConn, "NB_GroupPointCfg", "group_code = '" + sGroupCode + "'");

				if (nDataCnt.CompareTo(0) == 0)
				{
					if (!InsertDefaultValue(dbSqlConn))
					{
						throw new Exception("ش Ÿ ϴ.");                                      
					}
				}

				DataSet dsGroupPointCfg = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.GroupPointCfg(sGroupCode));

				if (dsGroupPointCfg != null)
				{
					DataTable dtJoinItemCfg = dsGroupPointCfg.Tables[0];

					if (dtJoinItemCfg.Rows.Count > 0)
					{
						NBCmnUtil.DataTbl_to_Control(dtJoinItemCfg.Rows[0], this.Controls);
					}
				}


				string sPointInherit = DBUtil.RunDBToScalar (CommandType.Text, "SELECT point_inherit FROM NB_GroupInfo");

				xchk_inherit_point.Checked = NBUtil.ConvStrToBool (sPointInherit);
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private bool InsertDefaultValue(SqlConnection dbSqlConn)
		{
			ArrayList InsertParam = new ArrayList();

			InsertParam.Add(DBUtil.InsertParamItem("group_code", NBLib.FieldQryType.Char, sGroupCode));

			string sInsertQry = DBUtil.CreateInsertQry("NB_GroupPointCfg", InsertParam);

			int nExec = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, sInsertQry);

			if (nExec > 0)
				return true;
			else
				return false;
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.  ޼ 
		///		ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtn_save.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_save_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void imgbtn_save_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;
		
			try
			{
				string sPointInheritUpdate = "UPDATE NB_GroupInfo SET point_inherit = '" + NBUtil.ConvBoolToStr (xchk_inherit_point.Checked) + "' ";
				sPointInheritUpdate += "WHERE group_code = '" + sGroupCode + "'";

				DBUtil.RunDBToNone (CommandType.Text, sPointInheritUpdate);


				DBUtil.DBConnection(ref dbSqlConn);

				ArrayList UpdateFields = NBCmnUtil.GetUpdateFields(this.Controls);

				if (UpdateFields.Count > 0)
				{
					string Qry = DBUtil.CreateUpdateQry("NB_GroupPointCfg", UpdateFields, "group_code = '" + sGroupCode + "'");

					if (Qry.Trim().Length > 0)
					{
						int nUpdate = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, Qry);

						if (nUpdate > 0)
						{
							SetEnableField (!xchk_inherit_point.Checked);

							NBCmnUtil.ViewAlertMsg (Page, " Ϸ");
						}
					}
				}				
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}            		
		}

		private void SetEnableField(bool bEnable)
		{
			ntxt_write_point.Enabled = bEnable;
			ntxt_cmmt_write_point.Enabled = bEnable;
			ntxt_reply_write_point.Enabled = bEnable;
		}
	}
}
