using System;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using BoardLib;

namespace NeAdmin.Body.MngPages.MemberPage
{
	public class AddItemCfg : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.ListBox lst_add_item;
		protected System.Web.UI.WebControls.TextBox txt_add_item_code;
		protected System.Web.UI.WebControls.TextBox txt_add_item_name;
		protected System.Web.UI.WebControls.TextBox txt_add_item_len;
		protected System.Web.UI.WebControls.DropDownList ddl_add_item_use;
		protected System.Web.UI.WebControls.DropDownList ddl_add_item_type;
		protected System.Web.UI.WebControls.Button btn_add_item_save;
		protected System.Web.UI.WebControls.Button btn_add_item_new;
		protected System.Web.UI.WebControls.TextBox txt_add_item_list;
		protected System.Web.UI.WebControls.Button btn_move_down;
		protected System.Web.UI.WebControls.Button btn_move_up;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hid_edit_mode;
		protected System.Web.UI.WebControls.DataGrid dAddItemList;
		protected System.Web.UI.WebControls.Button btn_add_item_del;

		private void Page_Load(object sender, System.EventArgs e)
		{
			BoardMng.BoardMng objParentPage = (BoardMng.BoardMng)this.Parent.Page;

			NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), " ߰ ׸", false);

			GetNewItemCode();

			GetAddMemberDataCfg();

			if (!NBCmnUtil.GetCookieValue ("NEADMIN_MBNO").Equals (NBLib.SuperAdmin))
			{
				Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
				pnlError.Visible = true;
				lst_add_item.Enabled = false;
				btn_add_item_save.Enabled = false;
				btn_add_item_del.Enabled = false;
			}

			ddl_add_item_type.Attributes["onchange"] = "AddItemInputType();";
			btn_add_item_save.Attributes["onclick"] = "return AddItemInputOK();";

			Page.PreRender += new EventHandler(Page_PreRender);
		}

		private void SetButtonState(string sMode)
		{
			if (sMode.Equals("E"))
			{
                btn_add_item_save.Text = "׸ ";
                btn_add_item_new.Visible = true;
				btn_add_item_del.Visible = true;
			}
			else if (sMode.Equals("N"))
			{
				btn_add_item_save.Text = "׸ ߰";
				btn_add_item_new.Visible = false;
				btn_add_item_del.Visible = false;
			}
		}

		private void DoBindList_AddItem()
		{
			string sQry = "SELECT add_item_code, add_item_name, add_item_use, add_item_type, add_item_len FROM NB_AddMemberDataCfg ORDER BY priority ASC";
			DataTable dt = DBUtil.RunDBToDataTable (CommandType.Text, sQry);

			dAddItemList.DataSource = dt;
			dAddItemList.DataBind();
		}

		private void GetNewItemCode()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				//  Ʈ
				string sNewItemCode = SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, AdminQryLib.GetNewMemberDataItemCode()).ToString();

				txt_add_item_code.Text = sNewItemCode.PadLeft(3, '0');
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void GetAddMemberDataCfg()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				//  Ʈ
				SqlDataReader drAddMemberDataCfg = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, AdminQryLib.GetMemberDataCfg_List());

                lst_add_item.Items.Clear();

				while (drAddMemberDataCfg.Read())
				{
					lst_add_item.Items.Add (new ListItem(drAddMemberDataCfg["add_item_name"].ToString(), drAddMemberDataCfg["add_item_code"].ToString()));
				}

				DoEnableMove();
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.  ޼ 
		///		ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.lst_add_item.SelectedIndexChanged += new System.EventHandler(this.lst_add_item_SelectedIndexChanged);
			this.btn_move_up.Click += new System.EventHandler(this.btn_move_up_Click);
			this.btn_move_down.Click += new System.EventHandler(this.btn_move_down_Click);
			this.btn_add_item_del.Click += new System.EventHandler(this.btn_add_item_del_Click);
			this.btn_add_item_save.Click += new System.EventHandler(this.btn_add_item_save_Click);
			this.btn_add_item_new.Click += new System.EventHandler(this.btn_add_item_new_Click);
			this.dAddItemList.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.dAddItemList_ItemDataBound_1);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void lst_add_item_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (lst_add_item.SelectedIndex > -1 && !lst_add_item.SelectedIndex.ToString().Equals(hid_edit_mode.Value))
			{
				SqlConnection dbSqlConn = null;
			
				try
				{
					DBUtil.DBConnection(ref dbSqlConn);

					//  Ʈ
					SqlDataReader drAddMemberDataCfg = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, AdminQryLib.GetMemberDataCfg_Detail(lst_add_item.SelectedValue));

					if (drAddMemberDataCfg.Read())
					{
						txt_add_item_code.Text = drAddMemberDataCfg["add_item_code"].ToString();
						txt_add_item_name.Text = drAddMemberDataCfg["add_item_name"].ToString();
						NBCmnUtil.DdlLst_Chk (ddl_add_item_use, drAddMemberDataCfg["add_item_use"].ToString());
						txt_add_item_len.Text = drAddMemberDataCfg["add_item_len"].ToString();
						NBCmnUtil.DdlLst_Chk (ddl_add_item_type, drAddMemberDataCfg["add_item_type"].ToString());
						txt_add_item_list.Text = drAddMemberDataCfg["add_item_list"].ToString();

						hid_edit_mode.Value = lst_add_item.SelectedIndex.ToString();

						DoEnableMove();

						SetButtonState("E");	
					}                				
				}
				catch(Exception E)
				{
					NBCmnUtil.ViewAlertMsg (Page, E.Message);
				}
				finally
				{
					DBUtil.DBConnDispose(ref dbSqlConn);
				}
			}
		}

		private bool DoInputValidChk()
		{
			if (NBUtil.StrEmptyChk(txt_add_item_code.Text))
			{
                NBCmnUtil.ViewAlertMsg (Page, "ڵ带 Է ּ.");
				return false;
			}

			if (NBUtil.StrEmptyChk(txt_add_item_name.Text))
			{
				NBCmnUtil.ViewAlertMsg (Page, "̸ Է ּ.");
				return false;
			}

			return true;
		}

		private void btn_add_item_save_Click(object sender, System.EventArgs e)
		{
			if (DoInputValidChk())
			{
				SqlConnection dbSqlConn = null;
			
				try
				{
					DBUtil.DBConnection(ref dbSqlConn);

					string
						sMode = string.Empty,
						sAddItemCode = string.Empty,
						sAddItemName = string.Empty,
						sAddItemUse = string.Empty,
						sAddItemLen = string.Empty,
						sAddItemType = string.Empty,
						sAddItemList = string.Empty;					

					if (lst_add_item.SelectedIndex > -1)
						sMode = "U";
					else
						sMode = "N";

					sAddItemCode = txt_add_item_code.Text;
					sAddItemName = txt_add_item_name.Text;
					sAddItemUse = ddl_add_item_use.SelectedValue;
					sAddItemType = ddl_add_item_type.SelectedValue;

					sAddItemLen = txt_add_item_len.Text;
                    sAddItemList = txt_add_item_list.Text;

					int nRunQry = SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, AdminQryLib.UpdateMemberDataCfg(
						sMode, sAddItemCode, sAddItemName, sAddItemUse, sAddItemType, sAddItemLen, sAddItemList
						));

					if (nRunQry > 0)
					{
						txt_add_item_name.Text = string.Empty;
						ddl_add_item_use.SelectedIndex = -1;
						txt_add_item_len.Text = string.Empty;
						ddl_add_item_type.SelectedIndex = -1;
						txt_add_item_list.Text = string.Empty;

						GetNewItemCode();
						GetAddMemberDataCfg();

						hid_edit_mode.Value = string.Empty;

						SetButtonState("N");
					}
				}
				catch(Exception E)
				{
					NBCmnUtil.ViewAlertMsg (Page, E.Message);
				}
				finally
				{
					DBUtil.DBConnDispose(ref dbSqlConn);
				}
			}
		}

		private void btn_add_item_new_Click(object sender, System.EventArgs e)
		{
			txt_add_item_name.Text = string.Empty;
			ddl_add_item_use.SelectedIndex = -1;
			txt_add_item_len.Text = string.Empty;
			ddl_add_item_type.SelectedIndex = -1;
			txt_add_item_list.Text = string.Empty;

			lst_add_item.SelectedIndex = -1;

			GetNewItemCode();		

			hid_edit_mode.Value = "";

			SetButtonState("N");
		}

		private void btn_add_item_del_Click(object sender, System.EventArgs e)
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				int nRunQry = SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, AdminQryLib.DoAddMemberDataDelete(lst_add_item.SelectedValue));

				if (nRunQry > 0)
				{
					txt_add_item_name.Text = string.Empty;
					ddl_add_item_use.SelectedIndex = -1;
					txt_add_item_len.Text = string.Empty;
					ddl_add_item_type.SelectedIndex = -1;
					txt_add_item_list.Text = string.Empty;

					GetNewItemCode();
					GetAddMemberDataCfg();

					SetButtonState("N");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}				
		}

		private void DoEnableMove()
		{
			btn_move_up.Enabled = true;
			btn_move_down.Enabled = true;

			if (lst_add_item.SelectedIndex == -1 || lst_add_item.Items.Count == 1)
			{
				btn_move_up.Enabled = false;
				btn_move_down.Enabled = false;
			}
			else if (lst_add_item.SelectedIndex == 0)
			{
				btn_move_up.Enabled = false;
			}
			else if (lst_add_item.SelectedIndex == (lst_add_item.Items.Count - 1))
			{
				btn_move_down.Enabled = false;
			}
		}

		private void btn_move_up_Click(object sender, System.EventArgs e)
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				int nRunQry = 0;

				nRunQry = SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, AdminQryLib.MoveMemberDataCfg ("UP", lst_add_item.SelectedValue));

				if (nRunQry > 0)
				{
					txt_add_item_name.Text = string.Empty;
					ddl_add_item_use.SelectedIndex = -1;
					txt_add_item_len.Text = string.Empty;
					ddl_add_item_type.SelectedIndex = -1;
					txt_add_item_list.Text = string.Empty;

					GetNewItemCode();
					GetAddMemberDataCfg();
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}		
		}

		private void btn_move_down_Click(object sender, System.EventArgs e)
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				int nRunQry = 0;

				nRunQry = SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, AdminQryLib.MoveMemberDataCfg ("DOWN", lst_add_item.SelectedValue));

				if (nRunQry > 0)
				{
					txt_add_item_name.Text = string.Empty;
					ddl_add_item_use.SelectedIndex = -1;
					txt_add_item_len.Text = string.Empty;
					ddl_add_item_type.SelectedIndex = -1;
					txt_add_item_list.Text = string.Empty;

					GetNewItemCode();
					GetAddMemberDataCfg();
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}		
		}

		private void dAddItemList_ItemDataBound_1(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if (e.Item.ItemType.Equals(ListItemType.Header))
			{
				return;
			}

			switch (e.Item.Cells[2].Text)
			{
				case "1":
					e.Item.Cells[2].Text = " + ";
					break;
				case "2":
					e.Item.Cells[2].Text = "ʼ + ";
					break;
				case "3":
					e.Item.Cells[2].Text = " + Ұ";
					break;
				case "4":
					e.Item.Cells[2].Text = "ʼ + Ұ";
					break;
				case "9":
					e.Item.Cells[2].Text = "";
					break;
				default:
					e.Item.Cells[2].Text = "Undefine";
					break;
			}

			switch (e.Item.Cells[4].Text)
			{
				case "01":
					e.Item.Cells[4].Text = "TextBox";
					break;
				case "02":
					e.Item.Cells[4].Text = "DropDownList";
					break;
				case "03":
					e.Item.Cells[4].Text = "RadioButton";
					break;
				case "04":
					e.Item.Cells[4].Text = "CheckBox";
					break;
				case "05":
					e.Item.Cells[4].Text = "TextArea";
					break;
				case "06":
					e.Item.Cells[4].Text = "Password";
					break;
				default:
					e.Item.Cells[4].Text = "Undefine";
					break;
			}
		}

		private void Page_PreRender(object sender, EventArgs e)
		{
			DoBindList_AddItem();
		}
	}
}
