using System;
using System.IO;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using BoardLib;

namespace NeAdmin.Body.MngPages.MemberPage
{
	public class AllowLevelSet : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.Table tbl_level_item_set;
		protected System.Web.UI.WebControls.DropDownList ddl_join_base_level;
		protected System.Web.UI.WebControls.ImageButton imgbtn_save;
		protected System.Web.UI.WebControls.Button btn_level_mod;

		private void Page_Load(object sender, System.EventArgs e)
		{
			BoardMng.BoardMng objParentPage = (BoardMng.BoardMng)this.Parent.Page;

			NBAdminUtil.view_pagetitle ((Label)objParentPage.FindControl("lbl_page_name"), "ȸ  : ȸ  ", false);

			DoLoadOldData();

			BindLevelItem();

			if (!NBCmnUtil.GetCookieValue ("NEADMIN_MBNO").Equals (NBLib.SuperAdmin))
			{
				NBCmnUtil.ViewMsgGoBack (Page, " ϴ.");
			}

			ButtonScriptSet();
		}

		private void ButtonScriptSet()
		{
			btn_level_mod.Attributes["onclick"] = "return WinOpenSimple('../MngPages/MemberPage/AllowLevelSet_Detail.aspx', 'GroupAdminAdd', 'width=560, height=280')";
		}

		private void DoLoadOldData()
		{
			DataTable dt = DBUtil.RunDBToDataTable (CommandType.Text, AdminQryLib.GetParentLevelList());

			ddl_join_base_level.DataSource = dt;
			ddl_join_base_level.DataTextField = "level_name";
			ddl_join_base_level.DataValueField = "level_code";
			ddl_join_base_level.DataBind();

			string sJoinBaseLvl = DBUtil.RunDBToScalar (CommandType.Text, "SELECT join_baselvl FROM NB_JoinItemCfg WHERE join_idx = '1'");

			NBUtil.lstctrl_chk (ddl_join_base_level, sJoinBaseLvl);
		}


		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.  ޼ 
		///		ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtn_save.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_save_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void BindLevelItem()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				int nLevelCnt = 0;

				DataTable dtAllowLevel = new DataTable();
				DataTable dtAllowLevelItems = new DataTable();
				
				ArrayList arrRoleItems = NBLib.GetUseLvlRole();

				DataSet dsLevelData = SqlHelper.ExecuteDataset (dbSqlConn, CommandType.Text, AdminQryLib.GetAllowLevelItems());
                
				if (dsLevelData.Tables[0] != null)
                    dtAllowLevel = dsLevelData.Tables[0];

				if (dsLevelData.Tables[1] != null)
					dtAllowLevelItems = dsLevelData.Tables[1];

				nLevelCnt = dtAllowLevel.Rows.Count;


				tbl_level_item_set.Rows.Clear();

				
				TableRow trItem = null;
				TableCell tdItem = null;

			
				// ù  ȸ   ǥ Ѵ.
				trItem = new TableRow();

				tdItem = new TableCell();
				tdItem.Text = "&nbsp;";
				tdItem.Width = 110;
				trItem.Cells.Add (tdItem);

				for (int nCntItem = 0; nCntItem < nLevelCnt; nCntItem++)
				{
					tdItem = new TableCell();
					tdItem.Text = dtAllowLevel.Rows[nCntItem][1].ToString();
					if (dtAllowLevel.Rows[nCntItem][2].ToString().Equals("1"))
                        tdItem.Text += " (ȸ)";
					tdItem.CssClass = "td_ud_title1";
					trItem.Cells.Add (tdItem);
				}

				tbl_level_item_set.Rows.Add (trItem);


				for (int nCnt = 0; nCnt < arrRoleItems.Count; nCnt++)
				{
					string[] arrAllLevelItem = (string[])arrRoleItems[nCnt];

					trItem = new TableRow();

					tdItem = new TableCell();
					tdItem.Text = arrAllLevelItem[1];
					
					tdItem.CssClass = "td_ud_title2";
					trItem.Cells.Add (tdItem);

					for (int nCntCell = 0; nCntCell < nLevelCnt; nCntCell++)
					{
						DataRow[] arrSelRole = dtAllowLevelItems.Select ("level_code = '" + dtAllowLevel.Rows[nCntCell][0].ToString() + "' AND role_code = '" + arrAllLevelItem[0] + "'");

						CheckBox chkIsUse = new CheckBox();
						chkIsUse.Attributes["value"] = dtAllowLevel.Rows[nCntCell][0].ToString() + "|" + arrAllLevelItem[0];

						if (dtAllowLevel.Rows[nCntCell][2].ToString().Equals("1") && arrAllLevelItem[0].Equals(NBLib.UserLvlRole.BoardAdmin))
						{
							//   ȸԴ ο  .
							//  ̸
							tdItem = new TableCell();
							chkIsUse.Enabled = false;
							chkIsUse.Checked = false;
							tdItem.Controls.Add (chkIsUse);
							tdItem.CssClass = "td_ud_content1";
							trItem.Cells.Add (tdItem);
						}
						else
						{
							if (arrSelRole.Length > 0)
							{
								//  ̸
								tdItem = new TableCell();
								chkIsUse.Checked = true;
								tdItem.Controls.Add (chkIsUse);
								tdItem.CssClass = "td_ud_content1";
								trItem.Cells.Add (tdItem);
							}
							else
							{
								//   ̸ 
								tdItem = new TableCell();
								chkIsUse.Checked = false;
								tdItem.Controls.Add (chkIsUse);
								tdItem.CssClass = "td_ud_content1";
								trItem.Cells.Add (tdItem);
							}
						}
					}

					tbl_level_item_set.Rows.Add (trItem);
				}				
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}
  
		private void imgbtn_save_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			try
			{
				//  ⺻  Ʈ

				if (ddl_join_base_level.SelectedIndex > -1)
				{
					string sQry = "UPDATE NB_JoinItemCfg SET join_baselvl = '" + ddl_join_base_level.SelectedValue + "' WHERE join_idx = '1'";

					int nCnt = DBUtil.RunDBToNone (CommandType.Text, sQry);
				}

				// Level Item Ʈ
				StringWriter Qry = new StringWriter();

				foreach (TableRow tr in tbl_level_item_set.Rows)
				{
					foreach (TableCell td in tr.Cells)
					{
						if (td.Controls.Count > 0)
						{
							if (td.Controls[0] != null && td.Controls[0].GetType().ToString().Equals("System.Web.UI.WebControls.CheckBox"))
							{
								string
									sMode = string.Empty,
									sLevelCode = string.Empty,
									sRoleCode = string.Empty;

								CheckBox chkBox = (CheckBox)td.Controls[0];

								string[] arrSelValue = chkBox.Attributes["value"].Split('|');

								sLevelCode = arrSelValue[0];
								sRoleCode = arrSelValue[1];

								if (chkBox.Checked)
									sMode = "ADD";
								else
									sMode = "REMOVE";

								Qry.WriteLine (AdminQryLib.DoUseAllowLevelDetail(sMode, sLevelCode, sRoleCode));
							}
						}
					}
				}

				if (!NBUtil.StrEmptyChk (Qry.ToString()))
				{
					int nItemCnt = DBUtil.RunDBToNone (CommandType.Text, Qry.ToString());
				}

				NBCmnUtil.ViewAlertMsg (Page, " Ͽϴ.");
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}
	}
}
