using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using BoardLib;

namespace NeAdmin.Body.MngPages.MemberPage
{
	/// <summary>
	/// AllowLevelSet_Detail   Դϴ.
	/// </summary>
	public class AllowLevelSet_Detail : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.ListBox lst_parent_level;
		protected System.Web.UI.WebControls.Button btn_parent_level_del;
		protected System.Web.UI.WebControls.Button btn_move_top;
		protected System.Web.UI.WebControls.Button btn_move_down;
		protected System.Web.UI.WebControls.TextBox txt_level_code;
		protected System.Web.UI.WebControls.TextBox txt_level_name;
		protected System.Web.UI.WebControls.Button btn_level_save;
		protected System.Web.UI.WebControls.Button btn_new_level;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hid_edit_mode;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				DoLoadLevelList();

				if (lst_parent_level.SelectedIndex > -1)
				{
					btn_new_level.Visible = true;
				}
				else
				{
					DoLoadNewLevelCode();
				}
			}
		}

		private void DoLoadLevelList()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				DBUtil.DBConnection(ref dbSqlConn);

				SqlDataReader drLevelList = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, AdminQryLib.GetParentLevelList());

				lst_parent_level.Items.Clear();

				while (drLevelList.Read())
				{
					lst_parent_level.Items.Add (new ListItem(drLevelList["level_name"].ToString(), drLevelList["level_code"].ToString()));
				}

				DoEnableMove();				
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void DoLoadNewLevelCode()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				//  Խ 
				string sNewAuthGroupCode = SqlHelper.ExecuteScalar(dbSqlConn, CommandType.Text, AdminQryLib.GetNewParentLevelCode()).ToString();

				if (!NBUtil.StrEmptyChk(sNewAuthGroupCode))
				{
					txt_level_code.Text = sNewAuthGroupCode.PadLeft (2, '0');
					txt_level_name.Text = string.Empty;
					
					lst_parent_level.SelectedIndex = -1;

					hid_edit_mode.Value = "";
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void btn_new_level_Click(object sender, System.EventArgs e)
		{
			DoLoadNewLevelCode();

			btn_level_save.Text = "ȸ  ߰";

			btn_new_level.Visible = false;
			btn_parent_level_del.Visible = false;
		}

		private void DoEnableMove()
		{
			btn_move_top.Enabled = true;
			btn_move_down.Enabled = true;

			if (lst_parent_level.SelectedIndex == -1 || lst_parent_level.Items.Count == 1)
			{
				btn_move_top.Enabled = false;
				btn_move_down.Enabled = false;
			}
			else if (lst_parent_level.SelectedIndex == 0)
			{
				btn_move_top.Enabled = false;
			}
			else if (lst_parent_level.SelectedIndex == (lst_parent_level.Items.Count - 1))
			{
				btn_move_down.Enabled = false;
			}
		}

		private void lst_parent_level_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (lst_parent_level.SelectedIndex > -1 && !lst_parent_level.SelectedIndex.ToString().Equals(hid_edit_mode.Value))
			{
				txt_level_code.Text = lst_parent_level.SelectedValue;
				txt_level_name.Text = lst_parent_level.SelectedItem.Text;

				SqlConnection dbSqlConn = null;
			
				try
				{
					DBUtil.DBConnection(ref dbSqlConn);
						
					string bChk = SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, AdminQryLib.GetParentNotMemberChk(lst_parent_level.SelectedValue)).ToString();
				}
				catch(Exception E)
				{
					NBCmnUtil.ViewAlertMsg (Page, E.Message);
				}
				finally
				{
					DBUtil.DBConnDispose(ref dbSqlConn);
				}

				hid_edit_mode.Value = lst_parent_level.SelectedIndex.ToString();

				DoEnableMove();

				btn_level_save.Text = "ȸ  ";

				btn_new_level.Visible = true;
				btn_parent_level_del.Visible = true;
			}
		}

		private void btn_parent_level_del_Click(object sender, System.EventArgs e)
		{
			if (lst_parent_level.SelectedIndex > -1)
			{
				int nNotMem = int.Parse(DBUtil.RunDBToScalar (CommandType.Text, AdminQryLib.ChkNotMember (lst_parent_level.SelectedValue)));

				if (nNotMem > 0)
				{
					NBCmnUtil.ViewAlertMsg (Page, "ȸ    ϴ.");
					return;
				}
				
				if (DBUtil.RunDBToNone (CommandType.Text, AdminQryLib.DeleteParentLevelCode(lst_parent_level.SelectedValue)) > 0)
				{
					DoLoadLevelList();
					DoLoadNewLevelCode();

					btn_level_save.Text = "ȸ  ߰";

					btn_new_level.Visible = false;
					btn_parent_level_del.Visible = false;

					NBCmnUtil.ViewMsgOpenerReLoadUrl (Page, " Ǿϴ.", false, "/neadmin/Body/BoardMng/BoardMng.aspx?pgc=MemberPage/AllowLevelSet.ascx");
				}
			}
		}

		private void btn_level_save_Click(object sender, System.EventArgs e)
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				if (!NBUtil.StrEmptyChk(txt_level_code.Text) && !NBUtil.StrEmptyChk(txt_level_name.Text))
				{
					DBUtil.DBConnection(ref dbSqlConn);

					int nRunQry = 0;
					string sMode = string.Empty;
                
					if (lst_parent_level.SelectedIndex > -1)
					{
						// 
						sMode = "U";				
					}
					else
					{
						// ű
						sMode = "N";
					}

					nRunQry = SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, AdminQryLib.UpdateParentLevel (sMode, txt_level_code.Text, txt_level_name.Text));

					if (nRunQry > 0)
					{
						DoLoadLevelList();

						DoLoadNewLevelCode();

						btn_level_save.Text = "ȸ  ߰";

						btn_new_level.Visible = false;
						btn_parent_level_del.Visible = false;

						NBCmnUtil.ViewMsgOpenerReLoadUrl (Page, " Ǿϴ.", false, "/neadmin/Body/BoardMng/BoardMng.aspx?pgc=MemberPage/AllowLevelSet.ascx");
					}
				}
				else
				{
					throw new Exception("ȸ  ڵ ̸ Է ּ.");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void btn_move_top_Click(object sender, System.EventArgs e)
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				int nRunQry = 0;

				nRunQry = SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, AdminQryLib.MoveParentLevel ("UP", lst_parent_level.SelectedValue));

				if (nRunQry > 0)
				{
					DoLoadLevelList();

					DoLoadNewLevelCode();

					NBCmnUtil.ViewMsgOpenerReLoadUrl (Page, "", false, "/neadmin/Body/BoardMng/BoardMng.aspx?pgc=MemberPage/AllowLevelSet.ascx");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void btn_move_down_Click(object sender, System.EventArgs e)
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				int nRunQry = 0;

				nRunQry = SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, AdminQryLib.MoveParentLevel ("DOWN", lst_parent_level.SelectedValue));

				if (nRunQry > 0)
				{
					DoLoadLevelList();

					DoLoadNewLevelCode();

					NBCmnUtil.ViewMsgOpenerReLoadUrl (Page, "", false, "/neadmin/Body/BoardMng/BoardMng.aspx?pgc=MemberPage/AllowLevelSet.ascx");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.lst_parent_level.SelectedIndexChanged += new System.EventHandler(this.lst_parent_level_SelectedIndexChanged);
			this.btn_move_top.Click += new System.EventHandler(this.btn_move_top_Click);
			this.btn_move_down.Click += new System.EventHandler(this.btn_move_down_Click);
			this.btn_parent_level_del.Click += new System.EventHandler(this.btn_parent_level_del_Click);
			this.btn_level_save.Click += new System.EventHandler(this.btn_level_save_Click);
			this.btn_new_level.Click += new System.EventHandler(this.btn_new_level_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
