using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using BoardLib;

namespace NeAdmin.Body.MngPages.MemberPage
{
	/// <summary>
	/// ChangeMemberLevel   Դϴ.
	/// </summary>
	public class ChangeMemberLevel : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DropDownList WNDdlLevelCode;
		protected System.Web.UI.HtmlControls.HtmlTable TblLevelSet;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hid_sel_guest_no;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hid_lvl_ctrl;
		protected System.Web.UI.WebControls.ImageButton WBBtnSave;
		protected System.Web.UI.HtmlControls.HtmlTable tbl_mem_data;
		public string sHidCtrlName = string.Empty;

		private void Page_Load(object sender, System.EventArgs e)
		{
			sHidCtrlName = NBCmnUtil.QStrLoad ("cn");

			DoLvlListBind();    
		}

		private void DoLvlListBind()
		{
			if (!IsPostBack)
			{
				DataTable dtUserAllowLvl = DBUtil.RunDBToDataTable (CommandType.Text, "SELECT level_code, level_name FROM NB_UserAllowLevel ORDER BY priority ASC");
				WNDdlLevelCode.DataSource = dtUserAllowLvl;
				WNDdlLevelCode.DataTextField = "level_name";
				WNDdlLevelCode.DataValueField = "level_code";
				WNDdlLevelCode.DataBind();
			}


			DataSet dsGroupList = DBUtil.RunDBToDataSet (CommandType.Text, AdminQryLib.GroupListMemDetail());

			if (dsGroupList != null)
			{
				DataTable dtGroupList = dsGroupList.Tables[0];

				HtmlTableRow trLvlList = null;
				HtmlTableCell tcLvlList = null;


				int nCnt = 0;

				TblLevelSet.Rows.Clear();
				hid_lvl_ctrl.Value = string.Empty;

				foreach (DataRow drGroupList in dtGroupList.Rows)
				{
					string s_GroupCode = drGroupList["group_code"].ToString();
					string s_GroupName = drGroupList["group_name"].ToString();
                    
					trLvlList = new HtmlTableRow();
					
					tcLvlList = new HtmlTableCell();
					tcLvlList.InnerText = s_GroupName;
					trLvlList.Cells.Add (tcLvlList);

					tcLvlList = new HtmlTableCell();
					tcLvlList.InnerHtml = "&nbsp;";
					trLvlList.Cells.Add (tcLvlList);

					// ü ȸ  Ʈ ε
					StringWriter Qry = new StringWriter();

					Qry.WriteLine ("SELECT level_code, level_name FROM NB_GroupUserLevel WHERE group_code = '" + s_GroupCode + "' ORDER BY priority ASC");

					DataSet ds = DBUtil.RunDBToDataSet (CommandType.Text, Qry.ToString());

					DropDownList ddlLvlList = null;
                    
					if (ds != null)
					{
						ddlLvlList = new DropDownList();
						ddlLvlList.ID = "ddl_grp_lvl_" + nCnt.ToString();
						hid_lvl_ctrl.Value += "ddl_grp_lvl_" + nCnt.ToString() + "|";
						nCnt++;
						ddlLvlList.Attributes["grpcode"] = s_GroupCode;
						ddlLvlList.CssClass = "font_normal";

						DataTable dt = ds.Tables[0];

						foreach (DataRow dr in dt.Rows)
						{
							ddlLvlList.Items.Add (new ListItem(dr["level_name"].ToString(), dr["level_code"].ToString()));
						}
					}

					tcLvlList = new HtmlTableCell();
					if (ddlLvlList != null)
						tcLvlList.Controls.Add (ddlLvlList);

					trLvlList.Cells.Add (tcLvlList);

					TblLevelSet.Rows.Add (trLvlList);
				}
			}
		}



		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.WBBtnSave.Click += new System.Web.UI.ImageClickEventHandler(this.WBBtnSave_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void WBBtnSave_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			string sGrpLvlCtrl = hid_lvl_ctrl.Value;

			if (!NBUtil.StrEmptyChk(sGrpLvlCtrl))
			{
				string[] arrGrpLvlCtrl = sGrpLvlCtrl.Split('|');

				string[] arrSelGuestNo = hid_sel_guest_no.Value.Split('|');

				
				StringWriter Qry = new StringWriter();

				foreach (string sGNoItem in arrSelGuestNo)
				{
					if (!NBUtil.StrEmptyChk (sGNoItem))
					{
						Qry.WriteLine("UPDATE NB_MemberData SET ");
						Qry.WriteLine(" level_code = '" + WNDdlLevelCode.SelectedValue.Replace("'", "''") + "' ");
						Qry.WriteLine(" WHERE guest_no = '" + sGNoItem + "'");

						foreach (string sCtrlItem in arrGrpLvlCtrl)
						{
							if (!NBUtil.StrEmptyChk(sCtrlItem))
							{
								DropDownList ddlGroupLvlList = (DropDownList)FindControl (sCtrlItem);

								string sSelGrpCode = ddlGroupLvlList.Attributes["grpcode"];

								Qry.WriteLine ("IF EXISTS(SELECT * FROM NB_UserLevelInGroup WHERE group_code = '" + sSelGrpCode + "' AND guest_no = '" + sGNoItem + "')");
								Qry.WriteLine ("	UPDATE NB_UserLevelInGroup SET level_code = '" + ddlGroupLvlList.SelectedValue + "' WHERE group_code = '" + sSelGrpCode + "' AND guest_no = '" + sGNoItem + "'");
								Qry.WriteLine ("ELSE");
								Qry.WriteLine ("	INSERT INTO NB_UserLevelInGroup (group_code, guest_no, level_code) VALUES ('" + sSelGrpCode + "', '" + sGNoItem + "', '" + ddlGroupLvlList.SelectedValue + "')");
							}
						}
					}
				}

				int nResult = DBUtil.RunDBToNone (CommandType.Text, Qry.ToString());

				if (nResult > 0)
				{
					NBCmnUtil.ViewMsgAndClose (Page, " Ǿϴ.");
				}
                				
			}
		}
	}
}
