﻿using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;
using BoardLib;


namespace NeAdmin.Body.MngPages.MemberPage
{
	/// <summary>
	///		MemJoinForm에 대한 요약 설명입니다.
	/// </summary>
	public class MemJoinForm : UserControl
	{
		protected CheckBox chk_mailling_use;
		protected CheckBox chk_memdesc_use;
		protected CheckBox chk_passfind_use;
		protected DropDownList ddl_citizennum_use;
		protected DropDownList ddl_birthday_use;
		protected DropDownList ddl_sex_use;
		protected DropDownList ddl_messenger_use;
		protected DropDownList ddl_homepage_use;
		protected DropDownList ddl_homeaddr_use;
		protected DropDownList ddl_homephone_use;
		protected DropDownList ddl_workaddr_use;
		protected DropDownList ddl_workphone_use;
		protected DropDownList ddl_mobilephone_use;
		protected DropDownList ddl_nickname_use;
		protected RadioButtonList rdolst_join_baseuse;
		protected ImageButton imgbtn_joinform_save;
		protected TextBox txt_afterjoin_url;
		protected System.Web.UI.WebControls.TextBox txt_joinid_limit;
		protected System.Web.UI.WebControls.DropDownList ddl_homezip_use;
		protected System.Web.UI.WebControls.DropDownList ddl_workzip_use;
		protected System.Web.UI.WebControls.TextBox ntxt_sess_timeout;
		protected System.Web.UI.WebControls.DropDownList ddl_mempic_use;
		protected System.Web.UI.WebControls.TextBox txt_passfind_desc;
		protected System.Web.UI.WebControls.CheckBox chk_openinfo_use;
		protected System.Web.UI.WebControls.TextBox ntxt_join_point;
		protected System.Web.UI.WebControls.TextBox ntxt_login_point;
		protected System.Web.UI.WebControls.TextBox txt_cancel_script;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hid_PassFind;
		BoardMng.BoardMng objParentPage;

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				// 페이지 타이틀 설정 ////////////////////
				objParentPage = (BoardMng.BoardMng)this.Parent.Page;
				NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "회원 관리 : 회원 가입폼", false);
				// ///////////////////////////////////////

				CfgOldDataLoad();	

				if (!NBCmnUtil.GetCookieValue ("NEADMIN_MBNO").Equals (NBLib.SuperAdmin))
				{
					Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
					pnlError.Visible = true;
                    imgbtn_joinform_save.Visible = false;
				}

				GetExamValue();
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void CfgOldDataLoad()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				int nDataCnt = DBUtil.GetCountData(dbSqlConn, "NB_JoinItemCfg", "join_idx = 1");

				if (nDataCnt.CompareTo(0) == 0)
				{
					if (!InsertDefaultValue(dbSqlConn))
					{
						throw new Exception("해당 데이타가 없습니다.");                                      
					}
				}

				DataSet dsJoinItemCfg = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.GetJoinItemCfgData());

				if (dsJoinItemCfg != null)
				{
					DataTable dtJoinItemCfg = dsJoinItemCfg.Tables[0];

					if (dtJoinItemCfg.Rows.Count > 0)
					{
						NBCmnUtil.DataTbl_to_Control(dtJoinItemCfg.Rows[0], this.Controls);
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		디자이너 지원에 필요한 메서드입니다. 이 메서드의 내용을
		///		코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtn_joinform_save.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_joinform_save_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private bool InsertDefaultValue(SqlConnection dbSqlConn)
		{
			ArrayList InsertParam = new ArrayList();

			InsertParam.Add(DBUtil.InsertParamItem("join_idx", NBLib.FieldQryType.Char, "1"));

			string sInsertQry = DBUtil.CreateInsertQry("NB_JoinItemCfg", InsertParam);

			int nExec = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, sInsertQry);

			if (nExec > 0)
				return true;
			else
				return false;
		}

		private void GetExamValue()
		{
			XmlDocument xmlDoc = new XmlDocument();
			XmlNode xmlNode;

			xmlDoc.PreserveWhitespace = true;
			xmlDoc.Load(Server.MapPath("../../CfgXml/ExamData.xml"));


			xmlNode = xmlDoc.SelectSingleNode ("/ExamData/JoinData/Items[@name='PWFQ']");

			if (xmlNode != null && !NBUtil.StrEmptyChk(xmlNode.InnerText))
				hid_PassFind.Value = xmlNode.InnerText.Trim().Replace("\t", "");
		}

		private void imgbtn_joinform_save_Click(object sender, ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;
		
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				int nDataCnt = DBUtil.GetCountData(dbSqlConn, "NB_JoinItemCfg", "join_idx = 1");

				if (nDataCnt.CompareTo(0) == 0)
				{
					throw new Exception("변경할 데이타가 없습니다.");
				}

				ArrayList UpdateFields = NBCmnUtil.GetUpdateFields(this.Controls);

				if (UpdateFields.Count > 0)
				{
					string Qry = DBUtil.CreateUpdateQry("NB_JoinItemCfg", UpdateFields, "join_idx = 1");

					if (Qry.Trim().Length > 0)
					{
						int nUpdate = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, Qry);

						if (nUpdate > 0)
							NBCmnUtil.ViewAlertMsg (Page, "수정 완료");
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}
	}
}
