﻿using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Web.Mail;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;


namespace NeAdmin.Body.MngPages.MemberPage
{
	/// <summary>
	///		MemMng에 대한 요약 설명입니다.
	/// </summary>
	public class MemMng : UserControl
	{
		#region Controls
		protected DataGrid dGroupList;
		protected TextBox txt_guest_no_s;
		protected TextBox txt_guest_no_e;
		protected TextBox txt_mem_id;
		protected TextBox txt_mem_name;
		protected TextBox txt_mem_email;
		protected TextBox txt_citizennum;
		protected TextBox txt_birthday;
		protected DropDownList ddl_sex;
		protected TextBox txt_join_time;
		protected TextBox txt_lastvisit_time;
		protected TextBox txt_page_cnt;
		protected DropDownList ddl_mailling_list;
		protected CheckBox chk_mem;
		protected ImageButton imgbtn_search_on;
		protected ImageButton imgbtn_enable_true;
		protected ImageButton imgbtn_enable_false;
		protected ImageButton imgbtn_del_mem;
		protected ImageButton imgbtn_mail_send_sel;
		protected ImageButton imgbtn_mail_send_all;
		protected Literal ltr_search_cnt;
		protected System.Web.UI.WebControls.ImageButton imgbtn_mail_send_search;
		protected System.Web.UI.WebControls.TextBox txt_point_num_s;
		protected System.Web.UI.WebControls.TextBox txt_point_num_e;
		protected System.Web.UI.WebControls.ImageButton imgbtn_chg_lvl;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hid_chk_ctrl_names;
		#endregion

		DataSet dsMemData;
		protected System.Web.UI.WebControls.CheckBox chk_inc_mailling;
		protected System.Web.UI.WebControls.DropDownList ddl_csv_file;
		protected System.Web.UI.WebControls.ImageButton imgbtn_csv_save;
		protected System.Web.UI.WebControls.CheckBox chk_public_info;
		protected System.Web.UI.WebControls.ImageButton imgbtn_mail_preview;		

		BoardMng.BoardMng objParentPage;

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				objParentPage = (BoardMng.BoardMng)this.Parent.Page;

				NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "회원 관리 : 회원 검색 및 관리", false);

				BindMaillingList();

				if (ViewState["sWhereStr"] != null)
				{
					MemDataBind(ViewState["sWhereStr"].ToString(), ViewState["PagerCnt"].ToString());
				}

				if (Request.Cookies["NB_MemMng_SearchPageRowCnt"] != null && !NBUtil.StrEmptyChk (Request.Cookies["NB_MemMng_SearchPageRowCnt"].Value))
					txt_page_cnt.Text = Request.Cookies["NB_MemMng_SearchPageRowCnt"].Value;

				Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
				NBAdminUtil.DisplayAdminAuth ("", NBLib.MngAuthRole.MemSearch, imgbtn_search_on, pnlError);
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		public string get_mem_detail(object data_item)
		{
			string guest_no = (string)DataBinder.Eval (data_item, "guest_no");
			string detail_link = "javascript:OpenMemDetail('" + guest_no + "');";

			return detail_link;
		}

		private void BindMaillingList()
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				DataSet ds = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.MaillingListSimple());

				ddl_mailling_list.DataSource = ds;
				ddl_mailling_list.DataTextField = "mail_name";
				ddl_mailling_list.DataValueField = "mail_code";
				ddl_mailling_list.DataBind();
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{
			this.imgbtn_search_on.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_search_on_Click);
			this.imgbtn_enable_true.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_enable_true_Click);
			this.imgbtn_enable_false.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_enable_false_Click);
			this.imgbtn_del_mem.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_del_mem_Click);
			this.imgbtn_chg_lvl.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_chg_lvl_Click);
			this.imgbtn_mail_send_sel.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_mail_send_sel_Click);
			this.imgbtn_mail_send_search.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_mail_send_search_Click);
			this.imgbtn_mail_send_all.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_mail_send_all_Click);
			this.imgbtn_csv_save.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_csv_save_Click);
			this.dGroupList.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.dGroupList_PageIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void MemDataBind(string sWhere, string sPagerCnt)
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				dsMemData = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.MemSearch(sWhere));

				if ( int.Parse(sPagerCnt) > 0)
				{
					dGroupList.AllowPaging = true;
					dGroupList.PageSize = int.Parse(sPagerCnt);
				}
				else
				{
					dGroupList.AllowPaging = false;					
				}

				dGroupList.DataSource = dsMemData;
				dGroupList.DataBind();

				if (dsMemData.Tables[0].Rows.Count > 0)
				{
					ltr_search_cnt.Text = dsMemData.Tables[0].Rows.Count.ToString("#,##0");
					SetButtonEnable(true);

					imgbtn_mail_preview.Attributes["onclick"] = "return MailPreviewWin('" + ddl_mailling_list.ClientID + "');";

					imgbtn_mail_send_sel.Attributes["onclick"] = "return MailSendAgree('1', '" + chk_inc_mailling.ClientID + "');";
					imgbtn_mail_send_search.Attributes["onclick"] = "return MailSendAgree('2', '" + chk_inc_mailling.ClientID + "');";
					imgbtn_mail_send_all.Attributes["onclick"] = "return MailSendAgree('3', '" + chk_inc_mailling.ClientID + "');";
				}
				else
				{
					ltr_search_cnt.Text = "0";
					SetButtonEnable(false);
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}


		private void SetButtonEnable(bool bState)
		{
			imgbtn_enable_false.Enabled = bState;
			imgbtn_enable_true.Enabled = bState;
			imgbtn_del_mem.Enabled = bState;
			imgbtn_chg_lvl.Enabled = bState;

			ddl_csv_file.Enabled = bState;
			chk_public_info.Enabled = bState;
			imgbtn_csv_save.Enabled = bState;

			imgbtn_enable_false.Visible = bState;
			imgbtn_enable_true.Visible = bState;
			imgbtn_del_mem.Visible = bState;
			imgbtn_chg_lvl.Visible = bState;

			ddl_csv_file.Visible = bState;
			chk_public_info.Visible = bState;
			imgbtn_csv_save.Visible = bState;
			
			if (ddl_mailling_list.Items.Count > 0)
			{
				ddl_mailling_list.Enabled = bState;
				chk_inc_mailling.Enabled = bState;
				imgbtn_mail_send_sel.Enabled = bState;
				imgbtn_mail_send_search.Enabled = bState;
				imgbtn_mail_send_all.Enabled = bState;
				imgbtn_mail_preview.Enabled = bState;
				

				ddl_mailling_list.Visible = bState;
				chk_inc_mailling.Visible = bState;
				imgbtn_mail_send_sel.Visible = bState;
				imgbtn_mail_send_search.Visible = bState;
				imgbtn_mail_send_all.Visible = bState;
				imgbtn_mail_preview.Visible = bState;
			}
		}

		private string GetWhereStr()
		{
			StringWriter sWhere = new StringWriter();

			sWhere.Write("WHERE");

			// 최고 관리자 제외
            sWhere.Write(" guest_no != '" + NBLib.SuperAdmin + "'");

			// 고객번호
			sWhere.Write(" AND guest_no BETWEEN ");
			sWhere.Write(DBUtil.QryConvStr(txt_guest_no_s.Text.Trim(), false));
            sWhere.Write(" AND ");
			if (!NBUtil.StrEmptyChk(txt_guest_no_e.Text))
				sWhere.Write(DBUtil.QryConvStr(txt_guest_no_e.Text.Trim(), false));
			else
				sWhere.Write("'z'");

			// 포인트
			sWhere.Write(" AND ISNULL(point_num, 0) BETWEEN ");
			sWhere.Write(DBUtil.QryConvInt(txt_point_num_s.Text.Trim(), "0", false));
			sWhere.Write(" AND ");
			if (!NBUtil.StrEmptyChk(txt_point_num_e.Text))
				sWhere.Write(DBUtil.QryConvInt(txt_point_num_e.Text.Trim(), "0", false));
			else
				sWhere.Write("9999999999");

			// 성별
			if (ddl_sex.SelectedValue.CompareTo("-") != 0)
				sWhere.Write(" AND sex = " + DBUtil.QryConvStr(ddl_sex.SelectedValue, false));

			// n일간 가입자
			if (!NBUtil.StrEmptyChk(txt_join_time.Text))
				sWhere.Write(" AND DATEDIFF(DAY, join_time, GETDATE()) <= " + DBUtil.QryConvInt(txt_join_time.Text, "", false));

			// n일간 접속 기록이 없는 사용자
			if (!NBUtil.StrEmptyChk(txt_lastvisit_time.Text))
				sWhere.Write(" AND (ISNULL(lastvisit_time, '') = '' OR DATEDIFF(DAY, lastvisit_time, GETDATE()) > " + DBUtil.QryConvInt(txt_lastvisit_time.Text, "", false) + ")");

			// 아이디
			if (!NBUtil.StrEmptyChk(txt_mem_id.Text))
				sWhere.Write(" AND mem_id like '%" + DBUtil.QryConvInt(txt_mem_id.Text, "", false) + "%'");

			// 이름
			if (!NBUtil.StrEmptyChk(txt_mem_name.Text))
				sWhere.Write(" AND mem_name like '%" + DBUtil.QryConvInt(txt_mem_name.Text, "", false) + "%'");

			// 이메일
			if (!NBUtil.StrEmptyChk(txt_mem_email.Text))
				sWhere.Write(" AND mem_email like '%" + DBUtil.QryConvInt(txt_mem_email.Text, "", false) + "%'");

			// 주민등록번호
			if (!NBUtil.StrEmptyChk(txt_citizennum.Text))
				sWhere.Write(" AND citizennum like '%" + DBUtil.QryConvInt(txt_citizennum.Text, "", false) + "%'");

			// 생일
			if (!NBUtil.StrEmptyChk(txt_birthday.Text))
				sWhere.Write(" AND birthday like '%" + DBUtil.QryConvInt(txt_birthday.Text, "", false) + "%'");
			
			return sWhere.ToString();
		}

		private void DoMemStateChg(ArrayList arrGuestNo, bool bState)
		{
			SqlConnection dbSqlConn = null;

			try
			{
				string sState = "";

				if (bState)
					sState = "1";
				else
					sState = "0";

				DBUtil.DBConnection(ref dbSqlConn);

				string[] GuestNos = new string[arrGuestNo.Count];

				for (int i=0; i < GuestNos.Length; i++)
				{
					GuestNos[i] = arrGuestNo[i].ToString();
				}

				string sGuestNos = "'" + String.Join("','", GuestNos) + "'";

				SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, AdminQryLib.MemStateChg(sState, sGuestNos));
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private void DoMemDelete(ArrayList arrGuestNo)
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				string[] GuestNos = new string[arrGuestNo.Count];

				for (int i=0; i < GuestNos.Length; i++)
				{
					GuestNos[i] = arrGuestNo[i].ToString();
				}

				string sGuestNos = "'" + String.Join("','", GuestNos) + "'";

				SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, AdminQryLib.MemDelete(sGuestNos));
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private ArrayList GetSelectItems()
		{
			ArrayList arrSelItems = new ArrayList();

			CheckBox selChkBox;

			foreach (DataGridItem dItem in dGroupList.Items)
			{
				selChkBox = (CheckBox)dItem.Cells[0].Controls[0];
			
				if (selChkBox.Checked)
				{
					arrSelItems.Add(dItem.Cells[1].Text.Trim());
					continue;
				}
			}

			return arrSelItems;
		}

		private void DoMaillingSend(string sMailCode, ArrayList arrGuestNo, bool allSend)
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				SqlDataReader drMailData = SqlHelper.ExecuteReader(dbSqlConn, CommandType.Text, AdminQryLib.MaillingData (sMailCode));

				if (drMailData.Read())
				{
					// 메일내용 데이타 *****************************************
					string sMailSubjectOrig = drMailData["mail_subject"].ToString();
					string sMailSubject = "";
					string sMailSender = drMailData["mail_sender"].ToString();
					string sMailBcc = drMailData["mail_bcc"].ToString();
					string sMailBodyOrig = drMailData["mail_body"].ToString();
					string sMailBody = "";
					string sMailBodyType = drMailData["mail_body_type"].ToString();
					// *********************************************************


					MailMessage objMailMsg = new MailMessage();

					objMailMsg.From = sMailSender;
					objMailMsg.Bcc = sMailBcc;
					if (sMailBodyType.CompareTo("0") == 0)
                        objMailMsg.BodyFormat = MailFormat.Text;
					else
						objMailMsg.BodyFormat = MailFormat.Html;
                                    
   				
					string sGuestNos = "";

					if (!allSend)
					{
						string[] GuestNos = new string[arrGuestNo.Count];

						for (int i=0; i < GuestNos.Length; i++)
						{
							GuestNos[i] = arrGuestNo[i].ToString();
						}

						sGuestNos = "'" + String.Join("','", GuestNos) + "'";
					}

					dbSqlConn.Close();

					SqlDataReader drMemData = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, AdminQryLib.MemDataForMailling(sGuestNos, chk_inc_mailling.Checked));

					int nSendCnt = 0;

					while (drMemData.Read())
					{

						if (!BoardLib.NBUtil.StrEmptyChk(drMemData["mem_email"].ToString()))
						{
							sMailSubject = sMailSubjectOrig.Replace("<#guest_no#>", drMemData["guest_no"].ToString());
							sMailSubject = sMailSubject.Replace("<#mem_id#>", drMemData["mem_id"].ToString());
							sMailSubject = sMailSubject.Replace("<#mem_pwd#>", drMemData["mem_pwd"].ToString());
							sMailSubject = sMailSubject.Replace("<#mem_name#>", drMemData["mem_name"].ToString());
							sMailSubject = sMailSubject.Replace("<#mem_email#>", drMemData["mem_email"].ToString());
							sMailSubject = sMailSubject.Replace("<#nick_name#>", drMemData["nick_name"].ToString());

							sMailBody = sMailBodyOrig.Replace("<#guest_no#>", drMemData["guest_no"].ToString());
							sMailBody = sMailBody.Replace("<#mem_id#>", drMemData["mem_id"].ToString());
							sMailBody = sMailBody.Replace("<#mem_pwd#>", drMemData["mem_pwd"].ToString());
							sMailBody = sMailBody.Replace("<#mem_name#>", drMemData["mem_name"].ToString());
							sMailBody = sMailBody.Replace("<#mem_email#>", drMemData["mem_email"].ToString());
							sMailBody = sMailBody.Replace("<#nick_name#>", drMemData["nick_name"].ToString());

							objMailMsg.To = drMemData["mem_email"].ToString();

							objMailMsg.Subject = sMailSubject;
							objMailMsg.Body = sMailBody;

							objMailMsg.Fields["http://schemas.microsoft.com/cdo/configuration/sendusing"] = "2";
							objMailMsg.Fields["http://schemas.microsoft.com/cdo/configuration/smtpserver"] = NBUtil.GetSmtpServer();


							try
							{
								SmtpMail.Send (objMailMsg);

								nSendCnt++;
							}
							catch
							{
							}
						}
					}

					NBCmnUtil.ViewAlertMsg (Page, "총 " + nSendCnt.ToString() + "통의 메일이 발송 되었습니다.");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}            
		}

		private void imgbtn_search_on_Click(object sender, ImageClickEventArgs e)
		{
			dGroupList.CurrentPageIndex = 0;

			ViewState["sWhereStr"] = GetWhereStr();

			if ( NBUtil.StrEmptyChk(txt_page_cnt.Text) || txt_page_cnt.Text.Trim().Equals("0") || !NBUtil.ChkNumType(txt_page_cnt.Text, 0))
			{
				ViewState["PagerCnt"] = "0";
			}
			else
			{
				ViewState["PagerCnt"] = txt_page_cnt.Text;
			}

			MemDataBind(ViewState["sWhereStr"].ToString(), ViewState["PagerCnt"].ToString());

			// 표시 회원 수 쿠키 저장 //
			NBCmnUtil.SaveCookiValue ("NB_MemMng_SearchPageRowCnt", txt_page_cnt.Text, 60 * 30);
		}

		private void imgbtn_enable_true_Click(object sender, ImageClickEventArgs e)
		{
			try
			{
				// 정상 회원으로 변경

				ArrayList SelectGuestNo = GetSelectItems();
          	
				if (SelectGuestNo.Count > 0)
				{
					DoMemStateChg(SelectGuestNo, true);
				}
				else
				{
					NBCmnUtil.ViewAlertMsg (Page, "변경할 회원을 선택해 주세요.");
				}

				imgbtn_search_on_Click(null, null);
			}
			catch(Exception E)
			{
				throw E;
			}
		}

		private void imgbtn_enable_false_Click(object sender, ImageClickEventArgs e)
		{
			// 차단 회원으로 변경

			ArrayList SelectGuestNo = GetSelectItems();
          	
			if (SelectGuestNo.Count > 0)
			{
				DoMemStateChg(SelectGuestNo, false);
			}
			else
			{
				NBCmnUtil.ViewAlertMsg (Page, "변경할 회원을 선택해 주세요.");
			}

			imgbtn_search_on_Click(null, null);
		}

		private void imgbtn_del_mem_Click(object sender, ImageClickEventArgs e)
		{
			// 선택 회원 삭제
			ArrayList SelectGuestNo = GetSelectItems();
          	
			if (SelectGuestNo.Count > 0)
			{
				DoMemDelete(SelectGuestNo);
			}
			else
			{
				NBCmnUtil.ViewAlertMsg (Page, "변경할 회원을 선택해 주세요.");
			}
	
			imgbtn_search_on_Click(null, null);
		}

		private void imgbtn_mail_send_sel_Click(object sender, ImageClickEventArgs e)
		{
			if (NBAdminUtil.ChkAdminAuth ("", NBLib.MngAuthRole.MaillingSend))
			{
				// 선택 회원에게 메일 발송
				if (ddl_mailling_list.Enabled && ddl_mailling_list.Visible && ddl_mailling_list.SelectedIndex > -1)
				{
					ArrayList SelectGuestNo = GetSelectItems();
          	
					if (SelectGuestNo.Count > 0)
					{
						DoMaillingSend(ddl_mailling_list.SelectedValue, SelectGuestNo, false);
					}
					else
					{
						NBCmnUtil.ViewAlertMsg (Page, "메일을 발송할 회원을 선택해 주세요.");
					}
				}
			}
			else
			{
				NBCmnUtil.ViewAlertMsg (Page, "권한이 없습니다.");
			}
		}

		private void imgbtn_mail_send_all_Click(object sender, ImageClickEventArgs e)
		{
			if (NBAdminUtil.ChkAdminAuth ("", NBLib.MngAuthRole.MaillingSend))
			{
				// 전체 회원에게 메일 발송
				if (ddl_mailling_list.Enabled && ddl_mailling_list.Visible && ddl_mailling_list.SelectedIndex > -1)
				{
					DoMaillingSend(ddl_mailling_list.SelectedValue, null, true);
				}
			}
			else
			{
				NBCmnUtil.ViewAlertMsg (Page, "권한이 없습니다.");
			}
		}

		private void dGroupList_PageIndexChanged(object source, DataGridPageChangedEventArgs e)
		{
			dGroupList.CurrentPageIndex = e.NewPageIndex;
			dGroupList.DataBind();
		}

		private void imgbtn_mail_send_search_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if (NBAdminUtil.ChkAdminAuth ("", NBLib.MngAuthRole.MaillingSend))
			{
				// 선택 회원에게 메일 발송
				if (ddl_mailling_list.Enabled && ddl_mailling_list.Visible && ddl_mailling_list.SelectedIndex > -1)
				{
					ArrayList SelectGuestNo = GetSearchMemList_ForMail();
          	
					if (SelectGuestNo != null && SelectGuestNo.Count > 0)
					{
						DoMaillingSend(ddl_mailling_list.SelectedValue, SelectGuestNo, false);
					}
				}
			}
			else
			{
				NBCmnUtil.ViewAlertMsg (Page, "권한이 없습니다.");
			}		
		}

		private ArrayList GetSearchMemList_ForMail()
		{
			ArrayList arrList = new ArrayList();

            DataTable dt = DBUtil.RunDBToDataTable (CommandType.Text, AdminQryLib.MemSearch (ViewState["sWhereStr"].ToString()));

			if (dt != null)
			{
				foreach (DataRow dr in dt.Rows)
				{
					arrList.Add (dr["guest_no"].ToString());
				}
			}

			return arrList;
		}

		private void imgbtn_chg_lvl_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			string joinIdx = string.Empty;

			ArrayList SelectGuestNo = GetSelectItems();

            object[] selIdx = SelectGuestNo.ToArray();

			foreach (object idxItem in selIdx)
			{
				joinIdx += idxItem + "|";
			}

			hid_chk_ctrl_names.Value = joinIdx;

			if (NBUtil.StrEmptyChk(joinIdx))
			{
				NBCmnUtil.ViewAlertMsg (Page, "회원을 선택해 주세요.");
			}
			else
			{
				Page.RegisterStartupScript ("ChgMemLvl", "<script language='javascript'>WinOpenSimple ('../MngPages/MemberPage/ChangeMemberLevel.aspx?cn=" + hid_chk_ctrl_names.ClientID + "', 'ChangeMemberLevel', 'width=500, height=400');</script>");
			}
		}

		private void imgbtn_csv_save_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			if (ddl_csv_file.Enabled && ddl_csv_file.Visible && ddl_csv_file.SelectedIndex > -1)
			{
				bool chkOpenInfo = chk_public_info.Checked;

				switch (ddl_csv_file.SelectedValue)
				{
					case "1":
						// 선택 회원 CSV 파일로
						ArrayList SelectGuestNo = GetSelectItems();
    
						if (SelectGuestNo != null && SelectGuestNo.Count > 0)
						{
							GetCsvFiles(SelectGuestNo, false, chkOpenInfo);
						}
						else
						{
							NBCmnUtil.ViewAlertMsg (Page, "CSV파일로 생성할 회원을 선택해 주세요.");
						}

						break;
					case "2":
						// 검색된 회원 CSV 파일로
						ArrayList SearchGuestNo = GetSearchMemList_ForMail();
    
						if (SearchGuestNo != null && SearchGuestNo.Count > 0)
						{
							GetCsvFiles(SearchGuestNo, false, chkOpenInfo);
						}

						break;
					case "3":
						// 전체 회원 CSV 파일로
						GetCsvFiles(null, true, chkOpenInfo);

						break;
					default:
						break;
				}
			}
		}

		private void GetCsvFiles(ArrayList arrGuestNo, bool allMake, bool bOpenInfo)
		{
			SqlConnection dbSqlConn = null;

			try
			{
				StringWriter sw = new StringWriter();
				
				sw.Write ("회원번호,");
				sw.Write ("회원 등급,");
				sw.Write ("아이디,");
				sw.Write ("비밀번호,");
				sw.Write ("이름,");
				sw.Write ("이메일,");
				sw.Write ("닉네임(별명),");
				sw.Write ("메신져 타입,");
				sw.Write ("메신져 ID,");
				sw.Write ("홈페이지,");
				sw.Write ("주민등록번호,");
				sw.Write ("생년월일,");
				sw.Write ("생일 음/양력,");
				sw.Write ("성별,");
				sw.Write ("핸드폰,");
				sw.Write ("집전화번호,");
				sw.Write ("회사전화번호,");
				sw.Write ("집 우편번호,");
				sw.Write ("집주소,");
				sw.Write ("회사 우편번호,");
				sw.Write ("회사 주소,");
				sw.Write ("비밀번호 질문,");
				sw.Write ("비밀번호 힌트,");
				sw.Write ("가입 시각,");
				sw.Write ("마지막 방문 시각,");
				sw.Write ("포인트,");
				sw.Write ("회원 승인 여부,");
				sw.Write ("메일링 승인 여부,");
				sw.Write ("회원 이미지,");
				sw.WriteLine ("사인 이미지");

				DBUtil.DBConnection(ref dbSqlConn);
 				
				string sGuestNos = "";

				if (!allMake)
				{
					string[] GuestNos = new string[arrGuestNo.Count];

					for (int i=0; i < GuestNos.Length; i++)
					{
						GuestNos[i] = arrGuestNo[i].ToString();
					}

					sGuestNos = "'" + String.Join("','", GuestNos) + "'";
				}


				SqlDataReader drMemData = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, AdminQryLib.MemDataForCsv(sGuestNos));

				while (drMemData.Read())
				{
					sw.Write (drMemData["guest_no"].ToString() + ",");
					sw.Write (drMemData["level_code"].ToString() + ",");
					sw.Write (drMemData["mem_id"].ToString() + ",");
					sw.Write (drMemData["mem_pwd"].ToString() + ",");
					

					if (bOpenInfo)
					{
						// 회원이 공개한 정보만
						if (NBUtil.ConvStrToBool (drMemData["mem_name_open"].ToString()))
							sw.Write (drMemData["mem_name"].ToString() + ",");
						else
							sw.Write (",");

						if (NBUtil.ConvStrToBool (drMemData["mem_email_open"].ToString()))
							sw.Write (drMemData["mem_email"].ToString() + ",");
						else
							sw.Write (",");

						if (NBUtil.ConvStrToBool (drMemData["nick_name_open"].ToString()))
							sw.Write (drMemData["nick_name"].ToString() + ",");
						else
							sw.Write (",");

						if (NBUtil.ConvStrToBool (drMemData["messenger_id_open"].ToString()))
						{
							sw.Write (ConvIMType (drMemData["messenger_type"].ToString()) + ",");
							sw.Write (drMemData["messenger_id"].ToString() + ",");
						}
						else
						{
							sw.Write (",");
							sw.Write (",");
						}

						if (NBUtil.ConvStrToBool (drMemData["homepage_open"].ToString()))
							sw.Write (drMemData["homepage"].ToString() + ",");
						else
							sw.Write (",");

						sw.Write (drMemData["citizennum"].ToString() + ",");

						if (NBUtil.ConvStrToBool (drMemData["birthday_open"].ToString()))
						{
							sw.Write (drMemData["birthday"].ToString() + ",");
							sw.Write (ConvLunarType (drMemData["lunar_use"].ToString()) + ",");
						}
						else
						{
							sw.Write (",");
							sw.Write (",");
						}
						
						if (NBUtil.ConvStrToBool (drMemData["sex_open"].ToString()))
							sw.Write (ConvSexType (drMemData["sex"].ToString()) + ",");
						else
							sw.Write (",");	

						if (NBUtil.ConvStrToBool (drMemData["mobilephone_open"].ToString()))
							sw.Write (drMemData["mobilephone"].ToString() + ",");
						else
							sw.Write (",");

						if (NBUtil.ConvStrToBool (drMemData["homephone_open"].ToString()))
							sw.Write (drMemData["homephone"].ToString() + ",");
						else
							sw.Write (",");

						if (NBUtil.ConvStrToBool (drMemData["workphone_open"].ToString()))
							sw.Write (drMemData["workphone"].ToString() + ",");
						else
							sw.Write (",");

						if (NBUtil.ConvStrToBool (drMemData["homeaddr_open"].ToString()))
						{
							sw.Write (drMemData["homezip"].ToString() + ",");
							sw.Write (drMemData["homeaddr"].ToString() + ",");
						}
						else
						{
							sw.Write (",");
							sw.Write (",");
						}

						if (NBUtil.ConvStrToBool (drMemData["workaddr_open"].ToString()))
						{
							sw.Write (drMemData["workzip"].ToString() + ",");
							sw.Write (drMemData["workaddr"].ToString() + ",");
						}
						else
						{
							sw.Write (",");
							sw.Write (",");
						}
					}
					else
					{
						// 모든 정보
						sw.Write (drMemData["mem_name"].ToString() + ",");
						sw.Write (drMemData["mem_email"].ToString() + ",");
						sw.Write (drMemData["nick_name"].ToString() + ",");
						sw.Write (ConvIMType (drMemData["messenger_type"].ToString()) + ",");
						sw.Write (drMemData["messenger_id"].ToString() + ",");
						sw.Write (drMemData["homepage"].ToString() + ",");
						sw.Write (drMemData["citizennum"].ToString() + ",");
						sw.Write (drMemData["birthday"].ToString() + ",");
						sw.Write (ConvLunarType (drMemData["lunar_use"].ToString()) + ",");
						sw.Write (ConvSexType (drMemData["sex"].ToString()) + ",");
						sw.Write (drMemData["mobilephone"].ToString() + ",");
						sw.Write (drMemData["homephone"].ToString() + ",");
						sw.Write (drMemData["workphone"].ToString() + ",");
						sw.Write (drMemData["homezip"].ToString() + ",");
						sw.Write (drMemData["homeaddr"].ToString() + ",");
						sw.Write (drMemData["workzip"].ToString() + ",");
						sw.Write (drMemData["workaddr"].ToString() + ",");
					}


					sw.Write (drMemData["passfind_q"].ToString() + ",");
					sw.Write (drMemData["passfind_a"].ToString() + ",");
					sw.Write (drMemData["join_time"].ToString() + ",");
					sw.Write (drMemData["lastvisit_time"].ToString() + ",");
					sw.Write (drMemData["point_num"].ToString() + ",");
					sw.Write (ConvUserEnable (drMemData["user_enable"].ToString()) + ",");
					sw.Write (ConvMaillingType (drMemData["mailling_chk"].ToString()) + ",");
					sw.Write (drMemData["mempic_name"].ToString() + ",");
					sw.WriteLine (drMemData["memsign_name"].ToString());
				}


				Response.Clear();
				Response.ContentEncoding = System.Text.Encoding.Default;
				Response.ContentType = "multipart/form-data";				
				Response.AddHeader 
					("Content-Disposition", "attachment;filename=neboard_member_" + DateTime.Now.ToString ("yyyyMMdd") + ".csv");
				Response.Write (sw.ToString());
				Response.Flush();
				Response.Close();
				Response.End();
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}            
		}

		private string ConvIMType(string IMType)
		{
			string sResult = string.Empty;

			if (IMType != null)
			{
				switch (IMType)
				{
					case "1":
						sResult = "MSN";
						break;
					case "2":
						sResult = "NateON";
						break;
					case "3":
						sResult = "Yahoo";
						break;
					case "4":
						sResult = "Daum";
						break;
					case "5":
						sResult = "BuddyBuddy";
						break;
					default:
						break;
				}

			}

			return sResult;
		}

		private string ConvSexType(string SexType)
		{
			string sResult = string.Empty;

			if (SexType != null)
			{
				switch (SexType)
				{
					case "0":
						sResult = "남성";
						break;
					case "1":
						sResult = "여성";
						break;
					default:
						break;
				}

			}

			return sResult;
		}

		private string ConvLunarType(string LunarType)
		{
			string sResult = string.Empty;

			if (LunarType != null)
			{
				switch (LunarType)
				{
					case "0":
						sResult = "양력";
						break;
					case "1":
						sResult = "음력";
						break;
					default:
						break;
				}

			}

			return sResult;
		}

		private string ConvMaillingType(string MaillingType)
		{
			string sResult = string.Empty;

			if (MaillingType != null)
			{
				switch (MaillingType)
				{
					case "0":
						sResult = "수신거부";
						break;
					case "1":
						sResult = "수신허용";
						break;
					default:
						break;
				}

			}

			return sResult;
		}

		private string ConvUserEnable(string UserEnable)
		{
			string sResult = string.Empty;

			if (UserEnable != null)
			{
				switch (UserEnable)
				{
					case "0":
						sResult = "미승인";
						break;
					case "1":
						sResult = "승인";
						break;
					default:
						break;
				}

			}

			return sResult;
		}
	}
}

