﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using BoardLib;
using System.IO;
using System.Text.RegularExpressions;

namespace NeAdmin.Body.MemberPage
{
	public class MemberDetail : System.Web.UI.Page
	{
		#region Controls

		protected System.Web.UI.WebControls.Label WNLblMbNo;
		protected System.Web.UI.WebControls.TextBox WNTxtMbName;
		protected System.Web.UI.WebControls.TextBox WNTxtNickname;
		protected System.Web.UI.WebControls.TextBox WNTxtJumnNo1;
		protected System.Web.UI.WebControls.TextBox WNTxtJumnNo2;
		protected System.Web.UI.WebControls.RadioButtonList WLRdoLunarGubn;
		protected System.Web.UI.WebControls.TextBox WNTxtLoginPwd;
		protected System.Web.UI.WebControls.TextBox WNTxtEmail;
		protected System.Web.UI.WebControls.TextBox WNTxtHomepg;
		protected System.Web.UI.WebControls.RadioButtonList WLRdoSexGubn;
		protected System.Web.UI.WebControls.TextBox WNTxtMobileTel;
		protected System.Web.UI.WebControls.TextBox WNTxtWorkTel;
		protected System.Web.UI.WebControls.TextBox WNTxtHomeTel;
		protected System.Web.UI.WebControls.TextBox WNTxtHomeZipNo1;
		protected System.Web.UI.WebControls.TextBox WNTxtHomeZipNo2;
		protected System.Web.UI.WebControls.TextBox WNTxtHomeAddrDong;
		protected System.Web.UI.WebControls.TextBox WNTxtWorkZipNo1;
		protected System.Web.UI.WebControls.TextBox WNTxtWorkZipNo2;
		protected System.Web.UI.WebControls.TextBox WNTxtWorkAddrDong;
		protected System.Web.UI.WebControls.Label WNLblJoinDate;
		protected System.Web.UI.WebControls.Label WNLblLastDate;
		protected System.Web.UI.WebControls.TextBox WNTxtHomeAddrDesc;
		protected System.Web.UI.WebControls.TextBox WNTxtWorkAddrDesc;
		protected System.Web.UI.WebControls.ImageButton WBBtnSave;
		protected System.Web.UI.WebControls.TextBox WNTxtBirthDate_Year;
		protected System.Web.UI.WebControls.TextBox WNTxtBirthDate_Month;
		protected System.Web.UI.WebControls.TextBox WNTxtBirthDate_Day;
		protected System.Web.UI.WebControls.Label WNLblLoginId;
		protected System.Web.UI.WebControls.RadioButtonList WLRdoEmailAccept;
		
		protected System.Web.UI.WebControls.RadioButtonList WLRdoAdminChk;
		protected System.Web.UI.WebControls.DropDownList WLCboAdminBoards;
		protected System.Web.UI.WebControls.DropDownList WLCboMemUse;
		protected System.Web.UI.HtmlControls.HtmlTable tbl_mem_data;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hid_add_ctrl;
		protected System.Web.UI.WebControls.DropDownList WNDdlMessengerType;
		protected System.Web.UI.WebControls.TextBox WNTxtMessengerId;

		protected System.Web.UI.WebControls.CheckBox chk_mem_name_open;
		protected System.Web.UI.WebControls.CheckBox chk_mem_email_open;
		protected System.Web.UI.WebControls.CheckBox chk_nick_name_open;
		protected System.Web.UI.WebControls.CheckBox chk_messenger_id_open;
		protected System.Web.UI.WebControls.CheckBox chk_homepage_open;
		protected System.Web.UI.WebControls.CheckBox chk_sex_open;
		protected System.Web.UI.WebControls.CheckBox chk_birthday_open;
		protected System.Web.UI.WebControls.CheckBox chk_mobilephone_open;
		protected System.Web.UI.WebControls.CheckBox chk_homephone_open;
		protected System.Web.UI.WebControls.CheckBox chk_workphone_open;
		protected System.Web.UI.WebControls.CheckBox chk_homeaddr_open;
		protected System.Web.UI.WebControls.CheckBox chk_workaddr_open;
		protected System.Web.UI.HtmlControls.HtmlTable TblLevelSet;
		protected System.Web.UI.HtmlControls.HtmlInputHidden hid_lvl_ctrl;
		protected System.Web.UI.WebControls.Panel pnl_auth_deny;
		protected System.Web.UI.WebControls.DropDownList WNDdlLevelCode;
		protected System.Web.UI.WebControls.TextBox WNTxtPointNum;

		string mGuestNo = string.Empty;

		#endregion
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			RequestQueryData();

			if (!IsPostBack)
			{
				MemberInfoBind();
			}
			
			DoBindGroupLvl();
            AddMemberInfoBind();

			NBAdminUtil.DisplayAdminAuth ("", NBLib.MngAuthRole.MemInfoMod, WBBtnSave, pnl_auth_deny);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// 디자이너 지원에 필요한 메서드입니다.
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{    
			this.WBBtnSave.Click += new System.Web.UI.ImageClickEventHandler(this.WBBtnSave_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void RequestQueryData()
		{
			try
			{
				if (!NBUtil.StrEmptyChk (Request.QueryString["gno"]))
					mGuestNo = Request.QueryString["gno"].Trim();
				else
					throw new Exception("회원번호가 잘못되었습니다.");
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewMsgAndClose (Page, E.Message);
			}
		}

		private void AddMemberInfoBind()
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);
				
				StringWriter Qry = new StringWriter();

				Qry.WriteLine ("SELECT");
				Qry.WriteLine ("	a.add_item_code, a.add_item_name, a.add_item_type, a.add_item_len, a.add_item_list,");
				Qry.WriteLine ("	b.add_item_value, b.open_info");
				Qry.WriteLine ("FROM");
				Qry.WriteLine ("	NB_AddMemberDataCfg a, NB_AddMemberData b");
				Qry.WriteLine ("WHERE");
				Qry.WriteLine ("	a.add_item_code *= b.add_item_code AND b.guest_no = '" + WNLblMbNo.Text + "'");
				Qry.WriteLine ("ORDER BY");
				Qry.WriteLine ("	a.priority ASC");

				SqlDataReader drAddMemData = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, Qry.ToString());

				HtmlTableRow htRow = null;
				HtmlTableCell htCell = null;

				int nCnt = 0;

				hid_add_ctrl.Value = string.Empty;

				while (drAddMemData.Read())
				{
					if (nCnt == 0)
					{
						htRow = new HtmlTableRow();

						htCell = new HtmlTableCell();
						htCell.InnerText = "추가 항목";
						htCell.ColSpan = 2;
						htCell.Height = "25";
						htCell.Attributes["class"] = "tb_data2";
						htRow.Cells.Add (htCell);

						htRow.Cells.Add (htCell);

						tbl_mem_data.Rows.Add (htRow);

						nCnt++;
					}

					
					htRow = new HtmlTableRow();                    
					
					// 항목 이름 설정
                    htCell = new HtmlTableCell();
                    htCell.InnerText = drAddMemData["add_item_name"].ToString();
					htCell.Attributes["class"] = "tb_title2";
					htRow.Cells.Add (htCell);

					int nItemLen = NBUtil.ConvStrToInt (drAddMemData["add_item_len"].ToString());
					string sItemCode = drAddMemData["add_item_code"].ToString();
					string sItemList = drAddMemData["add_item_list"].ToString();
					string sItemValue = drAddMemData["add_item_value"].ToString();
					string sOpenInfo = drAddMemData["open_info"].ToString();
					Regex splitRex = new Regex("\r\n");
					
					// 항목 입력 필드 설정
                    htCell = new HtmlTableCell();
					htCell.Attributes["class"] = "tb_data2";

					string sID = "additem_" + sItemCode;

					CheckBox chk_open_info = new CheckBox();
					chk_open_info.ID = sID + "_CHK";
					chk_open_info.Checked = NBUtil.ConvStrToBool (sOpenInfo);
					chk_open_info.Text = "공개";
                    
					switch (drAddMemData["add_item_type"].ToString())
					{
						case "01":
							// TextBox
							TextBox txt_input = new TextBox();
							// sID += "_01";
							txt_input.ID = sID + "_01";
							hid_add_ctrl.Value += txt_input.ClientID + "|";
							hid_add_ctrl.Value += chk_open_info.ClientID + "|";
							txt_input.CssClass = "write_input";
							
							if (nItemLen > 0)
							{
								txt_input.Columns = nItemLen + 1;
								txt_input.MaxLength = nItemLen;
							}

							if (!NBUtil.StrEmptyChk(sItemValue))
							{
								txt_input.Text = sItemValue;
							}

							htCell.Controls.Add (txt_input);
							htCell.Controls.Add (chk_open_info);
							break;
						case "02":
							// DropDownList
							if (!NBUtil.StrEmptyChk(sItemList.Trim()))
							{
								DropDownList ddl_input = new DropDownList();
								// sID += "_02";
								ddl_input.ID = sID + "_02";
								hid_add_ctrl.Value += ddl_input.ClientID + "|";
								hid_add_ctrl.Value += chk_open_info.ClientID + "|";
								ddl_input.CssClass = "font_normal";
								string[] sDdlItems = splitRex.Split(sItemList.Trim());
								
								foreach (string sItem in sDdlItems)
								{
									if (!NBUtil.StrEmptyChk(sItem))
										ddl_input.Items.Add (new ListItem(sItem, sItem));
								}

								if (!NBUtil.StrEmptyChk(sItemValue))
									NBCmnUtil.DdlLst_Chk (ddl_input, sItemValue);

								htCell.Controls.Add (ddl_input);
								htCell.Controls.Add (chk_open_info);
							}
							break;
						case "03":
							// RadioButton
							if (!NBUtil.StrEmptyChk(sItemList.Trim()))
							{
								RadioButtonList rdo_input = new RadioButtonList();
								// sID += "_03";
								rdo_input.ID = sID + "_03";
								hid_add_ctrl.Value += rdo_input.ClientID + "|";
								hid_add_ctrl.Value += chk_open_info.ClientID + "|";
								rdo_input.RepeatDirection = RepeatDirection.Horizontal;
								rdo_input.RepeatLayout = RepeatLayout.Flow;
								string[] sRdoItems = splitRex.Split(sItemList.Trim());
								
								foreach (string sItem in sRdoItems)
								{
									if (!NBUtil.StrEmptyChk(sItem))
										rdo_input.Items.Add (new ListItem(sItem, sItem));
								}

								if (!NBUtil.StrEmptyChk(sItemValue))
									NBCmnUtil.RdoBtn_Chk (rdo_input, sItemValue);

								htCell.Controls.Add (rdo_input);
								htCell.Controls.Add (new LiteralControl(" ("));
								htCell.Controls.Add (chk_open_info);
								htCell.Controls.Add (new LiteralControl(")"));
							}
							break;
						case "04":
							// CheckBox
							if (!NBUtil.StrEmptyChk(sItemList.Trim()))
							{
								CheckBoxList chk_input = new CheckBoxList();
								// sID += "_04";
								chk_input.ID = sID + "_04";
								hid_add_ctrl.Value += chk_input.ClientID + "|";
								hid_add_ctrl.Value += chk_open_info.ClientID + "|";
								chk_input.RepeatDirection = RepeatDirection.Horizontal;
								chk_input.RepeatLayout = RepeatLayout.Flow;
								string[] sChkItems = splitRex.Split(sItemList.Trim());
								
								foreach (string sItem in sChkItems)
								{
									if (!NBUtil.StrEmptyChk(sItem))
										chk_input.Items.Add (new ListItem(sItem, sItem));
								}

								if (!NBUtil.StrEmptyChk(sItemValue))
								{
									chk_input.SelectedIndex = -1;
									string[] arrChkSelect = sItemValue.Split('|');
									foreach (string sSelValue in arrChkSelect)
									{
										if (!NBUtil.StrEmptyChk(sSelValue))
											NBCmnUtil.ChkBoxList_Chk (chk_input, sSelValue);
									}
								}

								htCell.Controls.Add (chk_input);
								htCell.Controls.Add (new LiteralControl(" ("));
								htCell.Controls.Add (chk_open_info);
								htCell.Controls.Add (new LiteralControl(")"));
							}
							break;
						case "05":
							// TextArea
							TextBox mtxt_input = new TextBox();
							// sID += "_05";
							mtxt_input.ID = sID + "_05";
							hid_add_ctrl.Value += mtxt_input.ClientID + "|";
							hid_add_ctrl.Value += chk_open_info.ClientID + "|";
							mtxt_input.CssClass = "box_txtarea";
							mtxt_input.TextMode = TextBoxMode.MultiLine;
							mtxt_input.Width = Unit.Percentage(100);
							
							if (nItemLen > 0)
							{
								mtxt_input.Rows = nItemLen;
							}

							if (!NBUtil.StrEmptyChk(sItemValue))
							{
								mtxt_input.Text = sItemValue;
							}

							htCell.Controls.Add (mtxt_input);
							htCell.Controls.Add (chk_open_info);
							break;
						case "06":
							// Password
							TextBox ptxt_input = new TextBox();
							// sID += "_06";
							ptxt_input.ID = sID + "_06";
							hid_add_ctrl.Value += ptxt_input.ClientID + "|";
							hid_add_ctrl.Value += chk_open_info.ClientID + "|";
							ptxt_input.CssClass = "write_input";
							ptxt_input.TextMode = TextBoxMode.Password;
							
							if (nItemLen > 0)
							{
								ptxt_input.Columns = nItemLen + 1;
								ptxt_input.MaxLength = nItemLen;
							}

							if (!NBUtil.StrEmptyChk(sItemValue))
							{
								ptxt_input.Attributes["value"] = sItemValue;
							}

							htCell.Controls.Add (ptxt_input);
							break;
						default:
							break;
					}

					htRow.Cells.Add (htCell);

					tbl_mem_data.Rows.Add (htRow);
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewMsgAndClose (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}                        
		}

		private void MemberInfoBind()
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);
				
				StringWriter Qry = new StringWriter();

				Qry.WriteLine ("SELECT *");
				Qry.WriteLine ("FROM NB_MemberData");
				Qry.WriteLine ("WHERE guest_no = " + DBUtil.QryConvStr(mGuestNo, false));

				SqlDataReader drMemData = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, Qry.ToString());

				if (drMemData.Read())
				{
					WNLblMbNo.Text = drMemData["guest_no"].ToString();
					WNLblLoginId.Text = drMemData["mem_id"].ToString();
					WNTxtPointNum.Text = NBUtil.ConvStrToInt(drMemData["point_num"].ToString()).ToString();
					WNTxtLoginPwd.Text = drMemData["mem_pwd"].ToString();
					WNTxtMbName.Text = drMemData["mem_name"].ToString();
					WNTxtEmail.Text = drMemData["mem_email"].ToString();					
					WNTxtNickname.Text = drMemData["nick_name"].ToString();
					WNTxtHomepg.Text = drMemData["homepage"].ToString();

					string sTmpJumnNo = drMemData["citizennum"].ToString();
					if (sTmpJumnNo.Trim().Length == 14)
					{
						WNTxtJumnNo1.Text = sTmpJumnNo.Substring(0,6);
						WNTxtJumnNo2.Text = sTmpJumnNo.Substring(7,7);
					}

					string[] aBirthDate = drMemData["birthday"].ToString().Split('.');
					if (aBirthDate.Length == 3)
					{
						WNTxtBirthDate_Year.Text = aBirthDate[0].Trim();
						WNTxtBirthDate_Month.Text = aBirthDate[1].Trim();
						WNTxtBirthDate_Day.Text = aBirthDate[2].Trim();
					}

					NBUtil.lstctrl_chk(WLRdoLunarGubn, drMemData["lunar_use"].ToString());
					NBUtil.lstctrl_chk(WLRdoSexGubn, drMemData["sex"].ToString());

					WNTxtMobileTel.Text = drMemData["mobilephone"].ToString();
					WNTxtHomeTel.Text = drMemData["homephone"].ToString();
					WNTxtWorkTel.Text = drMemData["workphone"].ToString();

					string sTmpHomeZip = drMemData["homezip"].ToString();
					string sTmpHomeAddr = drMemData["homeaddr"].ToString();

					string[] aTmpHomeZip = sTmpHomeZip.Split('-');

					if (aTmpHomeZip.Length == 2)
					{
						WNTxtHomeZipNo1.Text = aTmpHomeZip[0];
						WNTxtHomeZipNo2.Text = aTmpHomeZip[1];
					}

					WNTxtHomeAddrDong.Text = sTmpHomeAddr;


					string sTmpWorkZip = drMemData["workzip"].ToString();
					string sTmpWorkAddr = drMemData["workaddr"].ToString();

					string[] aTmpWorkZip = sTmpWorkZip.Split('-');

					if (aTmpWorkZip.Length == 2)
					{
						WNTxtWorkZipNo1.Text = aTmpWorkZip[0];
						WNTxtWorkZipNo2.Text = aTmpWorkZip[1];
					}

					WNTxtWorkAddrDong.Text = sTmpWorkAddr;

					WNLblJoinDate.Text = drMemData["join_time"].ToString();
					WNLblLastDate.Text = drMemData["lastvisit_time"].ToString();

					NBUtil.lstctrl_chk(WLRdoEmailAccept, drMemData["mailling_chk"].ToString());

					NBUtil.lstctrl_chk(WLCboMemUse, drMemData["user_enable"].ToString());

					NBUtil.lstctrl_chk(WNDdlMessengerType, drMemData["messenger_type"].ToString());
					WNTxtMessengerId.Text = drMemData["messenger_id"].ToString();

                    
                    chk_mem_name_open.Checked = NBUtil.ConvStrToBool(drMemData["mem_name_open"].ToString());
					chk_mem_email_open.Checked = NBUtil.ConvStrToBool(drMemData["mem_email_open"].ToString());
					chk_nick_name_open.Checked = NBUtil.ConvStrToBool(drMemData["nick_name_open"].ToString());
					chk_messenger_id_open.Checked = NBUtil.ConvStrToBool(drMemData["messenger_id_open"].ToString());
					chk_homepage_open.Checked = NBUtil.ConvStrToBool(drMemData["sex_open"].ToString());
					chk_sex_open.Checked = NBUtil.ConvStrToBool(drMemData["user_enable"].ToString());
					chk_birthday_open.Checked = NBUtil.ConvStrToBool(drMemData["birthday_open"].ToString());
					chk_mobilephone_open.Checked = NBUtil.ConvStrToBool(drMemData["mobilephone_open"].ToString());
					chk_homephone_open.Checked = NBUtil.ConvStrToBool(drMemData["homephone_open"].ToString());
					chk_workphone_open.Checked = NBUtil.ConvStrToBool(drMemData["workphone_open"].ToString());
					chk_homeaddr_open.Checked = NBUtil.ConvStrToBool(drMemData["homeaddr_open"].ToString());
					chk_workaddr_open.Checked = NBUtil.ConvStrToBool(drMemData["workaddr_open"].ToString());


					DataTable dt = DBUtil.RunDBToDataTable (CommandType.Text, "SELECT level_code, level_name FROM NB_UserAllowLevel ORDER BY priority ASC");
					WNDdlLevelCode.DataSource = dt;
					WNDdlLevelCode.DataTextField = "level_name";
					WNDdlLevelCode.DataValueField = "level_code";
					WNDdlLevelCode.DataBind();

                    NBUtil.lstctrl_chk (WNDdlLevelCode, drMemData["level_code"].ToString());
				}
				else
				{
					throw new Exception("회원정보를 가져오는 도중 오류가 발생하였습니다.");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewMsgAndClose (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}


		private void WBBtnSave_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;

			try
			{
				StringWriter Qry = new StringWriter();

				string sQryGuestNo = DBUtil.QryConvStr(WNLblMbNo.Text, false);

				
				// 기본 항목 업데이트
				Qry.WriteLine("UPDATE NB_MemberData SET ");

				Qry.WriteLine(" nick_name = '" + WNTxtNickname.Text.Trim().Replace("'","''") + "', ");
				Qry.WriteLine(" level_code = '" + WNDdlLevelCode.SelectedValue.Replace("'", "''") + "', ");
				Qry.WriteLine(" homepage = '" + WNTxtHomepg.Text.Trim().Replace("'","''") + "', ");
				Qry.WriteLine(" citizennum = '" + WNTxtJumnNo1.Text.Trim().Replace("'","''") + "-" + WNTxtJumnNo2.Text.Trim().Replace("'","''") + "', ");
				Qry.WriteLine(" sex = '" + WLRdoSexGubn.SelectedItem.Value.Trim() + "', ");
				Qry.WriteLine(" birthday = '" + WNTxtBirthDate_Year.Text.Trim().Replace("'","''") + "." + WNTxtBirthDate_Month.Text.Trim().Replace("'","''") + "." + WNTxtBirthDate_Day.Text.Trim().Replace("'","''") + "', ");
				if (WLRdoLunarGubn.SelectedIndex > -1)
					Qry.WriteLine(" lunar_use = '" + WLRdoLunarGubn.SelectedItem.Value.Trim() + "', ");
				Qry.WriteLine(" homephone = '" + WNTxtHomeTel.Text.Trim().Replace("'","''") + "', ");
				if (WNDdlMessengerType.SelectedIndex > -1)
					Qry.WriteLine(" messenger_type = '" + WNDdlMessengerType.SelectedValue.Trim() + "', ");
				Qry.WriteLine(" messenger_id = '" + WNTxtMessengerId.Text.Trim().Replace("'","''") + "', ");
				Qry.WriteLine(" workphone = '" + WNTxtWorkTel.Text.Trim().Replace("'","''") + "', ");
				Qry.WriteLine(" mobilephone = '" + WNTxtMobileTel.Text.Trim().Replace("'","''") + "', ");
				Qry.WriteLine(" homezip = '" + WNTxtHomeZipNo1.Text.Trim().Replace("'","''") + "-" + WNTxtHomeZipNo2.Text.Trim().Replace("'","''") + "',  ");
				Qry.WriteLine(" workzip = '" + WNTxtWorkZipNo1.Text.Trim().Replace("'","''") + "-" + WNTxtWorkZipNo2.Text.Trim().Replace("'","''") + "', ");
				Qry.WriteLine(" homeaddr = '" + WNTxtHomeAddrDong.Text.Trim().Replace("'","''") + "', ");
				Qry.WriteLine(" workaddr = '" + WNTxtWorkAddrDong.Text.Trim().Replace("'","''") + "', ");
				Qry.WriteLine(" mailling_chk = '" + WLRdoEmailAccept.SelectedItem.Value.Trim() + "', ");
				Qry.WriteLine(" mem_pwd = '" + WNTxtLoginPwd.Text.Trim().Replace("'","''") + "', ");
				Qry.WriteLine(" point_num = " + WNTxtPointNum.Text.Trim().Replace("'","''") + ", ");
				Qry.WriteLine(" mem_name = '" + WNTxtMbName.Text.Trim().Replace("'","''") + "', ");
				Qry.WriteLine(" mem_email = '" + WNTxtEmail.Text.Trim().Replace("'","''") + "', ");
				Qry.WriteLine(" user_enable = '" + WLCboMemUse.SelectedItem.Value.Trim() + "', ");
				Qry.WriteLine(" mem_name_open = '" + NBUtil.ConvBoolToStr(chk_mem_name_open.Checked) + "', ");
				Qry.WriteLine(" mem_email_open = '" + NBUtil.ConvBoolToStr(chk_mem_email_open.Checked) + "', ");
				Qry.WriteLine(" nick_name_open = '" + NBUtil.ConvBoolToStr(chk_nick_name_open.Checked) + "', ");
				Qry.WriteLine(" messenger_id_open = '" + NBUtil.ConvBoolToStr(chk_messenger_id_open.Checked) + "', ");
				Qry.WriteLine(" homepage_open = '" + NBUtil.ConvBoolToStr(chk_homepage_open.Checked) + "', ");
				Qry.WriteLine(" sex_open = '" + NBUtil.ConvBoolToStr(chk_sex_open.Checked) + "', ");
				Qry.WriteLine(" birthday_open = '" + NBUtil.ConvBoolToStr(chk_birthday_open.Checked) + "', ");
				Qry.WriteLine(" mobilephone_open = '" + NBUtil.ConvBoolToStr(chk_mobilephone_open.Checked) + "', ");
				Qry.WriteLine(" homephone_open = '" + NBUtil.ConvBoolToStr(chk_homephone_open.Checked) + "', ");
				Qry.WriteLine(" workphone_open = '" + NBUtil.ConvBoolToStr(chk_workphone_open.Checked) + "', ");
				Qry.WriteLine(" homeaddr_open = '" + NBUtil.ConvBoolToStr(chk_homeaddr_open.Checked) + "', ");
				Qry.WriteLine(" workaddr_open = '" + NBUtil.ConvBoolToStr(chk_workaddr_open.Checked) + "' ");
				Qry.WriteLine(" WHERE guest_no = " + sQryGuestNo);


				string sGrpLvlCtrl = hid_lvl_ctrl.Value;

				if (!NBUtil.StrEmptyChk(sGrpLvlCtrl))
				{
					string[] arrGrpLvlCtrl = sGrpLvlCtrl.Split('|');

					foreach (string sCtrlItem in arrGrpLvlCtrl)
					{
						if (!NBUtil.StrEmptyChk(sCtrlItem))
						{
							DropDownList ddlGroupLvlList = (DropDownList)FindControl (sCtrlItem);

							string sSelGrpCode = ddlGroupLvlList.Attributes["grpcode"];

							Qry.WriteLine ("IF EXISTS(SELECT * FROM NB_UserLevelInGroup WHERE group_code = '" + sSelGrpCode + "' AND guest_no = " + sQryGuestNo + ")");
							Qry.WriteLine ("	UPDATE NB_UserLevelInGroup SET level_code = '" + ddlGroupLvlList.SelectedValue + "' WHERE group_code = '" + sSelGrpCode + "' AND guest_no = " + sQryGuestNo);
							Qry.WriteLine ("ELSE");
							Qry.WriteLine ("	INSERT INTO NB_UserLevelInGroup (group_code, guest_no, level_code) VALUES ('" + sSelGrpCode + "', " + sQryGuestNo + ", '" + ddlGroupLvlList.SelectedValue + "')");
						}
					}
				}


                string sItemValue = string.Empty;

				string sAddItemCtrlName = hid_add_ctrl.Value;

				if (!NBUtil.StrEmptyChk(sAddItemCtrlName))
				{
					string[] arrAddItemCtrlName = sAddItemCtrlName.Split('|');

					foreach (string sCtrlName in arrAddItemCtrlName)
					{
						Control objCtrl = null;

						if (!NBUtil.StrEmptyChk(sCtrlName))
						{
                            objCtrl = Page.FindControl(sCtrlName);
						}

						if (objCtrl != null && objCtrl.ID != null)
						{
							string[] objIDs = objCtrl.ID.Split('_');
							string sAddItemCode = DBUtil.QryConvStr(objIDs[1], false);

							switch (objIDs[2].Trim())
							{
								case "01":
									// TextBox
									TextBox tmpCtrl_txt = (TextBox)objCtrl;
									sItemValue = DBUtil.QryConvStr (tmpCtrl_txt.Text, false);
									Qry.WriteLine("IF EXISTS(SELECT * FROM NB_AddMemberData WHERE guest_no = " + sQryGuestNo + " AND add_item_code = " + sAddItemCode + ")");
									Qry.WriteLine("	UPDATE NB_AddMemberData SET add_item_value = " + sItemValue + " WHERE guest_no = " + sQryGuestNo + " AND add_item_code = " + sAddItemCode);
									Qry.WriteLine("ELSE");
									Qry.WriteLine("	INSERT INTO NB_AddMemberData (guest_no, add_item_code, add_item_value) VALUES (" + sQryGuestNo + ", " + sAddItemCode + ", " + sItemValue + ")");
									break;
								case "02":
									// DropDownList
									DropDownList tmpCtrl_ddl = (DropDownList)objCtrl;
									if (tmpCtrl_ddl.SelectedIndex > -1)
									{
										sItemValue = DBUtil.QryConvStr (tmpCtrl_ddl.SelectedValue, false);
										Qry.WriteLine("IF EXISTS(SELECT * FROM NB_AddMemberData WHERE guest_no = " + sQryGuestNo + " AND add_item_code = " + sAddItemCode + ")");
										Qry.WriteLine("	UPDATE NB_AddMemberData SET add_item_value = " + sItemValue + " WHERE guest_no = " + sQryGuestNo + " AND add_item_code = " + sAddItemCode);
										Qry.WriteLine("ELSE");
										Qry.WriteLine("	INSERT INTO NB_AddMemberData (guest_no, add_item_code, add_item_value) VALUES (" + sQryGuestNo + ", " + sAddItemCode + ", " + sItemValue + ")");
									}
									break;
								case "03":
									// RadioButton
									RadioButtonList tmpCtrl_rdo = (RadioButtonList)objCtrl;
									if (tmpCtrl_rdo.SelectedIndex > -1)
									{
										sItemValue = DBUtil.QryConvStr (tmpCtrl_rdo.SelectedValue, false);
										Qry.WriteLine("IF EXISTS(SELECT * FROM NB_AddMemberData WHERE guest_no = " + sQryGuestNo + " AND add_item_code = " + sAddItemCode + ")");
										Qry.WriteLine("	UPDATE NB_AddMemberData SET add_item_value = " + sItemValue + " WHERE guest_no = " + sQryGuestNo + " AND add_item_code = " + sAddItemCode);
										Qry.WriteLine("ELSE");
										Qry.WriteLine("	INSERT INTO NB_AddMemberData (guest_no, add_item_code, add_item_value) VALUES (" + sQryGuestNo + ", " + sAddItemCode + ", " + sItemValue + ")");
									}
									break;
								case "04":
									// CheckBox
									CheckBoxList tmpCtrl_chk = (CheckBoxList)objCtrl;
									if (tmpCtrl_chk.SelectedIndex > -1)
									{
										sItemValue = DBUtil.QryConvStr (string.Join("|", NBUtil.GetCheckBoxValue(tmpCtrl_chk)), false);
										Qry.WriteLine("IF EXISTS(SELECT * FROM NB_AddMemberData WHERE guest_no = " + sQryGuestNo + " AND add_item_code = " + sAddItemCode + ")");
										Qry.WriteLine("	UPDATE NB_AddMemberData SET add_item_value = " + sItemValue + " WHERE guest_no = " + sQryGuestNo + " AND add_item_code = " + sAddItemCode);
										Qry.WriteLine("ELSE");
										Qry.WriteLine("	INSERT INTO NB_AddMemberData (guest_no, add_item_code, add_item_value) VALUES (" + sQryGuestNo + ", " + sAddItemCode + ", " + sItemValue + ")");
									}
									break;
								case "05":
									// TextArea
									TextBox tmpCtrl_mtxt = (TextBox)objCtrl;
									sItemValue = DBUtil.QryConvStr (tmpCtrl_mtxt.Text, false);
									Qry.WriteLine("IF EXISTS(SELECT * FROM NB_AddMemberData WHERE guest_no = " + sQryGuestNo + " AND add_item_code = " + sAddItemCode + ")");
									Qry.WriteLine("	UPDATE NB_AddMemberData SET add_item_value = " + sItemValue + " WHERE guest_no = " + sQryGuestNo + " AND add_item_code = " + sAddItemCode);
									Qry.WriteLine("ELSE");
									Qry.WriteLine("	INSERT INTO NB_AddMemberData (guest_no, add_item_code, add_item_value) VALUES (" + sQryGuestNo + ", " + sAddItemCode + ", " + sItemValue + ")");
									break;
								case "06":
									// Password
									// TextArea
									TextBox tmpCtrl_ptxt = (TextBox)objCtrl;
									sItemValue = DBUtil.QryConvStr (tmpCtrl_ptxt.Text, false);
									Qry.WriteLine("IF EXISTS(SELECT * FROM NB_AddMemberData WHERE guest_no = " + sQryGuestNo + " AND add_item_code = " + sAddItemCode + ")");
									Qry.WriteLine("	UPDATE NB_AddMemberData SET add_item_value = " + sItemValue + " WHERE guest_no = " + sQryGuestNo + " AND add_item_code = " + sAddItemCode);
									Qry.WriteLine("ELSE");
									Qry.WriteLine("	INSERT INTO NB_AddMemberData (guest_no, add_item_code, add_item_value) VALUES (" + sQryGuestNo + ", " + sAddItemCode + ", " + sItemValue + ")");
									break;
								case "CHK":
									CheckBox tmpCtrl_openchk = (CheckBox)objCtrl;
									sItemValue = DBUtil.QryConvStr (NBUtil.ConvBoolToStr(tmpCtrl_openchk.Checked), false);
									Qry.WriteLine("	UPDATE NB_AddMemberData SET open_info = " + sItemValue + " WHERE guest_no = " + sQryGuestNo + " AND add_item_code = " + sAddItemCode);
									break;
								default:
									break;
							}                						
						}
					}
				}


				DBUtil.DBConnection (ref dbSqlConn);

				if (SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, Qry.ToString()) > 0)
				{
					NBCmnUtil.ViewMsgAndClose (Page, "저장하였습니다.");
					//NBCmnUtil.ViewAlertMsg (Page, "저장 OK");
				}
				else
				{
					throw new Exception("회원정보를 저장하는 도중 오류가 발생하였습니다.");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}

		private void DoBindGroupLvl()
		{
			DataSet dsGroupList = DBUtil.RunDBToDataSet (CommandType.Text, AdminQryLib.GroupListMemDetail());

			if (dsGroupList != null)
			{
				DataTable dtGroupList = dsGroupList.Tables[0];

				HtmlTableRow trLvlList = null;
				HtmlTableCell tcLvlList = null;


				int nCnt = 0;

				TblLevelSet.Rows.Clear();
				hid_lvl_ctrl.Value = string.Empty;

				foreach (DataRow drGroupList in dtGroupList.Rows)
				{
					string s_GroupCode = drGroupList["group_code"].ToString();
					string s_GroupName = drGroupList["group_name"].ToString();
                    
					trLvlList = new HtmlTableRow();
					
					tcLvlList = new HtmlTableCell();
					tcLvlList.InnerText = s_GroupName;
					trLvlList.Cells.Add (tcLvlList);

					tcLvlList = new HtmlTableCell();
					tcLvlList.InnerHtml = "&nbsp;";
					trLvlList.Cells.Add (tcLvlList);

					// 전체 회원 등급 리스트 바인드
					StringWriter Qry = new StringWriter();

					Qry.WriteLine ("SELECT level_code, level_name FROM NB_GroupUserLevel WHERE group_code = '" + s_GroupCode + "' ORDER BY priority ASC");

					DataSet ds = DBUtil.RunDBToDataSet (CommandType.Text, Qry.ToString());

					DropDownList ddlLvlList = null;
                    
					if (ds != null)
					{
                        ddlLvlList = new DropDownList();
						ddlLvlList.ID = "ddl_grp_lvl_" + nCnt.ToString();
						hid_lvl_ctrl.Value += "ddl_grp_lvl_" + nCnt.ToString() + "|";
						nCnt++;
						ddlLvlList.Attributes["grpcode"] = s_GroupCode;
						ddlLvlList.CssClass = "font_normal";

						DataTable dt = ds.Tables[0];

						foreach (DataRow dr in dt.Rows)
						{
							ddlLvlList.Items.Add (new ListItem(dr["level_name"].ToString(), dr["level_code"].ToString()));
						}
					}

					tcLvlList = new HtmlTableCell();
					if (ddlLvlList != null)
                        tcLvlList.Controls.Add (ddlLvlList);

					// 현재 선택된 회원 등급 바인드
					StringWriter Qry2 = new StringWriter();

					Qry2.WriteLine ("SELECT level_code ");
					Qry2.WriteLine ("FROM NB_UserLevelInGroup ");
					Qry2.WriteLine ("WHERE group_code = '" + s_GroupCode + "' AND guest_no = '" + WNLblMbNo.Text + "'");

					string sChkVal = DBUtil.RunDBToScalar (CommandType.Text, Qry2.ToString());

					NBUtil.lstctrl_chk (ddlLvlList, sChkVal);

                    trLvlList.Cells.Add (tcLvlList);

					TblLevelSet.Rows.Add (trLvlList);
				}
			}
		}
	}
}
