using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using BoardLib;

namespace NeAdmin.Body.MngPages.MemberPage
{
	public class OutMemInput : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.Button btn_run_trans;
		protected System.Web.UI.WebControls.Literal ltr_success_cnt;
		protected System.Web.UI.WebControls.Literal ltr_fail_cnt;
		protected System.Web.UI.WebControls.Literal ltr_fail_info;
		protected System.Web.UI.HtmlControls.HtmlTable tbl_match_item;

		BoardMng.BoardMng objParentPage;

		private void Page_Load(object sender, System.EventArgs e)
		{
			objParentPage = (BoardMng.BoardMng)this.Parent.Page;

			LoadMatchTable();

			if (!NBCmnUtil.GetCookieValue ("NEADMIN_MBNO").Equals (NBLib.SuperAdmin))
			{
				Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
				pnlError.Visible = true;
				btn_run_trans.Enabled = false;
			}
		}

		private void LoadMatchTable()
		{
			bool bMemIdChk = false;

			StringWriter Qry = new StringWriter();

			Qry.WriteLine ("SELECT src_field, tar_table, tar_field, src_sep, tar_sep, add_item ");
			Qry.WriteLine ("FROM NB_JoinMatchTable ");
			Qry.WriteLine ("WHERE");
			Qry.WriteLine ("	LTRIM(RTRIM(src_field)) <> '' AND");
			Qry.WriteLine ("	LTRIM(RTRIM(tar_field)) <> ''");
			Qry.WriteLine ("ORDER BY tar_table DESC");

			DataSet ds = DBUtil.RunDBToDataSet (CommandType.Text, Qry.ToString());

			if (ds != null)
			{
				DataTable dt = ds.Tables[0];

				if (dt != null)
				{
					HtmlTableRow tblRow = null;
					HtmlTableCell tblCell = null;

					foreach (DataRow dr in dt.Rows)
					{
						if (dr["src_field"].Equals("mem_id"))
							bMemIdChk = true;


                        tblRow = new HtmlTableRow();
						
						tblCell = new HtmlTableCell();
						tblCell.Attributes["class"] = "tb_data3";
						tblCell.InnerText = dr["src_field"].ToString();
						if (dr["add_item"].ToString().Equals("1"))
						{
							tblCell.InnerText += "(߰׸)";
						}
						tblRow.Cells.Add (tblCell);

						tblCell = new HtmlTableCell();
						tblCell.Attributes["class"] = "tb_data3";
						tblCell.InnerText = dr["tar_table"].ToString();
						tblRow.Cells.Add (tblCell);

						tblCell = new HtmlTableCell();
						tblCell.Attributes["class"] = "tb_data3";
						tblCell.InnerText = dr["tar_field"].ToString();
						tblRow.Cells.Add (tblCell);

						tblCell = new HtmlTableCell();
						tblCell.Attributes["class"] = "tb_data3";
						tblCell.InnerText = dr["src_sep"].ToString();
						tblRow.Cells.Add (tblCell);

						tblCell = new HtmlTableCell();
						tblCell.Attributes["class"] = "tb_data3";
						tblCell.InnerText = dr["tar_sep"].ToString();
						tblRow.Cells.Add (tblCell);

						tbl_match_item.Rows.Add (tblRow);
					}
				}
			}

			if (!bMemIdChk)
			{
				NBCmnUtil.ViewMsgGoBack(Page, " Ű  ϴ.");
				return;
			}
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.  ޼ 
		///		ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btn_run_trans.Click += new System.EventHandler(this.btn_run_trans_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btn_run_trans_Click(object sender, System.EventArgs e)
		{
			//  ʱȭ ʱȭ
			ltr_success_cnt.Text = "0";
			ltr_fail_cnt.Text = "0";
			ltr_fail_info.Text = "";

			//  ̺ Ī ID ε
			string
				sQry = string.Empty,
				sLvlUpQry = string.Empty,
				sTarTable = string.Empty,
				sMatchID = string.Empty,
				sJoinBaseLevel = string.Empty;

			sQry = "SELECT join_baselvl FROM NB_JoinItemCfg WHERE join_idx = 1";
			sJoinBaseLevel = DBUtil.RunDBToScalar (CommandType.Text, sQry);

			sLvlUpQry = GetLvlUpdateQry();

            sQry = "SELECT tar_field, tar_table FROM NB_JoinMatchTable ";
			sQry += "WHERE src_field = 'mem_id'";
            ArrayList getMatchKey = DBUtil.RunDBToArray (CommandType.Text, sQry);

			if (getMatchKey != null)
			{
				sMatchID = getMatchKey[0].ToString();
				sTarTable = getMatchKey[1].ToString();
			}

            
			if (!NBUtil.StrEmptyChk(sMatchID) && !NBUtil.StrEmptyChk(sTarTable))
			{
                sQry = "SELECT src_field, tar_field, src_sep, tar_sep FROM NB_JoinMatchTable WHERE add_item <> '1'";

                DataSet ds = DBUtil.RunDBToDataSet (CommandType.Text, sQry);

				if (ds != null)
				{
					DataTable dt = ds.Tables[0];

					StringWriter SrcField = new StringWriter();
					StringWriter TarField = new StringWriter();

					if (dt != null)
					{
						foreach (DataRow dr in dt.Rows)
						{
							SrcField.Write (dr["src_field"].ToString() + ",");
							TarField.Write ("REPLACE(" + dr["tar_field"].ToString() + ", '" + dr["tar_sep"].ToString() + "', '" + dr["src_sep"].ToString() + "') AS " + dr["tar_field"].ToString() + ",");
						}
					}

					SrcField.Write ("guest_no");
				


					string sQry2 = "SELECT " + TarField.ToString().Substring(0, TarField.ToString().Length - 1) + " FROM " + sTarTable;

					DataSet ds2 = DBUtil.RunDBToDataSet (CommandType.Text, sQry2);

					if (ds2 != null)
					{
						DataTable dt2 = ds2.Tables[0];

						foreach (DataRow dr in dt2.Rows)
						{
							object[] arrVal = dr.ItemArray;

							string sNewGNo = NBUtil.GetJoinNewGuestNo();

							StringWriter FullQry = new StringWriter();


							FullQry.WriteLine ("INSERT INTO NB_MemberData (join_time, level_code, " + SrcField + ") VALUES ");
							FullQry.Write ("(GETDATE(), '" + sJoinBaseLevel + "', ");
							foreach (object objItem in arrVal)
							{
								if (objItem.Equals(DBNull.Value))
									FullQry.Write ("null,"); 
								else
									FullQry.Write ("'" + objItem.ToString() + "', "); 
							}
							FullQry.WriteLine ("'" + NBUtil.GetJoinNewGuestNo() + "'");
							FullQry.WriteLine (")");


							int nRun = 0;
							string sDesc = string.Empty;

							try
							{
								//̵ ߺüũ
								if (DBUtil.RunDBToScalar (CommandType.StoredProcedure, "nbsp_dup_chk_mem_id", new SqlParameter("@mem_id", dr[sMatchID].ToString())).Equals("0"))
								{
									nRun = DBUtil.RunDBToNone (CommandType.Text, FullQry.ToString());

									DoInputAddItem (sNewGNo, sTarTable, sMatchID, dr[sMatchID].ToString());

									if (!NBUtil.StrEmptyChk (sLvlUpQry))
									{
                                        DoInputLvlUp (sLvlUpQry, sNewGNo);
									}
								}
								else
								{
									throw new Exception (dr[sMatchID].ToString() + " ߺ ̵ Դϴ.");
								}
							}
							catch (Exception E)
							{
								sDesc = E.Message;
							}

							if (nRun > 0)
							{
								// ȯ 
								ltr_success_cnt.Text = (int.Parse(ltr_success_cnt.Text) + 1).ToString();
							}
							else
							{
								// 
								ltr_fail_cnt.Text = (int.Parse(ltr_fail_cnt.Text) + 1).ToString();

								ltr_fail_info.Text += sDesc + "<br>";
							}
						}
					}
				}
			}
		}

		private string GetLvlUpdateQry()
		{
			string sResult = string.Empty;

			string sQry = "SELECT group_code, join_level FROM NB_GroupInfo ORDER BY group_code ASC";

			DataTable dtGroupInfo = DBUtil.RunDBToDataTable (CommandType.Text, sQry);

			if (dtGroupInfo != null)
			{
				foreach (DataRow dr in dtGroupInfo.Rows)
				{
					sResult += "DELETE NB_UserLevelInGroup WHERE group_code = '" + dr["group_code"].ToString() + "' AND guest_no = '{GNO}' \r\n";
					sResult += "INSERT INTO NB_UserLevelInGroup (group_code, guest_no, level_code) VALUES ";
					sResult += "('" + dr["group_code"].ToString() + "', '{GNO}', '" + dr["join_level"].ToString() + "') \r\n";
				}
			}

			return sResult;
		}

		private void DoInputLvlUp(string sLvlQry, string sGuestNo)
		{
            string sQry = sLvlQry.Replace ("{GNO}", sGuestNo);

            DBUtil.RunDBToNone (CommandType.Text, sQry);
		}

		private void DoInputAddItem(string sGNo, string sTarTable, string sMatchID, string sMatchIDValue)
		{
			//  ̺ Ī ID ε
			string sQry = "SELECT src_field, tar_field FROM NB_JoinMatchTable WHERE add_item = '1'";

			DataSet ds = DBUtil.RunDBToDataSet (CommandType.Text, sQry);

			if (ds != null)
			{
				DataTable dt = ds.Tables[0];

				StringWriter SrcField = new StringWriter();
				StringWriter TarField = new StringWriter();

				if (dt != null)
				{
					foreach (DataRow dr in dt.Rows)
					{
						string sQry2 = "SELECT " + dr["tar_field"].ToString() + " FROM " + sTarTable + " WHERE " + sMatchID + " = '" + sMatchIDValue + "'";

						string sTarValue = DBUtil.RunDBToScalar (CommandType.Text, sQry2);

						
						StringWriter FullQry = new StringWriter();

						FullQry.WriteLine ("INSERT INTO NB_AddMemberData (guest_no, add_item_code, add_item_value) VALUES ");
						FullQry.Write ("(");
                        FullQry.Write ("'" + sGNo + "', '" + dr["src_field"].ToString() + "', '" + sTarValue + "'");
						FullQry.WriteLine (")");


						int nRun = 0;
						string sDesc = string.Empty;

						try
						{
							nRun = DBUtil.RunDBToNone (CommandType.Text, FullQry.ToString());
						}
						catch
						{
						}
					}
				}
			}
		}
	}
}
