using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;
using System.IO;

namespace NeAdmin.Body.MngPages.MemberPage
{
	public class PointCfg : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.TextBox ntxt_write_point;
		protected System.Web.UI.WebControls.TextBox ntxt_cmmt_write_point;
		protected System.Web.UI.WebControls.TextBox ntxt_reply_write_point;
		protected System.Web.UI.WebControls.ImageButton imgbtn_save;

		private void Page_Load(object sender, System.EventArgs e)
		{
			BoardMng.BoardMng objParentPage = (BoardMng.BoardMng)this.Parent.Page;

			NBAdminUtil.view_pagetitle ((Label)objParentPage.FindControl("lbl_page_name"), "Ʈ ", false);

			CfgOldDataLoad();

			Panel pnlError = (Panel)objParentPage.FindControl ("pnl_auth_deny");
			NBAdminUtil.DisplayAdminAuth ("", NBLib.MngAuthRole.PointCfgMod, imgbtn_save, pnlError);
		}

		private void CfgOldDataLoad()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				int nDataCnt = DBUtil.GetCountData(dbSqlConn, "NB_PointCfg", "idx_no = 1");

				if (nDataCnt.CompareTo(0) == 0)
				{
					if (!InsertDefaultValue(dbSqlConn))
					{
						throw new Exception("ش Ÿ ϴ.");                                      
					}
				}

				DataSet dsPointCfg = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.Text, AdminQryLib.PointCfg());

				if (dsPointCfg != null)
				{
					DataTable dtJoinItemCfg = dsPointCfg.Tables[0];

					if (dtJoinItemCfg.Rows.Count > 0)
					{
						NBCmnUtil.DataTbl_to_Control(dtJoinItemCfg.Rows[0], this.Controls);
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		private bool InsertDefaultValue(SqlConnection dbSqlConn)
		{
			ArrayList InsertParam = new ArrayList();

			InsertParam.Add(DBUtil.InsertParamItem("idx_no", NBLib.FieldQryType.Num, "1"));

			string sInsertQry = DBUtil.CreateInsertQry("NB_PointCfg", InsertParam);

			int nExec = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, sInsertQry);

			if (nExec > 0)
				return true;
			else
				return false;
		}

		private void imgbtn_save_Click(object sender, System.Web.UI.ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;
		
			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				ArrayList UpdateFields = NBCmnUtil.GetUpdateFields(this.Controls);

				if (UpdateFields.Count > 0)
				{
					string Qry = DBUtil.CreateUpdateQry("NB_PointCfg", UpdateFields, "idx_no = 1");

					if (Qry.Trim().Length > 0)
					{
						int nUpdate = SqlHelper.ExecuteNonQuery(dbSqlConn, CommandType.Text, Qry);

						if (nUpdate > 0)
						{
							NBCmnUtil.ViewAlertMsg (Page, " Ϸ");
						}
					}
				}				
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}            		
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.  ޼ 
		///		ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.imgbtn_save.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_save_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
