﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Text;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;

namespace NeAdmin.Body.MngPages.MemberPage
{
	/// <summary>
	/// SuperAdminInfo에 대한 요약 설명입니다.
	/// </summary>
	public class SuperAdminInfo : Page
	{
		protected TextBox txt_mem_pwd;
		protected TextBox txt_mem_pwd_re;
		protected TextBox txt_mem_name;
		protected TextBox txt_mem_email;
		protected TextBox txt_mem_id;
		protected ImageButton imgbtn_admin_mod;

		public string ClientScript;
	
		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				if ( NBAdminUtil.isSuperAdmin() )
				{
					if (!IsPostBack)
					{
						SetOldData();
					}
				}
				else
				{
					ClientScript = "alert('관리자 로그인 상태가 아닙니다.'); ";
					ClientScript += "this.close();";

					Page.DataBind();
				}
			}
			catch (Exception E)
			{
                ClientScript = "alert(\"" + @E.Message + "\");";

				Page.DataBind();
			}
		}

		private void SetOldData()
		{
			SqlConnection dbSqlConn = null;
			
			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				string sQuery = "select mem_id, mem_name, mem_email from NB_MemberData where guest_no = '" + NBLib.SuperAdmin + "'";

				SqlDataReader drAdminInfo = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, sQuery);

				if (drAdminInfo.Read())
				{
                    txt_mem_id.Text = drAdminInfo["mem_id"].ToString();
					txt_mem_name.Text = drAdminInfo["mem_name"].ToString();
					txt_mem_email.Text = drAdminInfo["mem_email"].ToString();
				}
				else
				{
					throw new Exception ("관리자 정보가 없습니다.");
				}
			}
			catch(Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// 디자이너 지원에 필요한 메서드입니다.
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{    
			this.imgbtn_admin_mod.Click += new ImageClickEventHandler(this.imgbtn_admin_mod_Click);
			this.Load += new EventHandler(this.Page_Load);

		}
		#endregion

		private bool InputValidChk()
		{
			// 아이디 체크
			if (txt_mem_id.Text.Trim().Length < 5)
			{
				throw new Exception ("아이디를 입력해 주세요. 아이디는 최소 5자 이상이여야 합니다.");				
			}

			// 비밀번호가 서로 틀리면
			if (txt_mem_pwd.Text.Trim().Length > 0 || txt_mem_pwd_re.Text.Trim().Length > 0)
			{
				if (txt_mem_pwd.Text.CompareTo(txt_mem_pwd_re.Text) != 0)
				{
					throw new Exception ("입력하신 비밀번호가 서로 틀립니다.");
				}
			}

			if (txt_mem_name.Text.Trim().Length == 0)
			{
				throw new Exception ("이름을 입력해 주세요.");
			}

			return true;
		}

		private void imgbtn_admin_mod_Click(object sender, ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;

			try
			{
				if (InputValidChk())
				{
					DBUtil.DBConnection (ref dbSqlConn);

					string sQry = "select count(guest_no) from NB_MemberData where mem_id = '" + txt_mem_id.Text.Trim().Replace("'", "''") + "' and guest_no != '" + NBLib.SuperAdmin + "'";

					int nMemIdCnt = int.Parse(SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, sQry).ToString());

					if (nMemIdCnt > 0)
					{
						ClientScript = @"alert('동일한 아이디를 사용하는 회원이 있습니다.\n\n다른 아이디를 사용해 주세요.');";
					}
					else
					{
						StringBuilder sbQry = new StringBuilder();
					
						sbQry.Append ("update NB_MemberData set ");
						if (txt_mem_id.Text.Trim().Length > 0)
						{
							sbQry.Append ("mem_id = '" + txt_mem_id.Text.Trim().Replace("'", "''") + "', ");
						}
						if (txt_mem_pwd.Text.Trim().Length > 0)
						{
							sbQry.Append ("mem_pwd = '" + txt_mem_pwd.Text.Trim().Replace("'", "''") + "', ");
						}
						sbQry.Append ("mem_name = '" + txt_mem_name.Text.Trim().Replace("'", "''") + "', ");
						sbQry.Append ("mem_email = '" + txt_mem_email.Text.Trim().Replace("'", "''") + "' ");
						sbQry.Append ("where guest_no = '" + NBLib.SuperAdmin + "'");

						if (SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sbQry.ToString()) > 0)
						{
							FormsAuthentication.SignOut();

							ClientScript = @"alert('관리자 정보가 변경 되었습니다.\n\n변경 내용은 다음 로그인 부터 적용 됩니다.');";
							ClientScript += @"opener.location.reload();";
							ClientScript += @"this.close();";
						}
						else
						{
							ClientScript = @"alert('관리자 정보 변경이 이루어 지지 않았습니다.\n\n다시한번 시도해 주세요.');";
						}
					}

					Page.DataBind();
				}                
			}
			catch (Exception E)
			{
				ClientScript = "alert(\"" + @E.Message + "\");";

				Page.DataBind();
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		
		}
	}
}
