using System;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using BoardLib;

namespace NeAdmin.Body.MngPages.Report
{
	public class MemberReport : System.Web.UI.UserControl
	{
		protected System.Web.UI.WebControls.Literal ltrTotalMemCount;
		protected System.Web.UI.WebControls.Literal ltrTodayJoin;
		protected System.Web.UI.WebControls.Literal ltrTodayContact;
		protected System.Web.UI.WebControls.Literal ltrMonthJoin;
		protected System.Web.UI.WebControls.Literal ltrMonthContact;
		protected System.Web.UI.HtmlControls.HtmlTable tblMonthView;
		protected System.Web.UI.WebControls.Label lblCurrMonth;
		protected System.Web.UI.WebControls.LinkButton lnkPrevMonth;
		protected System.Web.UI.WebControls.LinkButton lnkNextMonth;

		public string pbSelMonth;

		BoardMng.BoardMng objParentPage;

		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				objParentPage = (BoardMng.BoardMng)this.Parent.Page;

				NBAdminUtil.view_pagetitle((Label)objParentPage.FindControl("lbl_page_name"), "ȸ ", false);

				if (!IsPostBack)
				{
					pbSelMonth = DateTime.Now.ToString ("yyyy.MM");
					lblCurrMonth.Text = pbSelMonth;

					GetMemReport();
					MonthViewDayRender();
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void GetMemReport()
		{
			StringWriter sw = new StringWriter();			

			sw.WriteLine ("declare ");
			sw.WriteLine ("	@total_count int, @today_join_count int, @today_contact_count int, ");
			sw.WriteLine ("	@month_join_count int, @month_contact_count int	");
			//  
			sw.WriteLine ("select @total_count = count (*) ");
			sw.WriteLine ("from nb_memberdata ");
			sw.WriteLine ("where guest_no != '000000'");
            //  
			sw.WriteLine ("select @today_join_count = count (*) ");
			sw.WriteLine ("from nb_memberdata ");
            sw.WriteLine ("where guest_no != '000000' and convert (char(10), join_time, 102) = convert (char(10), getdate(), 102)");
            //  
			sw.WriteLine ("select @today_contact_count = isnull(mem_login, 0) ");
			sw.WriteLine ("from NB_Log ");
			sw.WriteLine ("where log_date = convert (char(10), getdate(), 102)");
            //  
			sw.WriteLine ("select @month_join_count = count (*) ");
			sw.WriteLine ("from nb_memberdata ");
			sw.WriteLine ("where guest_no != '000000' and convert (char(7), join_time, 102) = '" + pbSelMonth + "'");
			//  
			sw.WriteLine ("select @month_contact_count = sum (isnull(mem_login, 0)) ");
			sw.WriteLine ("from NB_Log ");
			sw.WriteLine ("where substring (log_date, 1, 7) = '" + pbSelMonth + "'");
			
			sw.WriteLine ("select ");
			sw.WriteLine ("	isnull(@total_count, 0) as total_count, isnull(@today_join_count, 0) as today_join_count, isnull(@today_contact_count, 0) as today_contact_count, ");
			sw.WriteLine ("	isnull(@month_join_count, 0) as month_join_count, isnull(@month_contact_count, 0) as month_contact_count");
            
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

                SqlDataReader drData = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, sw.ToString());

				if (drData.Read())
				{
					ltrTotalMemCount.Text = long.Parse (drData["total_count"].ToString()).ToString ("#,0");
					ltrTodayJoin.Text = long.Parse (drData["today_join_count"].ToString()).ToString ("#,0");
					ltrTodayContact.Text = long.Parse (drData["today_contact_count"].ToString()).ToString ("#,0");
					ltrMonthJoin.Text = long.Parse (drData["month_join_count"].ToString()).ToString ("#,0");
					ltrMonthContact.Text = long.Parse (drData["month_contact_count"].ToString()).ToString ("#,0");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}		
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.  ޼ 
		///		ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.lnkPrevMonth.Click += new System.EventHandler(this.lnkPrevMonth_Click);
			this.lnkNextMonth.Click += new System.EventHandler(this.lnkNextMonth_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private double GetPercent(double nTotal, double nVal)
		{
            double nTmpVal = (nVal / nTotal) * 100.0;
			double nResult = Math.Round (nTmpVal, 1);

			if (nResult == 0.0)
			{
                nResult = 1.0;
			}

			return nResult;
		}

		private void MonthViewDayRender()
		{
			string[] arrDate = pbSelMonth.Split ('.');
			string sCurrDate = string.Empty;
			double nPercentJoin = 0.0;
			double nPercentContact = 0.0;

			int nMonthDays = DateTime.DaysInMonth (int.Parse(arrDate[0]), int.Parse(arrDate[1]));

			double nMonthJoinTotal = double.Parse (ltrMonthJoin.Text.Replace (",", ""));
			double nMonthContactTotal = double.Parse (ltrMonthContact.Text.Replace (",", ""));
			double nMaxCnt = 0.0;

			if (nMonthJoinTotal > nMonthContactTotal)
			{
				nMaxCnt = nMonthJoinTotal;              
			}
			else
			{
				nMaxCnt = nMonthContactTotal;
			}

			int nJoinCount;
			int nContactCount;

			MonthViewLoad();


			for (int i=1; i <= nMonthDays; i++)
			{
				nJoinCount = 0;
				nContactCount = 0;

				sCurrDate = pbSelMonth + "." + i.ToString().PadLeft (2, '0');

				DataRow[] drJoin = dtMonthJoin.Select ("dt = '" + sCurrDate + "'");

				if (drJoin.Length > 0)
				{
					nJoinCount = int.Parse (drJoin[0][1].ToString());
					nPercentJoin = GetPercent (nMaxCnt, double.Parse (drJoin[0][1].ToString()));
				}
				else
				{
					nPercentJoin = 0.0;
				}

				DataRow[] drContact = dtMonthContact.Select ("dt = '" + sCurrDate + "'");

				if (drContact.Length > 0)
				{
					nContactCount = int.Parse (drContact[0][1].ToString());
					nPercentContact = GetPercent (nMaxCnt, double.Parse (drContact[0][1].ToString()));
				}
				else
				{
					nPercentContact = 0.0;
				}

				
				HtmlTableRow htRow = null;
				HtmlTableCell htCell = null;

                
				htRow = new HtmlTableRow();

				htCell = new HtmlTableCell();
				htCell.RowSpan = 2;
				htCell.Align = "center";
				htCell.Width = "90";
				htCell.Attributes["class"] = "graph_header_font";
				htCell.InnerHtml = sCurrDate;
				htRow.Cells.Add (htCell);

                htCell = new HtmlTableCell();
				htCell.Align = "center";
				htCell.Width = "80";
				htCell.Attributes["class"] = "graph_title_font";
				htCell.InnerHtml = "";
				htRow.Cells.Add (htCell);

                htCell = new HtmlTableCell();
                htCell.Align = "left";
				htCell.Attributes["class"] = "graph_font";
				htCell.InnerHtml = "<div style='width : " + nPercentJoin.ToString() + "%' class='graph_color' title='" + nJoinCount.ToString("#,0") + "'><img src='../../Images/tran.gif' width='1' height='1' border='0'></div>";
				htRow.Cells.Add (htCell);

				tblMonthView.Rows.Add (htRow);

				htRow = new HtmlTableRow();

				htCell = new HtmlTableCell();
				htCell.Align = "center";
				htCell.Width = "80";
				htCell.Attributes["class"] = "graph_title_font";
				htCell.InnerHtml = "";
				htRow.Cells.Add (htCell);

				htCell = new HtmlTableCell();
				htCell.Align = "left";
				htCell.Attributes["class"] = "graph_font";
				htCell.InnerHtml = "<div style='width : " + nPercentContact.ToString() + "%' class='graph_color2' title='" + nContactCount.ToString("#,0") + "'><img src='../../Images/tran.gif' width='1' height='1' border='0'></div>";
				htRow.Cells.Add (htCell);

				tblMonthView.Rows.Add (htRow);
			}

			MonthViewUnLoad();
		}

		DataTable dtMonthJoin = null;
		DataTable dtMonthContact = null;

		private void MonthViewLoad()
		{
			StringWriter sw = new StringWriter();

			// Ϻ 
			sw.WriteLine ("select convert (char(10), join_time, 102) as dt, count (join_time) as cnt");
			sw.WriteLine ("from nb_memberdata");
			sw.WriteLine ("where guest_no != '000000' and convert (char(7), join_time, 102) = '" + pbSelMonth + "'");
			sw.WriteLine ("group by convert (char(10), join_time, 102)");
			sw.WriteLine ("order by convert (char(10), join_time, 102) asc");
			// Ϻ 
			sw.WriteLine ("select log_date as dt, sum (isnull(mem_login, 0)) as cnt");
			sw.WriteLine ("from nb_log");
			sw.WriteLine ("where substring(log_date, 1, 7) = '" + pbSelMonth + "'");
			sw.WriteLine ("group by log_date");
			sw.WriteLine ("order by log_date asc");


			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection(ref dbSqlConn);

				DataSet dsData = SqlHelper.ExecuteDataset (dbSqlConn, CommandType.Text, sw.ToString());

				if (dsData != null)
				{
					dtMonthJoin = dsData.Tables[0];
					dtMonthContact = dsData.Tables[1];
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose(ref dbSqlConn);
			}            		
		}

		private void MonthViewUnLoad()
		{
			if (dtMonthJoin != null)
			{
				dtMonthJoin.Dispose();
			}

			if (dtMonthContact != null)
			{
				dtMonthContact.Dispose();
			}
		}

		private void lnkPrevMonth_Click(object sender, System.EventArgs e)
		{
            MoveMonth (-1);		
		}

		private void lnkNextMonth_Click(object sender, System.EventArgs e)
		{
            MoveMonth (1);		
		}

		private void MoveMonth(int nMove)
		{
			string sCurMon = lblCurrMonth.Text;

			DateTime dtCur = DateTime.Parse (sCurMon + ".01");

			pbSelMonth = dtCur.AddMonths(nMove).ToString ("yyyy.MM");
            
			lblCurrMonth.Text = pbSelMonth;

			GetMemReport();
			MonthViewDayRender();
		}
	}
}
