﻿using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Text.RegularExpressions;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;
using System.Xml;
using System.IO;

namespace NeAdmin.NeBoardUpgrade
{
	public class SysUpgrade : Page
	{
		#region Controls
		protected TextBox txt_proc_qry;
		string sAppVer = string.Empty;
		protected ImageButton imgbtn_start_proc;
		protected System.Web.UI.WebControls.LinkButton lnk_spl_upgrade;
		protected System.Web.UI.WebControls.Panel pnl_file_up;
		string sDBVer = string.Empty;
		#endregion

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				sAppVer = VersionInfo.GetAppVersion();
				sDBVer = VersionInfo.GetDbVersion();

				// 1.0.000 버전에서 파일 업데이트 부분
				if (sDBVer != null && sDBVer.CompareTo("1.0.000") < 0)
					pnl_file_up.Visible = true;
				else
					pnl_file_up.Visible = false;

				// 업그레이드 쿼리 불러 오기
				if (!IsPostBack)
					GetProcQry();
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
			}
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// 디자이너 지원에 필요한 메서드입니다.
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{    
			this.imgbtn_start_proc.Click += new System.Web.UI.ImageClickEventHandler(this.imgbtn_start_proc_Click);
			this.lnk_spl_upgrade.Click += new System.EventHandler(this.lnk_spl_upgrade_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void GetProcQry()
		{
			// 처음 생성인지, 업그레이드인지 검사한다.

			try
			{
				VerCheck.VerCheck oVerCheck = null;
				
				try
				{
					oVerCheck = new VerCheck.VerCheck();
				}
				catch
				{
				}

				if (oVerCheck != null)
				{

					// DB 업그레이드
					string sUpdateQry = oVerCheck.GetUpgradeQry (sAppVer, sDBVer);

					if (sUpdateQry != null && sUpdateQry.Length > 3 && !sUpdateQry.StartsWith("Err"))
					{
						txt_proc_qry.Text = sUpdateQry;
						imgbtn_start_proc.Visible = true;
					}
					else
					{
						txt_proc_qry.Text = "DB 업그레이드 쿼리를 가지고 오는데 오류가 있었습니다.\n\n다시한번 시도해 주세요.";
						imgbtn_start_proc.Visible = false;
					}
				}
				else
				{
					throw new Exception ("웹서비스에 접근할 수 없습니다.");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void imgbtn_start_proc_Click(object sender, ImageClickEventArgs e)
		{
			try
			{
				if (!NBUtil.StrEmptyChk(txt_proc_qry.Text))
				{
					if (NBAdminUtil.InstallQryExec (txt_proc_qry.Text))
					{
						DoLevelUpdate();

						NBCmnUtil.ViewMsgGoUrl (Page, "../Default.aspx", @"DB 업그레이드에 성공 하였습니다.");
					}
					else
						NBCmnUtil.ViewAlertMsg (Page, @"DB 업그레이드 작업이 실패 하였습니다.\n\nDB 연결 정보와 실행 쿼리를 다시한번 확인해 주세요.");
				}
				else
				{
					NBCmnUtil.ViewAlertMsg (Page, "실행할 DB 업그레이드 쿼리가 없습니다.");
				}
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, @E.Message);
			}
		}

		private void DoLevelUpdate()
		{
			if (sDBVer.Equals("1.5.000"))
			{
				// ///////////////////////////////
				// 그룹 설정
				// ///////////////////////////////
				StringWriter Qry = new StringWriter();
                
				DataTable dt = DBUtil.RunDBToDataTable (CommandType.Text, "SELECT group_code FROM NB_GroupInfo ORDER BY group_code ASC");

				foreach (DataRow dr in dt.Rows)
				{
					string sNotMem = string.Empty;

					int nCnt = 9;

					for (int i=1; i < 11; i++)
					{
						if (i.Equals(10))
						{
							sNotMem = "1";
						}
						else
						{
							sNotMem = "0";
						}

						Qry.Write ("INSERT INTO NB_GroupUserLevel (group_code, level_code, level_name, priority, not_member) VALUES");
						Qry.WriteLine ("('" + dr["group_code"].ToString() + "', '" + i.ToString().PadLeft(2, '0') + "', 'Level " + i.ToString() + "', " + (i + nCnt).ToString() + ", '" + sNotMem + "')");

						nCnt--;
					}
				}

				DataTable dt2 = DBUtil.RunDBToDataTable (CommandType.Text, "SELECT * FROM NB_GroupLevelCfg ORDER BY group_code ASC, level_code ASC");

				foreach (DataRow dr in dt2.Rows)
				{
					object[] objRowData = dr.ItemArray;

					for (int i=2; i < 17; i++)
					{
						string sRoleCode = string.Empty;

						if (objRowData[i] != null && objRowData[i].ToString().Equals("1"))
						{
							switch (i)
							{
								case 2://list_view
                                    sRoleCode = "001";
									break;
								case 3://cont_view
									sRoleCode = "002";
									break;
								case 4://write_yn
									sRoleCode = "003";
									break;
								case 5://cmmt_write
									sRoleCode = "005";
									break;
								case 6://reply_write
									sRoleCode = "007";
									break;
								case 7://delete_yn
									sRoleCode = "008";
									break;
								case 8://allhtml_use
									sRoleCode = "009";
									break;
								case 9://notice_write
									sRoleCode = "010";
									break;
								case 10://private_view
									sRoleCode = "011";
									break;
								case 11://fileup_use
									sRoleCode = "012";
									break;
								case 12://filedown_use
									sRoleCode = "013";
									break;
								case 13://good_use
									sRoleCode = "014";
									break;
								case 14://listen_music
									sRoleCode = "015";
									break;
								case 15://vote_use
									sRoleCode = "016";
									break;
								case 16://vote_write
									sRoleCode = "017";
									break;
							}
						}

						if (!NBUtil.StrEmptyChk (sRoleCode))
						{
							Qry.Write ("INSERT INTO NB_GroupUserLevel_Detail (group_code, level_code, role_code) VALUES");
							Qry.WriteLine ("('" + objRowData[0].ToString() + "', '" + objRowData[1].ToString() + "', '" + sRoleCode + "')");
						}
					}

					Qry.Write ("INSERT INTO NB_GroupUserLevel_Detail (group_code, level_code, role_code) VALUES");
					Qry.WriteLine ("('" + objRowData[0].ToString() + "', '" + objRowData[1].ToString() + "', '004')");
					Qry.Write ("INSERT INTO NB_GroupUserLevel_Detail (group_code, level_code, role_code) VALUES");
					Qry.WriteLine ("('" + objRowData[0].ToString() + "', '" + objRowData[1].ToString() + "', '006')");
					Qry.Write ("INSERT INTO NB_GroupUserLevel_Detail (group_code, level_code, role_code) VALUES");
					Qry.WriteLine ("('" + objRowData[0].ToString() + "', '" + objRowData[1].ToString() + "', '018')");
					Qry.Write ("INSERT INTO NB_GroupUserLevel_Detail (group_code, level_code, role_code) VALUES");
					Qry.WriteLine ("('" + objRowData[0].ToString() + "', '" + objRowData[1].ToString() + "', '019')");
				}

                DBUtil.RunDBToNone (CommandType.Text, Qry.ToString());

				// ///////////////////////////////
				// 게시판 설정
				// ///////////////////////////////
				StringWriter Qry2 = new StringWriter();
                
				DataTable dt3 = DBUtil.RunDBToDataTable (CommandType.Text, "SELECT board_no FROM NB_BoardSet ORDER BY board_no ASC");

				foreach (DataRow dr in dt3.Rows)
				{
					string sNotMem = string.Empty;

					int nCnt = 9;

					for (int i=1; i < 11; i++)
					{
						if (i.Equals(10))
						{
							sNotMem = "1";
						}
						else
						{
							sNotMem = "0";
						}

						Qry2.Write ("INSERT INTO NB_BoardUserLevel (board_no, level_code, level_name, priority, not_member) VALUES");
						Qry2.WriteLine ("('" + dr["board_no"].ToString() + "', '" + i.ToString().PadLeft(2, '0') + "', 'Level " + i.ToString() + "', " + (i + nCnt).ToString() + ", '" + sNotMem + "')");

						nCnt--;
					}
				}

				DataTable dt4 = DBUtil.RunDBToDataTable (CommandType.Text, "SELECT * FROM NB_LevelCfg ORDER BY board_no ASC, level_code ASC");

				foreach (DataRow dr in dt4.Rows)
				{
					object[] objRowData = dr.ItemArray;

					for (int i=2; i < 17; i++)
					{
						string sRoleCode = string.Empty;

						if (objRowData[i] != null && objRowData[i].ToString().Equals("1"))
						{
							switch (i)
							{
								case 2://list_view
									sRoleCode = "001";
									break;
								case 3://cont_view
									sRoleCode = "002";
									break;
								case 4://write_yn
									sRoleCode = "003";
									break;
								case 5://cmmt_write
									sRoleCode = "005";
									break;
								case 6://reply_write
									sRoleCode = "007";
									break;
								case 7://delete_yn
									sRoleCode = "008";
									break;
								case 8://allhtml_use
									sRoleCode = "009";
									break;
								case 9://notice_write
									sRoleCode = "010";
									break;
								case 10://private_view
									sRoleCode = "011";
									break;
								case 11://fileup_use
									sRoleCode = "012";
									break;
								case 12://filedown_use
									sRoleCode = "013";
									break;
								case 13://good_use
									sRoleCode = "014";
									break;
								case 14://listen_music
									sRoleCode = "015";
									break;
								case 15://vote_use
									sRoleCode = "016";
									break;
								case 16://vote_write
									sRoleCode = "017";
									break;
							}
						}

						if (!NBUtil.StrEmptyChk (sRoleCode))
						{
							Qry2.Write ("INSERT INTO NB_BoardUserLevel_Detail (board_no, level_code, role_code) VALUES");
							Qry2.WriteLine ("('" + objRowData[0].ToString() + "', '" + objRowData[1].ToString() + "', '" + sRoleCode + "')");
						}
					}

					Qry.Write ("INSERT INTO NB_BoardUserLevel_Detail (group_code, level_code, role_code) VALUES");
					Qry.WriteLine ("('" + objRowData[0].ToString() + "', '" + objRowData[1].ToString() + "', '004')");
					Qry.Write ("INSERT INTO NB_BoardUserLevel_Detail (group_code, level_code, role_code) VALUES");
					Qry.WriteLine ("('" + objRowData[0].ToString() + "', '" + objRowData[1].ToString() + "', '006')");
					Qry.Write ("INSERT INTO NB_BoardUserLevel_Detail (group_code, level_code, role_code) VALUES");
					Qry.WriteLine ("('" + objRowData[0].ToString() + "', '" + objRowData[1].ToString() + "', '018')");
					Qry.Write ("INSERT INTO NB_BoardUserLevel_Detail (group_code, level_code, role_code) VALUES");
					Qry.WriteLine ("('" + objRowData[0].ToString() + "', '" + objRowData[1].ToString() + "', '019')");
				}

				DBUtil.RunDBToNone (CommandType.Text, Qry2.ToString());




				DataTable OldLevelData = DBUtil.RunDBToDataTable (CommandType.Text, "SELECT group_code FROM NB_GroupInfo ORDER BY group_code ASC");

				StringWriter TransQry = new StringWriter();
                
				TransQry.WriteLine ("DELETE NB_UserLevelInGroup");

				foreach (DataRow OldDataRow in OldLevelData.Rows)
				{
                    TransQry.WriteLine ("INSERT INTO NB_UserLevelInGroup (group_code, guest_no, level_code) SELECT '" + OldDataRow["group_code"].ToString() +"', guest_no, level_code FROM NB_MemberData");
				}

				DBUtil.RunDBToNone (CommandType.Text, TransQry.ToString());



				string sDelQry = "DROP TABLE NB_LevelCfg";
				
				DBUtil.RunDBToNone (CommandType.Text, sDelQry);

				sDelQry = "DROP TABLE NB_GroupLevelCfg";

				DBUtil.RunDBToNone (CommandType.Text, sDelQry);
			}
		}

		private void lnk_spl_upgrade_Click(object sender, System.EventArgs e)
		{
            SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				// 게시판 코드를 읽어 온다.

				DataSet dsBoardNos = SqlHelper.ExecuteDataset (dbSqlConn, CommandType.Text, "SELECT board_no FROM NB_BoardCfg ORDER BY board_no ASC");

				DataTable dtBoardNos = dsBoardNos.Tables[0];

				dbSqlConn.Close();

				if (dtBoardNos.Rows.Count > 0)
				{
					XmlDocument xmlDoc = new XmlDocument();
					XmlNode xmlNode;

					xmlDoc.Load(Server.MapPath("../CfgXml/TableCreate.xml"));

					xmlNode = xmlDoc.SelectSingleNode ("BoardCreate/TableCreate/Table[@Name='NB_FileData_']");

					foreach (DataRow drBoardNo in dtBoardNos.Rows)
					{
						// FileData 테이블을 생성한다.
						string sFileDataCreate = xmlNode.InnerText.Replace("#BoardNo#", drBoardNo["board_no"].ToString());

						SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sFileDataCreate);
						dbSqlConn.Close();
                        

						// BoardData 테이블의 첨부 파일을 FileData테이블로 이동 한다.
						string sTransFileData1 = "INSERT INTO NB_FileData_" + drBoardNo["board_no"].ToString();
						sTransFileData1 += " (idx_no, fidx_no, file_name, file_ext, file_down, file_size) ";
						sTransFileData1 += " SELECT idx_no, 1, f1_name, '.' + f1_ext, f1_downs, f1_size FROM NB_BoardData_" + drBoardNo["board_no"].ToString();

						SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sTransFileData1);
						dbSqlConn.Close();

						string sTransFileData2 = "INSERT INTO NB_FileData_" + drBoardNo["board_no"].ToString();
						sTransFileData2 += " (idx_no, fidx_no, file_name, file_ext, file_down, file_size) ";
						sTransFileData2 += " SELECT idx_no, 2, f2_name, '.' + f2_ext, f2_downs, f2_size FROM NB_BoardData_" + drBoardNo["board_no"].ToString();

						SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sTransFileData2);
						dbSqlConn.Close();

						// BoardData 테이블의 파일 관련 필드와 seq_no 필드 삭제
						string sDropField = "ALTER TABLE NB_BoardData_" + drBoardNo["board_no"].ToString();
						sDropField += " DROP COLUMN seq_no \r\n";

						sDropField += "ALTER TABLE NB_BoardData_" + drBoardNo["board_no"].ToString();
						sDropField += " DROP COLUMN f1_name \r\n";
						sDropField += "ALTER TABLE NB_BoardData_" + drBoardNo["board_no"].ToString();
						sDropField += " DROP COLUMN f1_ext \r\n";
						sDropField += "ALTER TABLE NB_BoardData_" + drBoardNo["board_no"].ToString();
						sDropField += " DROP COLUMN f1_downs \r\n";
						sDropField += "ALTER TABLE NB_BoardData_" + drBoardNo["board_no"].ToString();
						sDropField += " DROP COLUMN f1_size \r\n";

						sDropField += "ALTER TABLE NB_BoardData_" + drBoardNo["board_no"].ToString();
						sDropField += " DROP COLUMN f2_name \r\n";
						sDropField += "ALTER TABLE NB_BoardData_" + drBoardNo["board_no"].ToString();
						sDropField += " DROP COLUMN f2_ext \r\n";
						sDropField += "ALTER TABLE NB_BoardData_" + drBoardNo["board_no"].ToString();
						sDropField += " DROP COLUMN f2_downs \r\n";
						sDropField += "ALTER TABLE NB_BoardData_" + drBoardNo["board_no"].ToString();
						sDropField += " DROP COLUMN f2_size \r\n";

						SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sDropField);
						dbSqlConn.Close();
					}
				}

				NBCmnUtil.ViewAlertMsg (Page, "작업 완료");
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}
	}
}
