﻿// 이메일 형식 유효성 검사
function valid_email(email) { 
if(email.value == "") {      
    return false;
}

if(email.match("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+([\.][a-z0-9]+)+$") == null) {
    return false;
}

return true;
}

// 홈페이지 형식 유효성 검사
function valid_homepage(homepage) {
if(homepage == "") {
    return false;
}

if(homepage.match("(http|https|ftp|telnet|news):\/\/([a-z0-9_\-]+\.[][a-z0-9:;&#@=_~%\?\/\.\,\+\-]+)") == null) {
    return false;
}

return true;
}

function valid_phone(phone) {
if(phone.match("^[0-9]{2,3}-[0-9]{3,4}-[0-9]{4,4}$") == null) {
    return false;
}

return true;
}

// 주민등록번호 유효성 검사  
function valid_citizenno(citizen_no) {
if(citizen_no == "") {
    return false;
}

if(citizen_no.indexOf("-") == -1) {
    return false;
}

numbers = citizen_no.split("-");
id_number1 = numbers[0];
id_number2 = numbers[1];

if(id_number1.match(/\D/) != null || id_number2.match(/\D/) != null) {
    return false;
}

if(id_number1.length != 6 || id_number2.length != 7) {
    return false;
}

var SUMM,OSub,ModValue,LastVal;
	
var A     = parseInt(id_number1.charAt(0),10);
var B     = parseInt(id_number1.charAt(1),10);
var C     = parseInt(id_number1.charAt(2),10);
var D     = parseInt(id_number1.charAt(3),10);
var E     = parseInt(id_number1.charAt(4),10);
var F     = parseInt(id_number1.charAt(5),10);

var G     = parseInt(id_number2.charAt(0),10);
var H     = parseInt(id_number2.charAt(1),10);
var I     = parseInt(id_number2.charAt(2),10);
var J     = parseInt(id_number2.charAt(3),10);
var K     = parseInt(id_number2.charAt(4),10);
var L     = parseInt(id_number2.charAt(5),10);
var OSub  = parseInt(id_number2.charAt(6),10);

SUMM = (A*2) + (B*3) + (C*4) + (D*5) + (E*6) + (F*7) + (G*8) + (H*9) + (I*2) + (J*3) + (K*4) + (L*5);
ModValue = 11 - (SUMM % 11);
LastVal =  ModValue % 10 ;

if(OSub != LastVal) {
    return false; 
}

return true;
}

function check_digit(e) {
	if ((e.keyCode<48)||(e.keyCode>57)) {
		e.returnValue=false;
	}
}
		
function check_digit2(e) {
	if (((e.keyCode<48)||(e.keyCode>57)) && (e.keyCode != 46)) {
		e.returnValue=false;
	}
}


// ///////////////////////////////////////
// 날자 관련 함수 시작
function isDateTime(sDateTime){
	
	if(sDateTime.match("^[0-9]{4,4}\\.[0-9]{1,1}[0-9]{1,1}\\.[0-9]{1,1}[0-9]{1,1} [0-9]{2}:[0-9]{2}$") == null) {
		return false;
	}else{
		return true;
	}
}

function isDateStr(sDateStr){

	if(sDateStr.match("^[0-9]{4,4}\\.[0-9]{1,1}[0-9]{1,1}\\.[0-9]{1,1}[0-9]{1,1}$") == null) {
		return false;
	}else{
		return true;
	}

}
// 날자 관련 함수 끝
// ////////////////////////////////////////


function isNumeric(sNum){
	if (sNum.match(/\D/) != null){
		return false;
	}else{
		return true;
	}
}

function W_Close(){
	this.close();
	return false;
}

String.prototype.trim = function()
{
	 return this.replace(/(^ *)|( *$)/g, "");
}

function ErrInputProc(objCont)
{
	if (objCont)
	{
		objCont.focus();
	}
	return false;	
}

function OpenRplStrWin(tarid)
{
	window.open ("../MngPages/MemberPage/ReplaceStr.aspx?tarid=" + tarid, "GetReplaceStr", "width=300, height=400");
}

function OpenMemDetail(mid)
{
	window.open ("../MngPages/MemberPage/MemberDetail.aspx?gno=" + mid, "MemberDetail", "width=620, height=620, scrollbars=yes");
}

function AdminInfoWinOpen()
{
	window.open ("../MngPages/MemberPage/SuperAdminInfo.aspx", "SuperAdminInfo", "width=360, height=230");
}

function ColorDlg(colorTxtBox)
{
	if (colorTxtBox)
	{
		if (!colorTxtBox.disabled)
		{
			colorTxtBox.value = window.showModalDialog('../Tools/ColorPicker.htm',colorTxtBox.value,'dialogHeight:455px;dialogWidth:370px;center:Yes;help:No;scroll:No;resizable:No;status:No;');	
		}
	}
}

function ReplyMailChk(srcID, tarID)
{
	var srcCtrl = document.getElementById(srcID);
	var tarCtrl = document.getElementById(tarID);
	
	if (srcCtrl && tarCtrl)
	{
		if (srcCtrl.checked)
		{
			if (!tarCtrl.checked)
			{
				tarCtrl.checked = true;			
				
				alert ('답글 메일 기능 사용을 위해 [이메일 표시]가 자동으로 체크 되었습니다.');
			}
		}
	}
}

function TextAddList(srcID, tarID)
{
	var srcTextBox = document.getElementById(srcID);
	var tarListCtrl = document.getElementById(tarID);
	
	if (srcTextBox && tarListCtrl)
	{
		if (srcTextBox.value.trim() != "")
		{
			if (get_index_of_option_by_value(tarID, srcTextBox.value) == -1)
			{
				var optItem = new Option();
				optItem.text= srcTextBox.value;
				optItem.value = srcTextBox.value;
				
				tarListCtrl.add (optItem);
			}
			else
			{
				alert ('이미 동일한 항목이 입력되어 있습니다.');
			}
			
			srcTextBox.value = "";
		}
		else
		{
			alert ('추가할 항목을 입력해 주세요.');
		}
	}
}

function TextDelList(tarID)
{
	var tarListCtrl = document.getElementById(tarID);

    var idx = get_index_of_option(tarID);
    
    if (idx > -1)
    {
      for (var i=idx; i < tarListCtrl.options.length-1; i++)
      {
        tarListCtrl.options[i].text = tarListCtrl.options[i+1].text;
        tarListCtrl.options[i].value = tarListCtrl.options[i+1].value;
      }
      
      tarListCtrl.options.length--;
    }
    else
    {
			alert ('선택된 항목이 없습니다.');
    }
}

function get_index_of_option_by_value(tarID, strval)
{
	var tarListCtrl = document.getElementById(tarID);

	for (var i = 0; i < tarListCtrl.options.length; i++)
	{
		if (tarListCtrl.options[i].value == strval)
		{
			return i; 
		}
	}

  return -1;
}

function get_index_of_option(tarID)
{
	var tarListCtrl = document.getElementById(tarID);

	for (var i = 0; i < tarListCtrl.options.length; i++)
	{
		if (tarListCtrl.options[i].selected)
		{
			return i; 
		}
	}

  return -1;
}

function BoardRemove(bno)
{
	window.open ('../MngPages/CommonPage/BoardRemove.aspx?bno=' + bno, 'BoardRemove', 'width=390, height=220, status=yes');
}

function EndDataRemove(bno)
{
	window.open ('../MngPages/CommonPage/EndDataRemove.aspx?bno=' + bno, 'EndDataRemove', 'width=390, height=220, status=yes');
}

function FindMethodHelp()
{
	window.open ('../MngPages/NBUtil/FindMethodHelp.htm', 'FindAllHelp', 'width=420, height=400');
}

function FindMethodHelpMem()
{
	window.open ('../MngPages/MemberPage/FindMethodHelp.htm', 'FindAllHelp', 'width=420, height=150');
}

function SBarStylaWin()
{
	window.open ('../MngPages/BoardPage/ScrollBarStyle.htm', 'SBarStyle', 'width=465, height=530, scrollbars=yes, status=yes');
}

function DoChkAll()
{
	var chkIdIs = "";
	
	for (i=0; i < document.forms[0].length; i++)
	{
		var objCtrl = document.forms[0][i];
		
		if (objCtrl.type == "checkbox" && objCtrl.name.indexOf("UserPageControl:dGroupList:") > -1)
		{
			if (objCtrl.checked)
			{
				objCtrl.checked = false;				
			}
			else
			{
				objCtrl.checked = true;			
			}
		}
	}
}

function Do_FileUp_Default(objChkBox, txtUpCnt_ID, txtUpSize_ID)
{
	var objUpCnt = document.getElementById(txtUpCnt_ID);
	var objUpSize = document.getElementById(txtUpSize_ID);
	
	if (objChkBox.checked)
	{
		if (objUpCnt.value.trim() == "" || objUpCnt.value.trim() == "0")
		{
			objUpCnt.value = "3";
		}
		
		if (objUpSize.value.trim() == "" || objUpSize.value.trim() == "0")
		{
			objUpSize.value = 1024 * 4;
		}
	}
}

function Do_ListImg_Default(objChkBox, txtImgWidth_ID, txtImgHeight_ID)
{
	var objImgWidth = document.getElementById(txtImgWidth_ID);
	var objImgHeight = document.getElementById(txtImgHeight_ID);
	
	if (objChkBox.checked)
	{
		if (objImgWidth.value.trim() == "" || objImgWidth.value.trim() == "0")
		{
			objImgWidth.value = "100";
		}
		
		if (objImgHeight.value.trim() == "" || objImgHeight.value.trim() == "0")
		{
			objImgHeight.value = "100";
		}
	}
}

function Do_FireCnt_Default(objChkBox, txtFireCnt_ID)
{
	var objFireCnt = document.getElementById(txtFireCnt_ID);
	
	if (objChkBox.checked)
	{
		if (objFireCnt.value.trim() == "" || objFireCnt.value.trim() == "0")
		{
			objFireCnt.value = "10";
		}		
	}
}

function WinOpenSimple(sUrl, sName, sOpt)
{
	window.open (sUrl, sName, sOpt);
	
	return false;
}

function MailPreviewWin(sId)
{
	var objMailCode = document.getElementById(sId);
	
	if (objMailCode)
	{
		if (objMailCode.value)
		{
			window.open ("../MngPages/MemberPage/MailPreview.aspx?mcode=" + objMailCode.value, "SendMailPreview", "width=550,height=470,scrollbars=yes");
		}
	}
	
	return false;
}

function MailSendAgree(sType, sObjID)
{

	var sMsg = "";
	var objChk = document.getElementById(sObjID);

	if (sType == "1")
	{
		sMsg = "선택한 회원에게 메일이 발송 됩니다.";
	}
	else if (sType == "2")
	{
		sMsg = "검색된 모든 회원에게 메일이 발송 됩니다.";
	}
	else if (sType == "3")
	{
		sMsg = "등록된 전체 회원에게 메일이 발송 됩니다.";
	}
	else
	{
		return false;
	}
	

	if (objChk.checked)
	{
		sMsg += " (수신 거부 회원 포함) ";
	}
	else
	{
		sMsg += " (수신 거부 회원 제외) ";
	}
	
	sMsg += "\n\n발송을 시작 하시려면 확인을 눌러 주세요.";
	
	return confirm (sMsg);
}

function HiddenToTextArea(hidID, txtID)
{
	var objHid = document.getElementById(hidID);
	var objTxt = document.getElementById(txtID);
	
	if (objHid && objTxt)
	{
		if (objHid.value.trim() != "")
		{
			objTxt.value = objHid.value;
		}
		else
		{
			alert ("예제 데이타가 없습니다.");
		}
	}	
}

function FnAddItemExamData(tarid, srcid)
{
	var objSrc = document.getElementById(srcid);
	
	if (objSrc)
	{
		if (objSrc.readOnly)
		{
			alert ("항목이 입력 가능한 상태가 아닙니다.");
		}
		else
		{
			WinOpenSimple('../MngPages/MemberPage/AddMemberExamData.aspx?tarid=' + tarid, 'AddItemExam', 'width=260, height=140');
		}
	}
}