using System;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Xml;
using BoardLib;
using EeekSoft.Web;
using NeBoard.Common;

namespace NeBoard
{
	public class NBBoardUC : System.Web.UI.UserControl
	{
		#region Declare Field
		protected PopupWin popupWin;
		protected PlaceHolder ControlHolder;
		protected Literal LtrRightStamp;
		protected HtmlTable HTTblRightStamp;

		// Page Binding String
		public string
			PageBackColor,				//  
			PageBackImg,				//   ̹
			PageHeaderContent,			//   
			PageCopyRightContent,		// īǶƮ 
			PageTailContent,			//   
			ScrollBarStyle,				//  ũ  Ÿ
			CurrSkinPath,				//  Ų 
			UserCtrl_PreFix,			//   Ʈ PreFix
			gBoardNo,					// Խ ڵ
			gViewMode;					// Խ ۵ 

		// Խ 
		public NBLib.CurBoardCfg mBoardCfg;
		#endregion

		public string BoardNo
		{
			set
			{
				gBoardNo = value;
			}

			get
			{
                return gBoardNo;
			}
		}

		public string ViewMode
		{
			set
			{
				gViewMode = value;
			}

			get
			{
				return gViewMode;
			}
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				InitDataLoad();

				if (NBUtil.SetLicenseStamp(mBoardCfg, gViewMode, ref HTTblRightStamp, ref LtrRightStamp))
				{
					if(!NBUtil.DoIPChk(mBoardCfg, gBoardNo))
						NBPreProc.ShowMemoPopup (mBoardCfg, gBoardNo, popupWin);
					else
						throw new Exception ("Ͻ IP (" + Request.UserHostAddress + ") ܵ IPԴϴ.");
				}
			}
			catch(Exception E)
			{
				Response.Clear();
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void Page_PreRender(object sender, EventArgs e)
		{
			//  ε
			SetPageDataBind();
		}

		/// <summary>
		/// Խ ʱ   ε Ѵ.
		/// </summary>
		private void InitDataLoad()
		{
			if (Request.QueryString["bno"] != null)
                gBoardNo = NBCmnUtil.QStrLoad ("bno");
			
			if (Request.QueryString["mode"] != null)
                gViewMode = NBCmnUtil.QStrLoad ("mode");

			if (NBUtil.StrEmptyChk (gBoardNo))
				throw new Exception (@" Խ ڵ尡 ϴ.\n\nԽ  ּ.");

			if (NBUtil.StrEmptyChk (gViewMode))
				gViewMode = "LIST";

			NBUtil.GetData_BoardCfg (ref mBoardCfg, gBoardNo, gViewMode, "0");

			DoLoadControl();
		}

		private void DoLoadControl()
		{
			string sControlPath = string.Empty;

			UserControl oBoardControl = null;			

			switch (gViewMode.ToUpper())
			{
				case "LIST":
					sControlPath = mBoardCfg.bnd_skin_path + "/" + "BoardList.ascx";
					BoardList objUC_LIST = (BoardList)LoadControl(sControlPath);
                    objUC_LIST.BoardNo = gBoardNo;
					objUC_LIST.ViewMode = gViewMode;
                    oBoardControl = objUC_LIST;
					break;
				case "WRITE":
					sControlPath = mBoardCfg.bnd_skin_path + "/" + "BoardWrite.ascx";
					BoardWrite objUC_WRITE = (BoardWrite)LoadControl(sControlPath);
					objUC_WRITE.BoardNo = gBoardNo;
					objUC_WRITE.ViewMode = gViewMode;
					oBoardControl = objUC_WRITE;
					break;
				case "MODIFY":
					sControlPath = mBoardCfg.bnd_skin_path + "/" + "BoardModify.ascx";
					BoardModify objUC_MODIFY = (BoardModify)LoadControl(sControlPath);
					objUC_MODIFY.BoardNo = gBoardNo;
					objUC_MODIFY.ViewMode = gViewMode;
					oBoardControl = objUC_MODIFY;
					break;		
				case "VIEW":
					sControlPath = mBoardCfg.bnd_skin_path + "/" + "BoardView.ascx";
					BoardView objUC_VIEW = (BoardView)LoadControl(sControlPath);
					objUC_VIEW.BoardNo = gBoardNo;
					objUC_VIEW.ViewMode = gViewMode;
					oBoardControl = objUC_VIEW;
					break;
				case "DELETE":
					sControlPath = mBoardCfg.bnd_skin_path + "/" + "Delete.ascx";
					Delete objUC_DELETE = (Delete)LoadControl(sControlPath);
					objUC_DELETE.BoardNo = gBoardNo;
					objUC_DELETE.ViewMode = gViewMode;
					oBoardControl = objUC_DELETE;
					break;
				case "LOGIN":
					sControlPath = mBoardCfg.bld_loginskin_path + "/" + "Login.ascx";
					Login objUC_LOGIN = (Login)LoadControl(sControlPath);
					objUC_LOGIN.BoardNo = gBoardNo;
					objUC_LOGIN.ViewMode = gViewMode;
					oBoardControl = objUC_LOGIN;
					break;
				case "MYINFO":
					sControlPath = mBoardCfg.bld_loginskin_path + "/" + "MyInfo.ascx";
					MyInfo objUC_MYINFO = (MyInfo)LoadControl(sControlPath);
					objUC_MYINFO.BoardNo = gBoardNo;
					objUC_MYINFO.ViewMode = gViewMode;
					oBoardControl = objUC_MYINFO;
					break;
				case "JOIN":
					sControlPath = mBoardCfg.bjd_joinskin_path + "/" + "Signup.ascx";
					Signup objUC_JOIN = (Signup)LoadControl(sControlPath);
					objUC_JOIN.BoardNo = gBoardNo;
					objUC_JOIN.ViewMode = gViewMode;
					oBoardControl = objUC_JOIN;
					break;
				default:
					sControlPath = mBoardCfg.bnd_skin_path + "/" + "BoardList.ascx";
					BoardList objUC_LIST2 = (BoardList)LoadControl(sControlPath);
					objUC_LIST2.BoardNo = gBoardNo;
					objUC_LIST2.ViewMode = gViewMode;
					oBoardControl = objUC_LIST2;
					break;
			}

			UserCtrl_PreFix = "NBUC";
			
			oBoardControl.ID = UserCtrl_PreFix;
			oBoardControl.EnableViewState = false;
			ControlHolder.Controls.Add(oBoardControl);
		}

		private void SetPageDataBind()
		{
			if (gViewMode.ToUpper().Equals("LOGIN") || gViewMode.ToUpper().Equals("MYINFO"))
			{
				CurrSkinPath = mBoardCfg.bld_loginskin_path;

				PageBackColor = mBoardCfg.bld_loginbg_color;
				PageBackImg = mBoardCfg.bld_loginbg_img;

				NBUtil.SetDisplayType(ref PageHeaderContent, mBoardCfg.bld_loginheader_type, mBoardCfg.bld_loginheader_cont);
				NBUtil.SetDisplayType(ref PageCopyRightContent, mBoardCfg.bld_logincopyright_type, mBoardCfg.bld_logincopyright_cont);
				NBUtil.SetDisplayType(ref PageTailContent, mBoardCfg.bld_logintail_type, mBoardCfg.bld_logintail_cont);

				if (!NBUtil.StrEmptyChk (mBoardCfg.bld_loginsbar_style))
					ScrollBarStyle = "body {" + mBoardCfg.bld_loginsbar_style + "}";
			}
			else if (gViewMode.ToUpper().Equals("JOIN"))
			{
				CurrSkinPath = mBoardCfg.bjd_joinskin_path;

				PageBackColor = mBoardCfg.bjd_joinbg_color;
				PageBackImg = mBoardCfg.bjd_joinbg_img;

				NBUtil.SetDisplayType(ref PageHeaderContent, mBoardCfg.bjd_joinheader_type, mBoardCfg.bjd_joinheader_cont);
				NBUtil.SetDisplayType(ref PageCopyRightContent, mBoardCfg.bjd_joincopyright_type, mBoardCfg.bjd_joincopyright_cont);
				NBUtil.SetDisplayType(ref PageTailContent, mBoardCfg.bjd_jointail_type, mBoardCfg.bjd_jointail_cont);

				if (!NBUtil.StrEmptyChk (mBoardCfg.bjd_joinsbar_style))
					ScrollBarStyle = "body {" + mBoardCfg.bjd_joinsbar_style + "}";
			}
			else
			{
				CurrSkinPath = mBoardCfg.bnd_skin_path;
				
				PageBackColor = mBoardCfg.bnd_pagebg_color;
				PageBackImg = mBoardCfg.bnd_pagebg_img;

				NBUtil.SetDisplayType(ref PageHeaderContent, mBoardCfg.bnd_header_type, mBoardCfg.bnd_header_cont);
				NBUtil.SetDisplayType(ref PageCopyRightContent, mBoardCfg.bnd_copyright_type, mBoardCfg.bnd_copyright_cont);
				NBUtil.SetDisplayType(ref PageTailContent, mBoardCfg.bnd_tail_type, mBoardCfg.bnd_tail_cont);

				if (!NBUtil.StrEmptyChk (mBoardCfg.bnd_sbar_style))
					ScrollBarStyle = "body {" + mBoardCfg.bnd_sbar_style + "}";
			}
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.  ޼ 
		///		ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
