/* ***************************************************************
 *  : Խ  
 * 
 *  : Ǿ - www.dotnetpia.co.kr
 *        ȣ (potato@dotnetpia.co.kr) 
 * 
 * ***************************************************************/

using System;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Xml;
using BoardLib;
using EeekSoft.Web;
using NeBoard.Common;


namespace NeBoard
{
	public class BoardPreview : Page
	{
		#region Declare Field
		protected PopupWin popupWin;
		protected PlaceHolder ControlHolder;
		protected Literal LtrRightStamp;
		protected HtmlTable HTTblRightStamp;

		// Page Binding String
		public string
			BrowserTitle,				//  ŸƲ
			PageBackColor,				//  
			PageBackImg,				//   ̹
			PageHeaderContent,			//   
			PageCopyRightContent,		// īǶƮ 
			PageTailContent,			//   
			ScrollBarStyle,				//  ũ  Ÿ
			CurrSkinPath,				//  Ų 
			UserCtrl_PreFix,			//   Ʈ PreFix
			gBoardNo,					// Խ ڵ
			gViewMode;					// Խ ۵ 

		// Խ 
		public NBLib.CurBoardCfg mBoardCfg;
		#endregion
		
		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				InitDataLoad();

				if (NBUtil.SetLicenseStamp(mBoardCfg, gViewMode, ref HTTblRightStamp, ref LtrRightStamp))
				{
					if(!NBUtil.DoIPChk(mBoardCfg, gBoardNo))
						NBPreProc.ShowMemoPopup (mBoardCfg, gBoardNo, popupWin);
					else
						throw new Exception ("Ͻ IP (" + Request.UserHostAddress + ") ܵ IPԴϴ.");
				}

				SetPageDataBind();
			}
			catch(Exception E)
			{
				Response.Clear();
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		/// <summary>
		/// Խ ʱ   ε Ѵ.
		/// </summary>
		public void InitDataLoad()
		{
			gBoardNo = NBCmnUtil.QStrLoad ("bno");

			if (NBUtil.StrEmptyChk (gBoardNo))
				throw new Exception (@" Խ ڵ尡 ϴ.\n\nԽ  ּ.");

			gViewMode = NBCmnUtil.QStrLoad ("mode");

			NBUtil.GetData_BoardCfg (ref mBoardCfg, gBoardNo, gViewMode, "1");

			DoLoadControl();
		}

		public void DoLoadControl()
		{
			string sControlPath = string.Empty;

			switch (gViewMode.ToUpper())
			{
				case "LIST":
					sControlPath = mBoardCfg.bnd_skin_path + "/" + "BoardList.ascx";
					break;
				case "WRITE":
					sControlPath = mBoardCfg.bnd_skin_path + "/" + "BoardWrite.ascx";
					break;
				case "MODIFY":
					sControlPath = mBoardCfg.bnd_skin_path + "/" + "BoardModify.ascx";
					break;		
				case "VIEW":
					sControlPath = mBoardCfg.bnd_skin_path + "/" + "BoardView.ascx";
					break;
				case "DELETE":
					sControlPath = mBoardCfg.bnd_skin_path + "/" + "Delete.ascx";
					break;
				case "LOGIN":
					sControlPath = mBoardCfg.bld_loginskin_path + "/" + "Login.ascx";
					break;
				case "MYINFO":
					sControlPath = mBoardCfg.bld_loginskin_path + "/" + "MyInfo.ascx";
					break;
				case "JOIN":
					sControlPath = mBoardCfg.bjd_joinskin_path + "/" + "Signup.ascx";
					break;
				default:
					sControlPath = mBoardCfg.bnd_skin_path + "/" + "BoardList.ascx";
					break;
			}

			UserCtrl_PreFix = "NBUC";
			
			using (UserControl oBoardControl = (UserControl)this.LoadControl(sControlPath))
			{
				oBoardControl.ID = UserCtrl_PreFix;
				oBoardControl.EnableViewState = false;
                ControlHolder.Controls.Add(new LiteralControl ("<div oncontextmenu=\"return false\" onselectstart=\"return false\" ondragstart=\"return false\" onclick=\"return PreviewModeAlert();\"><span class=\"PreviewAlertStyle\"≯ Դϴ.</span>"));
				ControlHolder.Controls.Add(oBoardControl);
				ControlHolder.Controls.Add(new LiteralControl ("</div>"));
			}
		}

		private void SetPageDataBind()
		{
			if (!NBUtil.StrEmptyChk (mBoardCfg.bnd_browser_title))
				BrowserTitle = mBoardCfg.bnd_browser_title;

			CurrSkinPath = mBoardCfg.bnd_skin_path;
			
			PageBackColor = mBoardCfg.bnd_pagebg_color;
			PageBackImg = mBoardCfg.bnd_pagebg_img;

			NBUtil.SetDisplayType(ref PageHeaderContent, mBoardCfg.bnd_header_type, mBoardCfg.bnd_header_cont);
			NBUtil.SetDisplayType(ref PageCopyRightContent, mBoardCfg.bnd_copyright_type, mBoardCfg.bnd_copyright_cont);
			NBUtil.SetDisplayType(ref PageTailContent, mBoardCfg.bnd_tail_type, mBoardCfg.bnd_tail_cont);

			if (!NBUtil.StrEmptyChk (mBoardCfg.bnd_sbar_style))
				ScrollBarStyle = "body {" + mBoardCfg.bnd_sbar_style + "}";
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
