﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using BoardLib;

namespace NeBoard.Common
{
	public class AdminMng : Page
	{
		protected TextBox WNTxtAdminID;
		protected TextBox WNTxtAdminPwd;

		protected ImageButton WNIMGBtnLoginOK;
		protected ImageButton WNIMGBtnAdminAccess;
		protected Panel pnl_logined;
		protected Panel pnl_logouted;
		protected HtmlTable tbl_login_after;
		string mAdminUrl;
		public string ClientScript;
		protected string sBoardNo;
		BoardLib.NBLib.CurBoardCfg mBoardCfg;
	
		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				if (!NBUtil.StrEmptyChk(Request.QueryString["admurl"]))
				{
					mAdminUrl = Server.UrlDecode(Request.QueryString["admurl"].Trim());
				}

				if (!NBUtil.StrEmptyChk(Request.QueryString["bno"]))
				{
					sBoardNo = Server.UrlDecode(Request.QueryString["bno"].Trim());
				}

				

				InitSetting();
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewMsgAndClose (Page, E.Message);
			}
		}

		private void InitSetting()
		{
			if (NBUtil.isAdminLogin(mBoardCfg.bps_level_info))
			{
				WNTxtAdminID.Enabled = false;
				WNTxtAdminPwd.Enabled = false;
				WNIMGBtnLoginOK.Enabled = false;

				pnl_logined.Visible = false;
				WNIMGBtnLoginOK.Visible = false;

                pnl_logouted.Visible = true;
			}
			else
			{
				WNTxtAdminID.Enabled = true;
				WNTxtAdminPwd.Enabled = true;
				WNIMGBtnLoginOK.Enabled = true;

				pnl_logined.Visible = true;
				WNIMGBtnLoginOK.Visible = true;

				pnl_logouted.Visible = false;
			}
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// 디자이너 지원에 필요한 메서드입니다.
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{    
			this.WNIMGBtnLoginOK.Click += new ImageClickEventHandler(this.WNIMGBtnLoginOK_Click);
			this.WNIMGBtnAdminAccess.Click += new ImageClickEventHandler(this.WNIMGBtnAdminAccess_Click);
			this.Load += new EventHandler(this.Page_Load);

		}
		#endregion

		private void WNIMGBtnLoginOK_Click(object sender, ImageClickEventArgs e)
		{
			try
			{
				string sLoginGuestNo = NBUtil.do_login (120, WNTxtAdminID.Text, WNTxtAdminPwd.Text);

				NBUtil.GetData_BoardCfg (ref mBoardCfg, sBoardNo, "LIST", "");

				if (!NBUtil.isAdminLogin(mBoardCfg.bps_level_info))
				{
					// NBUtil.MemberSessionClear();

					NBCmnUtil.ViewMsgOpenerReLoad (Page, "", true);
				}
				else
				{
					NBCmnUtil.ViewMsgOpenerReLoad (Page, "", true);
				}
			}
			catch (Exception E)
			{
                NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void WNIMGBtnAdminAccess_Click(object sender, ImageClickEventArgs e)
		{
			ClientScript = "window.open('" + mAdminUrl + "');";
			ClientScript += "this.close();";
		}
	}
}
