﻿using System;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Xml;
using BoardLib;
using System.Text.RegularExpressions;

namespace NeBoard.Common
{
	public class BoardRss : Page
	{
		string reqBoardNo = string.Empty;
		string reqTopCnt = string.Empty;
		string reqOptType = string.Empty;

		string sBoardName = string.Empty; 
		string sNewIconTerm = string.Empty; 
		string sUpdateIconTerm = string.Empty; 
		string sRssEncoding = string.Empty;
		string sAutoLinkUse = string.Empty;
		string sImgThumbWidth = string.Empty;
		string sImgThumbHeight = string.Empty;
		bool bVoteUse = false;

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				reqBoardNo = NBCmnUtil.QStrLoad ("bno");

				reqTopCnt = NBCmnUtil.QStrLoad ("tcnt");

				if (NBUtil.StrEmptyChk(reqTopCnt))				
					reqTopCnt = "5";

				reqOptType = NBCmnUtil.QStrLoad ("type").ToUpper();

				if (!NBUtil.StrEmptyChk(reqBoardNo))
					RssCreate ();
			}
			catch {}
		}

		private Encoding GetRssEncoding(string sEncStr)
		{
			Encoding objEnc = null;

			try
			{
				if (!NBUtil.StrEmptyChk (sEncStr))
				{
					objEnc = Encoding.GetEncoding (sEncStr);
				}
			}
			catch {}

            if (objEnc == null)
				objEnc = Encoding.UTF8;

			return objEnc;
		}

		private void RssCreate()
		{
			DataTable dtBoardData = null;

			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				string sQry = string.Empty;
				string sGrpBoardCfg = string.Empty;
				string sGetBoardCfgTbl = string.Empty;

				sQry = "SELECT groupboardcfg_use FROM NB_BoardSet WHERE board_no = '" + reqBoardNo + "'";
				sGrpBoardCfg = SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, sQry).ToString();

				if (NBUtil.isUseChk(sGrpBoardCfg))
				{
					sGetBoardCfgTbl = "NB_GroupBoardCfg";
					sQry = "SELECT a.board_name, b.newicon_term, b.updateicon_term, b.rss_encoding, b.autolink_use, b.img_thumb_width, b.img_thumb_height, b.voteboard_use FROM NB_BoardSet a, " + sGetBoardCfgTbl + " b WHERE substring(a.board_no, 1, 3) = b.group_code AND a.board_no = '" + reqBoardNo + "'";
				}
				else
				{
					sGetBoardCfgTbl = "NB_BoardCfg";
					sQry = "SELECT a.board_name, b.newicon_term, b.updateicon_term, b.rss_encoding, b.autolink_use, b.img_thumb_width, b.img_thumb_height, b.voteboard_use FROM NB_BoardSet a, " + sGetBoardCfgTbl + " b WHERE a.board_no = b.board_no AND b.board_no = '" + reqBoardNo + "'";
				}

				

				SqlDataReader drBoardCfg = SqlHelper.ExecuteReader(dbSqlConn, CommandType.Text, sQry);

				drBoardCfg.Read();

				sBoardName = drBoardCfg["board_name"].ToString();
				sNewIconTerm = drBoardCfg["newicon_term"].ToString();
				sUpdateIconTerm = drBoardCfg["updateicon_term"].ToString();
				sRssEncoding = drBoardCfg["rss_encoding"].ToString();
				sAutoLinkUse = drBoardCfg["autolink_use"].ToString();
				sImgThumbWidth = drBoardCfg["img_thumb_width"].ToString();
				sImgThumbHeight = drBoardCfg["img_thumb_height"].ToString();
				bVoteUse = NBUtil.ConvStrToBool(drBoardCfg["voteboard_use"].ToString());

				dbSqlConn.Close();

                
				StringWriter Qry = new StringWriter();
				
				Qry.WriteLine ("select top " + reqTopCnt + " a.idx_no, a.subject, a.writer, a.cat_code, b.cat_name, a.write_date, a.content, a.sum_content, a.private_yn, a.html_use, a.sum_html_use, a.vote_yn, a.sum_yn, a.last_update ");

				if (reqOptType.IndexOf("C") > -1)
					Qry.WriteLine (", isnull(cmmt_cnt, 0) as cmmt_cnt ");

				if (reqOptType.IndexOf("R") > -1)
					Qry.WriteLine (", isnull(ref_cnt, 0) as ref_cnt ");

				Qry.WriteLine ("from NB_BoardData_" + reqBoardNo + " a, NB_CategoryData b ");

				if (reqOptType.IndexOf("C") > -1)
					Qry.WriteLine (", (select idx_no, count(cmmt_idx) as cmmt_cnt from NB_CommentData_" + reqBoardNo + " group by idx_no) c ");

				if (reqOptType.IndexOf("R") > -1)
					Qry.WriteLine (", (select ref_no, count(ref_no) as ref_cnt from NB_BoardData_" + reqBoardNo + " group by ref_no) d ");
				
				Qry.WriteLine ("where  a.cat_code *= b.cat_code and b.board_no = '" + reqBoardNo + "' and isnull(a.agree_yn, '1') = '1' and a.level_no1 = 0 and a.level_no2 = 0 ");

				if (reqOptType.IndexOf("C") > -1)
					Qry.WriteLine ("and a.idx_no *= c.idx_no ");

				if (reqOptType.IndexOf("R") > -1)
					Qry.WriteLine ("and a.ref_no *= d.ref_no ");

				Qry.WriteLine ("order by isnull(a.notice_yn, '0') desc, a.ref_no desc");


				DataSet dsBoardData = SqlHelper.ExecuteDataset (dbSqlConn, CommandType.Text, Qry.ToString());

				dtBoardData = dsBoardData.Tables[0];
			}
			catch(Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}


			try
			{
				Response.Clear();
				Response.ContentType = "text/xml";

				//특정 포트를 사용하는 경우를 위한 부분.
				int nPort = Request.Url.Port;
				string sPortStr = "";
				if (nPort != 80)
					sPortStr = ":" + nPort.ToString();

				string sSiteHost = Request.Url.Host + sPortStr;


				XmlTextWriter xWriter = new XmlTextWriter(Response.OutputStream, GetRssEncoding(sRssEncoding));

            
				// document Start
				xWriter.WriteStartDocument ();


				// rss Start
				xWriter.WriteStartElement ("rss");
				xWriter.WriteAttributeString ("version", "2.0");

				// channel Start
				xWriter.WriteStartElement ("channel");

				// title Element
				xWriter.WriteStartElement ("title");
				xWriter.WriteString (sBoardName);
				xWriter.WriteEndElement ();

				// link Element
				xWriter.WriteStartElement ("link");				
				xWriter.WriteString ("http://" + sSiteHost + NBUtil.GetBoardTransLink (reqBoardNo, "LIST"));
				xWriter.WriteEndElement ();

				// description Element
				xWriter.WriteStartElement ("description");
				xWriter.WriteString (sBoardName + "게시판의 업데이트된 게시물 목록 입니다.");
				xWriter.WriteEndElement ();

				// language Element
				xWriter.WriteStartElement ("language");
				xWriter.WriteString ("ko-KO");
				xWriter.WriteEndElement ();

				// webMaster Element
				xWriter.WriteStartElement ("webMaster");
				xWriter.WriteString (sBoardName);
				xWriter.WriteEndElement ();

				// lastBuildDate Element
				xWriter.WriteStartElement ("lastBuildDate");
				xWriter.WriteString (DateTime.Now.ToString("r"));
				xWriter.WriteEndElement ();

				foreach (DataRow drBoardData in dtBoardData.Rows)
				{			
					// item Start
					xWriter.WriteStartElement ("item");

				
					// ////////////////////////////////
					// 제목 설정

					string sBoardTitle = drBoardData["subject"].ToString();

					if (reqOptType.IndexOf("C") > -1)
					{
						if (int.Parse (drBoardData["cmmt_cnt"].ToString()) > 0)
							sBoardTitle += " C:" + drBoardData["cmmt_cnt"].ToString();
					}
					

					if (reqOptType.IndexOf("R") > -1)
					{
						if (int.Parse (drBoardData["ref_cnt"].ToString()) > 1)
							sBoardTitle += " R:" + drBoardData["ref_cnt"].ToString();
					}

					if (reqOptType.IndexOf("U") > -1)
					{
						//-- Update이미지
						if (sUpdateIconTerm.Trim().Length > 0 && int.Parse(sUpdateIconTerm.Trim()) > 0 && !NBUtil.StrEmptyChk (drBoardData["last_update"].ToString()))
						{
							if(DateTime.Parse(drBoardData["last_update"].ToString()) > DateTime.Now.AddHours (-1 * int.Parse(sUpdateIconTerm)))
								sBoardTitle += " U:1";
						}
					}
					

					//-- New이미지
					string sNewImgStr = string.Empty;

					if (sNewIconTerm.Trim().Length > 0 && int.Parse(sNewIconTerm.Trim()) > 0)
					{
						int nNewDispPeriod = int.Parse((sNewIconTerm.Trim() == ""?"1":sNewIconTerm));
			
						if(DateTime.Parse(drBoardData["write_date"].ToString()) > DateTime.Now.AddDays(-1 * nNewDispPeriod))
							sNewImgStr = " #NEW#";
					}

					// title Element
					xWriter.WriteStartElement ("title");
					xWriter.WriteString (sBoardTitle + sNewImgStr);
					xWriter.WriteEndElement ();

					// link Element
					xWriter.WriteStartElement ("link");
					xWriter.WriteString ("http://" + sSiteHost + NBUtil.GetBoardTransLink (reqBoardNo, "VIEW", "", "", "", "", drBoardData["idx_no"].ToString(), "", drBoardData["cat_code"].ToString()));
					xWriter.WriteEndElement ();

					// author Element
					xWriter.WriteStartElement ("author");
					xWriter.WriteString (drBoardData["writer"].ToString());
					xWriter.WriteEndElement ();

					// category Element
					xWriter.WriteStartElement ("category");
					xWriter.WriteString (drBoardData["cat_name"].ToString());
					xWriter.WriteEndElement ();

					// pubDate Element
					// (표준 시간대로 변경 시 현재 시간을 그대로 표준 시간 형식으로 변경하므로 현재 시간에서 -9 적용)
					xWriter.WriteStartElement ("pubDate");
					xWriter.WriteString (DateTime.Parse(drBoardData["write_date"].ToString()).AddHours(-9).ToString ("r"));
					xWriter.WriteEndElement ();

					// description Element
					xWriter.WriteStartElement ("description");
					if ( NBUtil.isUseChk(drBoardData["private_yn"].ToString()) )
					{
						xWriter.WriteCData ("비밀글 입니다.");
					}
					else
					{
						if (NBUtil.isUseChk (drBoardData["sum_yn"].ToString()))
						{
							// 요약 게시판 내용 사용
							xWriter.WriteCData (DoEncDisplayText (drBoardData["sum_content"].ToString(), drBoardData["sum_html_use"].ToString(), drBoardData["idx_no"].ToString(), false, false));
						}
						else
						{
							// 일반 내용 사용
							xWriter.WriteCData (DoEncDisplayText (drBoardData["content"].ToString(), drBoardData["html_use"].ToString(), drBoardData["idx_no"].ToString(), bVoteUse, NBUtil.ConvStrToBool(drBoardData["vote_yn"].ToString())));
						}
					}
					xWriter.WriteEndElement ();				

					// item End
					xWriter.WriteEndElement ();
				}


				// channel End
				xWriter.WriteEndElement();

				// rss End
				xWriter.WriteEndElement();


				// document End
				xWriter.WriteEndDocument();

				// document flush
				xWriter.Flush();
				xWriter.Close();

				HttpApplication happ = new HttpApplication();
				happ.CompleteRequest();
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private string DoEncDisplayText(string sSrcText, string bHtmlUse, string sIdxNo, bool bVoteUse, bool bVoteYn)
		{
			try
			{
				string sResult = sSrcText;

				if (bVoteUse && bVoteYn && sSrcText.StartsWith("<?xml"))
				{
					StringReader sSrcCont = new StringReader(sSrcText);
					XmlTextReader xmlRead = new XmlTextReader(sSrcCont);
					xmlRead.WhitespaceHandling = WhitespaceHandling.None;

					while (xmlRead.Read())
					{
						switch (xmlRead.LocalName)
						{
							case "content":
								sResult = xmlRead.ReadString();
								break;
							default:
								break;
						}
					}

					xmlRead.Close();
					sSrcCont.Close();                
				}

				// HTML/TEXT 구분에 따른 내용 내용 REPLACE
				if (!NBUtil.isUseChk(bHtmlUse))
				{
					sResult = Server.HtmlEncode (sResult);
					sResult = sResult.Replace("\r\n","<br/>\r\n");
				}				

				// URL이 포함되어 있을경우 자동링크 설정
				if (NBUtil.isUseChk(sAutoLinkUse))
				{
					string sMatchFilter = @"((http|ftp|https)):\/\/[\w]+(\.[\w]+)+([\w\-\.,@?^=%&:/~\+#]*[\w\-\@?^=%&/~\+#])(\s+)?";
					sResult = Regex.Replace (sResult, sMatchFilter, new MatchEvaluator (NBUtil.CapText));
				}

				// 파일 링크 관련 처리
				MatchCollection oMC = NBUtil.GetUpFileTag (sResult);

				if (oMC != null && oMC.Count > 0)
				{
					string sFileIndex = string.Empty;
					string sReplaceTag = string.Empty;
					DataTable dtUpFiles = NBUtil.GetUpFileCnt(reqBoardNo, sIdxNo);

					DataRow[] drImgFile = dtUpFiles.Select("", "fidx_no ASC");

					//특정 포트를 사용하는 경우를 위한 부분.
					int nPort = Request.Url.Port;
					string sPortStr = "";
					if (nPort != 80)
						sPortStr = ":" + nPort.ToString();

					string sSiteHost = Request.Url.Host + sPortStr;

				
					foreach (Match mcItem in oMC)
					{
						if (drImgFile.Length > 0)
						{
							sReplaceTag = string.Empty;
							sFileIndex = mcItem.Value.Split('_')[1].Substring(0, mcItem.Value.Split('_')[1].Length - 1);

							for (int drCnt = 0; drCnt < drImgFile.Length; drCnt++)
							{
								if ( sFileIndex.Equals(drImgFile[drCnt]["fidx_no"].ToString()) )
								{
									string sFileName = drImgFile[drCnt]["file_name"].ToString() + drImgFile[drCnt]["file_ext"].ToString();
									if ( NBUtil.isImgType(drImgFile[drCnt]["file_ext"].ToString()) )
									{
										// 업로드 파일 중 이미지 파일이 있으면
										sReplaceTag = "<img src=\"" + "http://" + sSiteHost + ConfigurationSettings.AppSettings["NeBoardPath"] + "/Common/DrawImage.aspx?bno=" + reqBoardNo + "&img=" + Server.UrlEncode(sFileName) + "&tf=1&iw=" + sImgThumbWidth + "&ih=" + sImgThumbHeight + "\" align=\"absmiddle\">";
									}
									else
									{
										sReplaceTag = "<a href=\"" + "http://" + sSiteHost + ConfigurationSettings.AppSettings["NeBoardPath"] + "/Common/NB_FileDown.aspx?bno=" + reqBoardNo + "&bidx=" + sIdxNo + "&fidx=" + drImgFile[drCnt]["fidx_no"].ToString() + "&fname=" + Server.UrlEncode(sFileName) + "\" target=\"_self\">";
										sReplaceTag += sFileName;
										sReplaceTag += "</a>";
									}

									if ( !NBUtil.StrEmptyChk(drImgFile[drCnt]["file_desc"].ToString()) )
										sReplaceTag = "<span title=\"" + drImgFile[drCnt]["file_desc"].ToString().Replace("'", "").Replace("\"", "").Replace("<br>", "\r\n") + "\">" + sReplaceTag + "</span>";

									break;
								}

							}

						}

						sResult = sResult.Replace(mcItem.Value, sReplaceTag);
					}

				}

				return sResult;
			}
			catch (Exception E)
			{
				throw E;
			}
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// 디자이너 지원에 필요한 메서드입니다.
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new EventHandler(this.Page_Load);
		}
		#endregion
	}

}

