﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;

namespace NeBoard.Common
{
	/// <summary>
	/// CmmtDel에 대한 요약 설명입니다.
	/// </summary>
	public class CmmtDel : Page
	{
		protected TextBox WNTxtPwd;
		protected ImageButton WBImgDelOk;

		string mIdxNo = string.Empty;
		string mCmmtIdx = string.Empty;
		string mBoardNo = string.Empty;		

		public string dispNotLogin = "none";
		public string dispLogin = "none";

		BoardLib.NBLib.CurBoardCfg mBoardCfg;

		private void Page_Load(object sender, EventArgs e)
		{
			DoLoadQryStr();

			NBUtil.GetData_BoardCfg (ref mBoardCfg, mBoardNo, "LIST", "");

			NotPassDelete();
		}

		private void DoLoadQryStr()
		{
			if (Request.QueryString["bno"] != null)
                mBoardNo = Request.QueryString["bno"].Trim();

			if (Request.QueryString["idxno"] != null)
				mIdxNo = Request.QueryString["idxno"].Trim();

			if (Request.QueryString["cmmtidx"] != null)
				mCmmtIdx = Request.QueryString["cmmtidx"].Trim();
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// 디자이너 지원에 필요한 메서드입니다.
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{    
			this.WBImgDelOk.Click += new System.Web.UI.ImageClickEventHandler(this.WBImgDelOk_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void DispDirectDel(bool bFlag)
		{
			if (bFlag)
			{
				dispNotLogin = "none";
				dispLogin = "";
			}
			else
			{
				dispNotLogin = "";
				dispLogin = "none";
			}
		}

		private void NotPassDelete()
		{
			try
			{
				if ( NBUtil.isAdminLogin(mBoardCfg.bps_level_info) || NBUtil.isLogin() )
				{
					if (!NBUtil.StrEmptyChk (mBoardNo) && !NBUtil.StrEmptyChk (mIdxNo) &&  !NBUtil.StrEmptyChk (mCmmtIdx))
						DelCmmt(mIdxNo, mCmmtIdx, mBoardNo, true);
					else
						throw new Exception ("삭제하실 코멘트를 선택해 주세요.");
				}
				else
				{
                    DispDirectDel(false);                    
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewMsgOpenerReLoad (Page, E.Message, true);
			}
		}

		private void WBImgDelOk_Click(object sender, ImageClickEventArgs e)
		{
			try
			{
				if (WNTxtPwd.Text.Trim().Length > 0)
				{
					if (!NBUtil.StrEmptyChk (mBoardNo) && !NBUtil.StrEmptyChk (mIdxNo) &&  !NBUtil.StrEmptyChk (mCmmtIdx))
					{
						DelCmmt(mIdxNo, mCmmtIdx, mBoardNo, false);
					}
					else
					{
						throw new Exception ("삭제하실 코멘트를 선택해 주세요.");
					}
				}
				else
				{
					NBCmnUtil.ViewAlertMsg (Page, "비밀번호를 입력해 주세요.");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewMsgOpenerReLoad (Page, E.Message, true);
			}
		}

		private void DelCmmt(string sIdxNo, string sCmmtIdx, string sBoardNo, bool bDirect)
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				string sQry = string.Empty;
				bool bPwdPass = false;
				bool bResult = false;
				int nPassCnt = 0;

				if (NBUtil.isAdminLogin(mBoardCfg.bps_level_info))
				{
					// 관리자일 경우
					bPwdPass = true;
				}
				else if (NBUtil.isLogin())
				{
					// 로그인 상태일 경우
					sQry = "SELECT count(*) from NB_CommentData_" + sBoardNo;
					sQry += "	WHERE idx_no = " + DBUtil.QryConvInt(sIdxNo, "", false) + " AND cmmt_idx = " + DBUtil.QryConvInt(sCmmtIdx, "", false) + " AND guest_no = " + DBUtil.QryConvStr (Server.UrlDecode(Request.Cookies["MBNO"].Value), false); //쿠키 디코딩 추가(2005.04.04)
					nPassCnt = int.Parse (SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, sQry).ToString());

					if (nPassCnt > 0)
                        bPwdPass = true;
				}
				else
				{
					// 로그아웃 상태일 경우
					sQry = "SELECT count(*) FROM NB_CommentData_" + sBoardNo;
					sQry += "	WHERE idx_no = " + DBUtil.QryConvInt(sIdxNo, "", false) + " AND cmmt_idx = " + DBUtil.QryConvInt(sCmmtIdx, "", false) + " AND pwd = " + DBUtil.QryConvStr (WNTxtPwd.Text.Trim(), false);
					nPassCnt = int.Parse (SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, sQry).ToString());

					if (nPassCnt > 0)
						bPwdPass = true;
				}

				if (bPwdPass)
				{
					sQry = "delete NB_CommentData_" + sBoardNo + " where idx_no = '" + sIdxNo + "' and cmmt_idx = '" + sCmmtIdx + "'";

					if (SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sQry) > 0)
						bResult = true;
				}

				if (bResult)
				{
					if (bDirect)
					{
						DispDirectDel (true);
					}
					else
					{
						throw new Exception ("삭제 되었습니다.");
					}
				}
				else
					throw new Exception ("비밀번호가 틀리거나 삭제 권한이 없습니다.");
			}
			catch(Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}
	}
}
