using System;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Xml;
using BoardLib;
using System.Text.RegularExpressions;

namespace NeBoard.Common
{
	public class GlobalSearch : Page
	{
		string reqTopCnt = string.Empty;
		string reqOptType = string.Empty;
		string reqSrchType = string.Empty;
		string reqSrchText = string.Empty;

		string sBoardName = string.Empty; 
		string sNewIconTerm = string.Empty; 
		string sRssEncoding = string.Empty;
		string sAutoLinkUse = string.Empty;
		string sImgThumbWidth = string.Empty;
		string sImgThumbHeight = string.Empty;
		bool bVoteUse = false;

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				reqTopCnt = NBCmnUtil.QStrLoad ("tcnt");

				if (NBUtil.StrEmptyChk(reqTopCnt))				
					reqTopCnt = "5";

				reqOptType = NBCmnUtil.QStrLoad ("type").ToUpper();

				reqSrchType = NBCmnUtil.QStrLoad ("stype").ToUpper();

				reqSrchText = Server.UrlDecode (NBCmnUtil.QStrLoad ("stxt")).Replace("'", "''");

				RssCreate ();
			}
			catch {}
		}

		private Encoding GetRssEncoding(string sEncStr)
		{
			Encoding objEnc = null;

			try
			{
				if (!NBUtil.StrEmptyChk (sEncStr))
				{
					objEnc = Encoding.GetEncoding (sEncStr);
				}
			}
			catch {}

			if (objEnc == null)
				objEnc = Encoding.UTF8;

			return objEnc;
		}

		private void RssCreate()
		{
			DataSet dsGlobalData = null;

			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				string sQry = string.Empty;
				string sGrpBoardCfg = string.Empty;
				string sGetBoardCfgTbl = string.Empty;

				sQry = "SELECT board_no, board_name, groupboardcfg_use FROM NB_BoardSet ORDER BY board_no ASC";
				DataSet dsBoardSet = SqlHelper.ExecuteDataset (dbSqlConn, CommandType.Text, sQry);
				

				foreach (DataRow rdGetBoardCfgTbl in dsBoardSet.Tables[0].Rows)
				{
					// Խ  о 
					if (NBUtil.isUseChk(sGrpBoardCfg))
					{
						sGetBoardCfgTbl = "NB_GroupBoardCfg";
						sQry = "SELECT a.board_name, b.newicon_term, b.rss_encoding, b.autolink_use, b.img_thumb_width, b.img_thumb_height, b.voteboard_use ";
						sQry += "FROM NB_BoardSet a, " + sGetBoardCfgTbl + " b WHERE substring(a.board_no, 1, 3) = b.group_code AND a.board_no = '" + rdGetBoardCfgTbl["board_no"].ToString() + "'";
					}
					else
					{
						sGetBoardCfgTbl = "NB_BoardCfg";
						sQry = "SELECT a.board_name, b.newicon_term, b.rss_encoding, b.autolink_use, b.img_thumb_width, b.img_thumb_height, b.voteboard_use ";
						sQry += "FROM NB_BoardSet a, " + sGetBoardCfgTbl + " b WHERE a.board_no = b.board_no AND b.board_no = '" + rdGetBoardCfgTbl["board_no"].ToString() + "'";
					}
                    
					dbSqlConn.Close();

					SqlDataReader drBoardCfg = SqlHelper.ExecuteReader(dbSqlConn, CommandType.Text, sQry);

					drBoardCfg.Read();

					sBoardName = drBoardCfg["board_name"].ToString();
					sNewIconTerm = drBoardCfg["newicon_term"].ToString();
					sRssEncoding = drBoardCfg["rss_encoding"].ToString();
					sAutoLinkUse = drBoardCfg["autolink_use"].ToString();
					sImgThumbWidth = drBoardCfg["img_thumb_width"].ToString();
					sImgThumbHeight = drBoardCfg["img_thumb_height"].ToString();
					bVoteUse = NBUtil.ConvStrToBool(drBoardCfg["voteboard_use"].ToString());

					// Խ Ÿ о 
					StringWriter Qry = new StringWriter();
				
					Qry.WriteLine ("select top " + reqTopCnt + " '" + rdGetBoardCfgTbl["board_no"].ToString() + "' as board_no, '" + rdGetBoardCfgTbl["board_name"].ToString() + "' as board_name,  a.idx_no, a.subject, a.writer, a.cat_code, b.cat_name, a.write_date, a.content, a.sum_content, a.private_yn, a.html_use, a.sum_html_use, a.vote_yn, a.sum_yn ");

					if (reqOptType.IndexOf("C") > -1)
						Qry.WriteLine (", isnull(cmmt_cnt, 0) as cmmt_cnt ");

					if (reqOptType.IndexOf("R") > -1)
						Qry.WriteLine (", isnull(ref_cnt, 0) as ref_cnt ");

					Qry.WriteLine ("from NB_BoardData_" + rdGetBoardCfgTbl["board_no"].ToString() + " a, NB_CategoryData b ");

					if (reqOptType.IndexOf("C") > -1)
						Qry.WriteLine (", (select idx_no, count(cmmt_idx) as cmmt_cnt from NB_CommentData_" + rdGetBoardCfgTbl["board_no"].ToString() + " group by idx_no) c ");

					if (reqOptType.IndexOf("R") > -1)
						Qry.WriteLine (", (select ref_no, count(ref_no) as ref_cnt from NB_BoardData_" + rdGetBoardCfgTbl["board_no"].ToString() + " group by ref_no) d ");
				
					Qry.WriteLine ("where  a.cat_code *= b.cat_code and b.board_no = '" + rdGetBoardCfgTbl["board_no"].ToString() + "' and isnull(a.agree_yn, '1') = '1' and a.level_no1 = 0 and a.level_no2 = 0 ");

					if (reqOptType.IndexOf("C") > -1)
						Qry.WriteLine ("and a.idx_no *= c.idx_no ");

					if (reqOptType.IndexOf("R") > -1)
						Qry.WriteLine ("and a.ref_no *= d.ref_no ");

					
					if (NBCmnUtil.ChkBitFlag (reqSrchType, 1) || NBCmnUtil.ChkBitFlag (reqSrchType, 2) || NBCmnUtil.ChkBitFlag (reqSrchType, 4))
					{
						Qry.WriteLine ("and (");
					
						if (NBCmnUtil.ChkBitFlag (reqSrchType, 1))
							Qry.WriteLine ("(a.writer LIKE '%" + reqSrchText + "%' AND LEN('" + reqSrchText + "') > 0) OR ");
						else
							Qry.WriteLine ("(a.writer LIKE '' AND LEN('') > 0) OR ");

						if (NBCmnUtil.ChkBitFlag (reqSrchType, 2))
							Qry.WriteLine ("(a.subject LIKE '%" + reqSrchText + "%' AND LEN('" + reqSrchText + "') > 0) OR ");
						else
							Qry.WriteLine ("(a.subject LIKE '' AND LEN('') > 0) OR ");

						if (NBCmnUtil.ChkBitFlag (reqSrchType, 4))
							Qry.WriteLine ("(a.content LIKE '%" + reqSrchText + "%' AND LEN('" + reqSrchText + "') > 0)");
						else
							Qry.WriteLine ("(a.subject LIKE '' AND LEN('') > 0)");
                    
						Qry.WriteLine (")");
					}


					Qry.WriteLine ("order by isnull(a.notice_yn, '0') desc, a.ref_no desc");

					
					dbSqlConn.Close();

					DataSet dsBoardData = SqlHelper.ExecuteDataset (dbSqlConn, CommandType.Text, Qry.ToString());

					if (dsGlobalData == null)
					{
						dsGlobalData = dsBoardData;
					}
					else
					{
						dsGlobalData.Merge (dsBoardData);
					}
				}
			}
			catch(Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}


			try
			{
				Response.Clear();
				Response.ContentType = "text/xml";

				//Ư Ʈ ϴ 츦  κ.
				int nPort = Request.Url.Port;
				string sPortStr = "";
				if (nPort != 80)
					sPortStr = ":" + nPort.ToString();

				string sSiteHost = Request.Url.Host + sPortStr;


				XmlTextWriter xWriter = new XmlTextWriter(Response.OutputStream, GetRssEncoding(sRssEncoding));

            
				// document Start
				xWriter.WriteStartDocument ();


				// rss Start
				xWriter.WriteStartElement ("rss");
				xWriter.WriteAttributeString ("version", "2.0");

				// channel Start
				xWriter.WriteStartElement ("channel");

				// title Element
				xWriter.WriteStartElement ("title");
				xWriter.WriteString (" ˻");
				xWriter.WriteEndElement ();

				// link Element
				xWriter.WriteStartElement ("link");				
				xWriter.WriteString ("http://" + sSiteHost);
				xWriter.WriteEndElement ();

				// description Element
				xWriter.WriteStartElement ("description");
				xWriter.WriteString ("ü Խ ˻ Դϴ.");
				xWriter.WriteEndElement ();

				// language Element
				xWriter.WriteStartElement ("language");
				xWriter.WriteString ("ko-KO");
				xWriter.WriteEndElement ();

				// webMaster Element
				xWriter.WriteStartElement ("webMaster");
				xWriter.WriteString ("");
				xWriter.WriteEndElement ();

				// lastBuildDate Element
				xWriter.WriteStartElement ("lastBuildDate");
				xWriter.WriteString (DateTime.Now.ToString("r"));
				xWriter.WriteEndElement ();

				foreach (DataRow drBoardData in dsGlobalData.Tables[0].Rows)
				{			
					// item Start
					xWriter.WriteStartElement ("item");

				
					// ////////////////////////////////
					//  

					string sBoardTitle = "[" + drBoardData["board_name"].ToString() + "] " + drBoardData["subject"].ToString();

					if (reqOptType.IndexOf("C") > -1)
					{
						if (int.Parse (drBoardData["cmmt_cnt"].ToString()) > 0)
							sBoardTitle += " C:" + drBoardData["cmmt_cnt"].ToString();
					}
					

					if (reqOptType.IndexOf("R") > -1)
					{
						if (int.Parse (drBoardData["ref_cnt"].ToString()) > 1)
							sBoardTitle += " R:" + drBoardData["ref_cnt"].ToString();
					}
					

					//-- New̹
					string sNewImgStr = string.Empty;

					if (sNewIconTerm.Trim().Length > 0 && int.Parse(sNewIconTerm.Trim()) > 0)
					{
						int nNewDispPeriod = int.Parse((sNewIconTerm.Trim() == ""?"1":sNewIconTerm));
			
						if(DateTime.Parse(drBoardData["write_date"].ToString()) > DateTime.Now.AddDays(-1 * nNewDispPeriod))
							sNewImgStr = " #NEW#";
					}

					// title Element
					xWriter.WriteStartElement ("title");
					xWriter.WriteString (sBoardTitle + sNewImgStr);
					xWriter.WriteEndElement ();

					// link Element
					xWriter.WriteStartElement ("link");
					xWriter.WriteString ("http://" + sSiteHost + NBUtil.GetBoardTransLink (drBoardData["board_no"].ToString(), "VIEW", "", "", "", "", drBoardData["idx_no"].ToString(), "", drBoardData["cat_code"].ToString()));
					xWriter.WriteEndElement ();

					// author Element
					xWriter.WriteStartElement ("author");
					xWriter.WriteString (drBoardData["writer"].ToString());
					xWriter.WriteEndElement ();

					// category Element
					xWriter.WriteStartElement ("category");
					xWriter.WriteString (drBoardData["cat_name"].ToString());
					xWriter.WriteEndElement ();

					// pubDate Element
					// (ǥ ð    ð ״ ǥ ð  ϹǷ  ð -9 )
					xWriter.WriteStartElement ("pubDate");
					xWriter.WriteString (DateTime.Parse(drBoardData["write_date"].ToString()).AddHours(-9).ToString ("r"));
					xWriter.WriteEndElement ();

					// description Element
					xWriter.WriteStartElement ("description");
					if ( NBUtil.isUseChk(drBoardData["private_yn"].ToString()) )
					{
						xWriter.WriteCData ("б Դϴ.");
					}
					else
					{
						if (NBUtil.isUseChk (drBoardData["sum_yn"].ToString()))
						{
							//  Խ  
							xWriter.WriteCData (DoEncDisplayText (drBoardData["board_no"].ToString(), drBoardData["sum_content"].ToString(), drBoardData["sum_html_use"].ToString(), drBoardData["idx_no"].ToString(), false, false));
						}
						else
						{
							// Ϲ  
							xWriter.WriteCData (DoEncDisplayText (drBoardData["board_no"].ToString(), drBoardData["content"].ToString(), drBoardData["html_use"].ToString(), drBoardData["idx_no"].ToString(), bVoteUse, NBUtil.ConvStrToBool(drBoardData["vote_yn"].ToString())));
						}
					}
					xWriter.WriteEndElement ();				

					// item End
					xWriter.WriteEndElement ();
				}


				// channel End
				xWriter.WriteEndElement();

				// rss End
				xWriter.WriteEndElement();


				// document End
				xWriter.WriteEndDocument();

				// document flush
				xWriter.Flush();
				xWriter.Close();

				HttpApplication happ = new HttpApplication();
				happ.CompleteRequest();
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private string DoEncDisplayText(string sBoardNo, string sSrcText, string bHtmlUse, string sIdxNo, bool bVoteUse, bool bVoteYn)
		{
			try
			{
				string sResult = sSrcText;

				if (bVoteUse && bVoteYn && sSrcText.StartsWith("<?xml"))
				{
					StringReader sSrcCont = new StringReader(sSrcText);
					XmlTextReader xmlRead = new XmlTextReader(sSrcCont);
					xmlRead.WhitespaceHandling = WhitespaceHandling.None;

					while (xmlRead.Read())
					{
						switch (xmlRead.LocalName)
						{
							case "content":
								sResult = xmlRead.ReadString();
								break;
							default:
								break;
						}
					}

					xmlRead.Close();
					sSrcCont.Close();                
				}

				// HTML/TEXT п    REPLACE
				if (!NBUtil.isUseChk(bHtmlUse))
				{
					sResult = Server.HtmlEncode (sResult);
					sResult = sResult.Replace("\r\n","<br/>\r\n");
				}				

				// URL ԵǾ  ڵũ 
				if (NBUtil.isUseChk(sAutoLinkUse))
				{
					string sMatchFilter = @"((http|ftp|https)):\/\/[\w]+(\.[\w]+)+([\w\-\.,@?^=%&:/~\+#]*[\w\-\@?^=%&/~\+#])(\s+)?";
					sResult = Regex.Replace (sResult, sMatchFilter, new MatchEvaluator (NBUtil.CapText));
				}

				//  ũ  ó
				MatchCollection oMC = NBUtil.GetUpFileTag (sResult);

				if (oMC != null && oMC.Count > 0)
				{
					string sFileIndex = string.Empty;
					string sReplaceTag = string.Empty;
					DataTable dtUpFiles = NBUtil.GetUpFileCnt(sBoardNo, sIdxNo);

					DataRow[] drImgFile = dtUpFiles.Select("", "fidx_no ASC");

					//Ư Ʈ ϴ 츦  κ.
					int nPort = Request.Url.Port;
					string sPortStr = "";
					if (nPort != 80)
						sPortStr = ":" + nPort.ToString();

					string sSiteHost = Request.Url.Host + sPortStr;

				
					foreach (Match mcItem in oMC)
					{
						if (drImgFile.Length > 0)
						{
							sReplaceTag = string.Empty;
							sFileIndex = mcItem.Value.Split('_')[1].Substring(0, mcItem.Value.Split('_')[1].Length - 1);

							for (int drCnt = 0; drCnt < drImgFile.Length; drCnt++)
							{
								if ( sFileIndex.Equals(drImgFile[drCnt]["fidx_no"].ToString()) )
								{
									string sFileName = drImgFile[drCnt]["file_name"].ToString() + drImgFile[drCnt]["file_ext"].ToString();
									if ( NBUtil.isImgType(drImgFile[drCnt]["file_ext"].ToString()) )
									{
										// ε   ̹  
										sReplaceTag = "<img src=\"" + "http://" + sSiteHost + ConfigurationSettings.AppSettings["NeBoardPath"] + "/Common/DrawImage.aspx?bno=" + sBoardNo + "&img=" + Server.UrlEncode(sFileName) + "&tf=1&iw=" + sImgThumbWidth + "&ih=" + sImgThumbHeight + "\" align=\"absmiddle\">";
									}
									else
									{
										sReplaceTag = "<a href=\"" + "http://" + sSiteHost + ConfigurationSettings.AppSettings["NeBoardPath"] + "/Common/NB_FileDown.aspx?bno=" + sBoardNo + "&bidx=" + sIdxNo + "&fidx=" + drImgFile[drCnt]["fidx_no"].ToString() + "&fname=" + Server.UrlEncode(sFileName) + "\" target=\"_self\">";
										sReplaceTag += sFileName;
										sReplaceTag += "</a>";
									}

									if ( !NBUtil.StrEmptyChk(drImgFile[drCnt]["file_desc"].ToString()) )
										sReplaceTag = "<span title=\"" + drImgFile[drCnt]["file_desc"].ToString().Replace("'", "").Replace("\"", "").Replace("<br>", "\r\n") + "\">" + sReplaceTag + "</span>";

									break;
								}

							}

						}

						sResult = sResult.Replace(mcItem.Value, sReplaceTag);
					}

				}

				return sResult;
			}
			catch (Exception E)
			{
				throw E;
			}
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new EventHandler(this.Page_Load);
		}
		#endregion
	}

}

