﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using BoardLib;
using System.IO;
using System.Text;

namespace NeBoard.Common
{
	/// <summary>
	/// MemoRcv에 대한 요약 설명입니다.
	/// </summary>
	public class MemoRcv : Page
	{
		protected Image imgTitles;
		protected HtmlTable tblRcvMemoList;
	
		private void Page_Load(object sender, EventArgs e)
		{
			if(NBUtil.isLogin())
			{
				RcvDataBind();
			}
			else
			{
				NBCmnUtil.ViewMsgAndClose (Page, "로그인해 주세요.");
			}
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// 디자이너 지원에 필요한 메서드입니다.
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new EventHandler(this.Page_Load);

		}
		#endregion


		// //////////////////////////////////////
		// 받은 메모 리스트를 컨트롤에 바인드 한다.
		private void RcvDataBind()
		{
			tblRcvMemoList.Rows.Clear();

			HtmlTableRow tblRow;
			HtmlTableCell tblCell;

			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				StringWriter sQry = new StringWriter();

				sQry.WriteLine ("SELECT ");
				sQry.WriteLine ("	b.send_guest_no, b.send_date, b.memo_subject, b.memo_cont, b.rcv_chk, a.mem_id ");
				sQry.WriteLine ("FROM ");
				sQry.WriteLine ("	NB_MemberData a, NB_MemoData b ");
				sQry.WriteLine ("WHERE ");
				sQry.WriteLine ("	a.guest_no = b.send_guest_no AND b.rcv_chk IN ('0', '1', '5') AND b.rcv_guest_no = " + DBUtil.QryConvStr (Server.UrlDecode(Request.Cookies["MBNO"].Value), false)); //쿠키 디코딩 추가(2005.04.04)
				sQry.WriteLine ("ORDER BY send_date DESC");

				DataSet dsMemoData = SqlHelper.ExecuteDataset (dbSqlConn, CommandType.Text, sQry.ToString());

				DataTable dtMemoData = dsMemoData.Tables[0];

				dbSqlConn.Close();

				// 여기 부터
				if(dtMemoData.Rows.Count > 0)
				{
					StringBuilder sbTitle;
					StringBuilder sbCont;
					string sMemoKey;
					LinkButton oDelBtn;
					LinkButton oReadBtn;
					LinkButton oReply;
					int nCnt = 0;

					foreach (DataRow drMemoData in dtMemoData.Rows)
					{
						// 구분선 추가
						tblRow = new HtmlTableRow();
						tblCell = new HtmlTableCell();
						tblCell.Height = "1";
						tblCell.BgColor = "#eaeaea";
						tblRow.Cells.Add(tblCell);
						tblRcvMemoList.Rows.Add(tblRow);



						sbTitle = new StringBuilder();
						if(drMemoData["rcv_chk"].ToString() == "0")
							sbTitle.Append("<span class=\"send_rcv_unchk\">미확인</span>");
						else
							sbTitle.Append("<span class=\"send_rcv_chk\">확인</span>");
							
							
						sbTitle.Append (" <span class=\"send_msg_id\">" + drMemoData["send_date"].ToString() + "</span>에 <span class=\"send_msg_id\">" + drMemoData["mem_id"].ToString() + "</span>님이 보낸 쪽지");
                        
						sbCont = new StringBuilder();
						sbCont.Append ("<span class=\"msg_title\">" + Server.HtmlEncode(drMemoData["memo_subject"].ToString()) + "</sapn><br>");
						sbCont.Append (Server.HtmlEncode(drMemoData["memo_cont"].ToString()).Replace("\r\n", "<br>"));


						tblRow = new HtmlTableRow();

						sMemoKey = sGetMemoKey("ChgState" + nCnt.ToString() + "_" + drMemoData["rcv_chk"].ToString(), drMemoData["send_guest_no"].ToString(), drMemoData["send_date"].ToString());
						oDelBtn = new LinkButton();
						oDelBtn.Text = "[X]";
						oDelBtn.Attributes["title"] = "삭제";
						oDelBtn.ID = sMemoKey;
						oDelBtn.Click += new EventHandler(this.MemoDelete_Click);
						
						tblCell = new HtmlTableCell();
						tblCell.Height = "22";
						tblCell.InnerHtml = sbTitle.ToString();
						
						tblCell.Controls.Add (oDelBtn);
						tblRow.Cells.Add (tblCell);

						tblRcvMemoList.Rows.Add(tblRow);


						tblRow = new HtmlTableRow();

						tblCell = new HtmlTableCell();
						tblCell.Attributes["class"] = "msg_body";
						tblCell.InnerHtml = sbCont.ToString();

						tblRow.Cells.Add (tblCell);

						tblRcvMemoList.Rows.Add(tblRow);




						tblRow = new HtmlTableRow();

						
						tblCell = new HtmlTableCell();
						
						sMemoKey = sGetMemoKey("ReadChk_" + nCnt.ToString(), drMemoData["send_guest_no"].ToString(), drMemoData["send_date"].ToString());
						oReadBtn = new LinkButton();
						if(drMemoData["rcv_chk"].ToString() == "0")
						{
							oReadBtn.Text = "[읽음확인]";
							oReadBtn.ID = sMemoKey;
							oReadBtn.Click += new EventHandler(this.MemoRead_Click);
							tblCell.Controls.Add (oReadBtn);
						}

						sMemoKey = sGetMemoKey("Reply_" + nCnt.ToString(), drMemoData["send_guest_no"].ToString(), drMemoData["send_date"].ToString());
						oReply = new LinkButton();
						oReply.Text = "[답장쓰기]";
						oReply.ID = sMemoKey + "_" + drMemoData["mem_id"].ToString();
						oReply.Click += new EventHandler(this.MemoReply_Click);
						tblCell.Controls.Add (oReply);

						tblRow.Cells.Add (tblCell);

						tblRcvMemoList.Rows.Add(tblRow);

						++nCnt;
					}
					}
				else
				{
					tblRow = new HtmlTableRow();

					tblCell = new HtmlTableCell();
					tblCell.Height = "40";
					tblCell.Align = "center";
					tblCell.InnerHtml = "받은 메시지가 없습니다.";

					tblRow.Cells.Add(tblCell);
					tblRcvMemoList.Rows.Add(tblRow);
				}

			}
			catch (Exception E)
			{
				Response.Write (E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}

		private string sGetMemoKey(string sPreText, string sKeyMbNo, string sKeyDateTime)
		{
			string sResult = "";

			DateTime oDT = DateTime.Parse(sKeyDateTime);

			sResult = sPreText + "_" + sKeyMbNo + "_" + oDT.ToString("yyyyMMddHHmmss");

			return sResult;
		}

		private void MemoDelete_Click(object sender, EventArgs e)
		{
			LinkButton thisBtn = (LinkButton)sender;

			string[] aBtnID = thisBtn.ID.Split('_');

			DoChgState(aBtnID[2], aBtnID[3], "6", aBtnID[1]);

			RcvDataBind();
		}

		private void MemoRead_Click(object sender, EventArgs e)
		{
			LinkButton thisBtn = (LinkButton)sender;

			string[] aBtnID = thisBtn.ID.Split('_');

			DoChgState(aBtnID[2], aBtnID[3], "1", "");

			RcvDataBind();
		}

		private void MemoReply_Click(object sender, EventArgs e)
		{
			LinkButton thisBtn = (LinkButton)sender;

			string[] aBtnID = thisBtn.ID.Split('_');

			DoChgState(aBtnID[2], aBtnID[3], "1", "");

			Response.Redirect ("MemoSend.aspx?tid=" + aBtnID[4], false);
		}

		private void DoChgState(string sMbNo, string sSendDate, string sChkFlag, string sRcvChk)
		{
			string sQDateTime = sSendDate.Substring(0, 4) + "-" + sSendDate.Substring(4, 2) + "-" + sSendDate.Substring(6, 2) + " ";
			sQDateTime += sSendDate.Substring(8, 2) + ":" + sSendDate.Substring(10, 2) + ":" + sSendDate.Substring(12, 2);

			string sQuery = string.Empty;

			if (sRcvChk == "5")
			{
                sQuery = "DELETE NB_MemoData WHERE send_guest_no = '" + sMbNo + "' and CONVERT(varchar, send_date, 20) = '" + sQDateTime + "' \r\n";
			}
			
			sQuery += "UPDATE NB_MemoData SET rcv_chk = " + DBUtil.QryConvStr(sChkFlag, false) + " WHERE send_guest_no = '" + sMbNo + "' and CONVERT(varchar, send_date, 20) = '" + sQDateTime + "'";

			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sQuery);

				Response.Redirect ("MemoRcv.aspx", false);
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}
	}
}
