﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Drawing;
using System.IO;
using BoardLib;
using System.Text;

namespace NeBoard.Common
{
	public class MemoSend : Page
	{
		protected System.Web.UI.WebControls.Image imgTitles;
		protected TextBox txtSendTarID;
		protected TextBox txtSendMsgTitle;
		protected TextBox txtSendMsgCont;
		protected ImageButton btnMemoSend;
		protected HtmlTable tblSendMemoList;

		string sGno;
	
		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				if(NBUtil.isLogin())
				{
					BindTarValue();
					SendDataBind();
				}
				else
				{
					throw new Exception ("로그인해 주세요.");
				}
			}
			catch (Exception E)
			{
				Response.Clear();
				NBCmnUtil.ViewMsgAndClose (Page, E.Message);
			}
		}

		/// <summary>
		/// 답장 보내기로 아이디가 넘어 왔을때 세팅
		/// </summary>
		private void BindTarValue()
		{
			if ( !IsPostBack )
			{
				if ( !NBUtil.StrEmptyChk(Request.QueryString["tid"]) )
					txtSendTarID.Text = Request.QueryString["tid"];
			}

			if ( !NBUtil.StrEmptyChk(Request.QueryString["gno"]) )
			{
				sGno = Request.QueryString["gno"];
				GetGnoToMemId (sGno);
			}
		}

		private void GetGnoToMemId(string sGno)
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				string sQry = "select mem_id from nb_memberdata where guest_no = '" + sGno.Replace("'", "''") + "'";

				string sMemID = SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, sQry).ToString();

				if (!NBUtil.StrEmptyChk (sMemID))
				{
					txtSendTarID.Text = sMemID;
					txtSendTarID.ReadOnly = true;
                    txtSendTarID.BackColor = Color.FromName("#f5f5f5");
				}
			}
			catch (Exception E)
			{
				Response.Write (E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}			
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// 디자이너 지원에 필요한 메서드입니다.
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnMemoSend.Click += new System.Web.UI.ImageClickEventHandler(this.btnMemoSend_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		/// <summary>
		/// 보낸 메모 리스트를 컨트롤에 바인드 한다.
		/// </summary>
		private void SendDataBind()
		{
			tblSendMemoList.Rows.Clear();

			HtmlTableRow tblRow;
			HtmlTableCell tblCell;

			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				StringWriter sQry = new StringWriter();

				sQry.WriteLine ("SELECT ");
				sQry.WriteLine ("	b.send_guest_no, b.send_date, b.memo_subject, b.memo_cont, b.rcv_chk, a.mem_id ");
				sQry.WriteLine ("FROM ");
				sQry.WriteLine ("	NB_MemberData a, NB_MemoData b ");
				sQry.WriteLine ("where ");
				sQry.WriteLine ("	a.guest_no = b.rcv_guest_no AND b.rcv_chk IN ('0', '1', '6') AND b.send_guest_no = " + DBUtil.QryConvStr (Server.UrlDecode(Request.Cookies["MBNO"].Value), false));//쿠키 디코딩 추가(2005.04.04)
				sQry.WriteLine ("ORDER BY send_date desc");

				DataSet dsSendData = SqlHelper.ExecuteDataset (dbSqlConn, CommandType.Text, sQry.ToString());

				DataTable dtSendData = dsSendData.Tables[0];

				dbSqlConn.Close();

				if(dtSendData.Rows.Count > 0)
				{
					StringBuilder sbTitle;
					StringBuilder sbCont;
					string sMemoKey;
					LinkButton oDelBtn;
					int nCnt = 0;

					foreach (DataRow drSendData in dtSendData.Rows)
					{
                        // 구분선 추가
						tblRow = new HtmlTableRow();
						tblCell = new HtmlTableCell();
						tblCell.Height = "1";
						tblCell.BgColor = "#eaeaea";
						tblRow.Cells.Add(tblCell);
						tblSendMemoList.Rows.Add(tblRow);



						sbTitle = new StringBuilder();
						if(drSendData["rcv_chk"].ToString() == "0")
							sbTitle.Append("<span class=\"send_rcv_unchk\">미확인</span>");
						else
							sbTitle.Append("<span class=\"send_rcv_chk\">확인</span>");
						sbTitle.Append (" <span class=\"send_msg_id\">" + drSendData["send_date"].ToString() + "</span>에 <span class=\"send_msg_id\">" + drSendData["mem_id"].ToString() + "</span>님 에게 발송");
                        
						sbCont = new StringBuilder();
						sbCont.Append ("<span class=\"msg_title\">" + Server.HtmlEncode(drSendData["memo_subject"].ToString()) + "</sapn><br>");
						sbCont.Append (Server.HtmlEncode(drSendData["memo_cont"].ToString()).Replace("\r\n", "<br>"));


						tblRow = new HtmlTableRow();

						sMemoKey = sGetMemoKey("ChgState" + nCnt.ToString() + "_" + drSendData["rcv_chk"].ToString(), Server.UrlDecode(Request.Cookies["MBNO"].Value), drSendData["send_date"].ToString());//쿠키 디코딩 추가(2005.04.04)
						oDelBtn = new LinkButton();
						oDelBtn.Text = "[X]";
						oDelBtn.Attributes["title"] = "삭제";
						oDelBtn.ID = sMemoKey;
						oDelBtn.Click += new EventHandler(this.MemoDelete_Click);
						tblCell = new HtmlTableCell();
						tblCell.Height = "22";
						tblCell.InnerHtml = sbTitle.ToString();
						tblCell.Controls.Add (oDelBtn);
						tblRow.Cells.Add (tblCell);

						tblSendMemoList.Rows.Add(tblRow);


						tblRow = new HtmlTableRow();

						tblCell = new HtmlTableCell();
						tblCell.Attributes["class"] = "msg_body";
						tblCell.InnerHtml = sbCont.ToString();

						tblRow.Cells.Add (tblCell);

						tblSendMemoList.Rows.Add(tblRow);

						++nCnt;
					}
				}
				else
				{
					tblRow = new HtmlTableRow();

					tblCell = new HtmlTableCell();
					tblCell.Height = "40";
					tblCell.Align = "center";
					tblCell.InnerHtml = "받은 메시지가 없습니다.";

					tblRow.Cells.Add(tblCell);
					tblSendMemoList.Rows.Add(tblRow);
				}
			}
			catch (Exception E)
			{
				Response.Write (E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}

		private void MemoDelete_Click(object sender, EventArgs e)
		{
			LinkButton thisBtn = (LinkButton)sender;

			string[] aBtnID = thisBtn.ID.Split('_');

			DoMemoDel(aBtnID[2], aBtnID[3], aBtnID[1]);

            SendDataBind();
		}

		private void DoMemoDel(string sMbNo, string sSendDate, string sRcvChk)
		{
			string sQDateTime = sSendDate.Substring(0, 4) + "-" + sSendDate.Substring(4, 2) + "-" + sSendDate.Substring(6, 2) + " ";
			sQDateTime += sSendDate.Substring(8, 2) + ":" + sSendDate.Substring(10, 2) + ":" + sSendDate.Substring(12, 2);

			string sQuery = string.Empty;

			if (sRcvChk == "6")
			{
				sQuery = "DELETE NB_MemoData WHERE send_guest_no = '" + sMbNo + "' and CONVERT(varchar, send_date, 20) = '" + sQDateTime + "' \r\n";
			}

			sQuery += "UPDATE NB_MemoData SET rcv_chk = '5' WHERE send_guest_no = '" + sMbNo + "' and CONVERT(varchar, send_date, 20) = '" + sQDateTime + "'";

			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sQuery);

				Response.Redirect ("MemoSend.aspx", false);
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}

		private string sGetMemoKey(string sPreText, string sKeyMbNo, string sKeyDateTime)
		{
			string sResult = "";

			DateTime oDT = DateTime.Parse(sKeyDateTime);

			sResult = sPreText + "_" + sKeyMbNo + "_" + oDT.ToString("yyyyMMddHHmmss");

			return sResult;
		}

		private void btnMemoSend_Click(object sender, ImageClickEventArgs e)
		{
			// 필드 체크
			if(txtSendTarID.Text.Trim() == string.Empty)
			{
				NBCmnUtil.ViewAlertMsg (Page, "메모를 받을 사람 ID를 입력해 주세요.");
				return;
			}

			if(txtSendMsgTitle.Text.Trim() == string.Empty)
			{
				NBCmnUtil.ViewAlertMsg (Page, "전달할 메모의 제목을 입력해 주세요.");
				return;
			}

			if(txtSendMsgCont.Text.Trim() == string.Empty)
			{
				NBCmnUtil.ViewAlertMsg (Page, "전달할 메모의 내용을 입력해 주세요.");
				return;
			}

			

			// 사용가능한 아이디 인지 체크
			
			string sQuery = "SELECT isNull(guest_no, '') as guest_no FROM NB_MemberData WHERE mem_id = '" + txtSendTarID.Text.Trim().Replace("'", "''") + "'";

			object oScalVal = null;
			string sRcvMbNo = "";

			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				oScalVal = SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, sQuery);

				if(oScalVal != null && !NBUtil.StrEmptyChk(oScalVal.ToString()))
				{
					sRcvMbNo = oScalVal.ToString();

					// 데이타 입력
					sQuery = "INSERT INTO NB_MemoData (send_guest_no, send_date, memo_subject, memo_cont, rcv_guest_no, rcv_chk) VALUES (";
					sQuery += "'" + Server.UrlDecode(Request.Cookies["MBNO"].Value) + "', getdate(), '" + txtSendMsgTitle.Text.Trim().Replace("'", "''") + "',";//쿠키 디코딩 추가(2005.04.04)
					sQuery += "'" + txtSendMsgCont.Text.Trim().Replace("'", "''") + "',";
					sQuery += "'" + sRcvMbNo + "', '0')";


					if(SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sQuery) > 0)
					{
						NBCmnUtil.ViewAlertMsg (Page, "메모가 발송 되었습니다.");

						Response.Redirect ("MemoSend.aspx", false);
					}
					else
					{
						NBCmnUtil.ViewAlertMsg (Page, "메모 발송중 오류가 발생 했습니다.");
					}
				}
				else
				{
					throw new Exception ("입력하신 ID는 없는 ID입니다.");
				}
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
				return;
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}
	}
}
