using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using BoardLib;
using System.Xml;
using System.Text.RegularExpressions;
using System.IO;

namespace NeBoard.Common
{
	public class NBVoteChk : System.Web.UI.Page
	{
		string sBoardNo = string.Empty;
		string sIdxNo = string.Empty;
		string sVoteIdx = string.Empty;
		int nReVoteTime = 0;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
            GetQryStrLoad();

			if (ChkReVote())
			{
                DoEndProc ("̹  ǥ Դϴ.");
			}
			else
			{
                DoVote();
			}
		}

		private void GetQryStrLoad()
		{
            sBoardNo = NBCmnUtil.QStrLoad("bno");
			sIdxNo = NBCmnUtil.QStrLoad("bidx");
			sVoteIdx = NBCmnUtil.QStrLoad("voteidx");
            nReVoteTime = NBUtil.ConvStrToInt(NBCmnUtil.QStrLoad("revote"));
		}

		private bool ChkReVote()
		{
			bool bResult = false;

			// Ű ˻
            string sReVoteIdx = NBCmnUtil.GetCookieValue ("REVOTE_IDX");
			
			if (!NBUtil.StrEmptyChk(sReVoteIdx))
			{
				string[] arrReVoteIdx = sReVoteIdx.Split('|');

				foreach (string sVotedIdx in arrReVoteIdx)
				{
					if (!NBUtil.StrEmptyChk(sVotedIdx) && sVotedIdx.Equals(sBoardNo + "^" + sIdxNo))
					{
						bResult = true;
						break;
					}
				}
			}

			if (!bResult && nReVoteTime > 0)
			{
				string sVoteIDX = NBCmnUtil.GetCookieValue ("REVOTE_IDX") + "|" + sBoardNo + "^" + sIdxNo;
				NBCmnUtil.SaveCookiValue ("REVOTE_IDX", sVoteIDX, nReVoteTime * 60);
			}

			return bResult;
		}

		private void DoVote()
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				string sQry = "SELECT content FROM NB_BoardData_" + sBoardNo + " WHERE idx_no = " + DBUtil.QryConvInt(sIdxNo, "0", false);

				string sContent = SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, sQry).ToString();


				if (!NBUtil.StrEmptyChk(sContent))
				{
					ArrayList arrItemStr = new ArrayList();
					ArrayList arrItemCount = new ArrayList();

					string 
						sSrcContent = string.Empty,
						sSrcSepItem = string.Empty,
						sSrcVoteItems = string.Empty;

					StringReader sSrcCont = new StringReader(sContent);
					XmlTextReader xmlRead = new XmlTextReader(sSrcCont);
					xmlRead.WhitespaceHandling = WhitespaceHandling.None;

					while (xmlRead.Read())
					{
						switch (xmlRead.LocalName)
						{
							case "content":
								sSrcContent = xmlRead.ReadString();
								break;
							case "sepitem":
								sSrcSepItem = xmlRead.ReadString();
								break;
							case "item":
								arrItemCount.Add (xmlRead.GetAttribute("count"));
								arrItemStr.Add (xmlRead.ReadString());								
								break;
							default:
								break;
						}
					}

					xmlRead.Close();
					sSrcCont.Close();
                

					// XML Ÿ 
					StringWriter swXmlCont = new StringWriter();

					XmlTextWriter xmlWr = new XmlTextWriter(swXmlCont);
					xmlWr.Formatting = Formatting.Indented;

					xmlWr.WriteStartDocument();

					xmlWr.WriteStartElement ("vote");
					
					xmlWr.WriteStartElement ("content");
					xmlWr.WriteCData (sSrcContent);
					xmlWr.WriteEndElement ();

					xmlWr.WriteStartElement ("sepitem");
					xmlWr.WriteCData (sSrcSepItem);
					xmlWr.WriteEndElement ();

					xmlWr.WriteStartElement ("voteitems");

					int nVoteCnt = 0;

					foreach (string sItem in arrItemStr)
					{
						xmlWr.WriteStartElement ("item");
						if (nVoteCnt.Equals(NBUtil.ConvStrToInt(sVoteIdx)))
                            xmlWr.WriteAttributeString ("count", Convert.ToString(int.Parse(arrItemCount[nVoteCnt].ToString()) + 1));
						else
							xmlWr.WriteAttributeString ("count", arrItemCount[nVoteCnt].ToString());
						xmlWr.WriteCData(sItem);
						xmlWr.WriteEndElement();

						nVoteCnt++;
					}
					
					xmlWr.WriteEndElement();

					xmlWr.WriteEndElement();

					xmlWr.WriteEndDocument();

					xmlWr.Flush();

					// sResult = swXmlCont.ToString();

					xmlWr.Close();
					swXmlCont.Close();

					sQry = "UPDATE NB_BoardData_" + sBoardNo + " SET content = " + DBUtil.QryConvStr(swXmlCont.ToString(), false) + " WHERE idx_no = " + DBUtil.QryConvInt(sIdxNo, "0", false);

					if (SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, sQry) > 0)
					{
						DoEndProc ("ǥ Ͽϴ.");
					}
					else
					{
						DoEndProc ("ǥ   ߻߽ϴ.");
					}
				}
			}
			catch(Exception E)
			{
				DoEndProc(E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}

		private void DoEndProc(string sErrMsg)
		{
            NBCmnUtil.ViewMsgOpenerReLoad (this, sErrMsg, true);			
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
