using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.IO;
using BoardLib;
using System.Text;

namespace NeBoard.Common
{
	/// <summary>
	/// NBVoteXML   Դϴ.
	/// </summary>
	public class NBVoteXML : System.Web.UI.Page
	{
		string sBoardNo = string.Empty;
		string sIdxNo = string.Empty;

		private void Page_Load(object sender, System.EventArgs e)
		{
            GetQryStr();
            GetXmlDoc();			
		}

		private void GetQryStr()
		{
			sBoardNo = NBCmnUtil.QStrLoad ("bno");
            sIdxNo = NBCmnUtil.QStrLoad ("idxno");
		}

		private void GetXmlDoc()
		{
			if (!NBUtil.StrEmptyChk (sBoardNo) && !NBUtil.StrEmptyChk (sIdxNo))
			{
				SqlConnection dbSqlConn = null;

				string sVoteYN = string.Empty;
				string sVoteCont = string.Empty;

				try
				{
					DBUtil.DBConnection (ref dbSqlConn);

					SqlDataReader drVoteXML = SqlHelper.ExecuteReader (dbSqlConn, CommandType.StoredProcedure, "nbsp_get_vote_content_" + sBoardNo, new SqlParameter("@idx_no", sIdxNo));

					if (drVoteXML.Read())
					{
						sVoteYN = drVoteXML["vote_yn"].ToString();
						sVoteCont = drVoteXML["content"].ToString();
					}
				}
				catch(Exception E)
				{
					Response.Write (E.Message);                
				}
				finally
				{
					DBUtil.DBConnDispose(ref dbSqlConn);
				}

				
				// ǥ Խù̸ ǥ ׸ ǥ ϰ ǥ  ư ǥ
				StringReader srSrcCont = new StringReader(sVoteCont);
				XmlTextReader xmlRead = new XmlTextReader(srSrcCont);
				xmlRead.WhitespaceHandling = WhitespaceHandling.None;

				string sSrcCont = string.Empty;
				ArrayList arrItems = new ArrayList();
                
				while (xmlRead.Read())
				{
					if (xmlRead.LocalName.Equals("content"))
                        sSrcCont = xmlRead.ReadString();

					if (xmlRead.LocalName.Equals("item"))
						arrItems.Add (xmlRead.ReadString());
				}

				xmlRead.Close();
				srSrcCont.Close();


				

				XmlTextWriter xWriter = new XmlTextWriter(Response.OutputStream, Encoding.Default);

				// document Start
				xWriter.WriteStartDocument ();


				xWriter.WriteStartElement ("vote");

				// title Element
				xWriter.WriteStartElement ("title");
				xWriter.WriteCData (sSrcCont);
				xWriter.WriteEndElement ();

				
				// item Start
				xWriter.WriteStartElement ("item");

				for (int nCnt=0; nCnt < arrItems.Count; nCnt++)
				{
					// title Element
					xWriter.WriteStartElement ("title");
					xWriter.WriteCData (arrItems[nCnt].ToString());
					xWriter.WriteEndElement ();
				}

				// item End
				xWriter.WriteEndElement ();

				
				xWriter.WriteEndElement ();


				// document End
				xWriter.WriteEndDocument();

				Response.Clear();
				Response.ContentType = "text/xml";

				// document flush
				xWriter.Flush();
				xWriter.Close();

				HttpApplication happ = new HttpApplication();
				happ.CompleteRequest();
			}
		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
