﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;

namespace NeBoard.Common
{
	/// <summary>
	/// PrivateWin에 대한 요약 설명입니다.
	/// </summary>
	public class PrivateWin : Page
	{
		protected TextBox txtPwd;
		protected Button btnSend;
		protected System.Web.UI.WebControls.LinkButton lnk_go_back;

		public NBLib.PageQryStr mPageQryInfo;	// QueryString으로 넘어온 결과 로드

		private void Page_Load(object sender, EventArgs e)
		{
			// 넘어온 QueryString 로드
			NBUtil.RequestQryLoad(ref mPageQryInfo);
		}

		private bool PwdChk(string sPwd)
		{
			SqlConnection dbSqlConn = null;

			bool bResult = false;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				string sQuery = "select pwd from NB_BoardData_" + mPageQryInfo.sBoardNo + " where idx_no = " + mPageQryInfo.sIdxNo;

				string sRealPwd = SqlHelper.ExecuteScalar (dbSqlConn, CommandType.Text, sQuery).ToString();

				if(sRealPwd.CompareTo(sPwd) == 0)
				{
					bResult = true;
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}

			return bResult;
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// 디자이너 지원에 필요한 메서드입니다.
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnSend.Click += new System.EventHandler(this.btnSend_Click);
			this.lnk_go_back.Click += new System.EventHandler(this.lnk_go_back_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnSend_Click(object sender, EventArgs e)
		{
			if(PwdChk(txtPwd.Text.Trim()))
			{
				GoView();
			}
			else
			{
				NBCmnUtil.ViewAlertMsg (Page, "비밀번호가 일치하지 않습니다.");
			}
		}

		private void GoView()
		{
			string sReq = Request.Url.ToString().Replace("Common/PrivateWin", "Board");

			Response.Redirect(sReq, false);
		}

		private void lnk_go_back_Click(object sender, System.EventArgs e)
		{
            NBCmnUtil.ViewMsgGoUrl (Page, NBUtil.GetBoardTransLink_WithCat (mPageQryInfo.sBoardNo, mPageQryInfo.sCatName, mPageQryInfo), "");
		}
	}
}
