﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using NeBoard.DpWebSvc_DpPost;

namespace NeBoard.Common
{
	/// <summary>
	/// ZipSearch에 대한 요약 설명입니다.
	/// </summary>
	public class ZipSearch : Page
	{
		protected TextBox WNTxtDong;
		protected ImageButton WBImgSearch;
		protected Table WTTblZipNoList;
		protected ImageButton WBImgClose;
	
		private void Page_Load(object sender, EventArgs e)
		{
			ButtonScript();
		}

		#region Web Form 디자이너에서 생성한 코드
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// 디자이너 지원에 필요한 메서드입니다.
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{    
			this.WBImgSearch.Click += new ImageClickEventHandler(this.WBImgSearch_Click);
			this.Load += new EventHandler(this.Page_Load);

		}
		#endregion

		private void ButtonScript()
		{
			WBImgSearch.Attributes.Add("onclick","return NB_Zip_ValidationChk()");
			WNTxtDong.Attributes["onkeypress"] = " if (event.keyCode == 13){ if (NB_Zip_ValidationChk()){ " + Page.GetPostBackEventReference(WBImgSearch) + ";} return false;}";
		}

		private void WBImgSearch_Click(object sender, ImageClickEventArgs e)
		{
			try
			{
				WTTblZipNoList.Rows.Clear();

				DpPost oDpPost = new DpPost();

				string[] aResult = oDpPost.GetPostByDong(WNTxtDong.Text.Trim());

				string sMode = "";

				if(Request["mode"] != null)
				{
					sMode = Request["mode"].ToUpper();
				}

				for (int i = 0; i < aResult.Length; i++)
				{
					TableRow oTR = new TableRow();
					TableCell oTD_Addr = new TableCell();
					TableCell oTD_ZipNo = new TableCell();
					
					oTR.Height = 20;
					oTR.Attributes.Add("onmouseover","javascript:this.style.background='#ECECEC'");
					oTR.Attributes.Add("onmouseout","javascript:this.style.background='#FFFFFF'");

					oTD_Addr.Width = Unit.Percentage(80);
					oTD_ZipNo.Width = Unit.Percentage(20);

					oTD_Addr.HorizontalAlign = HorizontalAlign.Left;
					oTD_ZipNo.HorizontalAlign = HorizontalAlign.Right;

					string[] aJuso = aResult[i].Trim().Split('|');

					oTD_Addr.Text = "<a href=\"javascript:NB_Zip_SelectAddr('" + sMode + "','" + aJuso[0].Trim() + "','" + aJuso[1].Trim() + "')\" class='board'>" + aJuso[1].Trim() + " " + aJuso[2].Trim() + "</a>";
					oTD_ZipNo.Text = "[" + aJuso[0].Trim() + "]";

					oTR.Cells.Add(oTD_Addr);
					oTR.Cells.Add(oTD_ZipNo);

					WTTblZipNoList.Rows.Add(oTR);
				}
			}
			catch
			{
				TableRow oTR = new TableRow();
				TableCell oTD = new TableCell();

				oTR.Height = 30;
				oTD.HorizontalAlign = HorizontalAlign.Center;
				
				oTD.Text = "검색된 주소가 없습니다.";

				oTR.Cells.Add(oTD);
				WTTblZipNoList.Rows.Add(oTR);
			}

			WTTblZipNoList.Visible = true;
		}
	}
}
