﻿using System;
using System.Configuration;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Text;
using System.Web;
using System.Xml;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using BoardLib;
using System.Text.RegularExpressions;

namespace NeBoard
{
	public abstract class BoardModify : UserControl
	{
		#region Controls
		protected HyperLink lnk_HomeBtn;
		protected HyperLink lnk_AdminBtn;
		protected HyperLink lnk_LoginBtn;
		protected HyperLink lnk_LogoutBtn;
		protected HyperLink lnk_SignupBtn;
		protected HyperLink lnk_MyinfoBtn;
		protected HyperLink lnk_MemoBoxBtn;

		protected HtmlTableRow HTTrEmail;
		protected HtmlTableRow HTTrHomePage;
		protected HtmlTableRow HTTrRefLink;
		protected Label WNLblMbName;
		protected TextBox WNTxtName;
		protected TextBox WNTxtPwd;
		protected TextBox WNTxtEmail;
		protected TextBox WNTxtHomepage;
		protected TextBox WNTxtSubject;
		protected TextBox WNTxtContent;
		protected TextBox WNTxtSumContent;
		protected TextBox WNTxtVoteStart;
		protected TextBox WNTxtVoteEnd;
		protected CheckBox WNChkHtml;
		protected CheckBox WNChkAlert;
		protected CheckBox WNChkCmmtAlert;
		protected CheckBox WNChkSecret;
		protected CheckBox WNChkNotice;
		protected CheckBox WNChkVote;
		protected CheckBox WNChkSum;
		protected CheckBox WNChkSumHtml;
		protected CheckBox WNChkASync;
		protected TextBox WNTxtLink1;
		protected TextBox WNTxtLink2;
		protected ImageButton WBImgSave;
		protected ImageButton WBImgCancel;
		protected HtmlTable HTTblHeaderText;
		protected HtmlTableRow HTTrHeaderText;
		protected HtmlTableCell HTTdHeaderText;
		protected HtmlTable HTTblOuterTable;
		protected HtmlTable HTTblBoardList;
		protected HtmlInputFile HNFleUpFile1;
		protected HtmlInputFile HNFleUpFile2;
		protected HtmlTable HTTblCopyright;
		protected HtmlTableCell HTTdCopyright;
		protected HtmlTable HTTblTailText;
		protected HtmlTableCell HTTdTailText;
		protected HtmlTableRow HTTrLoginName;
		protected HtmlTableRow HTTrLogoutName;
		protected HtmlTableRow HTTrUpload;
		protected DropDownList WNDdlCatList;
		protected Literal ltr_FileUpListBind;
		protected HtmlInputHidden HidStartUploadDate;
		protected HtmlInputHidden HidStartDeleteDate;

		public NBLib.PageQryStr mPageQryInfo;	// QueryString으로 넘어온 결과 로드
		public NBLib.CurBoardCfg mBoardCfg;

		protected BoardQryLib QryLib;

		public string BoardTitleContent;
		#endregion

		public string
			gBoardNo,					// 게시판 코드
			gViewMode;					// 게시판 작동 모드

		public string BoardNo
		{
			set
			{
				gBoardNo = value;
			}

			get
			{
				return gBoardNo;
			}
		}

		public string ViewMode
		{
			set
			{
				gViewMode = value;
			}

			get
			{
				return gViewMode;
			}
		}

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				do_init_set();
			}
			catch(Exception E)
			{
				Response.Clear();
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}			
		}

		/// <summary>
		/// 게시판 환경 설정 내용을 적용한다.
		/// </summary>
		private void do_init_set()
		{
			// 전역 데이타 로드
			if ( nb_utils.GetGlobalValue (ref mPageQryInfo, ref mBoardCfg, gBoardNo, gViewMode) )
			{
				QryLib = new BoardQryLib(mPageQryInfo.sBoardNo);

				// 게시판 타이틀 설정
				NBUtil.SetDisplayType(ref BoardTitleContent, mBoardCfg.bnd_boardtitle_view, mBoardCfg.bnd_boardtitle_cont.Replace("[BRD_NAME]", mBoardCfg.bnc_board_name));

				set_pagebutton();
		
				set_page_display();

				NBUtil.SetBoardListTblCfg (mBoardCfg, HTTblOuterTable);

				WNDdlCatList.Enabled = false;
				WNDdlCatList.Visible = false;

				if (NBUtil.isUseChk(mBoardCfg.bnc_category_use))
				{
					NBUtil.LoadCatList(WNDdlCatList, mPageQryInfo.sBoardNo);

					if (WNDdlCatList.Items.Count > 0)
					{
						WNDdlCatList.Enabled = true;
						WNDdlCatList.Visible = true;
					}
				}

				BoardDataBind();

				set_ToolTip();
			}
		}

		private void set_ToolTip()
		{
			WNChkHtml.ToolTip = "본문에 HTML 태그를 사용할지 결정 합니다.";
			WNChkAlert.ToolTip = "답변글이 등록되면 이메일로 알려드립니다.";
			WNChkCmmtAlert.ToolTip = "코멘트가 등록되면 이메일로 알려드립니다.";
			WNChkSecret.ToolTip = "현재 게시물을 비밀글로 작성 합니다.";
			WNChkNotice.ToolTip = "현재 게시물을 공지글로 작성 합니다.";
			WNChkVote.ToolTip = "투표글을 작성 합니다.\n투표 시작/종료 시각을 입력 하시고,\n내용에서 투표 항목을 입력 하시면 됩니다.";
			WNChkSum.ToolTip = "RSS의 본문 내용에 들어갈 내용을 따로 입력하고 싶으실 경우 사용 합니다.";
			WNChkASync.ToolTip = "게시물의 등록 시각과 삭제 시작을 예약할 수 있습니다.";
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		디자이너 지원에 필요한 메서드입니다.
		///		이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{
			this.WBImgSave.Click += new ImageClickEventHandler(this.WBImgSave_Click);
			this.WBImgCancel.Click += new ImageClickEventHandler(this.WBImgCancel_Click);
			this.Load += new EventHandler(this.Page_Load);
		}
		#endregion

		/// <summary>
		/// 페이지 버튼 설정
		/// </summary>
		private void set_pagebutton()
		{
			//-- 버튼의 링크 설정
			if ( NBUtil.StrEmptyChk(lnk_AdminBtn.NavigateUrl) )
			{
				lnk_AdminBtn.Attributes["onclick"] = "BoardList_Admin('" + ConfigurationSettings.AppSettings["NeAdminPath"] + "/Default.aspx" + "', '" + mPageQryInfo.sBoardNo + "');";
			}

			if ( lnk_MemoBoxBtn.NavigateUrl.Trim().Length.Equals(0) )
				lnk_MemoBoxBtn.NavigateUrl = "javascript:BoardList_Memobox()";

			if ( lnk_HomeBtn.NavigateUrl.Trim().Length.Equals(0) )
				lnk_HomeBtn.NavigateUrl = mBoardCfg.bnc_homebtn_url;

			if ( lnk_LoginBtn.NavigateUrl.Trim().Length.Equals(0) )
				lnk_LoginBtn.NavigateUrl = NBUtil.GetBoardTransLink (mPageQryInfo.sBoardNo, "LOGIN", mPageQryInfo);

			if ( lnk_LogoutBtn.NavigateUrl.Trim().Length.Equals(0) )
				lnk_LogoutBtn.NavigateUrl = "javascript:NBLogoutProc();";

			if ( lnk_MyinfoBtn.NavigateUrl.Trim().Length.Equals(0) )
				lnk_MyinfoBtn.NavigateUrl = NBUtil.GetBoardTransLink (mPageQryInfo.sBoardNo, "MYINFO", mPageQryInfo);

			if ( lnk_SignupBtn.NavigateUrl.Trim().Length.Equals(0) )
				lnk_SignupBtn.NavigateUrl = NBUtil.GetBoardTransLink (mPageQryInfo.sBoardNo, "JOIN", mPageQryInfo);

			//-- 버튼의 표시 여부 결정
			NBLib.PageBtnView stBtnView = NBUtil.GetBtnViewSet (mBoardCfg) ;

			lnk_HomeBtn.Visible = stBtnView.home_btn;

			lnk_AdminBtn.Visible = stBtnView.admin_btn;

			lnk_LoginBtn.Visible = stBtnView.login_btn;

			lnk_LogoutBtn.Visible = stBtnView.logout_btn;

			lnk_SignupBtn.Visible = stBtnView.signup_btn;

			lnk_MyinfoBtn.Visible = stBtnView.myinfo_btn;

			lnk_MemoBoxBtn.Visible = stBtnView.memo_box;

			WBImgSave.Attributes.Add("onclick", "return BoardWrite_ValidationChk()");

			WNTxtContent.Attributes["onkeydown"] = "NBInputInsertBR (this);";
			WNTxtContent.Attributes["onkeyup"] = "NBRemoveShiftBR (this);";
			WNTxtContent.ToolTip = "Shift + Enter : <BR>";

			WNTxtSumContent.Attributes["onkeydown"] = "NBInputInsertBR (this);";
			WNTxtSumContent.Attributes["onkeyup"] = "NBRemoveShiftBR (this);";
			WNTxtSumContent.ToolTip = "Shift + Enter : <BR>";
		}

		private void set_page_display()
		{
			// homepg_disp : 홈페이지 사용 여부에 따라 홈 버튼의 보기 여부를 결정한다.
			if ((int.Parse(mBoardCfg.bnc_homepage_use) & NBLib.ViewModeBit.WriteUseFlag) == NBLib.ViewModeBit.WriteUseFlag)
				HTTrHomePage.Visible = true;
			else
				HTTrHomePage.Visible = false;

			// email_disp : 이메일 사용 여부에 따라 이메일 버튼의 보기 여부를 결정한다.
			if ((int.Parse(mBoardCfg.bnc_email_use) & NBLib.ViewModeBit.WriteUseFlag) == NBLib.ViewModeBit.WriteUseFlag)
			{
				HTTrEmail.Visible = true;

				// Replay Mail
				if ( NBUtil.isUseChk(mBoardCfg.bnc_replymail_use) )
				{
					WNChkAlert.Visible = true;
				}
				else
				{
					WNChkAlert.Checked = false;
					WNChkAlert.Visible = false;
				}

				// Replay Mail
				if ( NBUtil.isUseChk(mBoardCfg.bnc_cmmtmail_use) )
				{
					WNChkCmmtAlert.Visible = true;
				}
				else
				{
					WNChkCmmtAlert.Checked = false;
					WNChkCmmtAlert.Visible = false;
				}
			}
			else
			{
				HTTrEmail.Visible = false;

				WNChkAlert.Checked = false;
				WNChkAlert.Visible = false;

				WNChkCmmtAlert.Checked = false;
				WNChkCmmtAlert.Visible = false;
			}

			//Upload
			if ( NBUtil.isFileUpUse (mBoardCfg.bnc_fileupdown_use, NBUtil.chkLvlRole (mBoardCfg.bps_level_info, NBLib.UserLvlRole.FileUpload)) )
				HTTrUpload.Visible = true;
			else
				HTTrUpload.Visible = false;

			// Link : 참조 링크 사용 여부에 따라 참조 링크 보기 여부를 결정 한다.
			if (NBUtil.isUseChk(mBoardCfg.bnc_sitelink_use))
				HTTrRefLink.Visible = true;
			else
				HTTrRefLink.Visible = false;

			// Private
			if ( NBUtil.isUseChk(mBoardCfg.bnc_private_use) && NBUtil.chkLvlRole (mBoardCfg.bps_level_info, NBLib.UserLvlRole.PrivateWrite))
			{
				WNChkSecret.Visible = true;
			}
			else
			{
				WNChkSecret.Checked = false;
				WNChkSecret.Visible = false;
			}

			// 투표 사용 여부에 따라 투표 설정을 한다.
			if (  NBUtil.isUseChk(mBoardCfg.bnc_voteboard_use) && NBUtil.chkLvlRole (mBoardCfg.bps_level_info, NBLib.UserLvlRole.VoteWrite) )
			{
				WNChkVote.Visible = true;
				WNChkVote.Attributes["onclick"] = "NBVote_Display(this, '" + WNTxtContent.ClientID + "');";
			}
			else
			{
				if (WNChkVote != null)
				{
					WNChkVote.Checked = false;
					WNChkVote.Visible = false;
				}
			}


			//Notice : 공지글 사용 여부와 권한에 따라 공지글 설정의 보기 여부를 결정 한다.
			if (NBUtil.isUseChk(mBoardCfg.bnc_notice_use) && NBUtil.chkLvlRole (mBoardCfg.bps_level_info, NBLib.UserLvlRole.NoticeWrite) )
			{
				// 부모글이 공지글일 경우에는 답변글을 작성할 수 없다.
				if (mPageQryInfo.bReplyYN)
					WNChkNotice.Visible = false;
				else
					WNChkNotice.Visible = true;
			}
			else
			{
				WNChkNotice.Checked = false;
				WNChkNotice.Visible = false;
			}

			// HTML Use
			if ( mBoardCfg.bnc_html_use.Equals("1") ||  mBoardCfg.bnc_html_use.Equals("2") || mBoardCfg.bnc_html_use.Equals("3") )
			{
				WNChkHtml.Visible = true;
			}
			else
			{
				WNChkHtml.Checked = false;
				WNChkHtml.Visible = false;
				
			}

			// 예약 등록/삭제 기능 설정
			if ( NBUtil.isUseChk (mBoardCfg.bnc_async_update_use) )
			{
				WNChkASync.Visible = true;
				WNChkASync.Attributes["onclick"] = "NBAsyncWin(this, '" + HidStartUploadDate.ClientID + "', '" + HidStartDeleteDate.ClientID + "');";
			}
			else
			{
				WNChkASync.Checked = false;
				WNChkASync.Visible = false;
			}
		}

		
		private void BoardDataBind()
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);


				SqlDataReader drContentData = SqlHelper.ExecuteReader (dbSqlConn, CommandType.StoredProcedure, "nbsp_board_data_all_" + mPageQryInfo.sBoardNo, new SqlParameter("@idx_no", mPageQryInfo.sIdxNo));

				if (drContentData.Read())
				{
					if (NBUtil.isUseChk(mBoardCfg.bnc_category_use))
					{
						if (!NBUtil.StrEmptyChk(drContentData["cat_code"].ToString()) &&
							drContentData["level_no1"].ToString() != "0")
						{
							NBCmnUtil.DdlLst_Chk(WNDdlCatList, drContentData["cat_code"].ToString());
							WNDdlCatList.Enabled = false;
						}
					}

					if (drContentData["guest_no"].ToString().Trim().Length > 0)//회원이 작성한 글일경우
					{
						//자기가 작성한 글일 경우에는 수정하고 그렇지 않을경우에는 권한없음 메시지 보임 .. 쿠키 디코딩 추가(2005.04.04)
						if (NBUtil.isAdminLogin(mBoardCfg.bps_level_info) || (NBUtil.isLogin() && drContentData["guest_no"].ToString().CompareTo(Server.UrlDecode(Request.Cookies["MBNO"].Value)) == 0))
						{
							WNLblMbName.Text = Server.HtmlEncode(drContentData["writer"].ToString());
							HTTrLoginName.Visible = true;
							HTTrLogoutName.Visible = false;
						}
						else
						{
							NBCmnUtil.ViewMsgGoBack (Page, "수정 권한이 없습니다.");
						}
					}
					else
					{
						WNTxtName.Text = drContentData["writer"].ToString();
						HTTrLoginName.Visible = false;
						HTTrLogoutName.Visible = true;

						if (NBUtil.isAdminLogin(mBoardCfg.bps_level_info))
						{
							WNTxtPwd.Visible = false;
						}
					}


					if (!IsPostBack)
					{

						//Email
						WNTxtEmail.Text = drContentData["email"].ToString();
						//Homepage
						WNTxtHomepage.Text = drContentData["homepage"].ToString();
						//제목
						WNTxtSubject.Text = drContentData["subject"].ToString();
						//내용
						if (NBUtil.isUseChk(drContentData["vote_yn"].ToString()))
						{
							string 
								sVoteContent = null, 
								sVoteSep = null, 
								sVoteItems = null;

							StringReader sSrcCont = new StringReader(drContentData["content"].ToString());
							XmlTextReader xmlRead = new XmlTextReader(sSrcCont);
							xmlRead.WhitespaceHandling = WhitespaceHandling.None;

							while (xmlRead.Read())
							{
								switch (xmlRead.LocalName)
								{
									case "content":
										sVoteContent = xmlRead.ReadString();
										break;
									case "sepitem":
										sVoteSep = xmlRead.ReadString();
										break;
									case "item":
										string sTmpReadItem = xmlRead.ReadString();
										if (!NBUtil.StrEmptyChk(sTmpReadItem))
											sVoteItems += sTmpReadItem + ";";
										break;
									default:
										break;
								}
							}

							WNTxtContent.Text = sVoteContent + "\n\n" + sVoteSep + "\n" + sVoteItems;

							xmlRead.Close();
							sSrcCont.Close();
						}
						else
						{
							WNTxtContent.Text = drContentData["content"].ToString();
						}
					
						//문서형식
						if ( NBUtil.isUseChk(drContentData["html_use"].ToString()) )
							WNChkHtml.Checked = true;

						//답변메일받기
						if ( NBUtil.isUseChk(drContentData["replymail_yn"].ToString()) )
							WNChkAlert.Checked = true;

						//코멘트메일받기
						if ( NBUtil.isUseChk(drContentData["cmmtmail_yn"].ToString()) )
							WNChkCmmtAlert.Checked = true;
					
						//비밀글
						if ( NBUtil.isUseChk(drContentData["private_yn"].ToString()) )
							WNChkSecret.Checked = true;
					
						if( !NBUtil.isUseChk(mBoardCfg.bnc_private_use) )
							WNChkSecret.Visible = false;

						//공지글
						if ( NBUtil.isUseChk(drContentData["notice_yn"].ToString()) )
							WNChkNotice.Checked = true;

						//투표
						if ( WNChkVote != null && NBUtil.isUseChk(drContentData["vote_yn"].ToString()) )
						{
							WNChkVote.Checked = true;

							// 투표 기간, 타입 설정 
							WNTxtVoteStart.Text = drContentData["vote_start"].ToString();
							WNTxtVoteEnd.Text = drContentData["vote_end"].ToString();

							Page.RegisterStartupScript ("VoteView", "<script language=\"javascript\">NBVote_PlaceView();</script>");
						}

						// 요약 게시판 글
						if (NBUtil.ConvStrToInt (drContentData["level_no1"].ToString()) > 0)
						{
							// 답변글일 경우 요약 게시판 내용 입력 기능을 Disable 시킨다.
							WNChkSum.Checked = false;
							WNChkSum.Visible = false;
						}
						else
						{
							WNChkSum.Checked = NBUtil.ConvStrToBool (drContentData["sum_yn"].ToString());
							WNChkSumHtml.Checked = NBUtil.ConvStrToBool (drContentData["sum_html_use"].ToString());
							WNTxtSumContent.Text = drContentData["sum_content"].ToString();

							WNChkSum.Attributes["onclick"] = "NBSumContent_Display(this);";

							if (WNChkSum.Checked)
							{
                                Page.RegisterStartupScript ("SumView", "<script language=\"javascript\">NBSum_PlaceView();</script>");
							}
						}

						//링크#1
						if (drContentData["link1"].ToString().Length > 0)
							WNTxtLink1.Text = drContentData["link1"].ToString();

						//링크#2
						if (drContentData["link2"].ToString().Length > 0)
							WNTxtLink2.Text = drContentData["link2"].ToString();

						if ( NBUtil.isUseChk(mBoardCfg.bnc_category_use) && drContentData["cat_code"].ToString().Length > 0 )
							NBCmnUtil.DdlLst_Chk (WNDdlCatList, drContentData["cat_code"].ToString());

						if (!NBUtil.StrEmptyChk(drContentData["disp_start_date"].ToString()) || !NBUtil.StrEmptyChk(drContentData["disp_end_date"].ToString()))
						{
							WNChkASync.Checked = true;
							string dtStartDate = drContentData["disp_start_date"].ToString().Trim();
							string dtEndDate = drContentData["disp_end_date"].ToString().Trim();

							if (!NBUtil.StrEmptyChk(dtStartDate))
							{
                                HidStartUploadDate.Value = DateTime.Parse(drContentData["disp_start_date"].ToString().Trim()).ToString("yyyy-MM-dd HH:mm");
							}

							if (!NBUtil.StrEmptyChk(dtEndDate))
							{
								HidStartDeleteDate.Value = DateTime.Parse(drContentData["disp_end_date"].ToString().Trim()).ToString("yyyy-MM-dd HH:mm");
							}
						}
						else
						{
							WNChkASync.Checked = false;
							HidStartUploadDate.Value = "";
							HidStartDeleteDate.Value = "";
						}
					}

					DoFileUpListBind();
				}
				else
				{
					throw new Exception("해당 글이 삭제 되었거나 링크가 잘못되었습니다.");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewMsgGoBack (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}

		private void DoFileUpListBind()
		{
			if ( NBUtil.isFileUpUse (mBoardCfg.bnc_fileupdown_use, NBUtil.chkLvlRole (mBoardCfg.bps_level_info, NBLib.UserLvlRole.FileUpload)) && !NBUtil.StrEmptyChk(mBoardCfg.bnc_file_up_cnt) && int.Parse(mBoardCfg.bnc_file_up_cnt) > 0 )
			{
				string sFileUpDesignTxt = NBCmnUtil.TextFileRead (HttpContext.Current.Server.MapPath(mBoardCfg.bnd_skin_path + "/FileUpDesign.htm"));

				if ( !NBUtil.StrEmptyChk(sFileUpDesignTxt) )
				{
					sFileUpDesignTxt = sFileUpDesignTxt.Replace (NBLib.NBFileUpDesignTag.FileUp_Count, mBoardCfg.bnc_file_up_cnt);

					StringBuilder sbFileUpDesign = new StringBuilder(sFileUpDesignTxt);

					string sRepeatStr = NBCmnUtil.GetDesignTag_Str (sbFileUpDesign.ToString(), NBLib.NBFileUpDesignTag.FileUpRepeat_S, NBLib.NBFileUpDesignTag.FileUpRepeat_E);

					string sResultRowData = string.Empty;

					NBLib.FileInfo[] oldFileInfo = DoUpFileBind();

					for (int nFileUpCnt = 0; nFileUpCnt < int.Parse(mBoardCfg.bnc_file_up_cnt); nFileUpCnt++)
					{
						string sRepeatResultStr = sRepeatStr;

						sRepeatResultStr = sRepeatResultStr.Replace (NBLib.NBFileUpDesignTag.FileUpPlace_ID, "FileUpPlace_" + nFileUpCnt.ToString());

						if (nFileUpCnt == 0 || !NBUtil.StrEmptyChk(oldFileInfo[nFileUpCnt].FileName))
						{
							sRepeatResultStr = sRepeatResultStr.Replace (NBLib.NBFileUpDesignTag.FileUpPlace_Style, "display : block;");
						}
						else
						{
							sRepeatResultStr = sRepeatResultStr.Replace (NBLib.NBFileUpDesignTag.FileUpPlace_Style, "display : none;");
						}

						sRepeatResultStr = sRepeatResultStr.Replace (NBLib.NBFileUpDesignTag.FileUp_Input, "<input type=\"file\" name=\"NBFileUp_File\" size=\"44\" class=\"inputbox\" onchange=\"ViewPreImg(this, 'PreImg_" + nFileUpCnt.ToString() + "');\">");
						sRepeatResultStr = sRepeatResultStr.Replace (NBLib.NBFileUpDesignTag.FileUp_Desc, "<input type=\"text\" name=\"NBFileUp_Desc\" size=\"44\" class=\"inputbox\" value=\"" + oldFileInfo[nFileUpCnt].FileDesc + "\">");
						sRepeatResultStr = sRepeatResultStr.Replace (NBLib.NBFileUpDesignTag.FileUp_InTag, " #FileViewLink_" + nFileUpCnt.ToString() + "#");
						sRepeatResultStr = sRepeatResultStr.Replace (NBLib.NBFileUpDesignTag.FileUp_OldFile, oldFileInfo[nFileUpCnt].FileName + oldFileInfo[nFileUpCnt].FileExt );
						if ( NBUtil.StrEmptyChk(oldFileInfo[nFileUpCnt].FileName) )
                            sRepeatResultStr = sRepeatResultStr.Replace (NBLib.NBFileUpDesignTag.FileUp_Delete, "<input type=\"checkbox\" name=\"NBFileUp_Delete\" value=\"\" style=\"display:none\">");
						else
							sRepeatResultStr = sRepeatResultStr.Replace (NBLib.NBFileUpDesignTag.FileUp_Delete, "<input type=\"checkbox\" name=\"NBFileUp_Delete\" value=\"" + nFileUpCnt.ToString() + "\">삭제");
						sRepeatResultStr = sRepeatResultStr.Replace (NBLib.NBFileUpDesignTag.PreImg_ID, "PreImg_" + nFileUpCnt.ToString());

						sResultRowData += sRepeatResultStr;
					}

					NBCmnUtil.GetDesignTagReplace(ref sbFileUpDesign, NBLib.NBFileUpDesignTag.FileUpRepeat_S, NBLib.NBFileUpDesignTag.FileUpRepeat_E, sResultRowData);

					ltr_FileUpListBind.Text = sbFileUpDesign.ToString();
				}
			}
		}

		private NBLib.FileInfo[] DoUpFileBind()
		{
			SqlConnection dbSqlConn = null;
			NBLib.FileInfo[] oFileInfo = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				SqlDataReader drFileInfo = SqlHelper.ExecuteReader(dbSqlConn, CommandType.StoredProcedure, "nbsp_sel_filedata_" + mPageQryInfo.sBoardNo, new SqlParameter("@idx_no", mPageQryInfo.sIdxNo));

				oFileInfo = new NBLib.FileInfo[int.Parse(mBoardCfg.bnc_file_up_cnt)];

				int nCnt = 0;

				while (drFileInfo.Read())
				{
					oFileInfo[nCnt].FileName = drFileInfo["file_name"].ToString();
					oFileInfo[nCnt].FileExt = drFileInfo["file_ext"].ToString();
					oFileInfo[nCnt].FileDesc = drFileInfo["file_desc"].ToString();
					++nCnt;
				}
			}
			catch(Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}

			return oFileInfo;
		}
	
		/// <summary>
		/// 게시물을 작성하기 전에 게시물의 내용이 제한사항에 걸리지 않는지 확인한다.
		/// </summary>
		/// <returns></returns>
		private bool DoInputValidChk()
		{
			try
			{
				if (HTTrLogoutName.Visible)
				{
					if ( NBUtil.StrEmptyChk(WNTxtName.Text) )
					{
						NBCmnUtil.ViewAlertMsg (Page, "이름을 입력해 주세요.");
						return true;
					}

					if ( !NBUtil.isAdminLogin(mBoardCfg.bps_level_info) && NBUtil.StrEmptyChk(WNTxtPwd.Text) )
					{
						NBCmnUtil.ViewAlertMsg (Page, "비밀번호를 입력해 주세요.");
						return true;
					}
				}

				if (HTTrEmail.Visible)
				{
					if ( NBUtil.StrEmptyChk(WNTxtEmail.Text) || NBCmnUtil.ValidChk_Email (WNTxtEmail.Text) )
					{
						NBCmnUtil.ViewAlertMsg (Page, "이메일 주소를 정확히 입력해 주세요.");
						return true;
					}
				}

				if ( NBUtil.StrEmptyChk (WNTxtSubject.Text) )
				{
					NBCmnUtil.ViewAlertMsg (Page, "제목을 입력해 주세요.");
					return true;
				}

				// 관리자가 아닌경우에는 글/파일 업로드 제한 체크를 한다.
				if ( !NBUtil.isAdminLogin(mBoardCfg.bps_level_info) )
				{
					if ( WNChkHtml.Checked && NBUtil.DoHtmlTagChk (NBUtil.chkLvlRole (mBoardCfg.bps_level_info, NBLib.UserLvlRole.AdvHtmlUse), mBoardCfg.bnc_html_use, mBoardCfg.bnc_use_htmltag, WNTxtContent.Text) )
						return true;

					if( NBUtil.DoWordChk (mBoardCfg.bnc_badword_use, mBoardCfg.bnc_badword_word, WNTxtSubject.Text, WNTxtContent.Text) )
						return true;

					// File Input을 HttpPostedFile 배열로 변환
					HttpFileCollection upfile_coll = Request.Files;

					if( NBUtil.isUseChk(mBoardCfg.bnc_fileupdown_use) && NBUtil.DoFileChk (mBoardCfg.bnc_fileup_ext_use, mBoardCfg.bnc_fileup_ext, mBoardCfg.bnc_fileup_size, upfile_coll) )
						return true;
				
					if( NBUtil.DoWriterLimitChk (mBoardCfg.bnc_writer_limit, WNTxtName.Text) )
						return true;
				}
			}
			catch (Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
				return true;
			}

			return false;
		}


		private void WBImgCancel_Click(object sender, ImageClickEventArgs e)
		{
			NBCmnUtil.ViewMsgGoUrl (Page, NBUtil.GetBoardTransLink (mPageQryInfo.sBoardNo, "VIEW", mPageQryInfo, mPageQryInfo.sIdxNo), "");
		}


		private string GetContentParse(string sCont)
		{
			string sResult = string.Empty;

			if (NBUtil.isUseChk(mBoardCfg.bnc_voteboard_use) && WNChkVote != null && WNChkVote.Checked)
			{
				SqlConnection dbSqlConn = null;
				string sParentCont = string.Empty;

				try
				{
					DBUtil.DBConnection (ref dbSqlConn);

                    SqlDataReader dbVoteDr = SqlHelper.ExecuteReader (dbSqlConn, CommandType.StoredProcedure, "nbsp_get_vote_content_" + mPageQryInfo.sBoardNo, new SqlParameter("@idx_no", mPageQryInfo.sIdxNo));

					if (dbVoteDr.Read())
					{
						if (!NBUtil.StrEmptyChk (dbVoteDr["vote_yn"].ToString()) && NBUtil.isUseChk(dbVoteDr["vote_yn"].ToString()))
							sParentCont = dbVoteDr["content"].ToString();
					}
				}
				catch(Exception E)
				{
					throw E;
				}
				finally
				{
					DBUtil.DBConnDispose (ref dbSqlConn);
				}


				ArrayList arrItemIndex = new ArrayList();

				if (!NBUtil.StrEmptyChk(sParentCont))
				{
					StringReader sSrcCont = new StringReader(sParentCont);
					XmlTextReader xmlRead = new XmlTextReader(sSrcCont);
					xmlRead.WhitespaceHandling = WhitespaceHandling.None;

					while (xmlRead.Read())
					{
						if ( xmlRead.LocalName.Equals("item") && !NBUtil.StrEmptyChk(xmlRead.GetAttribute("count")) )
                            arrItemIndex.Add(xmlRead.GetAttribute("count"));
					}

					xmlRead.Close();
					sSrcCont.Close();
				}
                

				// 투표 게시판으로 사용하고 있으면
				string sVoteSep = "--투표항목--";
				string sVoteContent = string.Empty;
				string sVoteItem = string.Empty;
				string[] arrVoteCont = null;
				string[] arrVoteItem = null;

				Regex regVote = new Regex(sVoteSep);
				arrVoteCont = regVote.Split(sCont);

				if (arrVoteCont.Length.Equals(2))
				{
					sVoteContent = arrVoteCont[0].Trim();
					sVoteItem = arrVoteCont[1].Trim();

					arrVoteItem = sVoteItem.Split(';');

					if (arrVoteItem.Length > 1)
					{
						// XML 데이타 생성
						StringWriter swXmlCont = new StringWriter();

						XmlTextWriter xmlWr = new XmlTextWriter(swXmlCont);
						xmlWr.Formatting = Formatting.Indented;

						xmlWr.WriteStartDocument();

						xmlWr.WriteStartElement ("vote");
							
						xmlWr.WriteStartElement ("content");
						xmlWr.WriteCData (sVoteContent);
						xmlWr.WriteEndElement ();

						xmlWr.WriteStartElement ("sepitem");
						xmlWr.WriteCData (sVoteSep);
						xmlWr.WriteEndElement ();

						xmlWr.WriteStartElement ("voteitems");

						
						
						int nVoteCnt = 0;

						foreach (string sItem in arrVoteItem)
						{
							if (!NBUtil.StrEmptyChk(sItem))
							{
								xmlWr.WriteStartElement ("item");
								
								if (arrItemIndex.Count > nVoteCnt && arrItemIndex[nVoteCnt] != null)
     								xmlWr.WriteAttributeString ("count", arrItemIndex[nVoteCnt].ToString());
								else
									xmlWr.WriteAttributeString ("count", "0");									

								xmlWr.WriteCData(sItem);
								xmlWr.WriteEndElement();

								nVoteCnt++;
							}
						}
							
						xmlWr.WriteEndElement();

						xmlWr.WriteEndElement();

						xmlWr.WriteEndDocument();

						xmlWr.Flush();

						sResult = swXmlCont.ToString();

						xmlWr.Close();
						swXmlCont.Close();						
					}
					else
					{
						throw new Exception ("투표 항목을 입력해 주세요.");
					}
                    										
				}
				else
				{
					throw new Exception (sVoteSep + " 구분자가 없습니다.");
				}
			}
			else
			{
				sResult = sCont;
			}

			return sResult;
		}


		private void WBImgSave_Click(object sender, ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;

			try
			{
				if (DoInputValidChk())
					return;

				string sBoardDataPath = string.Empty;

				StringWriter oUploadQry = new StringWriter();
				StringWriter oFileUpQry = new StringWriter();

				string[] arrOldFileName = null;
				string[] arrOldFileExt = null;
				Int64[] arrOldFileSize = null;

				string[] aSaveFileName = null;
				string[] aSaveExtName = null;
				Int64[] aSaveFileSize = null;
				bool[] bFileChange = null;


				DBUtil.DBConnection (ref dbSqlConn);


				// 비회원이고 관리자가 아니면 비밀번호 검사
				if (!NBUtil.isAdminLogin(mBoardCfg.bps_level_info) && !NBUtil.isLogin ())
				{
					string sPwd = SqlHelper.ExecuteScalar (dbSqlConn, CommandType.StoredProcedure, "nbsp_get_board_pwd_" + mPageQryInfo.sBoardNo, new SqlParameter("@idx_no", mPageQryInfo.sIdxNo)).ToString();

					dbSqlConn.Close();

					if ( !sPwd.Equals(WNTxtPwd.Text.Trim()) )
							throw new Exception("비밀번호가 틀렸습니다.");
				}

				if ( NBUtil.isFileUpUse (mBoardCfg.bnc_fileupdown_use, NBUtil.chkLvlRole (mBoardCfg.bps_level_info, NBLib.UserLvlRole.FileUpload)) )
				{
					//파일필드
					HttpFileCollection oFileColl = Request.Files;

					sBoardDataPath = NBUtil.GetUploadRootPath () + "\\NB_BoardData_" + mPageQryInfo.sBoardNo;

					////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
					// 기존 업로드 파일 정보를 읽어 온다.
					DataSet dsOldFileInfo = SqlHelper.ExecuteDataset(dbSqlConn, CommandType.StoredProcedure, "nbsp_sel_filedata_" + mPageQryInfo.sBoardNo, new SqlParameter("@idx_no", mPageQryInfo.sIdxNo));
					DataTable dtOldFileInfo = dsOldFileInfo.Tables[0];
					
					if (dtOldFileInfo.Rows.Count > 0)
					{
						arrOldFileName = new string[oFileColl.Count];
						arrOldFileExt = new string[oFileColl.Count];
						arrOldFileSize = new Int64[oFileColl.Count];

						for (int drCnt=0; drCnt < oFileColl.Count; drCnt++)
						{
							if (dtOldFileInfo.Rows.Count > drCnt)
							{
								// 파일1의 정보 읽기
								arrOldFileName[drCnt] = dtOldFileInfo.Rows[drCnt]["file_name"].ToString();
								arrOldFileExt[drCnt] = dtOldFileInfo.Rows[drCnt]["file_ext"].ToString();
								arrOldFileSize[drCnt] = Int64.Parse(dtOldFileInfo.Rows[drCnt]["file_size"].ToString());
							}
						}
					}

					dbSqlConn.Close();


					
					////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
					// 파일 업로드
					if (Directory.Exists(sBoardDataPath) == false)
						Directory.CreateDirectory(sBoardDataPath).Create();

					aSaveFileName = new string[oFileColl.Count];
					aSaveExtName = new string[oFileColl.Count];
					aSaveFileSize = new Int64[oFileColl.Count];
					bFileChange = new bool[oFileColl.Count];

					int nFileCnt = 0;
					
					string[] arrFileDelChk = Request.Form.GetValues("NBFileUp_Delete");
					string[] arrFileDesc = Request.Form.GetValues("NBFileUp_Desc");

					for (int nFileInputCnt = 0; nFileInputCnt < oFileColl.Count; nFileInputCnt++)
					{
						bool bFlagFileDel = false;

						aSaveFileName[nFileCnt] = string.Empty;
						aSaveExtName[nFileCnt] = string.Empty;
						aSaveFileSize[nFileCnt] = 0;
						bFileChange[nFileCnt] = false;

						// 파일을 수정할 경우 //
						if ( !NBUtil.StrEmptyChk(oFileColl[nFileInputCnt].FileName) )
						{
							// 기존에 파일 있을 경우 삭제 처리
							if ( !NBUtil.StrEmptyChk(arrOldFileName[nFileCnt]) )
								NBUtil.FileDelete (arrOldFileName[nFileCnt].Trim() + arrOldFileExt[nFileCnt].Trim(), sBoardDataPath);

							if (oFileColl[nFileInputCnt].ContentLength > 0)
							{
								// 새로운 업로드 파일 저장
								string sSavedFileName = NBUtil.FileUpload (oFileColl[nFileInputCnt], sBoardDataPath);

								// 새로 업로드한 파일 정보 저장
								if ( !NBUtil.StrEmptyChk (sSavedFileName) )
								{
									aSaveExtName[nFileCnt] = Path.GetExtension(sSavedFileName);
									aSaveFileName[nFileCnt] = Path.GetFileNameWithoutExtension(sSavedFileName);
									aSaveFileSize[nFileCnt] = oFileColl[nFileInputCnt].ContentLength;
									bFileChange[nFileCnt] = true;
								}
							}
						}
						// 새로운 업로드 파일이 없는 경우
						else
						{
							if ( arrOldFileName != null && !NBUtil.StrEmptyChk(arrOldFileName[nFileCnt]) )
							{
								if (arrFileDelChk != null && arrFileDelChk.Length > 0)
								{
									foreach (string ChkFileDel in arrFileDelChk)
									{
										if (ChkFileDel.Equals(nFileCnt.ToString()))
										{
											NBUtil.FileDelete (arrOldFileName[nFileCnt].Trim() + arrOldFileExt[nFileCnt].Trim(), sBoardDataPath);
                                            bFlagFileDel = true;											
											break;
										}
										
									}
								}

								//기존파일 삭제를 체크했을경우
								if (!bFlagFileDel)
								{
									aSaveFileName[nFileCnt] = arrOldFileName[nFileCnt].Trim();
									aSaveExtName[nFileCnt] = arrOldFileExt[nFileCnt].Trim();
									aSaveFileSize[nFileCnt] = arrOldFileSize[nFileCnt];
								}
								else
								{
									bFileChange[nFileCnt] = true;
								}
							}
						}


						string 
							parmFileDesc = string.Empty,
							parmFileChange = "0";
                        
						if (bFileChange[nFileCnt])
							parmFileChange = "1";

						if ( !NBUtil.StrEmptyChk(aSaveFileName[nFileCnt]) )
							parmFileDesc = arrFileDesc[nFileCnt];						

						SqlParameter[] sqlParm = new SqlParameter[7];
						sqlParm[0] = new SqlParameter("@idx_no", mPageQryInfo.sIdxNo);
						sqlParm[1] = new SqlParameter("@fidx_no", nFileCnt.ToString());
						sqlParm[2] = new SqlParameter("@file_name", aSaveFileName[nFileCnt]);
						sqlParm[3] = new SqlParameter("@file_ext", aSaveExtName[nFileCnt]);
						sqlParm[4] = new SqlParameter("@file_size", aSaveFileSize[nFileCnt]);
						sqlParm[5] = new SqlParameter("@file_desc", parmFileDesc);
						sqlParm[6] = new SqlParameter("@file_chg", parmFileChange);

						SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.StoredProcedure, "nbsp_update_filedata_" + mPageQryInfo.sBoardNo, sqlParm);

						nFileCnt++;
					}
				}

				string
					parmWriter = string.Empty,
					parmCatCode = string.Empty,
					parmVoteChk = string.Empty,
					parmVoteStart = string.Empty,
                    parmVoteEnd = string.Empty,
					parmVoteDispType = string.Empty,
					parmSumYn = string.Empty,
					parmSumHtmlUse = string.Empty,
					parmSumContent = string.Empty,
					parmDispStartDate = string.Empty,
					parmDispEndDate = string.Empty;
                
				if (NBUtil.isLogin())
				{
					parmWriter = Server.UrlDecode(Request.Cookies["MBNAME"].Value);//쿠키 디코딩 추가(2005.04.04)
				}
				else
					parmWriter = WNTxtName.Text;

				if (NBUtil.isUseChk(mBoardCfg.bnc_category_use) && WNDdlCatList.SelectedIndex > -1)
					parmCatCode = WNDdlCatList.SelectedValue;

				if (WNChkVote != null && WNChkVote.Checked)
				{
					parmVoteChk = NBUtil.ConvBoolToStr (WNChkVote.Checked);

					// 투표 설정
					parmVoteStart = WNTxtVoteStart.Text;
					parmVoteEnd = WNTxtVoteEnd.Text;
				}

				if (WNChkSum.Checked)
				{
					parmSumYn = "1";
					parmSumHtmlUse = NBUtil.ConvBoolToStr (WNChkSumHtml.Checked);
					parmSumContent = WNTxtSumContent.Text;
				}

				if (WNChkASync.Checked)
				{
					parmDispStartDate = HidStartUploadDate.Value;
					parmDispEndDate = HidStartDeleteDate.Value;
				}
                
                SqlParameter[] sqlUpdateParm = new SqlParameter[24];
				sqlUpdateParm[0] = new SqlParameter("@idx_no", mPageQryInfo.sIdxNo);
				sqlUpdateParm[1] = new SqlParameter("@writer", parmWriter);
				sqlUpdateParm[2] = new SqlParameter("@email", WNTxtEmail.Text);
				sqlUpdateParm[3] = new SqlParameter("@homepage", WNTxtHomepage.Text);
				sqlUpdateParm[4] = new SqlParameter("@writer_ip", Request.UserHostAddress);
				sqlUpdateParm[5] = new SqlParameter("@cat_code", parmCatCode);
				sqlUpdateParm[6] = new SqlParameter("@subject", WNTxtSubject.Text);
				sqlUpdateParm[7] = new SqlParameter("@content", GetContentParse(WNTxtContent.Text));
				sqlUpdateParm[8] = new SqlParameter("@html_use", NBUtil.ConvBoolToStr (WNChkHtml.Checked));
				sqlUpdateParm[9] = new SqlParameter("@replymail_yn", NBUtil.ConvBoolToStr (WNChkAlert.Checked));
				sqlUpdateParm[10] = new SqlParameter("@private_yn", NBUtil.ConvBoolToStr (WNChkSecret.Checked));
				sqlUpdateParm[11] = new SqlParameter("@notice_yn", NBUtil.ConvBoolToStr (WNChkNotice.Checked));
				sqlUpdateParm[12] = new SqlParameter("@link1", WNTxtLink1.Text);
				sqlUpdateParm[13] = new SqlParameter("@link2", WNTxtLink2.Text);
				sqlUpdateParm[14] = new SqlParameter("@cmmtmail_yn", NBUtil.ConvBoolToStr (WNChkCmmtAlert.Checked));
				sqlUpdateParm[15] = new SqlParameter("@vote_yn", parmVoteChk);
				sqlUpdateParm[16] = new SqlParameter("@vote_start", parmVoteStart);
				sqlUpdateParm[17] = new SqlParameter("@vote_end", parmVoteEnd);
				sqlUpdateParm[18] = new SqlParameter("@vote_disp_type", parmVoteDispType);
				sqlUpdateParm[19] = new SqlParameter("@sum_yn", parmSumYn);
				sqlUpdateParm[20] = new SqlParameter("@sum_content", parmSumContent);
				sqlUpdateParm[21] = new SqlParameter("@sum_html_use", parmSumHtmlUse);
				sqlUpdateParm[22] = new SqlParameter("@disp_start_date", parmDispStartDate);
				sqlUpdateParm[23] = new SqlParameter("@disp_end_date", parmDispEndDate);

				if (SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.StoredProcedure, "nbsp_update_boarddata_" + mPageQryInfo.sBoardNo, sqlUpdateParm) > 0)
				{
					if ( NBUtil.StrEmptyChk (mBoardCfg.bnc_afteredit_url) )
					{
						Response.Redirect (NBUtil.GetBoardTransLink (mPageQryInfo.sBoardNo, "VIEW", mPageQryInfo, mPageQryInfo.sIdxNo), false);
					}
					else
					{
                        Response.Redirect (mBoardCfg.bnc_afteredit_url, false);
					}
				}
				else
					throw new Exception("게시판에 글을 등록하는 도중 오류가 발생하였습니다.");					
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg(Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}
	}
}

