﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Text;
using System.Web.UI;
using System.Web.UI.WebControls;
using BoardLib;

namespace NeBoard
{
	public abstract class Login : UserControl
	{
		protected TextBox WNTxtId;
		protected TextBox WNTxtPwd;
		protected CheckBox WNChkIDSave;
		protected ImageButton WBImgLoginOk;
		protected HyperLink lnk_login_cancel;
		protected Label lbl_passfind;

		public NBLib.PageQryStr mPageQryInfo;	// QueryString으로 넘어온 결과 로드

		public NBLib.CurBoardCfg mBoardCfg;

        public string BoardTitleContent;
		public string MemJoinLink;

		public string
			gBoardNo,					// 게시판 코드
			gViewMode;					// 게시판 작동 모드

		public string BoardNo
		{
			set
			{
				gBoardNo = value;
			}

			get
			{
				return gBoardNo;
			}
		}

		public string ViewMode
		{
			set
			{
				gViewMode = value;
			}

			get
			{
				return gViewMode;
			}
		}

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				// 전역 데이타 로드
				if (!nb_utils.GetGlobalValue (ref mPageQryInfo, ref mBoardCfg, gBoardNo, gViewMode))
					return;

				NBUtil.SetDisplayType(ref BoardTitleContent, mBoardCfg.bld_logintitle_view, mBoardCfg.bld_logintitle_cont);

				MemJoinLink = NBUtil.GetBoardTransLink (mPageQryInfo.sBoardNo, "JOIN", mPageQryInfo);

				ButtonScript();
				PrivDisplayLoginID();

				if (!NBUtil.isUseChk(mBoardCfg.bgc_passfind_use))
					lbl_passfind.Visible = false;
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		private void PrivDisplayLoginID()
		{
			if(Request.Cookies["UserLoginID"] != null && Request.Cookies["UserLoginID"].Value.Trim() != string.Empty)
			{
				WNTxtId.Text = Server.UrlDecode(Request.Cookies["UserLoginID"].Value);//쿠키 디코딩 추가(2005.04.04)
				WNChkIDSave.Checked = true;
			}
			else
			{
				WNTxtId.Text = "";
				WNChkIDSave.Checked = false;
			}
		}

		private void SaveLoginID()
		{
			if(WNChkIDSave.Checked)
			{
				Response.Cookies["UserLoginID"].Value = Server.UrlEncode(WNTxtId.Text.Trim());//쿠키 인코딩 추가(2005.04.04)
				Response.Cookies["UserLoginID"].Expires = DateTime.Now.AddDays(30);
			}
			else
			{
				Response.Cookies["UserLoginID"].Expires = DateTime.Now.AddDays(-1);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		디자이너 지원에 필요한 메서드입니다.
		///		이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{
			this.WBImgLoginOk.Click += new ImageClickEventHandler(this.WBImgLoginOk_Click);
			this.Load += new EventHandler(this.Page_Load);

		}
		#endregion

		private void ButtonScript()
		{
			WBImgLoginOk.Attributes.Add("onclick","return Login_ValidationChk()");
			lnk_login_cancel.NavigateUrl = NBUtil.GetBoardTransLink_WithCat (mPageQryInfo.sBoardNo, mPageQryInfo.sCatName, mPageQryInfo);
		}

		private void WBImgLoginOk_Click(object sender, ImageClickEventArgs e)
		{
			try
			{
				string sLoginGuestNo = NBUtil.do_login (mBoardCfg.bgc_sess_timeout, WNTxtId.Text, WNTxtPwd.Text);

				SaveLoginID();

				// 포인트 적용
				NBUtil.DoPointApply (mBoardCfg.bgc_login_point, sLoginGuestNo);

				string sRedirectUrl = string.Empty;
				string sTarget = string.Empty;

				if (NBUtil.StrEmptyChk(mBoardCfg.bnc_afterlogin_url))
				{
					sRedirectUrl = NBUtil.GetBoardTransLink (mPageQryInfo.sBoardNo, "LIST", mPageQryInfo);
					sTarget = "self";
				}
				else
				{
					sRedirectUrl = mBoardCfg.bnc_afterlogin_url;
					sTarget = "top";
				}

				Response.Write(@"<script language='javascript'>" + sTarget + @".location.href='" + sRedirectUrl + @"';</script>");
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewMsgGoBack (Page, E.Message);
			}
		}
	}
}
