﻿using System;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.IO;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using BoardLib;
using System.Text.RegularExpressions;

namespace NeBoard
{
	public abstract class MyInfo : UserControl
	{
		#region Controls
		protected ImageButton WBBtnSave;
		protected ImageButton WBBtnClose;
		
		public string 
			pbGuestNo = string.Empty,
			pbMemID = string.Empty,
			pbLevelName = string.Empty,
			pbGroupLevelName = string.Empty,
			pbLevelUserStyle = string.Empty,
			pbJoinDate = string.Empty,
			pbLastVisit = string.Empty;

		protected Label WNLblPwdReq;
		protected Label WNLblPwdCfmReq;
		protected Label WNLblMbNameReq;
		protected Label WNLblEmailReq;
		protected Label WNLblNicknameUse;
		protected Label WNLblHomepgUse;
		protected Label WNLblJuminUse;
		protected Label WNLblSexUse;
		protected Label WNLblBirthdayUse;
		protected Label WNLblMobileTelUse;
		protected Label WNLblHomeTelUse;
		protected Label WNLblWorkTelUse;
		protected Label WNLblHomeZipUse;
		protected Label WNLblHomeAddrUse;
		protected Label WNLblWorkZipUse;
		protected Label WNLblWorkAddrUse;
		protected Label WNLblEmailAcceptUse;
		protected Label WNLblMemPicUse;
		protected Label WNLblMessengerUse;

		protected RadioButtonList WLRdoEmailAccept;

		protected CheckBox MemPic_Del;
		protected CheckBox MemSign_Del;
		
		protected TextBox WNTxtLoginPwd;
		protected TextBox WNTxtPwdConfirm;
		protected TextBox WNTxtMbName;
		protected TextBox WNTxtEmail;
		protected TextBox WNTxtNickname;
		protected TextBox WNTxtHomepg;
		protected TextBox WNTxtJumnNo1;
		protected TextBox WNTxtJumnNo2;
		protected TextBox WNTxtMobileTel;
		protected TextBox WNTxtHomeTel;
		protected TextBox WNTxtWorkTel;
		protected TextBox WNTxtHomeZipNo1;
		protected TextBox WNTxtHomeAddrDong;
		protected TextBox WNTxtHomeAddrDesc;
		protected TextBox WNTxtWorkZipNo1;
		protected TextBox WNTxtWorkZipNo2;
		protected TextBox WNTxtWorkAddrDong;
		protected TextBox WNTxtWorkAddrDesc;
		protected TextBox WNTxtHomeZipNo2;
		protected TextBox WNTxtBirthDate_Day;
		protected TextBox WNTxtBirthDate_Month;
		protected TextBox WNTxtBirthDate_Year;
		protected TextBox WNTxtMessengerId;
		protected DropDownList WNDdlPassFind_Q;		
		protected DropDownList WNDdlMessengerType;	
		protected TextBox WNTxtPassFind_A;		
		protected HtmlInputFile WNFileMemPic;
		protected HtmlInputFile WNFileMemSign;

		protected RadioButtonList WLRdoLunarGubn;
		protected RadioButtonList WLRdoSexGubn;

		protected HtmlTableRow HTTrHomepage;
		protected HtmlTableRow HTTrJumnNo;
		protected HtmlTableRow HTTrSexGubn;
		protected HtmlTableRow HTTrBirthDate;
		protected HtmlTableRow HTTrMobileTel;
		protected HtmlTableRow HTTrHomeTel;
		protected HtmlTableRow HTTrWorkTel;
		protected HtmlTableRow HTTrHomeZip;
		protected HtmlTableRow HTTrWorkZip;
		protected HtmlTableRow HTTrHomeAddr;
		protected HtmlTableRow HTTrWorkAddr;
		protected HtmlTableRow HTTrEmaliAccept;
		protected HtmlTableRow HTTrNickname;
		protected HtmlTableRow HTTrMemPic;
		protected HtmlTableRow HTTrPassFind;
		protected HtmlTableRow HTTrMessenger;

		protected CheckBox chk_mem_name_open;
		protected CheckBox chk_mem_email_open;
		protected CheckBox chk_nick_name_open;
		protected CheckBox chk_messenger_id_open;
		protected CheckBox chk_homepage_open;
		protected CheckBox chk_sex_open;
		protected CheckBox chk_birthday_open;
		protected CheckBox chk_mobilephone_open;
		protected CheckBox chk_homephone_open;
		protected CheckBox chk_workphone_open;
		protected CheckBox chk_homeaddr_open;
		protected CheckBox chk_workaddr_open;

		protected HtmlInputHidden HNHidNicknameUse;
		protected HtmlInputHidden HNHidHomepgUse;
		protected HtmlInputHidden HNHidJuminUse;
		protected HtmlInputHidden HNHidBirthdayUse;
		protected HtmlInputHidden HNHidSexUse;
		protected HtmlInputHidden HNHidMobileTelUse;
		protected HtmlInputHidden HNHidHomeTelUse;
		protected HtmlInputHidden HNHidWorkTelUse;
		protected HtmlInputHidden HNHidHomeAddrUse;
		protected HtmlInputHidden HNHidWorkAddrUse;
		protected HtmlInputHidden HNHidHomeZipUse;
		protected HtmlInputHidden HNHidWorkZipUse;
		protected HtmlInputHidden HNHidEmailAcceptUse;
		protected HtmlInputHidden HNHidMemPicValidChk;
		protected HtmlInputHidden HNHidMemPicUse;

		protected HtmlInputHidden hid_add_ctrl;

		protected HtmlTable tbl_join_main;
		#endregion

		public NBLib.PageQryStr mPageQryInfo;	// QueryString으로 넘어온 결과 로드
		public NBLib.CurBoardCfg mBoardCfg;
		public NBBoardMain mParentPage;

		public string BoardTitleContent;
		public string sOldMemPicName;
		public string sOldMemSignName;

		public string
			gBoardNo,					// 게시판 코드
			gViewMode;					// 게시판 작동 모드

		public string BoardNo
		{
			set
			{
				gBoardNo = value;
			}

			get
			{
				return gBoardNo;
			}
		}

		public string ViewMode
		{
			set
			{
				gViewMode = value;
			}

			get
			{
				return gViewMode;
			}
		}

		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				// 전역 데이타 로드
				if (!nb_utils.GetGlobalValue (ref mPageQryInfo, ref mBoardCfg, gBoardNo, gViewMode))
					return;

				//로그인 체크
				if (!NBUtil.isLogin())
				{
					NBCmnUtil.ViewMsgGoBack (Page, "회원전용 메뉴입니다.\n\n먼저 로그인을 해주십시요.");
					return;
				}

				// 타이틀 표시
				NBUtil.SetDisplayType(ref BoardTitleContent, mBoardCfg.bld_logintitle_view, mBoardCfg.bld_logintitle_cont);

				// 입력 필드 설정
				FieldCheck();

				// 회원 정보 읽어 오기
				MemberInfoBind();
				NBUtil.AddMemberInfoBind(pbGuestNo, hid_add_ctrl, tbl_join_main, true);

				if(!IsPostBack)
				{
					ButtonScript();
				}
			}
			catch(Exception E)
			{
				Response.Write (E.Message);
			}
		}

		private void MemberInfoBind()
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				pbGuestNo = Server.UrlDecode(Request.Cookies["MBNO"].Value);//쿠키 디코딩 추가(2005.04.04)

				SqlDataReader drMemData = SqlHelper.ExecuteReader (dbSqlConn, CommandType.StoredProcedure, "nbsp_get_sel_memberdata", new SqlParameter("@guest_no", pbGuestNo));

				if (drMemData.Read())
				{
					pbMemID = drMemData["mem_id"].ToString();

					pbLevelName = drMemData["level_name"].ToString();

					pbJoinDate = NBUtil.GetStrToDT(drMemData["join_time"].ToString(), "yyyy년 MM월 dd일 HH시 mm분");
					pbLastVisit = NBUtil.GetStrToDT(drMemData["lastvisit_time"].ToString(), "yyyy년 MM월 dd일 HH시 mm분");
					
					WNTxtMbName.Text = drMemData["mem_name"].ToString();
					WNTxtEmail.Text = drMemData["mem_email"].ToString();
					WNTxtNickname.Text = drMemData["nick_name"].ToString();
					
					WNTxtMessengerId.Text = drMemData["messenger_id"].ToString();
					NBUtil.lstctrl_chk (WNDdlMessengerType, drMemData["messenger_type"].ToString());

					WNTxtHomepg.Text = drMemData["homepage"].ToString();

					string[] aTmpJumnNo = drMemData["citizennum"].ToString().Split('-');
					if (aTmpJumnNo.Length == 2)
					{
						WNTxtJumnNo1.Text = aTmpJumnNo[0].Trim();
						WNTxtJumnNo2.Text = aTmpJumnNo[1].Trim();
					}

					string[] aBirthDate = drMemData["birthday"].ToString().Split('.');
					if (aBirthDate.Length == 3)
					{
						WNTxtBirthDate_Year.Text = aBirthDate[0].Trim();
						WNTxtBirthDate_Month.Text = aBirthDate[1].Trim();
						WNTxtBirthDate_Day.Text = aBirthDate[2].Trim();
					}

					NBUtil.lstctrl_chk(WLRdoLunarGubn, drMemData["lunar_use"].ToString());
					NBUtil.lstctrl_chk(WLRdoSexGubn, drMemData["sex"].ToString());

					WNTxtMobileTel.Text = drMemData["mobilephone"].ToString();
					WNTxtHomeTel.Text = drMemData["homephone"].ToString();
					WNTxtWorkTel.Text = drMemData["workphone"].ToString();
					
					string sTmpHomeZip = drMemData["homezip"].ToString();
					string sTmpHomeAddr = drMemData["homeaddr"].ToString();

					string[] aTmpHomeZip = sTmpHomeZip.Split('-');

					if (aTmpHomeZip.Length == 2)
					{
						WNTxtHomeZipNo1.Text = aTmpHomeZip[0];
						WNTxtHomeZipNo2.Text = aTmpHomeZip[1];
					}

					if (sTmpHomeAddr.Length > 0)
					{
						string[] aTmpHomeAddr = sTmpHomeAddr.Split(' ');

						if (aTmpHomeAddr.Length > 0)
						{
							WNTxtHomeAddrDong.Text = string.Join(" ", aTmpHomeAddr, 0, aTmpHomeAddr.Length - 1);
							WNTxtHomeAddrDesc.Text = aTmpHomeAddr[aTmpHomeAddr.Length - 1];
						}
						else
							WNTxtHomeAddrDong.Text = sTmpHomeAddr;
					}

					string sTmpWorkZip = drMemData["workzip"].ToString();
					string sTmpWorkAddr = drMemData["workaddr"].ToString();

					string[] aTmpWorkZip = sTmpWorkZip.Split('-');

					if (aTmpWorkZip.Length == 2)
					{
						WNTxtWorkZipNo1.Text = aTmpWorkZip[0];
						WNTxtWorkZipNo2.Text = aTmpWorkZip[1];
					}

					if (sTmpWorkAddr.Length > 0)
					{
						string[] aTmpWorkAddr = sTmpWorkAddr.Split(' ');

						if (aTmpWorkAddr.Length > 0)
						{
							WNTxtWorkAddrDong.Text = string.Join(" ", aTmpWorkAddr, 0, aTmpWorkAddr.Length - 1);
							WNTxtWorkAddrDesc.Text = aTmpWorkAddr[aTmpWorkAddr.Length - 1];
						}
						else
							WNTxtWorkAddrDong.Text = sTmpWorkAddr;
					}
                    

					NBUtil.lstctrl_chk(WLRdoEmailAccept, drMemData["mailling_chk"].ToString());
                    
					if ( NBUtil.StrEmptyChk (drMemData["mempic_name"].ToString()) )
					{
						sOldMemPicName = "Common/Images/spare.gif";
						MemPic_Del.Visible = false;
					}
					else
						sOldMemPicName = "Common/DrawImage.aspx?bno=1000000&img=" + Server.UrlEncode(drMemData["mempic_name"].ToString()) + "&tf=0&iw=0&ih=0";

					if ( NBUtil.StrEmptyChk (drMemData["memsign_name"].ToString()) )
					{
						sOldMemSignName = "Common/Images/spare.gif";
						MemSign_Del.Visible = false;
					}
					else
						sOldMemSignName = "Common/DrawImage.aspx?bno=1000000&img=" + Server.UrlEncode(drMemData["memsign_name"].ToString()) + "&tf=0&iw=0&ih=0";

					if (HTTrPassFind.Visible)
					{
						NBCmnUtil.DdlLst_Chk (WNDdlPassFind_Q, drMemData["passfind_q"].ToString());
						WNTxtPassFind_A.Text = drMemData["passfind_a"].ToString();
					}
					
					chk_birthday_open.Checked = NBUtil.ConvStrToBool (drMemData["birthday_open"].ToString());
					chk_homeaddr_open.Checked = NBUtil.ConvStrToBool (drMemData["homeaddr_open"].ToString());
					chk_homepage_open.Checked = NBUtil.ConvStrToBool (drMemData["homepage_open"].ToString());
					chk_homephone_open.Checked = NBUtil.ConvStrToBool (drMemData["homephone_open"].ToString());
					chk_mem_email_open.Checked = NBUtil.ConvStrToBool (drMemData["mem_email_open"].ToString());
					chk_mem_name_open.Checked = NBUtil.ConvStrToBool (drMemData["mem_name_open"].ToString());
					chk_messenger_id_open.Checked = NBUtil.ConvStrToBool (drMemData["messenger_id_open"].ToString());
					chk_mobilephone_open.Checked = NBUtil.ConvStrToBool (drMemData["mobilephone_open"].ToString());
					chk_nick_name_open.Checked = NBUtil.ConvStrToBool (drMemData["nick_name_open"].ToString());
					chk_sex_open.Checked = NBUtil.ConvStrToBool (drMemData["sex_open"].ToString());
					chk_workaddr_open.Checked = NBUtil.ConvStrToBool (drMemData["workaddr_open"].ToString());
					chk_workphone_open.Checked = NBUtil.ConvStrToBool (drMemData["workphone_open"].ToString());

					
					if (NBUtil.ConvStrToBool (mBoardCfg.bnc_view_userlevel))
					{
						pbLevelUserStyle = "";

						if (drMemData.NextResult())
						{

							string sTmpGroupLevel = string.Empty;

							while (drMemData.Read())
							{
								sTmpGroupLevel += "<b>" + drMemData["group_name"].ToString() + "</b>그룹의 레벨은 <b>" + drMemData["level_name"].ToString() + "</b>입니다.<br>";
							}

							pbGroupLevelName = sTmpGroupLevel;
						}
					}
					else
					{
						pbLevelUserStyle = "style=\"display : none;\"";
					}
				}
				else
				{
					throw new Exception("회원정보를 가져오는 도중 오류가 발생하였습니다.");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewMsgGoBack (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}

		

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// 디자이너 지원에 필요한 메서드입니다.
		/// 이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{    
			this.WBBtnSave.Click += new ImageClickEventHandler(this.WBBtnSave_Click);
			this.Load += new EventHandler(this.Page_Load);

		}
		#endregion

		private void ButtonScript()
		{
			//WBBtnClose.Attributes.Add("onclick","location.href='" + NBUtil.GetBoardTransLink (mPageQryInfo.sBoardNo, "LIST") + "'; return false;");
			WBBtnSave.Attributes.Add("onclick","return NB_Join_Validation()");
		}

		private void FieldCheck()
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				SqlDataReader drJoinItemCfg = SqlHelper.ExecuteReader (dbSqlConn, CommandType.StoredProcedure, "nbsp_get_joinitem_cfg", null);

				if (drJoinItemCfg.Read())
				{
					HNHidNicknameUse.Value = drJoinItemCfg["nickname_use"].ToString();
					HNHidHomepgUse.Value = drJoinItemCfg["homepage_use"].ToString();
					HNHidJuminUse.Value = drJoinItemCfg["citizennum_use"].ToString();
					HNHidBirthdayUse.Value = drJoinItemCfg["birthday_use"].ToString();
					HNHidSexUse.Value = drJoinItemCfg["sex_use"].ToString();
					HNHidMobileTelUse.Value = drJoinItemCfg["mobilephone_use"].ToString();
					HNHidHomeTelUse.Value = drJoinItemCfg["homephone_use"].ToString();
					HNHidWorkTelUse.Value = drJoinItemCfg["workphone_use"].ToString();
					HNHidHomeZipUse.Value = drJoinItemCfg["homezip_use"].ToString();
					HNHidWorkZipUse.Value = drJoinItemCfg["workzip_use"].ToString();
					HNHidHomeAddrUse.Value = drJoinItemCfg["homeaddr_use"].ToString();
					HNHidWorkAddrUse.Value = drJoinItemCfg["workaddr_use"].ToString();
					HNHidEmailAcceptUse.Value = drJoinItemCfg["mailling_use"].ToString();
					HNHidMemPicUse.Value = drJoinItemCfg["mempic_use"].ToString();

					FieldControlSetting(HTTrNickname, WNLblNicknameUse, WNTxtNickname, drJoinItemCfg["nickname_use"].ToString());
					FieldControlSetting(HTTrMessenger, WNLblMessengerUse, WNTxtMessengerId, drJoinItemCfg["messenger_use"].ToString());
					FieldControlSetting(HTTrHomepage, WNLblHomepgUse, WNTxtHomepg, drJoinItemCfg["homepage_use"].ToString());
					FieldControlSetting(HTTrJumnNo, WNLblJuminUse, WNTxtJumnNo1, drJoinItemCfg["citizennum_use"].ToString());
					FieldControlSetting(HTTrJumnNo, WNLblJuminUse, WNTxtJumnNo2, drJoinItemCfg["citizennum_use"].ToString());
					FieldControlSetting(HTTrBirthDate, WNLblBirthdayUse, WNTxtBirthDate_Year, drJoinItemCfg["birthday_use"].ToString());
					FieldControlSetting(HTTrBirthDate, WNLblBirthdayUse, WNTxtBirthDate_Month, drJoinItemCfg["birthday_use"].ToString());
					FieldControlSetting(HTTrBirthDate, WNLblBirthdayUse, WNTxtBirthDate_Day, drJoinItemCfg["birthday_use"].ToString());
					FieldControlSetting(HTTrBirthDate, WNLblBirthdayUse, WLRdoLunarGubn, drJoinItemCfg["birthday_use"].ToString());
					FieldControlSetting(HTTrSexGubn, WNLblSexUse, WLRdoSexGubn, drJoinItemCfg["sex_use"].ToString());
					FieldControlSetting(HTTrMobileTel, WNLblMobileTelUse, WNTxtMobileTel, drJoinItemCfg["mobilephone_use"].ToString());
					FieldControlSetting(HTTrHomeTel, WNLblHomeTelUse, WNTxtHomeTel, drJoinItemCfg["homephone_use"].ToString());
					FieldControlSetting(HTTrWorkTel, WNLblWorkTelUse, WNTxtWorkTel, drJoinItemCfg["workphone_use"].ToString());
					FieldControlSetting(HTTrHomeZip, WNLblHomeZipUse, WNTxtHomeZipNo1, drJoinItemCfg["homezip_use"].ToString());
					FieldControlSetting(HTTrHomeZip, WNLblHomeZipUse, WNTxtHomeZipNo2, drJoinItemCfg["homezip_use"].ToString());
					FieldControlSetting(HTTrHomeAddr, WNLblHomeAddrUse, WNTxtHomeAddrDong, drJoinItemCfg["homeaddr_use"].ToString());
					FieldControlSetting(HTTrHomeAddr, WNLblHomeAddrUse, WNTxtHomeAddrDesc, drJoinItemCfg["homeaddr_use"].ToString());
					FieldControlSetting(HTTrWorkZip, WNLblWorkZipUse, WNTxtWorkZipNo1, drJoinItemCfg["workzip_use"].ToString());
					FieldControlSetting(HTTrWorkZip, WNLblWorkZipUse, WNTxtWorkZipNo2, drJoinItemCfg["workZip_use"].ToString());
					FieldControlSetting(HTTrWorkAddr, WNLblWorkAddrUse, WNTxtWorkAddrDong, drJoinItemCfg["workaddr_use"].ToString());
					FieldControlSetting(HTTrWorkAddr, WNLblWorkAddrUse, WNTxtWorkAddrDesc, drJoinItemCfg["workaddr_use"].ToString());
					FieldControlSetting(HTTrEmaliAccept, WNLblEmailAcceptUse, WLRdoEmailAccept, drJoinItemCfg["mailling_use"].ToString());
					FieldControlSetting(HTTrMemPic, WNLblMemPicUse, WNFileMemPic, drJoinItemCfg["mempic_use"].ToString());
					FieldControlSetting(HTTrMemPic, WNLblMemPicUse, WNFileMemSign, drJoinItemCfg["mempic_use"].ToString());

					//취소버튼 설정
					if (drJoinItemCfg["cancel_script"].ToString().Trim() == "")
						WBBtnClose.Attributes.Add("onclick","location.href='" + NBUtil.GetBoardTransLink (mPageQryInfo.sBoardNo, "LIST") + "'; return false;");
					else
						WBBtnClose.Attributes.Add("onclick",drJoinItemCfg["cancel_script"].ToString().Trim() + "; return false;");

					if (NBUtil.isUseChk(drJoinItemCfg["passfind_use"].ToString()))
					{
						DoPassFindBind(drJoinItemCfg["passfind_desc"].ToString());

						if (WNDdlPassFind_Q.Items.Count == 0)
						{
							HTTrPassFind.Visible = false;
						}
					}
					else
					{
						HTTrPassFind.Visible = false;
					}
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}

		private void DoPassFindBind(string sPassFindDesc)
		{
			if ( !NBUtil.StrEmptyChk (sPassFindDesc) )
			{
				string[] arrPassFindDesc = Regex.Split(sPassFindDesc, "\r\n");

				int nCnt = 0;
				int nSelIdx = -1;

				WNDdlPassFind_Q.SelectedIndex = nSelIdx;
                
				foreach (string sPassFindItem in arrPassFindDesc)
				{
					if ( !NBUtil.StrEmptyChk(sPassFindItem) )
					{
						string sItem = sPassFindItem;

						if (sItem.EndsWith("*"))
						{
							nSelIdx = nCnt;

							sItem = sItem.Remove (sItem.Length - 1, 1);
						}

						if (sItem.Length > 100)
							sItem = sItem.Substring(0, 100);

						WNDdlPassFind_Q.Items.Add (new ListItem(sItem, sItem));

						

						++nCnt;
					}
				}

				if (nSelIdx > -1)
				{
					WNDdlPassFind_Q.SelectedIndex = nSelIdx;
				}
			}
		}

		private void FieldControlSetting(HtmlTableRow HTTrField, Label lblCheckLabel, HtmlInputFile filMemFile, string sCheckValue)
		{
			//1:선택 + 수정가능, 2:필수 + 수정가능, 3:선택 + 수정불가, 4:필수 + 수정불가, 9:사용안함
			switch (sCheckValue)
			{
				case "1":
					break;
				case "2":
					lblCheckLabel.Font.Bold = true;
					break;
				case "3":
					filMemFile.Visible = false;
					break;
				case "4":
					lblCheckLabel.Font.Bold = true;
					filMemFile.Visible = false;
					break;
				case "9":
					HTTrField.Visible = false;
					break;
				default:
					break;
			}
		}

		private void FieldControlSetting(HtmlTableRow HTTrField, Label lblCheckLabel, TextBox txtCheckText, string sCheckValue)
		{
			//1:선택 + 수정가능, 2:필수 + 수정가능, 3:선택 + 수정불가, 4:필수 + 수정불가, 9:사용안함
			switch (sCheckValue)
			{
				case "1":
					break;
				case "2":
					lblCheckLabel.Font.Bold = true;
					break;
				case "3":
					txtCheckText.ReadOnly = true;
					txtCheckText.BackColor = Color.FromName("#F0F0F0");
					break;
				case "4":
					lblCheckLabel.Font.Bold = true;
					txtCheckText.ReadOnly = true;
					txtCheckText.BackColor = Color.FromName("#F0F0F0");
					break;
				case "9":
					HTTrField.Visible = false;
					break;
				default:
					break;
			}
		}

		private void FieldControlSetting(HtmlTableRow HTTrField, Label lblCheckLabel, RadioButtonList optCheckRadio, string sCheckValue)
		{
			//1:필수항목,2:수정가능,3:필수 + 수정
			//1:선택 + 수정가능, 2:필수 + 수정가능, 3:선택 + 수정불가, 4:필수 + 수정불가, 9:사용안함
			switch (sCheckValue)
			{
				case "1":
					break;
				case "2":
					lblCheckLabel.Font.Bold = true;
					break;
				case "3":
					optCheckRadio.Enabled = false;
					break;
				case "4":
					lblCheckLabel.Font.Bold = true;
					optCheckRadio.Enabled = false;
					break;
				case "9":
					HTTrField.Visible = false;
					break;
				default:
					break;
			}
		}

		

		private bool DoInputValidChk()
		{
			// 가입 추가 항목 검사
			string sItemValue = string.Empty;
			string sItemUse = string.Empty;
			string sItemName = string.Empty;
				
			string sAddItemCtrlName = hid_add_ctrl.Value;

			if (!NBUtil.StrEmptyChk(sAddItemCtrlName))
			{
				string[] arrAddItemCtrlName = sAddItemCtrlName.Split('|');

				foreach (string sCtrlName in arrAddItemCtrlName)
				{
					Control objCtrl = null;

					if (!NBUtil.StrEmptyChk(sCtrlName))
					{
						objCtrl = FindControl(sCtrlName);
					}

					if (objCtrl != null && objCtrl.ID != null)
					{
						string[] objIDs = objCtrl.ID.Split('_');
						string sAddItemCode = DBUtil.QryConvStr(objIDs[objIDs.Length - 2], false);

						switch (objIDs[objIDs.Length - 1].Trim())
						{
							case "01":
								// TextBox
								TextBox tmpCtrl_txt = (TextBox)objCtrl;
								sItemUse = tmpCtrl_txt.Attributes["ItemUse"];
								sItemName = tmpCtrl_txt.Attributes["ItemName"];

								if (sItemUse.Equals("2") || sItemUse.Equals("4"))
								{
									if (NBUtil.StrEmptyChk(tmpCtrl_txt.Text))
									{
										NBCmnUtil.ViewAlertMsg (Page, sItemName + " 을/를 입력해 주세요.");

										return true;
									}
								}
								
								break;
							case "02":
								// DropDownList
								DropDownList tmpCtrl_ddl = (DropDownList)objCtrl;
								sItemUse = tmpCtrl_ddl.Attributes["ItemUse"];
								sItemName = tmpCtrl_ddl.Attributes["ItemName"];

								if (sItemUse.Equals("2") || sItemUse.Equals("4"))
								{
									if (tmpCtrl_ddl.SelectedIndex < 0)
									{
										NBCmnUtil.ViewAlertMsg (Page, sItemName + " 을/를 선택해 주세요.");

										return true;
									}
								}

								break;
							case "03":
								// RadioButton
								RadioButtonList tmpCtrl_rdo = (RadioButtonList)objCtrl;
								sItemUse = tmpCtrl_rdo.Attributes["ItemUse"];
								sItemName = tmpCtrl_rdo.Attributes["ItemName"];

								if (sItemUse.Equals("2") || sItemUse.Equals("4"))
								{
									if (tmpCtrl_rdo.SelectedIndex < 0)
									{
										NBCmnUtil.ViewAlertMsg (Page, sItemName + " 을/를 선택해 주세요.");

										return true;
									}
								}

								break;
							case "04":
								// CheckBox
								CheckBoxList tmpCtrl_chk = (CheckBoxList)objCtrl;
								sItemUse = tmpCtrl_chk.Attributes["ItemUse"];
								sItemName = tmpCtrl_chk.Attributes["ItemName"];

								if (sItemUse.Equals("2") || sItemUse.Equals("4"))
								{
									if (tmpCtrl_chk.SelectedIndex < 0)
									{
										NBCmnUtil.ViewAlertMsg (Page, sItemName + " 을/를 하나 이상 선택해 주세요.");

										return true;
									}
								}

								break;
							case "05":
								// TextArea
								TextBox tmpCtrl_mtxt = (TextBox)objCtrl;
								sItemUse = tmpCtrl_mtxt.Attributes["ItemUse"];
								sItemName = tmpCtrl_mtxt.Attributes["ItemName"];

								if (sItemUse.Equals("2") || sItemUse.Equals("4"))
								{
									if (NBUtil.StrEmptyChk(tmpCtrl_mtxt.Text))
									{
										NBCmnUtil.ViewAlertMsg (Page, sItemName + " 을/를 입력해 주세요.");

										return true;
									}
								}
								
								break;
							case "06":
								// Password
								TextBox tmpCtrl_ptxt = (TextBox)objCtrl;
								sItemUse = tmpCtrl_ptxt.Attributes["ItemUse"];
								sItemName = tmpCtrl_ptxt.Attributes["ItemName"];

								if (sItemUse.Equals("2") || sItemUse.Equals("4"))
								{
									if (NBUtil.StrEmptyChk(tmpCtrl_ptxt.Text))
									{
										NBCmnUtil.ViewAlertMsg (Page, sItemName + " 을/를 입력해 주세요.");

										return true;
									}
								}

								break;
							default:
								break;
						}                						
					}
				}
			}


			return false;
		}


		private void WBBtnSave_Click(object sender, ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;

			try
			{
				if (DoInputValidChk())
					return;

				DBUtil.DBConnection (ref dbSqlConn);

				#region 회원 이미지 처리
				// 회원 이미지 업로드 (파일 업로드 했으면 파일 업로드)
				string sMemPicPath = NBUtil.GetUploadRootPath () + "\\NB_MemPic";
				string sOldPicFile = string.Empty;
				string sOldSignFile = string.Empty;
				string sMemPicUp = "NONE";
				string sMemSignUp = "NONE";
                
				string sQry = "SELECT mempic_name, memsign_name FROM NB_MemberData WHERE guest_no = " +DBUtil.QryConvStr (pbGuestNo, false);

                SqlDataReader drMemPics = SqlHelper.ExecuteReader (dbSqlConn, CommandType.Text, sQry);

				if (drMemPics.Read())
				{
					sOldPicFile = drMemPics["mempic_name"].ToString();
					sOldSignFile = drMemPics["memsign_name"].ToString();
				}

                drMemPics.Close();
                dbSqlConn.Close();

				if (MemPic_Del.Checked)
				{
                    NBUtil.FileDelete (Path.GetFileName(sOldPicFile), sMemPicPath);
					sMemPicUp = string.Empty;
				}
				else
				{
					if ( !NBUtil.StrEmptyChk (WNFileMemPic.Value) && HNHidMemPicValidChk.Value.Equals("1") )
					{
						NBUtil.FileDelete (Path.GetFileName(sOldPicFile), sMemPicPath);
						sMemPicUp = NBUtil.FileUpload (WNFileMemPic.PostedFile, sMemPicPath);
					}
				}

				if (MemSign_Del.Checked)
				{
					NBUtil.FileDelete (Path.GetFileName(sOldSignFile), sMemPicPath);
					sMemSignUp = string.Empty;
				}
				else
				{
					if ( !NBUtil.StrEmptyChk (WNFileMemSign.Value) )
					{
						NBUtil.FileDelete (Path.GetFileName(sOldSignFile), sMemPicPath);
						sMemSignUp = NBUtil.FileUpload (WNFileMemSign.PostedFile, sMemPicPath);
					}
				}
				#endregion

				int nTmpParmCnt = 0;

				string
					parmHomeZip = string.Empty,
					parmWorkZip = string.Empty,
					parmHomeAddr = string.Empty,
					parmWorkAddr = string.Empty,
					parmPassFindQ = string.Empty,
					parmMemPicUp = string.Empty,
					parmMemSignUp = string.Empty;

				if ( HTTrPassFind.Visible && WNDdlPassFind_Q.SelectedIndex > -1 )
					parmPassFindQ = WNDdlPassFind_Q.SelectedValue;

				if (HNHidHomeZipUse.Value.Equals("1") || HNHidHomeZipUse.Value.Equals("2"))
					parmHomeZip = WNTxtHomeZipNo1.Text.Trim() + "-" + WNTxtHomeZipNo2.Text.Trim();

				if (HNHidWorkZipUse.Value.Equals("1") || HNHidWorkZipUse.Value.Equals("2"))
					parmWorkZip = WNTxtWorkZipNo1.Text.Trim() + "-" + WNTxtWorkZipNo2.Text.Trim();

				if (HNHidHomeAddrUse.Value.Equals("1") || HNHidHomeAddrUse.Value.Equals("2"))
					parmHomeAddr = WNTxtHomeAddrDong.Text.Trim() + " " + WNTxtHomeAddrDesc.Text.Trim();

				if (HNHidWorkAddrUse.Value.Equals("1") || HNHidWorkAddrUse.Value.Equals("2"))
					parmWorkAddr = WNTxtWorkAddrDong.Text.Trim() + " " + WNTxtWorkAddrDesc.Text.Trim();

				if (!NBUtil.StrEmptyChk (sMemPicUp))
					parmMemPicUp = Path.GetFileName(sMemPicUp);

				if (!NBUtil.StrEmptyChk (sMemSignUp))
					parmMemSignUp = Path.GetFileName(sMemSignUp);

				SqlParameter[] sqlParm = new SqlParameter[39];
				sqlParm[nTmpParmCnt] = new SqlParameter("@edit_mode", "2");
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@guest_no", pbGuestNo);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mem_id", "");
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mem_pwd", WNTxtLoginPwd.Text);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mem_name", WNTxtMbName.Text);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mem_email", WNTxtEmail.Text);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@nick_name", WNTxtNickname.Text);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@messenger_type", WNDdlMessengerType.SelectedValue);// 7
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@messenger_id", WNTxtMessengerId.Text);// 8
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homepage", WNTxtHomepg.Text);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@citizennum", WNTxtJumnNo1.Text + "-" + WNTxtJumnNo2.Text);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@birthday", WNTxtBirthDate_Year.Text + "." + WNTxtBirthDate_Month.Text + "." + WNTxtBirthDate_Day.Text);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@lunar_use", WLRdoLunarGubn.SelectedValue);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@sex", WLRdoSexGubn.SelectedItem.Value);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mobilephone", WNTxtMobileTel.Text);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homephone", WNTxtHomeTel.Text);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@workphone", WNTxtWorkTel.Text);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homezip", parmHomeZip);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homeaddr", parmHomeAddr);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@workzip", parmWorkZip);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@workaddr", parmWorkAddr);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@passfind_q", parmPassFindQ);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@passfind_a", WNTxtPassFind_A.Text);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@point_num", 0);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mailling_chk", WLRdoEmailAccept.SelectedValue);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mempic_name", parmMemPicUp);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@memsign_name", parmMemSignUp);
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mem_name_open", NBUtil.ConvBoolToStr (chk_mem_name_open.Checked));// 27
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mem_email_open", NBUtil.ConvBoolToStr (chk_mem_email_open.Checked));// 28
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@nick_name_open", NBUtil.ConvBoolToStr (chk_nick_name_open.Checked));// 29
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@messenger_id_open", NBUtil.ConvBoolToStr (chk_messenger_id_open.Checked));// 30
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homepage_open", NBUtil.ConvBoolToStr (chk_homepage_open.Checked));// 31
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@birthday_open", NBUtil.ConvBoolToStr (chk_birthday_open.Checked));// 32
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@sex_open", NBUtil.ConvBoolToStr (chk_sex_open.Checked));// 33
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mobilephone_open", NBUtil.ConvBoolToStr (chk_mobilephone_open.Checked));// 34
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homephone_open", NBUtil.ConvBoolToStr (chk_homephone_open.Checked));// 35
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@workphone_open", NBUtil.ConvBoolToStr (chk_workphone_open.Checked));// 36
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homeaddr_open", NBUtil.ConvBoolToStr (chk_homeaddr_open.Checked));// 37
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@workaddr_open", NBUtil.ConvBoolToStr (chk_workaddr_open.Checked));// 38


				SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.StoredProcedure, "nbsp_join_member", sqlParm);

				string Qry = NBUtil.AddItemSaveQry(pbGuestNo, hid_add_ctrl, this);

				if (!NBUtil.StrEmptyChk(Qry))
                    SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, Qry);

                NBCmnUtil.ViewMsgGoUrl (Page, NBUtil.GetBoardTransLink (mPageQryInfo.sBoardNo, "LIST"), "회원정보가 수정되었습니다.");
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewMsgGoBack (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}		
		}
	}
}
