using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using BoardLib;
using NeBoard.Common;

namespace NeBoard
{
	/// <summary>
	/// NeBoardPlayList   Դϴ.
	/// </summary>
	public class NeBoardPlayList : System.Web.UI.Page
	{
		protected System.Web.UI.HtmlControls.HtmlTable HTTblPlayList;

		private string sBoardNo = "";
		private string sSongFile = "";
		private string sSongName = "";
		private string sSinger = "";
		private string sMusicIdx = "";
		private string sPlayIdx = "";

		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				InitDataLoad();
				PlayListBind();
			}
			catch(Exception E)
			{
				Response.Clear();
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}

		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion


		private void InitDataLoad()
		{
			sBoardNo = NBCmnUtil.FStrLoad("hidBoardNo").Trim();
			sSongFile = NBCmnUtil.FStrLoad("hidSongFile").Trim();
			sSongName = NBCmnUtil.FStrLoad("hidSongName").Trim();
			sSinger = NBCmnUtil.FStrLoad("hidSinger").Trim();
			sMusicIdx = NBCmnUtil.FStrLoad("hidMusicIdx").Trim();
			sPlayIdx = NBCmnUtil.FStrLoad("hidPlayIdx").Trim();
		}


		private void PlayListBind()
		{
			string[] aSongFileSplit = sSongFile.Split(';');
			string[] aSongNameSplit = sSongName.Split(';');
			string[] aSingerSplit = sSinger.Split(';');
			string[] aMusicIdxSplit = sMusicIdx.Split(';');
			int nCurrIdx = int.Parse(sPlayIdx);

			HTTblPlayList.Rows.Clear();

			for (int i = 0; i < aMusicIdxSplit.Length; i++)
			{
				int nSelIdx = int.Parse(aMusicIdxSplit[i].Trim());

				HtmlTableRow oTR = new HtmlTableRow();
				HtmlTableCell oTD_Play = new HtmlTableCell();
				HtmlTableCell oTD_Title = new HtmlTableCell();
				HtmlTableCell oTD_Button = new HtmlTableCell();

				string sDispSongName = string.Empty;
				string sDispSingerName = string.Empty;

                if (NBUtil.StrEmptyChk(aSongNameSplit[nSelIdx]))
					sDispSongName = aSongFileSplit[i].Split('|')[2];
				else
                    sDispSongName = aSongNameSplit[nSelIdx];

				if (NBUtil.StrEmptyChk(aSingerSplit[nSelIdx]))
					sDispSingerName = " ";
				else
					sDispSingerName = aSingerSplit[nSelIdx];
				
				oTD_Title.Attributes["class"] = "music_list_subject";
				oTD_Title.InnerHtml = "<NOBR style=\"width:285px;DISPLAY: block; OVERFLOW: hidden;\">" + (i == nCurrIdx ? "<font color='#C0E0FF'><b></b></font>&nbsp;":"&nbsp;&nbsp;&nbsp;") + sDispSongName + " - <font class=\"music_list_artist\">" + sDispSingerName + "</font></NOBR>";
				oTD_Button.Attributes["class"] = "listen_icon_right";
				oTD_Button.InnerHtml = "<img src=\"images/icon_listen.gif\" width=\"40\" height=\"18\" border=\"0\" onclick=\"PlayMusic('" + i.ToString() + "')\" style=\"cursor:hand\">";
				
				oTR.Cells.Add(oTD_Title);
				oTR.Cells.Add(oTD_Button);

				HTTblPlayList.Rows.Add(oTR);

				//Seperator
				HtmlTableRow oTR_Sep = new HtmlTableRow();
				HtmlTableCell oTD_Sep = new HtmlTableCell();

				oTD_Sep.ColSpan = 2;
				oTD_Sep.Height = "1";
				oTD_Sep.Attributes["background"] = "images/dotline_01.gif";

				oTR_Sep.Cells.Add(oTD_Sep);
				
				HTTblPlayList.Rows.Add(oTR_Sep);
			}
		}
	}
}
