using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.IO;
using BoardLib;
using NeBoard.Common;

namespace NeBoard
{
	public class NeBoardPlayer : System.Web.UI.Page
	{
		protected System.Web.UI.HtmlControls.HtmlInputHidden HNHidBoardNo;
		protected System.Web.UI.HtmlControls.HtmlInputHidden HNHidSongName;
		protected System.Web.UI.HtmlControls.HtmlInputHidden HNHidSinger;
		protected System.Web.UI.HtmlControls.HtmlInputHidden HNHidSongFile;

		private string sBoardNo = string.Empty;
		private string sMFileInfo = string.Empty;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			try
			{
				InitDataLoad();
				MusicFileInfoBind();
			}
			catch(Exception E)
			{
				Response.Clear();
				NBCmnUtil.ViewMsgAndClose (Page, E.Message);
			}

		}

		#region Web Form ̳ʿ  ڵ
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion


		private void InitDataLoad()
		{
			sBoardNo = NBCmnUtil.QStrLoad ("bno");	
			//Խùε#ε;Խùε#ε;...
			sMFileInfo = Server.UrlDecode(NBCmnUtil.QStrLoad ("mfile"));

			if (NBUtil.StrEmptyChk (sBoardNo) || NBUtil.StrEmptyChk (sMFileInfo))
			{
				throw new Exception ("   ϴ.");
			}
		}

		private void MusicFileInfoBind()
		{
			try
			{
				string[] aFileInfo = sMFileInfo.Split(';');

                StringWriter Qry = new StringWriter();
				
                Qry.Write ("SELECT idx_no, fidx_no, file_name + file_ext as file_name, file_desc ");
				Qry.Write ("FROM NB_FileData_" + sBoardNo.Trim().Replace("'","''"));
				Qry.Write (" WHERE CONVERT(VARCHAR, idx_no) + '#' + CONVERT(VARCHAR, fidx_no) IN (''");
				
				for (int i = 0; i < aFileInfo.Length; i++)
					Qry.Write (",'" + aFileInfo[i].Trim().Replace("'","''") + "'");

				Qry.WriteLine (") ORDER BY idx_no DESC, fidx_no DESC");

				DataTable dtFileList = DBUtil.RunDBToDataTable (CommandType.Text, Qry.ToString());

				if (dtFileList.Rows.Count > 0)
				{
					string 
						sFileList = string.Empty,
						sSongName = string.Empty,
                        sSinger = string.Empty;

					foreach (DataRow drRow in dtFileList.Rows)
					{
						if (!NBUtil.StrEmptyChk(drRow["file_name"].ToString()))
						{
							if (Path.GetExtension (drRow["file_name"].ToString()).ToUpper().Equals(".MP3") ||
								Path.GetExtension (drRow["file_name"].ToString()).ToUpper().Equals(".ASF") ||
								Path.GetExtension (drRow["file_name"].ToString()).ToUpper().Equals(".WMA") ||
								Path.GetExtension (drRow["file_name"].ToString()).ToUpper().Equals(".OGG"))
							{

								sFileList += ";" + drRow["idx_no"].ToString().Trim() + "|" + drRow["fidx_no"].ToString().Trim() + "|" + drRow["file_name"].ToString().Trim().Replace("'","\\'").Replace("\"", "\\\"");
								string[] aTmpSongInfo = drRow["file_desc"].ToString().Trim().Split('|');
								sSongName += ";" + aTmpSongInfo[0].Trim().Replace("'","\\'").Replace("\"", "\\\"");
								if (aTmpSongInfo.Length > 1)
									sSinger += ";" + aTmpSongInfo[1].Trim().Replace("'","\\'").Replace("\"", "\\\"");
								else
									sSinger += ";";
							}
						}
					}
					
					if (!NBUtil.StrEmptyChk(sFileList))
					{
						HNHidBoardNo.Value = sBoardNo.Trim();
						HNHidSongFile.Value = sFileList.Substring(1);
						HNHidSongName.Value = sSongName.Substring(1);
						HNHidSinger.Value = sSinger.Substring(1);
					}
				}
				else
				{
					throw new Exception(@"     ߽ϴ.");
				}
			}
			catch(Exception E)
			{
				throw E;
			}
		}
	}
}
