﻿using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.IO;
using System.Text.RegularExpressions;
using BoardLib;

namespace NeBoard
{
	public abstract class Signup : UserControl
	{
		#region Controls
		protected Label WNLblPwdReq;
		protected Label WNLblPwdCfmReq;
		protected Label WNLblMbNameReq;
		protected Label WNLblEmailReq;
		protected Label WNLblNicknameUse;
		protected Label WNLblHomepgUse;
		protected Label WNLblJuminUse;
		protected Label WNLblSexUse;
		protected Label WNLblBirthdayUse;
		protected Label WNLblMobileTelUse;
		protected Label WNLblHomeTelUse;
		protected Label WNLblWorkTelUse;
		protected Label WNLblHomeZipUse;
		protected Label WNLblHomeAddrUse;
		protected Label WNLblWorkZipUse;
		protected Label WNLblWorkAddrUse;
		protected Label WNLblEmailAcceptUse;
		protected Label WNLblMemPicUse;
		protected Label WNLblMessengerUse;

		protected TextBox WNTxtLoginId;
		protected TextBox WNTxtLoginPwd;
		protected TextBox WNTxtPwdConfirm;
		protected TextBox WNTxtMbName;
		protected TextBox WNTxtEmail;
		protected TextBox WNTxtNickname;
		protected TextBox WNTxtHomepg;
		protected TextBox WNTxtJumnNo1;
		protected TextBox WNTxtJumnNo2;
		protected TextBox WNTxtBirthDate_Year;
		protected TextBox WNTxtBirthDate_Month;
		protected TextBox WNTxtBirthDate_Day;
		protected TextBox WNTxtMobileTel;
		protected TextBox WNTxtHomeTel;
		protected TextBox WNTxtWorkTel;
		protected TextBox WNTxtHomeZipNo1;
		protected TextBox WNTxtHomeZipNo2;
		protected TextBox WNTxtHomeAddrDong;
		protected TextBox WNTxtHomeAddrDesc;
		protected TextBox WNTxtWorkZipNo1;
		protected TextBox WNTxtWorkZipNo2;
		protected TextBox WNTxtWorkAddrDong;
		protected TextBox WNTxtWorkAddrDesc;
		protected HtmlInputFile WNFileMemPic;
		protected HtmlInputFile WNFileMemSign;
		protected DropDownList WNDdlPassFind_Q;
		protected TextBox WNTxtPassFind_A;
		protected DropDownList WNDdlMessengerType;
		protected TextBox WNTxtMessengerId;
		protected RadioButtonList WLRdoSexGubn;
		protected RadioButtonList WLRdoLunarGubn;
		protected RadioButtonList WLRdoEmailAccept;

		protected CheckBox chk_mem_name_open;
		protected CheckBox chk_mem_email_open;
		protected CheckBox chk_nick_name_open;
		protected CheckBox chk_messenger_id_open;
		protected CheckBox chk_homepage_open;
		protected CheckBox chk_sex_open;
		protected CheckBox chk_birthday_open;
		protected CheckBox chk_mobilephone_open;
		protected CheckBox chk_homephone_open;
		protected CheckBox chk_workphone_open;
		protected CheckBox chk_homeaddr_open;
		protected CheckBox chk_workaddr_open;

		protected ImageButton WBBtnSave;
		protected ImageButton WBBtnClose;
		protected HtmlTableRow HTTrNickname;
		protected HtmlTableRow HTTrHomepage;
		protected HtmlTableRow HTTrJumnNo;
		protected HtmlTableRow HTTrSexGubn;
		protected HtmlTableRow HTTrBirthDate;
		protected HtmlTableRow HTTrMobileTel;
		protected HtmlTableRow HTTrHomeTel;
		protected HtmlTableRow HTTrWorkTel;
		protected HtmlTableRow HTTrHomeZip;
		protected HtmlTableRow HTTrHomeAddr;
		protected HtmlTableRow HTTrWorkZip;
		protected HtmlTableRow HTTrWorkAddr;
		protected HtmlTableRow HTTrEmaliAccept;
		protected HtmlTableRow HTTrMemPic;
		protected HtmlTableRow HTTrPassFind;
		protected HtmlTableRow HTTrMessenger;
		protected HtmlInputHidden HNHidMbNo;
		protected HtmlInputHidden HNHidNicknameUse;
		protected HtmlInputHidden HNHidHomepgUse;
		protected HtmlInputHidden HNHidJuminUse;
		protected HtmlInputHidden HNHidBirthdayUse;
		protected HtmlInputHidden HNHidSexUse;
		protected HtmlInputHidden HNHidMobileTelUse;
		protected HtmlInputHidden HNHidHomeTelUse;
		protected HtmlInputHidden HNHidWorkTelUse;
		protected HtmlInputHidden HNHidHomeZipUse;
		protected HtmlInputHidden HNHidWorkZipUse;
		protected HtmlInputHidden HNHidHomeAddrUse;
		protected HtmlInputHidden HNHidWorkAddrUse;
		protected HtmlInputHidden HNHidEmailAcceptUse;
		protected HtmlInputHidden HNHidMemPicUse;
		protected HtmlInputHidden HNHidMessengerUse;

		protected HtmlInputHidden HNHidIDValidChk;
		protected HtmlInputHidden HNHidMemPicValidChk;
		protected HtmlInputHidden hid_add_ctrl;
		
		protected LinkButton LnkCheckUserId;

		protected HtmlTable tbl_join_main;
		#endregion

		private string mJoinIdLimit;
		private string mJoinAfterUrl;

		private NBLib.PageQryStr mPageQryInfo;
		private NBLib.CurBoardCfg mBoardCfg;
		
		public string BoardTitleContent;

		public string
			gBoardNo,					// 게시판 코드
			gViewMode;					// 게시판 작동 모드

		public string BoardNo
		{
			set
			{
				gBoardNo = value;
			}

			get
			{
				return gBoardNo;
			}
		}

		public string ViewMode
		{
			set
			{
				gViewMode = value;
			}

			get
			{
				return gViewMode;
			}
		}
		
		private void Page_Load(object sender, EventArgs e)
		{
			try
			{
				if (!nb_utils.GetGlobalValue (ref mPageQryInfo, ref mBoardCfg, gBoardNo, gViewMode))
					return;

				ButtonScript();

				NBUtil.SetDisplayType(ref BoardTitleContent, mBoardCfg.bjd_jointitle_view, mBoardCfg.bjd_jointitle_cont);

				FieldCheck();

				NBUtil.AddMemberInfoBind("", hid_add_ctrl, tbl_join_main, false);
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: 이 호출은 ASP.NET Web Form 디자이너에 필요합니다.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		디자이너 지원에 필요한 메서드입니다.
		///		이 메서드의 내용을 코드 편집기로 수정하지 마십시오.
		/// </summary>
		private void InitializeComponent()
		{
			this.WBBtnSave.Click += new ImageClickEventHandler(this.WBBtnSave_Click);
			this.LnkCheckUserId.Click += new EventHandler(this.LnkCheckUserId_Click);
			this.Load += new EventHandler(this.Page_Load);
		}
		#endregion

		/// <summary>
		/// 버튼의 스크립트 생성
		/// </summary>
		private void ButtonScript()
		{
			//WBBtnClose.Attributes.Add("onclick","location.href='" + NBUtil.GetBoardTransLink (mPageQryInfo.sBoardNo, "LIST") + "'; return false;");
			WBBtnSave.Attributes.Add("onclick","return NB_Join_Validation()");
		}

		private void FieldCheck()
		{
			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				SqlDataReader drJoinItem = SqlHelper.ExecuteReader (dbSqlConn, CommandType.StoredProcedure, "nbsp_get_joinitem_cfg", null);

				if (drJoinItem.Read())
				{
					HNHidNicknameUse.Value = drJoinItem["nickname_use"].ToString();
					HNHidMessengerUse.Value = drJoinItem["messenger_use"].ToString();
					HNHidHomepgUse.Value = drJoinItem["homepage_use"].ToString();
					HNHidJuminUse.Value = drJoinItem["citizennum_use"].ToString();
					HNHidBirthdayUse.Value = drJoinItem["birthday_use"].ToString();
					HNHidSexUse.Value = drJoinItem["sex_use"].ToString();
					HNHidMobileTelUse.Value = drJoinItem["mobilephone_use"].ToString();
					HNHidHomeTelUse.Value = drJoinItem["homephone_use"].ToString();
					HNHidWorkTelUse.Value = drJoinItem["workphone_use"].ToString();
					HNHidHomeZipUse.Value = drJoinItem["homezip_use"].ToString();
					HNHidWorkZipUse.Value = drJoinItem["workzip_use"].ToString();
					HNHidHomeAddrUse.Value = drJoinItem["homeaddr_use"].ToString();
					HNHidWorkAddrUse.Value = drJoinItem["workaddr_use"].ToString();
					HNHidEmailAcceptUse.Value = drJoinItem["mailling_use"].ToString();
					HNHidMemPicUse.Value = drJoinItem["mempic_use"].ToString();
					mJoinAfterUrl = drJoinItem["afterjoin_url"].ToString();
					mJoinIdLimit = drJoinItem["joinid_limit"].ToString();

					FieldControlSetting(HTTrNickname, WNLblNicknameUse, drJoinItem["nickname_use"].ToString());
					FieldControlSetting(HTTrMessenger, WNLblMessengerUse, drJoinItem["messenger_use"].ToString());
					FieldControlSetting(HTTrHomepage, WNLblHomepgUse, drJoinItem["homepage_use"].ToString());
					FieldControlSetting(HTTrJumnNo, WNLblJuminUse, drJoinItem["citizennum_use"].ToString());
					FieldControlSetting(HTTrBirthDate, WNLblBirthdayUse, drJoinItem["birthday_use"].ToString());
					FieldControlSetting(HTTrSexGubn, WNLblSexUse, drJoinItem["sex_use"].ToString());
					FieldControlSetting(HTTrMobileTel, WNLblMobileTelUse, drJoinItem["mobilephone_use"].ToString());
					FieldControlSetting(HTTrHomeTel, WNLblHomeTelUse, drJoinItem["homephone_use"].ToString());
					FieldControlSetting(HTTrWorkTel, WNLblWorkTelUse, drJoinItem["workphone_use"].ToString());
					FieldControlSetting(HTTrHomeZip, WNLblHomeZipUse, drJoinItem["homezip_use"].ToString());
					FieldControlSetting(HTTrHomeAddr, WNLblHomeAddrUse, drJoinItem["homeaddr_use"].ToString());
					FieldControlSetting(HTTrWorkZip, WNLblWorkZipUse, drJoinItem["workzip_use"].ToString());
					FieldControlSetting(HTTrWorkAddr, WNLblWorkAddrUse, drJoinItem["workaddr_use"].ToString());
					FieldControlSetting(HTTrEmaliAccept, WNLblEmailAcceptUse, drJoinItem["mailling_use"].ToString());
					FieldControlSetting(HTTrMemPic, WNLblMemPicUse, drJoinItem["mempic_use"].ToString());

					//취소버튼 설정
					if (drJoinItem["cancel_script"].ToString().Trim() == "")
						WBBtnClose.Attributes.Add("onclick","location.href='" + NBUtil.GetBoardTransLink (mPageQryInfo.sBoardNo, "LIST") + "'; return false;");
					else
						WBBtnClose.Attributes.Add("onclick",drJoinItem["cancel_script"].ToString().Trim() + "; return false;");

					if (NBUtil.isUseChk(drJoinItem["passfind_use"].ToString()))
					{
						DoPassFindBind(drJoinItem["passfind_desc"].ToString());

						if (WNDdlPassFind_Q.Items.Count == 0)
							HTTrPassFind.Visible = false;
					}
					else
						HTTrPassFind.Visible = false;
				}
				else
				{
					throw new Exception ("회원 가입 항목 설정을 읽어올 수 없습니다.");
				}
			}
			catch(Exception E)
			{
				throw E;
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}

		private void DoPassFindBind(string sPassFindDesc)
		{
			if ( !NBUtil.StrEmptyChk (sPassFindDesc) )
			{
				string[] arrPassFindDesc = Regex.Split(sPassFindDesc, "\r\n");

				int nCnt = 0;
				int nSelIdx = -1;

				WNDdlPassFind_Q.SelectedIndex = nSelIdx;
                
				foreach (string sPassFindItem in arrPassFindDesc)
				{
					if ( !NBUtil.StrEmptyChk(sPassFindItem) )
					{
						string sItem = sPassFindItem;

						if (sItem.EndsWith("*"))
						{
                            nSelIdx = nCnt;

                            sItem = sItem.Remove (sItem.Length - 1, 1);
						}

						if (sItem.Length > 100)
							sItem = sItem.Substring(0, 100);

						WNDdlPassFind_Q.Items.Add (new ListItem(sItem, sItem));

						

						++nCnt;
					}
				}

				if (nSelIdx > -1)
				{
					WNDdlPassFind_Q.SelectedIndex = nSelIdx;
				}
			}
		}

		private void FieldControlSetting(HtmlTableRow HTTrField, Label lblCheckLabel, string sCheckValue)
		{
			//1:선택 + 수정가능, 2:필수 + 수정가능, 3:선택 + 수정불가, 4:필수 + 수정불가, 9:사용안함
			switch (sCheckValue)
			{
				case "2":
				case "4":
					if (lblCheckLabel != null)
                        lblCheckLabel.Font.Bold = true;
					break;
				case "9":
				case "0":
					HTTrField.Visible = false;
					break;
				default:
					break;
			}
		}

		
		private bool DoJoinIDLimitChk()
		{
			bool bResult = false;

			string sTxtLoginID = WNTxtLoginId.Text.Trim();

			if (!NBUtil.StrEmptyChk(mJoinIdLimit) && !NBUtil.StrEmptyChk (sTxtLoginID))
			{
				string[] arrIDLimit = mJoinIdLimit.Split(';');
				
				foreach (string sLimitItem in arrIDLimit)
				{
					if (!NBUtil.StrEmptyChk (sLimitItem))
					{
						if (sLimitItem.StartsWith("*") && sLimitItem.EndsWith("*"))
						{
							if (sTxtLoginID.IndexOf (sLimitItem.Remove (sLimitItem.Length - 1, 1).Remove(0, 1).Trim()) > -1)
							{
                                bResult = true;								
							}
						}
						else if (sLimitItem.StartsWith("*"))
						{
							if (sTxtLoginID.EndsWith (sLimitItem.Remove (0, 1)))
							{
								bResult = true;
							}
						}
						else if (sLimitItem.EndsWith("*"))
						{
							if (sTxtLoginID.StartsWith (sLimitItem.Remove (sLimitItem.Length - 1, 1)))
							{
								bResult = true;
							}
						}
						else
						{
							if (sTxtLoginID.Equals(sLimitItem.Trim()))
							{
								bResult = true;
							}
						}

						if (bResult)
						{
							NBCmnUtil.ViewAlertMsg (Page, "입력하신 아이디 \"" + sTxtLoginID + "\"는(은) 사용할 수 없습니다.");
							break;
						}
					}
				}
			}

			return bResult;
		}


		private bool DoInputValidChk()
		{
			if (DoJoinIDLimitChk())
				return true;

			// 가입 추가 항목 검사
			string sItemValue = string.Empty;
			string sItemUse = string.Empty;
			string sItemName = string.Empty;
				
			string sAddItemCtrlName = hid_add_ctrl.Value;

			if (!NBUtil.StrEmptyChk(sAddItemCtrlName))
			{
				string[] arrAddItemCtrlName = sAddItemCtrlName.Split('|');

				foreach (string sCtrlName in arrAddItemCtrlName)
				{
					Control objCtrl = null;

					if (!NBUtil.StrEmptyChk(sCtrlName))
					{
						objCtrl = FindControl(sCtrlName);
					}

					if (objCtrl != null && objCtrl.ID != null)
					{
						string[] objIDs = objCtrl.ID.Split('_');
						string sAddItemCode = DBUtil.QryConvStr(objIDs[objIDs.Length - 2], false);

						switch (objIDs[objIDs.Length - 1].Trim())
						{
							case "01":
								// TextBox
								TextBox tmpCtrl_txt = (TextBox)objCtrl;
								sItemUse = tmpCtrl_txt.Attributes["ItemUse"];
								sItemName = tmpCtrl_txt.Attributes["ItemName"];

								if (sItemUse.Equals("2") || sItemUse.Equals("4"))
								{
									if (NBUtil.StrEmptyChk(tmpCtrl_txt.Text))
									{
										NBCmnUtil.ViewAlertMsg (Page, sItemName + " 을/를 입력해 주세요.");

										return true;
									}
								}
								
								break;
							case "02":
								// DropDownList
								DropDownList tmpCtrl_ddl = (DropDownList)objCtrl;
								sItemUse = tmpCtrl_ddl.Attributes["ItemUse"];
								sItemName = tmpCtrl_ddl.Attributes["ItemName"];

								if (sItemUse.Equals("2") || sItemUse.Equals("4"))
								{
									if (tmpCtrl_ddl.SelectedIndex < 0)
									{
										NBCmnUtil.ViewAlertMsg (Page, sItemName + " 을/를 선택해 주세요.");

										return true;
									}
								}

								break;
							case "03":
								// RadioButton
								RadioButtonList tmpCtrl_rdo = (RadioButtonList)objCtrl;
								sItemUse = tmpCtrl_rdo.Attributes["ItemUse"];
								sItemName = tmpCtrl_rdo.Attributes["ItemName"];

								if (sItemUse.Equals("2") || sItemUse.Equals("4"))
								{
									if (tmpCtrl_rdo.SelectedIndex < 0)
									{
										NBCmnUtil.ViewAlertMsg (Page, sItemName + " 을/를 선택해 주세요.");

										return true;
									}
								}

								break;
							case "04":
								// CheckBox
								CheckBoxList tmpCtrl_chk = (CheckBoxList)objCtrl;
								sItemUse = tmpCtrl_chk.Attributes["ItemUse"];
								sItemName = tmpCtrl_chk.Attributes["ItemName"];

								if (sItemUse.Equals("2") || sItemUse.Equals("4"))
								{
									if (tmpCtrl_chk.SelectedIndex < 0)
									{
										NBCmnUtil.ViewAlertMsg (Page, sItemName + " 을/를 하나 이상 선택해 주세요.");

										return true;
									}
								}

								break;
							case "05":
								// TextArea
								TextBox tmpCtrl_mtxt = (TextBox)objCtrl;
								sItemUse = tmpCtrl_mtxt.Attributes["ItemUse"];
								sItemName = tmpCtrl_mtxt.Attributes["ItemName"];

								if (sItemUse.Equals("2") || sItemUse.Equals("4"))
								{
									if (NBUtil.StrEmptyChk(tmpCtrl_mtxt.Text))
									{
										NBCmnUtil.ViewAlertMsg (Page, sItemName + " 을/를 입력해 주세요.");

										return true;
									}
								}
								
								break;
							case "06":
								// Password
								TextBox tmpCtrl_ptxt = (TextBox)objCtrl;
								sItemUse = tmpCtrl_ptxt.Attributes["ItemUse"];
								sItemName = tmpCtrl_ptxt.Attributes["ItemName"];

								if (sItemUse.Equals("2") || sItemUse.Equals("4"))
								{
									if (NBUtil.StrEmptyChk(tmpCtrl_ptxt.Text))
									{
										NBCmnUtil.ViewAlertMsg (Page, sItemName + " 을/를 입력해 주세요.");

										return true;
									}
								}

								break;
							default:
								break;
						}                						
					}
				}
			}

			return false;
		}


		private void WBBtnSave_Click(object sender, ImageClickEventArgs e)
		{
			SqlConnection dbSqlConn = null;

			string
				parmGuestNo = string.Empty,
				parmHomeZip = string.Empty,
				parmWorkZip = string.Empty,
				parmPassFindQ = string.Empty,
				parmPassFindA = string.Empty,
				parmMemPicUp = string.Empty,
				parmMemSignUp = string.Empty;

			try
			{
				if (DoInputValidChk())
					return;                    

				DBUtil.DBConnection (ref dbSqlConn);                
				
				//아이디 중복체크
				if (!SqlHelper.ExecuteScalar (dbSqlConn, CommandType.StoredProcedure, "nbsp_dup_chk_mem_id", new SqlParameter("@mem_id", WNTxtLoginId.Text)).ToString().Equals("0"))
					throw new Exception("이미 등록된 아이디 입니다.");


				// 회원 이미지 업로드 (파일 업로드 했으면 파일 업로드)
				string sMemPicPath = NBUtil.GetUploadRootPath () + "\\NB_MemPic";
				string sMemPicUp = string.Empty;
				string sMemSignUp = string.Empty;
				
				if ( !NBUtil.StrEmptyChk (WNFileMemPic.Value) && HNHidMemPicValidChk.Value.Equals("1") )
					sMemPicUp = NBUtil.FileUpload (WNFileMemPic.PostedFile, sMemPicPath);

				if ( !NBUtil.StrEmptyChk (WNFileMemSign.Value) )
					sMemSignUp = NBUtil.FileUpload (WNFileMemSign.PostedFile, sMemPicPath);

				int nTmpParmCnt = 0;

				// 비밀번호 질문/답변
				if ( HTTrPassFind.Visible && WNDdlPassFind_Q.SelectedIndex > -1 )
				{
					parmPassFindQ = WNDdlPassFind_Q.SelectedValue;
					parmPassFindA = WNTxtPassFind_A.Text;
				}

				parmHomeZip = WNTxtHomeZipNo1.Text.Trim();
				if (!NBUtil.StrEmptyChk(WNTxtHomeZipNo2.Text) )
					parmHomeZip += "-" + WNTxtHomeZipNo2.Text.Trim();

				parmWorkZip = WNTxtWorkZipNo1.Text.Trim();
				if (!NBUtil.StrEmptyChk(WNTxtWorkZipNo2.Text) )
					parmWorkZip += "-" + WNTxtWorkZipNo2.Text.Trim();

				if (!NBUtil.StrEmptyChk (sMemPicUp))
					parmMemPicUp = Path.GetFileName(sMemPicUp);

				if (!NBUtil.StrEmptyChk (sMemSignUp))
					parmMemSignUp = Path.GetFileName(sMemSignUp);

				parmGuestNo = NBUtil.GetJoinNewGuestNo();

				SqlParameter[] sqlParm = new SqlParameter[39];
				sqlParm[nTmpParmCnt] = new SqlParameter("@edit_mode", "1");// 0
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@guest_no", parmGuestNo);// 1
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mem_id", WNTxtLoginId.Text);// 2
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mem_pwd", WNTxtLoginPwd.Text);// 3
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mem_name", WNTxtMbName.Text);// 4
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mem_email", WNTxtEmail.Text);// 5
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@nick_name", WNTxtNickname.Text);// 6
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@messenger_type", WNDdlMessengerType.SelectedValue);// 7
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@messenger_id", WNTxtMessengerId.Text);// 8
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homepage", WNTxtHomepg.Text);// 9
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@citizennum", WNTxtJumnNo1.Text + "-" + WNTxtJumnNo2.Text);// 10
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@birthday", WNTxtBirthDate_Year.Text + "." + WNTxtBirthDate_Month.Text + "." + WNTxtBirthDate_Day.Text);// 11
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@lunar_use", WLRdoLunarGubn.SelectedValue);// 12
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@sex", WLRdoSexGubn.SelectedItem.Value);// 13
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mobilephone", WNTxtMobileTel.Text);// 14
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homephone", WNTxtHomeTel.Text);// 15
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@workphone", WNTxtWorkTel.Text);// 16
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homezip", parmHomeZip);// 17
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homeaddr", WNTxtHomeAddrDong.Text + " " + WNTxtHomeAddrDesc.Text);// 18
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@workzip", parmWorkZip);// 19
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@workaddr", WNTxtWorkAddrDong.Text + " " + WNTxtWorkAddrDesc.Text);// 20
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@passfind_q", parmPassFindQ);// 21
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@passfind_a", parmPassFindA);// 22
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@point_num", 0);// 23
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mailling_chk", WLRdoEmailAccept.SelectedValue);// 24
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mempic_name", parmMemPicUp);// 25
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@memsign_name", parmMemSignUp);// 26
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mem_name_open", NBUtil.ConvBoolToStr (chk_mem_name_open.Checked));// 27
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mem_email_open", NBUtil.ConvBoolToStr (chk_mem_email_open.Checked));// 28
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@nick_name_open", NBUtil.ConvBoolToStr (chk_nick_name_open.Checked));// 29
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@messenger_id_open", NBUtil.ConvBoolToStr (chk_messenger_id_open.Checked));// 30
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homepage_open", NBUtil.ConvBoolToStr (chk_homepage_open.Checked));// 31
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@birthday_open", NBUtil.ConvBoolToStr (chk_birthday_open.Checked));// 32
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@sex_open", NBUtil.ConvBoolToStr (chk_sex_open.Checked));// 33
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@mobilephone_open", NBUtil.ConvBoolToStr (chk_mobilephone_open.Checked));// 34
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homephone_open", NBUtil.ConvBoolToStr (chk_homephone_open.Checked));// 35
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@workphone_open", NBUtil.ConvBoolToStr (chk_workphone_open.Checked));// 36
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@homeaddr_open", NBUtil.ConvBoolToStr (chk_homeaddr_open.Checked));// 37
				++nTmpParmCnt;
				sqlParm[nTmpParmCnt] = new SqlParameter("@workaddr_open", NBUtil.ConvBoolToStr (chk_workaddr_open.Checked));// 38

				SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.StoredProcedure, "nbsp_join_member", sqlParm);

				string Qry = NBUtil.AddItemSaveQry(parmGuestNo, hid_add_ctrl, this);

				if (!NBUtil.StrEmptyChk(Qry))
				{
					SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, Qry.ToString());
				}

				NBUtil.SetUserLevel(parmGuestNo);

				// 포인트 적용
				NBUtil.DoPointApply (mBoardCfg.bgc_join_point, parmGuestNo);

				// 로그인 처리
				if (NBUtil.ConvStrToBool(mBoardCfg.bgc_join_baseuse))
				{
					NBUtil.do_login (mBoardCfg.bgc_sess_timeout, WNTxtLoginId.Text, WNTxtLoginPwd.Text);
				}

				string sRedirectUrl = string.Empty;
				string sTarget = string.Empty;

				if (NBUtil.StrEmptyChk(mJoinAfterUrl))
				{
					sRedirectUrl = NBUtil.GetBoardTransLink (mPageQryInfo.sBoardNo, "LIST");
					sTarget = "self";
				}
				else
				{
					sRedirectUrl = mJoinAfterUrl;
					sTarget = "top";
				}

				Response.Write(@"<script language='javascript'>" + sTarget + @".location.href='" + sRedirectUrl + @"';</script>");
			}
			catch (Exception E)
			{
				if (!NBUtil.StrEmptyChk(parmGuestNo))
				{
					StringWriter QryErr = new StringWriter();

					QryErr.WriteLine("IF EXISTS(SELECT * FROM NB_MemberData WHERE guest_no = " + parmGuestNo + ")");
					QryErr.WriteLine("	DELETE NB_MemberData WHERE guest_no = " + parmGuestNo);
					QryErr.WriteLine("IF EXISTS(SELECT * FROM NB_AddMemberData WHERE guest_no = " + parmGuestNo + ")");
					QryErr.WriteLine("	DELETE NB_AddMemberData WHERE guest_no = " + parmGuestNo);

					SqlHelper.ExecuteNonQuery (dbSqlConn, CommandType.Text, QryErr.ToString());
				}

				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}

		private void LnkCheckUserId_Click(object sender, EventArgs e)
		{
			if(WNTxtLoginId.Text.Trim().Length == 0)
			{
				NBCmnUtil.ViewAlertMsg (Page, "체크할 ID를 입력해 주세요.");
				return;
			}

			if (DoJoinIDLimitChk())
				return;

			SqlConnection dbSqlConn = null;

			try
			{
				DBUtil.DBConnection (ref dbSqlConn);

				if(int.Parse(SqlHelper.ExecuteScalar (dbSqlConn, CommandType.StoredProcedure, "nbsp_dup_chk_mem_id", new SqlParameter("@mem_id", WNTxtLoginId.Text)).ToString()) > 0)
				{
					throw new Exception(WNTxtLoginId.Text.Trim() + "는 이미 사용하는 ID 입니다.");
				}
				else
				{
					HNHidIDValidChk.Value = "1";

					throw new Exception(WNTxtLoginId.Text.Trim() + "는 사용 가능한 ID 입니다.");
				}
			}
			catch(Exception E)
			{
				NBCmnUtil.ViewAlertMsg (Page, E.Message);
			}
			finally
			{
				DBUtil.DBConnDispose (ref dbSqlConn);
			}
		}
	}
}
