using System;
using System.Web.UI.WebControls;
using System.Web.UI;
using System.Web;
using System.Xml;
using System.IO;
using System.Text;

namespace NeBoard
{
	public struct RpChar
	{
		public static readonly string Start = "<!--#ListStart#-->";			// Ʈ ݺǴ  κ
		public static readonly string End = "<!--#ListEnd#-->";				// Ʈ ݺǴ  κ
		public static readonly string Title = "<!--#ItemTitle#-->";			// Ʈ  ǥõ κ
		public static readonly string Link = "<!--#ItemLink#-->";				// Ʈ Խù  б ũ
		public static readonly string Author = "<!--#ItemAuthor#-->";			// Ʈ Խù ۼ
		public static readonly string Category = "<!--#ItemCategory#-->";		// Ʈ Խù īװ
		public static readonly string PubDate = "<!--#ItemPubDate#-->";		// Ʈ Խù ۼ
		public static readonly string Desc = "<!--#ItemDescription#-->";		// Ʈ Խù 
		public static readonly string BoardTitle = "<!--#BoardTitle#-->";			//  Խǿ ǥõǴ 
		public static readonly string BoardMoreLink = "<!--#MoreLink#-->";			//  Խ More ũ
	}

	public class SumBoardLib
	{
		public SumBoardLib()
		{
		}

		/// <summary>
		/// ũ QueryString о IFRAME ũ   ش.
		/// </summary>
		public static void DoBoardProc(ref string BoardQryStr, string sDfltBno)
		{
			if (HttpContext.Current.Request.QueryString != null && HttpContext.Current.Request.QueryString.ToString().Length > 0)
				BoardQryStr = HttpContext.Current.Request.QueryString.ToString();
			else
				BoardQryStr = "bno=" + sDfltBno + "&mode=LIST&goto=1";
		}


		

		/// <summary>
		///  Խ ε
		/// </summary>
		public string DoSumBoardBind(string[] arrParm)
		{
			string sResult = string.Empty;

			try
			{
				// Է° üũ
				ParamValidChk(arrParm);

				string sXmlSrcUrl = "http://" + HttpContext.Current.Request.Url.Host;
				sXmlSrcUrl += "/neboard/Common/BoardRss.aspx?bno=" + arrParm[0];

				// XML ҽ  Ʈ  
				XmlNode xBoardCont = GetBoardSrcItem (sXmlSrcUrl);

				// Ų ҽ  Ų ؽƮ 
				string sSkinText = GetSkinText (HttpContext.Current.Server.MapPath(arrParm[1]));

				//  ġȯ (ڰ  XML ҽ Խ )
				if ( DoEmptyChk(arrParm[3]) )
					sSkinText = sSkinText.Replace (RpChar.BoardTitle, arrParm[3]);
				else
				{
					XmlNode xTitleNode = xBoardCont.SelectSingleNode ("title");

					if ( xTitleNode != null && DoEmptyChk(xTitleNode.InnerText) )
						sSkinText = sSkinText.Replace (RpChar.BoardTitle, xTitleNode.InnerText.Trim());
				}

				// More ũ ȯ (ڰ  XML ҽ Խ ũ ̵)
				if ( DoEmptyChk(arrParm[2]) )
					sSkinText = sSkinText.Replace (RpChar.BoardMoreLink, arrParm[2]);
				else
				{
					XmlNode xLinkNode = xBoardCont.SelectSingleNode ("link");

					if (xLinkNode != null && xLinkNode.InnerText.Trim().Length > 0)
						sSkinText = sSkinText.Replace (RpChar.BoardMoreLink, xLinkNode.InnerText.Trim());
				}
                

				// ***********************
				// Խ Ʈ 

				// Ų ݺ Խ Ʈ κ ؽƮ ε
				string sRepeatList = GetRepeatList (sSkinText);

				// XML ҽ  Խ Ʈ ݺ
				XmlNodeList xNLBoardList = xBoardCont.SelectNodes ("item");

				StringWriter swRepeatList = new StringWriter();

				if (xNLBoardList.Count > 0)
				{
					foreach (XmlNode xBoardItem in xNLBoardList)
					{
						string[] arrContParm = new string[6];

						arrContParm[0] = xBoardItem.SelectSingleNode ("title").InnerText;
						arrContParm[1] = xBoardItem.SelectSingleNode ("link").InnerText;
						arrContParm[2] = xBoardItem.SelectSingleNode ("author").InnerText;
						arrContParm[3] = xBoardItem.SelectSingleNode ("category").InnerText;
						arrContParm[4] = xBoardItem.SelectSingleNode ("pubDate").InnerText;
						arrContParm[5] = xBoardItem.SelectSingleNode ("description").InnerText;

						if ( DoEmptyChk(arrParm[4]) )
							arrContParm[0] = arrContParm[0].Replace ("#NEW#", arrParm[4]);

						swRepeatList.WriteLine (GetRepeatContent (sRepeatList, arrContParm, arrParm[2]));
					}
				}
				else
				{
					string[] arrContParm = new string[6];

					arrContParm[0] = "ϵ Խù ϴ.";
					arrContParm[1] = "javascript:void(0);";

					swRepeatList.WriteLine (GetRepeatContent (sRepeatList, arrContParm, ""));
				}
			
				sResult = GetRepeatListClear (sSkinText);

				sResult = sResult.Insert (sSkinText.IndexOf (RpChar.Start) + RpChar.Start.Length, swRepeatList.ToString());
			}
			catch(Exception E)
			{
				sResult = E.Message;
			}

			return sResult;
		}

		/// <summary>
		/// ü Խ ˻ ε
		/// </summary>
		public string DoGlobalSearchBind(string[] arrParm)
		{
			string sResult = string.Empty;

			try
			{
				// Է° üũ
				ParamValidChk(arrParm);

				string sXmlSrcUrl = "http://" + HttpContext.Current.Request.Url.Host;
				sXmlSrcUrl += "/neboard/Common/globalsearch.aspx?tcnt=" + arrParm[0] + "&type=" + arrParm[1] + "&stype=" + arrParm[2] + "&stxt=" + HttpContext.Current.Server.UrlEncode (arrParm[3]);

				// XML ҽ  Ʈ  
				XmlNode xBoardCont = GetBoardSrcItem (sXmlSrcUrl);

				// Ų ҽ  Ų ؽƮ 
				string sSkinText = GetSkinText (HttpContext.Current.Server.MapPath(arrParm[4]));

				//  ġȯ (ڰ  XML ҽ Խ )
				if ( DoEmptyChk(arrParm[5]) )
					sSkinText = sSkinText.Replace (RpChar.BoardTitle, arrParm[5]);
				else
				{
					XmlNode xTitleNode = xBoardCont.SelectSingleNode ("title");

					if ( xTitleNode != null && DoEmptyChk(xTitleNode.InnerText) )
						sSkinText = sSkinText.Replace (RpChar.BoardTitle, xTitleNode.InnerText.Trim());
				}


				// ***********************
				// Խ Ʈ 

				// Ų ݺ Խ Ʈ κ ؽƮ ε
				string sRepeatList = GetRepeatList (sSkinText);

				// XML ҽ  Խ Ʈ ݺ
				XmlNodeList xNLBoardList = xBoardCont.SelectNodes ("item");

				StringWriter swRepeatList = new StringWriter();

				if (xNLBoardList.Count > 0)
				{
					foreach (XmlNode xBoardItem in xNLBoardList)
					{
						string[] arrContParm = new string[6];

						arrContParm[0] = xBoardItem.SelectSingleNode ("title").InnerText;
						arrContParm[1] = xBoardItem.SelectSingleNode ("link").InnerText;
						arrContParm[2] = xBoardItem.SelectSingleNode ("author").InnerText;
						arrContParm[3] = xBoardItem.SelectSingleNode ("category").InnerText;
						arrContParm[4] = xBoardItem.SelectSingleNode ("pubDate").InnerText;
						arrContParm[5] = xBoardItem.SelectSingleNode ("description").InnerText;

						if ( DoEmptyChk(arrParm[6]) )
							arrContParm[0] = arrContParm[0].Replace ("#NEW#", arrParm[6]);

						swRepeatList.WriteLine (GetRepeatContent (sRepeatList, arrContParm, ""));
					}
				}
				else
				{
					string[] arrContParm = new string[6];

					arrContParm[0] = "ϵ Խù ϴ.";
					arrContParm[1] = "javascript:void(0);";

					swRepeatList.WriteLine (GetRepeatContent (sRepeatList, arrContParm, ""));
				}
			
				sResult = GetRepeatListClear (sSkinText);

				sResult = sResult.Insert (sSkinText.IndexOf (RpChar.Start) + RpChar.Start.Length, swRepeatList.ToString());
			}
			catch(Exception E)
			{
				sResult = E.Message;
			}

			return sResult;
		}

		private string GetRepeatContent(string sSrc, string[] arrContParm, string sMoreLink)
		{
			string sResultStr = sSrc;

			if ( DoEmptyChk(arrContParm[0]) )
				sResultStr = sResultStr.Replace (RpChar.Title, HttpContext.Current.Server.HtmlEncode(arrContParm[0].Replace("'", "").Replace("\"", "").Replace("<br/>", "\r\n")));
			else
				sResultStr = sResultStr.Replace (RpChar.Title, "");

			if ( DoEmptyChk(arrContParm[1]) )
			{
				if (DoEmptyChk(sMoreLink))
				{
					Uri urlQry = new Uri(arrContParm[1]);
					
					sResultStr = sResultStr.Replace (RpChar.Link, sMoreLink + urlQry.Query);
				}
				else
				{
                    sResultStr = sResultStr.Replace (RpChar.Link, arrContParm[1]);					
				}
			}
			else
				sResultStr = sResultStr.Replace (RpChar.Link, "javascript:void(0);");

			if ( DoEmptyChk(arrContParm[2]) )
				sResultStr = sResultStr.Replace (RpChar.Author, arrContParm[2]);
			else
				sResultStr = sResultStr.Replace (RpChar.Author, "");

			if ( DoEmptyChk(arrContParm[3]) )
				sResultStr = sResultStr.Replace (RpChar.Category, arrContParm[3]);
			else
				sResultStr = sResultStr.Replace (RpChar.Category, "");

			if ( DoEmptyChk(arrContParm[4]) )
				sResultStr = sResultStr.Replace (RpChar.PubDate, DateTime.Parse(arrContParm[4]).ToString("yyyy.MM.dd"));
			else
				sResultStr = sResultStr.Replace (RpChar.PubDate, "");

			if ( DoEmptyChk(arrContParm[5]) )
				sResultStr = sResultStr.Replace (RpChar.Desc, arrContParm[5]);
			else
				sResultStr = sResultStr.Replace (RpChar.Desc, "");

			return sResultStr;
		}

		/// <summary>
		/// Ķ ȿ ˻
		/// </summary>
		/// <param name="arrParm"></param>
		private void ParamValidChk(string[] arrParm)
		{
			if (!DoEmptyChk(arrParm[0]))
				throw new Exception ("Խù  ϴ.");
		}
		
		/// <summary>
		///  ڿ üũ ( ڿ ƴ  True)
		/// </summary>
		/// <param name="sVal"></param>
		/// <returns></returns>
		private bool DoEmptyChk(string sVal)
		{
			bool bResult = false;

			if (sVal != null)
			{
				if (sVal.Trim().Length > 0)
					bResult = true;
			}

			return bResult;
		}
		
		/// <summary>
		/// RSS XML URL  /rss/channel Node  ´.
		/// </summary>
		/// <param name="sXmlSrc"></param>
		/// <returns></returns>
		private XmlNode GetBoardSrcItem(string sXmlSrc)
		{
			XmlNode xmlChannelNode = null;

			if ( DoEmptyChk(sXmlSrc) )
			{
				XmlTextReader getRss = new XmlTextReader(sXmlSrc);
				XmlDocument xmlDoc = new XmlDocument();

				try
				{
					xmlDoc.Load(getRss);
				}
				finally
				{
					getRss.Close();
				}

				xmlChannelNode = xmlDoc.SelectSingleNode ("/rss/channel");
			}

			return xmlChannelNode;
		}

		/// <summary>
		/// Ų   TEXT о ´.
		/// </summary>
		/// <param name="sSkinSrc"></param>
		/// <returns></returns>
 		private string GetSkinText(string sSkinSrc)
		{
			string sSkinText = null;

			if ( DoEmptyChk(sSkinSrc) )
			{
				StreamReader sr = null;

				try
				{
					if (File.Exists(sSkinSrc))
					{
						sr = new StreamReader(sSkinSrc, Encoding.Default);

						sSkinText = sr.ReadToEnd();
					}
				}
				finally
				{
					if (sr != null)
                        sr.Close();
				}
			}

			return sSkinText;
		}

		/// <summary>
		/// Խ Ʈ ݺ    Text о ´.
		/// </summary>
		/// <param name="sSkinSrc"></param>
		/// <returns></returns>
		private string GetRepeatList(string sSkinSrc)
		{
			string sRepeatList = null;

			if ( DoEmptyChk(sSkinSrc) )
			{
				int nStartPoint = sSkinSrc.IndexOf (RpChar.Start) + RpChar.Start.Length;
				int nLstLen = sSkinSrc.IndexOf (RpChar.End) - nStartPoint;

                if (nStartPoint > 0 && nLstLen > 0)
                    sRepeatList = sSkinSrc.Substring (nStartPoint, nLstLen);
			}

			return sRepeatList;
		}

		/// <summary>
		/// Ų ִ Ʈ ݺ  κ 
		/// </summary>
		/// <param name="sSkinSrc"></param>
		/// <returns></returns> 
		private string GetRepeatListClear(string sSkinSrc)
		{
			string sRepeatList = null;

			if ( DoEmptyChk (sSkinSrc) )
			{
				int nStartPoint = sSkinSrc.IndexOf (RpChar.Start) + RpChar.Start.Length;
				int nLstLen = sSkinSrc.IndexOf (RpChar.End) - nStartPoint;

				if (nStartPoint > 0 && nLstLen > 0)
                    sRepeatList = sSkinSrc.Remove (nStartPoint, nLstLen);
			}

			return sRepeatList;
		}
	}
}
