﻿	//######################################################################################################
	//#########################              플레이어 컨트롤 관련 기능..           #########################
	//######################################################################################################
	var aSongFile = Array();//재생파일 목록
	var aSongName = Array();//노래재목
	var aSinger = Array();//가수명
	
	var sSongFileSplit;
	var sSongNameSplit;
	var sSingerSplit;

	var nMusicIdx = Array(); //재생순서 변수

	var nTotalCnt = 0;		//전체 음악파일 갯수
	var nPlayIdx = 0;		//음악파일 인덱스

	var sSongDuration;		//재생시간(초)
	var sSongDurationStr;	//재생시간(분:초)
	var sSongName;			//제목
	var sSinger;			//가수
	var sSongUrl;			//음악파일 주소
	
	var bRepeatAll;			//전체반복
	var bRepeatCurrent;		//현재곡 반복
	var bRandom;			//랜덤재생
	var bViewPlayList;	//재생목록 보기

	var sBoardNo;		//게시판 번호


	//###############################################
	//	재생파일 목록 초기화
	//###############################################
	function InitPlayList()
	{
		var f = document.forms[0];
		
		if (f.HNHidSongFile.value != "")
		{
			//게시판 번호
			sBoardNo = f.HNHidBoardNo.value;

			sSongFileSplit = f.HNHidSongFile.value.split(";");
			sSongNameSplit = f.HNHidSongName.value.split(";");
			sSingerSplit = f.HNHidSinger.value.split(";");

			nTotalCnt = sSongFileSplit.length;

			for (i = 0; i < nTotalCnt; i++){
				nMusicIdx[i] = i;
			}	

			bRepeatAll = false;
			bRepeatCurrent = false;

			bViewPlayList = false;

			//음량조절 막대 위치 설정
			setTrackVolIcon();

			//실행
			WMP_Play();
		}
		else
		{
			alert ("재생할 음악 파일이 없습니다.");
			self.close();
		}
	}

	//###############################################
	//	플레이어 초기화
	//###############################################
	function WMPInit()
	{
		var nTmpIdx = nMusicIdx[nPlayIdx];
		var aItemInfo = sSongFileSplit[nTmpIdx].split("|");
		sSongUrl = "../../../Common/NB_FileDown.aspx?bno=" + sBoardNo + "&bidx=" + aItemInfo[0] + "&fidx=" + aItemInfo[1] + "&fname=" + escape(aItemInfo[2]);
		
		if (sSongNameSplit[nTmpIdx] != "")
			sSongName = sSongNameSplit[nTmpIdx];
		else
			sSongName = aItemInfo[2];
			
		if (sSingerSplit[nTmpIdx] != "")
			sSinger = sSingerSplit[nTmpIdx];
		else
			sSinger = "어떤 가수";
						
		SendList();
	}

	//###############################################
	//	전체반복설정
	//###############################################
	function WMP_RepeatAll(){
		if (bRepeatAll == true){
			bRepeatAll = false;
			document.all["btnRepeatAll"].src = "Images/listen_all_off.gif";
		}else{
			bRepeatAll = true;
			document.all["btnRepeatAll"].src = "Images/listen_all_on.gif";
			//전체반복 설정 시에는 현재곡 반복설정을 해제한다.
			bRepeatCurrent = false;
			document.all["btnRepeat"].src = "Images/listen_select_off.gif";
		}
	}

	//###############################################
	//	현재곡 반복설정
	//###############################################
	function WMP_RepeatCurrent(){
		if (bRepeatCurrent == true){
			bRepeatCurrent = false;
			document.all["btnRepeat"].src = "Images/listen_select_off.gif";
		}else{
			bRepeatCurrent = true;
			document.all["btnRepeat"].src = "Images/listen_select_on.gif";
			//현재곡 반복 설정 시에는 전체반복설정을 해제한다.
			bRepeatAll = false;
			document.all["btnRepeatAll"].src = "Images/listen_all_off.gif";
		}
	}

	//###############################################
	//	랜덤재생
	//###############################################
	function WMP_Random(){
		var tempPlayList = new Array();
		
		// 임시로 쓸 변수
		var tempNumber = 0;
		while(true)
		{
			// 리스트 번호 중에서 랜덤 번호를 뽑는다.
			var randomIdx = Math.floor(Math.random() * nTotalCnt);
			tempPlayList[tempNumber] = randomIdx;
			
			// 랜덤으로 뽑은 것이 이미 뽑았던 번호인지 확인한다.
			var IsValid;
			for(i=0; i < tempNumber; i++){
				if(tempPlayList[i] == randomIdx){
					IsValid = false;
					break;
				}
				IsValid = true;
			}
			
			if(tempNumber == nTotalCnt){
				break;
			}
			
			if(IsValid != false){
				tempNumber++;
			}
		}

		WMP_Stop();
		
		nMusicIdx = tempPlayList;
		nPlayIdx = 0;
		WMP_Play();
	}

	//###############################################
	//	재생
	//###############################################
	function WMP_Play(){
		if(WMP.playState == 3){
			WMP.controls.Pause();
		}else if(WMP.playState == 2)	{
			WMP.controls.Play();
		}else{		
			WMPInit();
			WMP.URL = sSongUrl;
			WMP.controls.currentPosition = 1;
		}
	}

	//###############################################
	//	일시정지
	//###############################################
	function WMP_Pause(){
		if(WMP.playState == 3){
			WMP.controls.Pause();
		}else if(WMP.playState == 2){
			WMP.controls.Play();
		}
	}

	//###############################################
	//	정지
	//###############################################
	function WMP_Stop(){
		WMP.Controls.stop();
	}

	//###############################################
	//	이전곡
	//###############################################
	function WMP_Prev(){
		if(nPlayIdx == 0)
		{
			alert("처음곡 입니다");
			return false;
		}
		else
		{
			WMP_Stop();
			nPlayIdx--;
			setTimeout("WMP_Play();", 300);
		}
	}

	//###############################################
	//	다음곡
	//###############################################
	function WMP_Next(){
		var nTmpIdx;

		if (bRepeatAll == true && nPlayIdx == (nTotalCnt - 1)){		//전체반복 + 마지막곡
			nTmpIdx = 0;
		}		
		else if (bRepeatCurrent == true){		//현재곡 반복
			nTmpIdx = nPlayIdx;
		}		
		else if (nPlayIdx == (nTotalCnt - 1)){		//마지막곡
			document.all["state"].innerHTML = "마지막곡 입니다.";
			return false;
		}		
		else{		//다음곡
			nTmpIdx = nPlayIdx + 1;
		}

		WMP_Stop();
		nPlayIdx = nTmpIdx;
		setTimeout("WMP_Play();", 300);
	}

	//###############################################
	//	미디어 플레이어 재생 상태
	//###############################################
	function PlayerState(state)
	{
		switch(state)
		{
			case 1 :	//stop
			
				document.all["state"].innerHTML = " Stop";
				document.all["duration"].innerHTML = "00:00 / 00:00 [" + (nPlayIdx + 1) + "/" + nTotalCnt + "]";
				//진행바 위치 초기화
				ClearPosition();
				break;
			
			case 2 :	//pause
				document.all["state"].innerHTML = " Pause";
				break;
			
			case 3 :	//playing
				sSongDuration = WMP.currentMedia.duration;
				sSongDurationStr = time_paser(WMP.currentMedia.duration);

				//진행바 이동
				showProgress();
				
				//제목표시				
				document.all["state"].innerHTML = "<marquee scrollamount=3>" + (parseInt(nPlayIdx)+1) + ". " + sSongName + " - " + sSinger + "</marquee>";
				setInterval("playingTime()",1000);
				break;
			
			case 6 :	//buffering
				document.all["state"].innerHTML = " Now Buffering";
				//document.all["duration"].innerHTML = "00:00 / 00:00 [" + (nPlayIdx + 1) + "/" + nTotalCnt + "]";
				break;
			
			case 7 :	//waiting
				document.all["state"].innerHTML = " Wait...";
				//document.all["duration"].innerHTML = "00:00 / 00:00 [" + (nPlayIdx + 1) + "/" + nTotalCnt + "]";
				break;
			
			case 8 :	//ending
				if (bRepeatAll == true || bRepeatCurrent == true || nPlayIdx != (nTotalCnt - 1))
					setTimeout("WMP_Next();", 500);
				break;
			
			case 10 :	//ready
				document.all["state"].innerHTML = " Ready...";
				//document.all["duration"].innerHTML = "00:00 / 00:00 [" + (nPlayIdx + 1) + "/" + nTotalCnt + "]";
				break;
		}
		
	}

	//###############################################
	//	진행시간 표시
	//###############################################
	function playingTime(){
		var sTmpCurrentPosition = WMP.controls.currentPositionString;
		if (sTmpCurrentPosition == "")
			sTmpCurrentPosition = "00:00";
		var sTmpDuration = time_paser(WMP.currentMedia.duration);
		document.all["duration"].innerHTML = sTmpCurrentPosition + " / " + sTmpDuration + " [" + (nPlayIdx + 1) + "/" + nTotalCnt + "]";
	}


	//###############################################
	//	시간 문자열 변환
	//###############################################
	function time_paser(i_time)
	{
		var PlyTime,PlyCl,PlyMin,PlySec,temp;
		PlyTime=i_time;
		temp=Math.floor(PlyTime/60);
		PlySec=Math.floor(PlyTime%60);
		PlyClk=Math.floor(temp/60);
		PlyMin=Math.floor(temp%60);
		if (PlyMin <10) {PlyMin='0'+PlyMin;}
		if (PlySec <10) {PlySec='0'+PlySec;}
		if (PlyClk==0){r_TimeText=PlyMin+':'+PlySec;}else{r_TimeText=PlyClk+':'+PlyMin+':'+PlySec;}
		return r_TimeText
	}

	//###############################################
	//	재생목록 넘기기
	//###############################################
	function SendList(){
		if (bViewPlayList == true){
			var sMusicIdx = "";
			for(i = 0; i < nTotalCnt; i++){
				sMusicIdx += ";" + nMusicIdx[i];
			}
			
			var f0 = document.forms[0];
			var f1 = document.forms[1];

			f1.hidBoardNo.value = f0.HNHidBoardNo.value;
			f1.hidSongFile.value = f0.HNHidSongFile.value;
			f1.hidSongName.value = f0.HNHidSongName.value;
			f1.hidSinger.value = f0.HNHidSinger.value;
			f1.hidMusicIdx.value = sMusicIdx.substring(1);
			f1.hidPlayIdx.value = nPlayIdx.toString();
			f1.target = "songList";
			f1.submit();
		}
	}

	function PlayList_View()
	{
		if (bViewPlayList == true)
		{
			bViewPlayList = false;
			document.all["songList"].style.display = "none";
			window.resizeTo(410,175)
		}
		else
		{
			bViewPlayList = true;
			document.all["songList"].style.display = "";
			SendList();
			window.resizeTo(410,473)
		}
	}


	//######################################################################################################
	//#########################              진행바 이동 관련 기능                 #########################
	//######################################################################################################
	var trackPositionSts;
	var positionSet = false;
	var var_length = 183;
	var var_startpoint = 17;
	var dragapproved;
	var nowPosition;
	var iex;
	var iey;
	var tempx;
	var tempy;


	//###############################################
	//	진행바 자동 이동 설정
	//###############################################
	function showProgress()
	{
		if (WMP.controls.currentPosition > 0)
		{
			trackPositionSts = setInterval('setTrackIcon()',500);
		}
	}

	//###############################################
	//	진행바를 드래그해서 진행 위치 변경하기 위한 초기 설정
	//###############################################
	function initTrackPosition() {
		positionSet = true;
		iex = event.clientX;	//현재의 마우스 좌표 X
		iey = event.clientY;	//현재의 마우스 좌표 Y
		tempx = document.all.position.style.pixelLeft;	//현재의 진행바 좌표 X
		tempy = document.all.position.style.pixelTop;	//현재의 진행바 좌표 Y
		dragapproved=true;
		document.onmousemove = positionDragControl;
			
		if(document.all) document.onmouseup = playerSetPosition;
	}

	//###############################################
	//	진행바 위치 설정
	//###############################################
	function playerSetPosition() {
		if(positionSet == true) {
			positionSet=false;
			dragapproved = false;
			per = (document.all["position"].style.pixelLeft - var_startpoint) / var_length;
				
			psit = Math.floor(sSongDuration * per);
			setPosition(psit);
		}
	}

	//###############################################
	//	진행바 위치 이동
	//###############################################
	function positionDragControl() {
		if(dragapproved == true) {
			
			var mov = tempx + event.clientX - iex; // 진행바의 좌표 X와 마우스로 클릭한 지점의 좌표 X와의 거리때문에 이렇게 계산함..
				
			if(mov >= var_startpoint && mov <= var_startpoint+var_length) {
				document.all["position"].style.pixelLeft = tempx + event.clientX - iex;
			}
			
			return false;
		}
	}

	//###############################################
	//	플레이어의 진행 위치 지정
	//###############################################
	function setPosition(psit) {
		WMP.controls.currentPosition = psit;
	}

	//###############################################
	//	플레이어의 현재 진행위치로 진행바 이동
	//###############################################
	function setTrackIcon()
	{
		nowPosition = WMP.controls.currentPosition;
		
		if (nowPosition > 0)
		{
			if(positionSet == false)
			{
				var now_position = Math.floor(nowPosition);
				var total_position = Math.floor(sSongDuration);
				
				if (now_position > 0)
				{
					document.all.position.style.pixelLeft = var_startpoint + (var_length * (now_position / total_position));
				}
			}
		}
	}

	//###############################################
	//	진행바 위치 초기화
	//###############################################
	function ClearPosition() {
		document.all["position"].style.pixelLeft = var_startpoint;
	}


	//######################################################################################################
	//#########################            음량 조절바 이동 관련 기능              #########################
	//######################################################################################################
	var volumePositionSts;
	var volumeSet = false;
	var vol_var_length = 144;
	var vol_var_startpoint = 225;
	var vol_dragapproved;
	var nowVolume;
	var vol_iex;
	var vol_iey;
	var vol_tempx;
	var vol_tempy;


	//###############################################
	//	음량 조절바를 드래그해서 음량 조절 위한 초기 설정
	//###############################################
	function initVolTrackPosition() {
		volumeSet = true;
		vol_iex = event.clientX;	//현재의 마우스 좌표 X
		vol_iey = event.clientY;	//현재의 마우스 좌표 Y
		vol_tempx = document.all.volume.style.pixelLeft;	//현재의 진행바 좌표 X
		vol_tempy = document.all.volume.style.pixelTop;	//현재의 진행바 좌표 Y
		vol_dragapproved=true;
		document.onmousemove = volumeDragControl;
			
		if(document.all) document.onmouseup = playerSetVolume;
	}

	//###############################################
	//	음량 설정
	//###############################################
	function playerSetVolume() {
		if(volumeSet == true) {
			volumeSet=false;
			vol_dragapproved = false;
			per = (document.all["volume"].style.pixelLeft - vol_var_startpoint) / vol_var_length;
				
			psit = Math.floor(100 * per);
			WMP.settings.volume = psit;
		}
	}

	//###############################################
	//	음량 조절바 위치 이동
	//###############################################
	function volumeDragControl()
	{
		if(vol_dragapproved == true)
		{
			var mov = vol_tempx + event.clientX - vol_iex; // 진행바의 좌표 X와 마우스로 클릭한 지점의 좌표 X와의 거리때문에 이렇게 계산함..
				
			if(mov >= vol_var_startpoint && mov <= vol_var_startpoint+vol_var_length)
			{
				document.all["volume"].style.pixelLeft = vol_tempx + event.clientX - vol_iex;
			}
			
			return false;
		}
	}

	//###############################################
	//	플레이어의 현재 음량 크기로 음량 조절바 이동
	//###############################################
	function setTrackVolIcon() {
		nowVolume = WMP.settings.volume;
		if(volumeSet == false) {
				document.all.volume.style.pixelLeft = vol_var_startpoint + (vol_var_length * (nowVolume / 100));
		}
	}


	function OverImg(Gubn){
		if (Gubn == "1")
			document.all["btnRepeat"].src = "Images/listen_select_on.gif";
		else
			document.all["btnRepeatAll"].src = "Images/listen_all_on.gif";
	}

	function OutImg(Gubn){
		if (Gubn == "1"){
			if (bRepeatCurrent == true)
				document.all["btnRepeat"].src = "Images/listen_select_on.gif";
			else
				document.all["btnRepeat"].src = "Images/listen_select_off.gif";
		}else{
			if (bRepeatAll == true)
				document.all["btnRepeatAll"].src = "Images/listen_all_on.gif";
			else
				document.all["btnRepeatAll"].src = "Images/listen_all_off.gif";
		}
	}


	function killErr()
	{
		return true;
	}

	
	document.onkeydown = processKey;
	
	function processKey()
	{
		if( (event.ctrlKey == true && (event.keyCode == 68 || event.keyCode == 72 || event.keyCode == 78 || event.keyCode == 82)) || (event.keyCode >= 112 && event.keyCode <= 123) )
		{
			event.keyCode = 0; 
			event.cancelBubble = true; 
			event.returnValue = false; 
		}

		if(event.keyCode == 27)
		{
			event.keyCode = 0; 
			event.cancelBubble = true; 
			event.returnValue = false; 
		}
	}